class ChairOnTable(var number: Long) {

    var next: ChairOnTable? = null
    var isFree = true
}

class RoundChairs {
    var head: ChairOnTable? = null

    fun add(`val`: Long) {
        val newChair = ChairOnTable(`val`)

        if (head == null) {
            head = newChair
        } else {
            var temp = head

            while (temp!!.next != null) {
                temp = temp.next
            }

            temp.next = newChair
        }
    }
}

fun main() {
    val quantityChair = readLine()!!.toLong()
    val quantityIntrovert = readLine()!!.toLong()

    val head = getRoundChairs(quantityChair)
    println(getAnswer(head, quantityIntrovert))
}

fun getRoundChairs(quantity: Long): ChairOnTable? {
    val roundChairs = RoundChairs()
    var number = 1L

    while (number <= quantity) {
        roundChairs.add(number)

        number++
    }

    return roundChairs.head
}

fun getAnswer(head: ChairOnTable?, introvertConst: Long): Long {
    head?.isFree = false
    var current: ChairOnTable? = head?.next?.next
    var freePrevChairs = 0L
    var closeChairs = 2L
    var lastIntrovertPrevFree = 0L
    var range = 0L

    while (current != null) {
        if (lastIntrovertPrevFree + freePrevChairs < introvertConst) {
            range = introvertConst
        }

        if (range > 0) {
            freePrevChairs++
            lastIntrovertPrevFree = freePrevChairs
            range--
            current = current.next
            continue
        }

        val nextFree = getFreeNextChairs(current)

        if (nextFree + freePrevChairs >= introvertConst && current.next != null) {
            current.isFree = false
            closeChairs++
            lastIntrovertPrevFree = freePrevChairs
            freePrevChairs = 0L
        } else {
            freePrevChairs++
        }

        current = current.next
    }

    return closeChairs
}

fun getFreeNextChairs(chairOnTable: ChairOnTable?): Long {
    var i = 0L
    var current: ChairOnTable? = chairOnTable

    while (current!!.next != null) {
        current = current.next

        i++
    }

    return i
}