
data class Point(val x: Long, val y: Long, var distance: Double);

fun distance(x1 : Long, y1 : Long, x2 : Long, y2 : Long) : Double {
    return Math.sqrt(
        Math.pow((x1 - x2).toDouble(), 2.0) +
                Math.pow((y1 - y2).toDouble(), 2.0)
    );
}

fun main(args: Array<String>) {
    val eyesCount = readLine()!!.toInt();
    val points = mutableListOf<Point>();

    for(i in 1 .. eyesCount)
    {
        val pointValue = readLine()!!.split(' ').map(String::toLong);
        points.add(Point(pointValue[0], pointValue[1], 0.0));
    }

    var resultDistance : Double = 0.0
    var firstPoint = points[0]

    points.remove(firstPoint)

    for (index in points.size - 1 downTo 0)
    {
        var minDistancePoint = points[0];

        minDistancePoint.distance =
            distance(firstPoint.x, firstPoint.y,
                minDistancePoint.x, minDistancePoint.y);

        for (point in points)
        {
            point.distance = distance(firstPoint.x, firstPoint.y,
                point.x, point.y);

            if (minDistancePoint.distance > point.distance)
                minDistancePoint = point;
        }

        resultDistance += minDistancePoint.distance;

        firstPoint = minDistancePoint
        points.remove(minDistancePoint);
    }

    println(resultDistance);
}