data class Point(val x: Long, val y: Long, var distance: Double)

fun distance(point1: Point, point2: Point): Double {
    point2.distance = kotlin.math.sqrt(
        Math.pow((point1.x - point2.x).toDouble(), 2.0) +
                Math.pow((point1.y - point2.y).toDouble(), 2.0)
    )

    return point2.distance
}

fun main() {
    val eyesCount = readLine()!!.toInt()
    val points = List(eyesCount) {
        val (x, y) = readLine()!!.split(' ').map(String::toLong)
        Point(x, y, 0.0)
    }.toMutableList()

    var resultDistance = 0.0
    var firstPoint = points.removeAt(0)

    while (points.isNotEmpty()) {
        val minDistancePoint = points.minByOrNull { it.distance }!!

        distance(firstPoint, minDistancePoint)
        resultDistance += minDistancePoint.distance

        firstPoint = minDistancePoint
        points.remove(minDistancePoint)
    }

    println(resultDistance)
}