def calculate_probability(N, K, S1, S2):
    max_sum = N * K
    prob1 = [0] * (max_sum + 1)
    prob2 = [0] * (max_sum + 1)

    prob1[0] = 1
    prob2[0] = 1

    for i in range(1, N + 1):
        new_prob1 = [0] * (max_sum + 1)
        new_prob2 = [0] * (max_sum + 1)

        for j in range(1, K + 1):
            for s in range(j, max_sum + 1):
                new_prob1[s] += prob1[s - j]
                new_prob2[s] += prob2[s - j]

        prob1 = [p / K for p in new_prob1]
        prob2 = [p / K for p in new_prob2]

    probability_s1 = prob1[S1]
    probability_s2 = prob2[S2]

    if probability_s1 > probability_s2:
        return "First"
    elif probability_s2 > probability_s1:
        return "Second"
    else:
        return "Equal"


N = int(input())
K = int(input())
S1 = int(input())
S2 = int(input())

result = calculate_probability(N, K, S1, S2)
print(result)
