def calculate_probability(N, K, S1, S2):
    max_sum = N * K
    memo = {}  # Мемоизация для сохранения результатов предыдущих вычислений

    def dp(n, s):
        if n == 0:
            return 1 if s == 0 else 0
        if (n, s) in memo:
            return memo[(n, s)]

        total = 0
        for i in range(1, K + 1):
            if s - i >= 0:
                total += dp(n - 1, s - i)

        memo[(n, s)] = total
        return total

    probability_s1 = dp(N, S1)
    probability_s2 = dp(N, S2)

    if probability_s1 > probability_s2:
        return "First"
    elif probability_s2 > probability_s1:
        return "Second"
    else:
        return "Equal"


N = int(input())
K = int(input())
S1 = int(input())
S2 = int(input())

result = calculate_probability(N, K, S1, S2)
print(result)
