#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <utility>
#include <functional>
#include <cmath>
#include <map>
#include <set>
#include <unordered_set>
#include <queue>
#include <deque>
#include <stack>
#include <unordered_map>
#include <cassert>
#include <iomanip>
#include <cstring>
#include <numeric>
#include <random>

#define ll long long
#define dbl double
#define ld long double
#define str std::string

#define pb push_back
#define eb emplace_back
#define fi first
#define se second
#define all(x) (x).begin(), (x).end()

using namespace std;

#define inf 1'000'000'000'000;

struct node;

struct edge {
  ll depth = 0;
  node *to = nullptr;
};

struct node {
  node *parent = nullptr;
  map<char, edge> edg;
  bool used = false;
};

vector<node> nd(200'000);
ll nd_ptr = 0;

node *create_node(node *parent) {
  nd[nd_ptr].parent = parent;
  return &nd[nd_ptr++];
}

void update_depth(edge *e) {
  e->depth = inf;
  for (char i = '0'; i <= '9'; i++) {
    if (e->to->edg.find(i) != e->to->edg.end()) {
      e->depth = min(e->depth, e->to->edg[i].depth + 1);
    }
  }
}

void handle_node(node *cur, str &name, bool first) {
  ll mi = '0';

  if (!cur->used) {
    cur->used = true;
    return;
  }

  char fc = '0';

  if (first)
    fc = '1';

  for (char i = fc; i <= '9'; i++) {
    if (cur->edg.find(i) == cur->edg.end()) {
      name += i;
      cur->edg[i] = {1, create_node(cur)};
      cur->edg[i].to->used = true;

      update_depth(&cur->edg[i]);

      return;
    }

    if (cur->edg[i].depth < cur->edg[mi].depth) {
      mi = i;
    }
  }

  name += mi;

  handle_node(cur->edg[mi].to, name, false);

  update_depth(&cur->edg[mi]);
}

void add_name(node *root, str &name, ll pos = 0) {
  if (pos == name.size()) {
    handle_node(root, name, true);

    return;
  }

  if (root->edg.find(name[pos]) == root->edg.end()) {
    root->edg[name[pos]] = {0, create_node(root)};
  }

  add_name(root->edg[name[pos]].to, name, pos + 1);

  update_depth(&root->edg[name[pos]]);
}

void solution() {
  ll n;

  cin >> n;

  str name;

  for (ll i = 0; i < n; i++) {
    cin >> name;
    add_name(&nd[0], name);

    cout << name << "\n";
  }
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.tie(nullptr);

  ll n = 1;

  // cin >> n;

  for (ll i = 0; i < n; i++) {
    solution();
  }

  return 0;
}
