#include <algorithm>
#include <array>
#include <bitset>
#include <cassert>
#include <chrono>
#include <climits>
#include <cmath>
#include <complex>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <ctime>
#include <iomanip>
#include <iostream>
#include <map>
#include <queue>
#include <random>
#include <set>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <vector>
#define forn(i, n) for (int i = 0; i < n; ++i)
#define ll long long
using namespace std;

int n, m;
int tox, toy;
map<pair<int, int>, int> used;
vector<vector<int>> g;
bool valid(int x, int y) {
    return 0 <= x && x < n && 0 <= y && y < m;
}
bool dfs(int x, int y, int k) {
    used[{x, y}] = 1;
    if (x == tox && y == toy) {
        return true;
    }
    if (valid(x - 1, y) && g[x - 1][y] && used.count({x - 1, y}) == 0) {
        if (dfs(x - 1, y, k - 1)) return true;
    }

    if (valid(x + 1, y) && g[x + 1][y] && used.count({x + 1, y}) == 0) {
        if (dfs(x + 1, y, k - 1)) return true;
    }

    if (valid(x, y - 1) && g[x][y - 1] && used.count({x, y - 1}) == 0) {
        if (dfs(x, y - 1, k - 1)) return true;
    }

    if (valid(x, y + 1) && g[x][y + 1] && used.count({x, y + 1}) == 0) {
        if (dfs(x, y + 1, k - 1)) return true;
    }

    if (k > 0) {
        if (valid(x - 2, y) && g[x - 2][y] && used.count({x - 2, y}) == 0) {
            if (dfs(x - 2, y, k - 1)) return true;
        }

        if (valid(x + 2, y) && g[x + 2][y] && used.count({x + 2, y}) == 0) {
            if (dfs(x + 2, y, k - 1)) return true;
        }

        if (valid(x, y - 2) && g[x][y - 2] && used.count({x, y - 2}) == 0) {
            if (dfs(x, y - 2, k - 1)) return true;
        }

        if (valid(x, y + 2) && g[x][y + 2] && used.count({x, y + 2}) == 0) {
            if (dfs(x, y + 2, k - 1)) return true;
        }

    }
    return false;
}

int main() {
    int k, frx, fry;
    cin >> n >> m >> k;
    g.assign(n, vector<int>(m, 0));
    for (int i = 0; i < n; ++i) {
        string s;
        cin >> s;
        for (int j = 0; j < m; ++j)
            g[i][j] = (s[j] == '.');
    }
    cin >> frx >> fry >> tox >> toy;
    --frx, --fry, --tox, --toy;
    if (dfs(frx, fry, k)) {
        cout << "YES\n";
    } else
        cout << "NO\n";
}
