#include <iostream>
#include <vector>
#include <bitset>

using namespace std;

int n, m;
int tox, toy;
vector<vector<bool>> used;
vector<string> graph;

bool good(int x, int y) {
    return (0 <= x && x < n && 0 <= y && y < m && graph[x][y] == '.');
}

struct State {
    int x;
    int y;
    int l;
};

int main() {

    int k;
    cin >> n >> m >> k;
    graph.resize(n);
    used = vector<vector<bool>>(n, vector<bool>(m));
    string s(m, '.');
    for (int i = 0; i < n; ++i) {
        cin >> graph[i];
    }

    int fx, fy;
    cin >> fx >> fy >> tox >> toy;
    --fx, --fy, --tox, --toy;

    vector<State> dfs;
    dfs.push_back({fx, fy, k});
    while (!dfs.empty()) {
        State cur = dfs.back();
        dfs.pop_back();
        int x = cur.x;
        int y = cur.y;

        if (!good(x, y) || used[x][y])
            continue;
        if (x == tox && y == toy) {
            cout << "YES\n";
            return 0;
        }

        int l = cur.l;
        used[x][y] = true;
            dfs.push_back({x + 1, y, l});
            dfs.push_back({x - 1, y, l});
            dfs.push_back({x, y + 1, l});
            dfs.push_back({x, y - 1, l});
        if (l > 0) {
            l--;
                dfs.push_back({x + 2, y, l});
                dfs.push_back({x - 2, y, l});
                dfs.push_back({x, y + 2, l});
                dfs.push_back({x, y - 2, l});
        }
    }

    cout << "NO";

    return 0;
}