#include <bitset>
#include <iostream>
#include <map>
#include <vector>

using namespace std;

int n, m;
int tox, toy;
vector<string> graph;

bool good(int x, int y) {
    return (0 <= x && x < n && 0 <= y && y < m && graph[x][y] == '.');
}

struct State {
    int x;
    int y;
    int l;
};

map<pair<pair<int, int>, int>, bool> used;

int main() {

    int k;
    cin >> n >> m >> k;
    graph.resize(n);

    for (int i = 0; i < n; ++i) {
        cin >> graph[i];
    }

    int fx, fy;
    cin >> fx >> fy >> tox >> toy;
    --fx, --fy, --tox, --toy;

    vector<State> dfs;
    dfs.push_back({fx, fy, k});
    while (!dfs.empty()) {

        State cur = dfs.back();
        dfs.pop_back();

        int x = cur.x;
        int y = cur.y;
        int l = cur.l;

        if (good(x, y) && !used[{{x, y}, l}]) {
            used[{{x, y}, l}] = true;

            if (x == tox && y == toy) {
                cout << "YES\n";
                return 0;
            }

            dfs.push_back({x + 1, y, l});
            dfs.push_back({x - 1, y, l});
            dfs.push_back({x, y + 1, l});
            dfs.push_back({x, y - 1, l});

            if (l > 0) {
                dfs.push_back({x + 2, y, l - 1});
                dfs.push_back({x - 2, y, l - 1});
                dfs.push_back({x, y + 2, l - 1});
                dfs.push_back({x, y - 2, l - 1});
            }
        }
    }

    cout << "NO";

    return 0;
}