#include <bits/stdc++.h>

using namespace std;

#ifdef DEBUG
#define DEB 1
#else
#define DEB 0
#define cerr \
  if (DEB)   \
  cerr
#endif
#define MTEST() \
  int _t;       \
  cin >> _t;    \
  for (int _tn = 0; _tn < _t; ++_tn)
#define ALL(c) c.begin(), c.end()
#define SZ(c) (int)c.size()

typedef long long ll;

void run_solve();

signed main() {
#if DEB
  assert(freopen("test.in", "r", stdin));
  assert(freopen("test.out", "w", stdout));
#endif
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  cerr.precision(3);
  cerr << fixed;
  int start = (int)clock();
  run_solve();
  double run_time = (double)(clock() - start) / CLOCKS_PER_SEC;
  cerr << "TIME: " << run_time << '\n';
  return 0;
}

const int N = DEB ? 10 : 1007;

int n, m, k;
int dx, dy, ax, ay, s, t;

int decode(int x, int y) {
  return x * n + y;
}

char f[N][N];

void scan() {
  cin >> n >> m >> k;
  for (int i = 0; i < n; ++i) {
    for (int j = 0; j < m; ++j) {
      cin >> f[i][j];
    }
  }
  cin >> dx >> dy >> ax >> ay;
  --dx, --dy, --ax, --ay;
  s = decode(dx, dy);
  t = decode(ax, ay);
}

vector<int> g1[N * N];

void build_g1() {
  for (int i = 0; i < n; ++i) {
    for (int j = 0; j < m; ++j) {
      if (f[i][j] == '#') {
        continue;
      }
      int di[4] = {0, 0, -1, +1};
      int dj[4] = {-1, +1, 0, 0};
      for (int d = 0; d < 4; ++d) {
        int x = i + di[d];
        int y = j + dj[d];
        if (x >= 0 && x < n && y >= 0 && y < m && f[x][y] == '.') {
          g1[decode(i, j)].push_back(decode(x, y));
        }
      }
    }
  }
}

int color[N * N];
int cnt_color = 0;

void dfs1(int v) {
  color[v] = cnt_color;
  for (int u : g1[v]) {
    if (!color[u]) {
      dfs1(u);
    }
  }
}

void part1() {
  build_g1();
  for (int v = 0; v < n * m; ++v) {
    if (!color[v]) {
      ++cnt_color;
      dfs1(v);
    }
  }
}

vector<int> g2[N * N];

void build_g2() {
  for (int i = 0; i < n; ++i) {
    for (int j = 0; j < m; ++j) {
      if (f[i][j] == '#') {
        continue;
      }
      int di[4] = {0, 0, -2, +2};
      int dj[4] = {-2, +2, 0, 0};
      for (int d = 0; d < 4; ++d) {
        int x = i + di[d];
        int y = j + dj[d];
        if (x >= 0 && x < n && y >= 0 && y < m && f[x][y] == '.') {
          g2[color[decode(i, j)]].push_back(color[decode(x, y)]);
        }
      }
    }
  }
}

const int INF = 1e9 + 7;
int dist2[N * N];

int bfs2(int start, int finish) {
  fill(dist2, dist2 + cnt_color + 1, INF);
  queue<int> q;
  dist2[start] = 0;
  q.push(start);
  while (!q.empty()) {
    int v = q.front();
    q.pop();
    for (int u : g2[v]) {
      if (dist2[u] == INF) {
        dist2[u] = dist2[v] + 1;
        q.push(u);
      }
    }
  }
  return dist2[finish];
}

void part2() {
  build_g2();
  int ans = bfs2(color[s], color[t]);
  if (ans <= k) {
    cout << "YES\n";
  } else {
    cout << "NO\n";
  }
}

void run_solve() {
  scan();
  part1();
  part2();
}