#include <iostream>
#include <chrono>
#include <iomanip>  // Для установки точности вывода

int find_gcd(int a, int b) {
    while (b) {
        int temp = b;
        b = a % b;
        a = temp;
    }
    return a;
}

std::pair<int, int> find_first_max_gcd_pair(int L, int R) {
    int max_gcd = 0;
    std::pair<int, int> result_pair;

    for (int x = R; x >= L; x--) {
        for (int y = x - 1; y >= L; y--) {
            int gcd = find_gcd(x, y);

            if (gcd >= max_gcd) {
                max_gcd = gcd;
                result_pair = std::make_pair(x, y);
            }
        }
    }

    return result_pair;
}

int main() {
    int L, R;
    std::cin >> L >> R;

    if (L < R) {
        auto start_time = std::chrono::high_resolution_clock::now();
        std::pair<int, int> first_max_gcd_pair = find_first_max_gcd_pair(L, R);
        auto end_time = std::chrono::high_resolution_clock::now();

        std::cout << first_max_gcd_pair.first << " " << first_max_gcd_pair.second << std::endl;

        auto duration = std::chrono::duration_cast<std::chrono::milliseconds>(end_time - start_time); // Измерение в миллисекундах
        //std::cout << "Execution time: " << std::fixed << std::setprecision(2) << duration.count() / 1000.0 << " seconds" << std::endl; // Вывод времени в секундах с точностью до сотых
    }

    return 0;
}


