package icpc;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;

import static java.lang.Math.max;
import static java.lang.Math.sqrt;

public class F {
	public static void main(String[] args) throws IOException {
		BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
		int n = Integer.parseInt(reader.readLine());
		List<Line> lines = new ArrayList<>();
		Point first = readPoint(reader);
		Point prev = first;
		Point last = first;
		for (int i = 1; i < n; i++) {
			Point next = readPoint(reader);
			lines.add(new Line(prev, next));
			prev = next;
			last = next;
		}
		lines.add(new Line(last, first));
		double maxLen = 0;
		double perim = 0;
		for (Line line : lines) {
			double len = line.length();
			maxLen = max(maxLen, len);
			perim += len;
		}
		System.out.println(String.format("%.7f", perim - maxLen));
	}

	static Point readPoint(BufferedReader reader) throws IOException {
		String[] xy = reader.readLine().split(" ");
		int x = Integer.parseInt(xy[0]);
		int y = Integer.parseInt(xy[1]);
		return new Point(x, y);
	}

	static class Point {
		public double x, y;
		public Point(int x, int y) {
			this.x = x;
			this.y = y;
		}
	}

	static class Line {
		Point a, b;
		Line(Point a, Point b) {
			this.a = a;
			this.b = b;
		}

		public double length() {
			double x = a.x - b.x;
			double y = a.y - b.y;
			return sqrt(x*x + y*y);
		}
	}
}
