package icpc;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.*;

public class H {
	public static void main(String[] args) throws IOException {
		BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
		int q = Integer.parseInt(reader.readLine());
		List<String> names = new ArrayList<>();
		//String tmp = "abcdefghjk";
		for (int i = 0; i < q; i++) {
			names.add(reader.readLine());
			//names.add(tmp);
		}
		solve(names);
	}

	static void solve(List<String> names) {
		Map<String, Integer> namesMap = new HashMap<>();
		for (String name : names) {
			putInMap(namesMap, name);
		}
	}

	static void putInMap(Map<String, Integer> map, String name) {
		if (map.containsKey(name)) {
			int nextVal = map.get(name) + 1;
			while (containsSubstrInMap(map, name + nextVal)) {
				nextVal++;
			}
			map.put(name, nextVal);
			System.out.println(name + nextVal);
		}
		else {
			if (containsSubstrInMap(map, name)) {
				int nextVal = 1;
				while (containsSubstrInMap(map, name + nextVal)) {
					nextVal++;
				}
				map.put(name, nextVal);
				System.out.println(name + nextVal);
			}
			else {
				map.put(name, 0);
				System.out.println(name);
			}
		}
	}

	static boolean containsSubstrInMap(Map<String, Integer> map, String name) {
		if (map.containsKey(name)) return true;
		char[] chars = name.toCharArray();
		int end = chars.length - 1;
		int number = 0;
		int mult = 1;
		while (end > 0 && Character.isDigit(chars[end])) {
			number += mult * (chars[end] - '0');
			if (number == 0) {
				mult *= 10;
				end--;
				continue;
			}

			String newName = String.valueOf(chars, 0, end);
			if (map.containsKey(newName)) {
				if (map.get(newName) >= number) {
					return true;
				}
			}
			mult *= 10;
			end--;
			if (mult == 1000000) break;
		}
		return false;
	}
}
