package icpc;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;
import java.util.Queue;

/**
 * TODO Class Description
 *
 * @author Vladislav Kornilov
 * @since 14.10.2023
 */
public class I {
	public static void main(String[] args) throws IOException {
		BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
		String[] ints = reader.readLine().split(" ");
		int n = Integer.parseInt(ints[0]);
		int m = Integer.parseInt(ints[1]);
		int k = Integer.parseInt(ints[2]);
		List<List<Point>> matrix = new ArrayList<>();
		for (int i = 0; i < n; i++) {
			String line = reader.readLine();
			List<Point> linePoints = new ArrayList<>();
			for (int j = 0; j < line.length(); j++) {
				boolean isWall = line.charAt(j) == '#';
				linePoints.add(new Point(j, i, isWall));
			}
			matrix.add(linePoints);
		}
		ints = reader.readLine().split(" ");
		int y = Integer.parseInt(ints[0]) - 1;
		int x = Integer.parseInt(ints[1]) - 1;
		Point start = matrix.get(y).get(x);
		start.dist = 0;
		start.jumps = 0;
		ints = reader.readLine().split(" ");
		y = Integer.parseInt(ints[0]) - 1;
		x = Integer.parseInt(ints[1]) - 1;
		Point finish = matrix.get(y).get(x);

		Queue<Point> queue = new LinkedList<>();
		queue.add(start);
		while (!queue.isEmpty()) {
			Point curr = queue.remove();
			if (curr == finish) {
				break;
			}
			for (Point point : getNeighborPoints(matrix, curr)) {
				if (point.jumps > curr.jumps) {
					point.jumps = curr.jumps;
					point.dist = curr.dist + 1;
					queue.add(point);
				}
				else if (point.jumps == curr.jumps && point.dist > curr.dist + 1) {
					point.dist = curr.dist + 1;
					queue.add(point);
				}
			}
			if (curr.jumps < k) {
				for (Point point : getNeighborJumpPoints(matrix, curr)) {
					if (point.jumps > curr.jumps + 1) {
						point.jumps = curr.jumps + 1;
						point.dist = curr.dist + 1;
						queue.add(point);
					}
				}
			}
		}
		if (finish.jumps <= k) {
			System.out.println("YES");
		}
		else {
			System.out.println("NO");
		}
	}

	static List<Point> getNeighborPoints(List<List<Point>> matrix, Point point) {
		int[] dx = {-1, 0, 1, 0};
		int[] dy = {0, -1, 0, 1};
		List<Point> neighbors = new ArrayList<>();
		for (int i = 0; i < 4; i++) {
			int x = point.x + dx[i];
			int y = point.y + dy[i];
			if (x >= 0 && y >= 0 && x < matrix.get(0).size() && y < matrix.size()) {
				Point nei = matrix.get(y).get(x);
				if (!nei.isWall) {
					neighbors.add(nei);
				}
			}
		}
		return neighbors;
	}

	static List<Point> getNeighborJumpPoints(List<List<Point>> matrix, Point point) {
		int[] dx = {-2, 0, 2, 0};
		int[] dy = {0, -2, 0, 2};
		List<Point> neighbors = new ArrayList<>();
		for (int i = 0; i < 4; i++) {
			int x = point.x + dx[i];
			int y = point.y + dy[i];
			if (x >= 0 && y >= 0 && x < matrix.get(0).size() && y < matrix.size()) {
				Point nei = matrix.get(y).get(x);
				if (!nei.isWall) {
					neighbors.add(nei);
				}
			}
		}
		return neighbors;
	}

	static class Point {
		int x;
		int y;
		boolean isWall;
		int dist;
		int jumps;

		Point(int x, int y, boolean isWall) {
			this.x = x;
			this.y = y;
			this.isWall = isWall;
			dist = Integer.MAX_VALUE;
			jumps = Integer.MAX_VALUE;
		}
	}
}
