#include <stdio.h>
#include <iostream>
#include <vector>
#include <queue>
using namespace std;

class Point {
public:
    int x;
	int y;
	bool isWall;
	bool visited;
	int jumps;
	
	Point(int x, int y, bool isWall) {
		this->x = x;
		this->y = y;
		this->isWall = isWall;
		this->visited = false;
		this->jumps = 2000000000;
	}
};

vector<Point*> getNeighborPoints(vector<vector<Point*>> matrix, Point* point) {
    int dx[4] = {-1, 0, 1, 0};
	int dy[4] = {0, -1, 0, 1};
	vector<Point*> neighbors;
	for (int i = 0; i < 4; i++) {
	    int x = point->x + dx[i];
	    int y = point->y + dy[i];
	    if (x >= 0 && y >= 0 && x < matrix.size() && y < matrix[0].size()) {
	        Point* nei = matrix[x][y];
	        if (!nei->isWall) {
	            neighbors.push_back(nei);
	        }
	    }
	}
	return neighbors;
}

vector<Point*> getNeighborJumpPoints(vector<vector<Point*>> matrix, Point* point) {
    int dx[4] = {-2, 0, 2, 0};
	int dy[4] = {0, -2, 0, 2};
	vector<Point*> neighbors;
	for (int i = 0; i < 4; i++) {
	    int x = point->x + dx[i];
	    int y = point->y + dy[i];
	    if (x >= 0 && y >= 0 && x < matrix.size() && y < matrix[0].size()) {
	        Point* nei = matrix[x][y];
	        if (!nei->isWall) {
	            neighbors.push_back(nei);
	        }
	    }
	}
	return neighbors;
}

int main()
{
    int n, m, k;
    cin >> n >> m >> k;
    vector<vector<Point*>> matrix(n);
    for (int i = 0; i < n; i++) {
        string line;
        cin >> line;
        vector<Point*> linePoints(m);
        for (int j = 0; j < m; j++) {
            linePoints[j] = new Point(i, j, line[j] == '#');
        }
        matrix[i] = linePoints;
    }
    int x, y;
    cin >> x >> y;
    x--; y--;
    Point* start = matrix[x][y];
    start->visited = true;
    start->jumps = 0;
    cin >> x >> y;
    x--; y--;
    Point* finish = matrix[x][y];
    
    queue<Point*> queue;
    queue.push(start);
    while (!queue.empty()) {
        Point* curr = queue.front();
        queue.pop();
        
        if (curr == finish) {
            break;
        }
        for (Point* point : getNeighborPoints(matrix, curr)) {
            if (point->jumps > curr->jumps) {
                point->jumps = curr->jumps;
                point->visited = true;
                queue.push(point);
            }
            else if (point->jumps == curr->jumps && !point->visited) {
                point->visited = true;
                queue.push(point);
            }
        }
        if (curr->jumps < k) {
            for (Point* point : getNeighborJumpPoints(matrix, curr)) {
                if (point->jumps > curr->jumps + 1) {
                    point->jumps = curr->jumps + 1;
                    point->visited = true;
                    queue.push(point);
                }
            }
        }
    }
    if (finish->jumps <= k) {
		cout << "YES";
	}
	else {
		cout << "NO";
	}

    return 0;
}
