// #pragma GCC optimize("Os")
#pragma GCC optimize("Ofast", "no-stack-protector", "inline")
#pragma comment(linker, "/stack:200000000")
#pragma GCC target("avx,avx2,fma")


#include <bits/stdc++.h>
//#include <ext/rope>

// #include <ext/pb_ds/assoc_container.hpp>
// #include <ext/pb_ds/tree_policy.hpp>
// using namespace __gnu_pbds;

//template<typename T>
// #define ordered_set tree<int, null_type, less_equal<>, rb_tree_tag, tree_order_statistics_node_update>

#define endl "\n"
#define int long long
#define ui unsigned int
#define ll long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define mall(a) a.mutable_begin(), a.mutable_end()
#define X first
#define Y second
#define pii pair<int, int>
#define ull unsigned ll
#define double long double
#define fast ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)

using namespace std;

template<typename T, typename G>
bool rmax(T &a, G b1) {
    T b = static_cast<T>(b1);
    if (a < b) {
        a = b;
        return 1;
    }
    return 0;
}

template<typename T, typename G>
bool rmin(T &a, G b1) {
    T b = static_cast<T>(b1);
    if (b < a) {
        a = b;
        return 1;
    }
    return 0;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &it : a) {
        in >> it;
    }
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, const vector<T> &a) {
    for (auto &it : a) {
        out << it << ' ';
    }
    return out;
}

template<typename T, typename G>
istream& operator>>(istream& in, const pair<T, G> &a) {
    in >> a.X >> a.Y;
    return in;
}

struct node {
    int l;
    int r;
    int sum;
};

const int MAXN = 5e6;
node tree[MAXN];
int ind = 0;

int create_vertex() {
    tree[ind] = {-1, -1, 0};
    return ind++;
}

void update(int v, int tl, int tr, int pos) {
    if (tl >= tr || tl > pos || tr <= pos) {
        return;
    }

    if (tl + 1 == tr) {
        tree[v].sum = 1;
        return;
    }

    int tm = (tl + tr) / 2;
    if (tree[v].l == -1) {
        tree[v].l = create_vertex();
    }

    if (tree[v].r == -1) {
        tree[v].r = create_vertex();
    }

    tree[v].sum = min(tree[tree[v].l].sum, tree[tree[v].r].sum);

    update(tree[v].l, tl, tm, pos);
    update(tree[v].r, tm, tr, pos);
}

int get_mex(int v, int tl, int tr, int l) {
    if (tl >= tr || tr <= l) {
        return -1;
    }

    if (tree[v].sum > 0) {
        return -1;
    }

    if (tl + 1 == tr) {
        return tl;
    }

    int tm = (tl + tr) / 2;
    if (tree[v].l == -1) {
        tree[v].l = create_vertex();
    }

    if (tree[v].r == -1) {
        tree[v].r = create_vertex();
    }

    int pushed = get_mex(tree[v].l, tl, tm, l);
    if (pushed == -1) {
        return get_mex(tree[v].r, tm, tr, l);
    }

    return pushed;
}

void solve() {
    unordered_map<string, unordered_map<string, int>> string_to_tree;
    unordered_set<string> were;


    int n;
    cin >> n;

    while (n--) {
        string f;
        cin >> f;

        string gh = "";

        while (f.size() > 0 && isdigit(f.back())) {
            gh += f.back();
            f.pop_back();
        }

        reverse(all(gh));

        int number = 0;

        for (auto &it : gh) {
            number = number * 10 + it - '0';
        }

        string ans = "";

        if (were.count(f + gh) == 0) {
            number = 0;
            ans = f + gh;
        } else {
            number = get_mex(string_to_tree[f][gh], 0, 1e15, 0);
            ans = f + gh + to_string(number);
        }

        cout << ans << endl;
        were.insert(ans);

        string fg = "";
        if (string_to_tree[f].count("") == 0) {
            string_to_tree[f][""] = create_vertex();
        }

        if (number != 0) {
            gh += to_string(number);
        }
        
        number = 0;

        for (auto &it : gh) {
            number = number * 10 + it - '0';
        }


        update(string_to_tree[f][""], 0, 1e15, number);
        for (int i = 0; i < gh.size(); ++i) {
            fg += gh[i];

            int result = 0;
            for (int j = i + 1; j < gh.size(); ++j) {
                result = result * 10 + gh[j] - '0';
            }


            if (string_to_tree[f].count(fg) == 0) {
                string_to_tree[f][fg] = create_vertex();
            }

            update(string_to_tree[f][fg], 0, 1e15, result);
        }
    }
}
signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

#if defined(LOCAL)
    freopen("./input.txt", "r", stdin);
    freopen("./output.txt", "w", stdout);
#endif

    int t = 1;

    while (t--)
        solve();
}