#include <bits/stdc++.h>
using namespace std;

const long double pi = 3.14159265358979323846264338;

struct point {
    long double x, y;
};

point operator+(const point &a, const point &b) {
    return {a.x + b.x, a.y + b.y};
}

point operator-(const point &a, const point &b) {
    return {a.x - b.x, a.y - b.y};
}

long double dp(const point &a, const point &b) {
    return a.x * b.x + a.y * b.y;
}

long double cp(const point &a, const point &b) {
    return a.x * b.y - a.y * b.x;
}

long double len2(const point &a) {
    return a.x * a.x + a.y * a.y;
}

long double len(const point &a) {
    return sqrtl(a.x * a.x + a.y * a.y);
}

long double len_point_segment(point a, point c, point d) {
    if (dp(a - c, d - c) >= 0 && dp(a - d, c - d) >= 0) {
        return abs(cp(a - c, d - c)) * 1.0 / len(d - c);
    } else
        return min(len(a - c), len(a - d));
}

bool cmp(point p, point c, point d) {
    point a = c - p;
    point b = d - p;
    return cp(a, b) > 0 || (cp(a, b) == 0 && len2(a) < len2(b));
}

bool inside(point p, vector<point> &poly) {
    int b = 0;
    for(size_t i = 0; i < poly.size(); ++i) {
        b += (cp(p  - poly[i], poly[(i + 1) % poly.size()] - poly[i]) > 0);
    }
    return abs(b) % poly.size() == 0;
}


int gi(int i, int n) {
    while (i < 0) {
        i += n;
    }
    return i % n;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n;
    cin >> n;
    vector<point> poly(n);
    for (int i = 0; i < n; ++i) {
        long double x, y;
        cin >> x >> y;
        poly[i] = {x, y};
    }

    vector<point> norms(n);
    long double S = 0, P = 0, x0 = 0, y0 = 0;
    for (int i = 0; i < n; ++i) {
        S += cp(poly[i], poly[(i + 1) % n]);
        P += len(poly[i] - poly[(i + 1) % n]);
        norms[i] = {
            poly[(i + i) % n].y - poly[i].y, poly[i].x - poly[(i + 1) % n].x};
        x0 += poly[i].x;
        y0 += poly[i].y;
    }
    S = abs(S / 2);

    // cout << S << ' ' << P << '\n';

    int q;
    cin >> q;
    vector<point> cities(q);
    for (int i = 0; i < q; ++i) {
        long double x, y;
        cin >> x >> y;
        cities[i] = {x, y};
    }

    // sort(cities.begin(), cities.end(), [x0, y0](point a, point b){return
    // cmp({x0, y0}, a, b);});

    vector<long double> dists(q, 2e9);
    for (int i = 0; i < q; ++i) {
        for (int j = 0; j < n; ++j) {
            dists[i] =
                min(dists[i],
                    len_point_segment(cities[i], poly[j], poly[(j + 1) % n]));
        }
    }

    vector<long double> rs;
    for (unsigned long long i = 0; i < 50; ++i) {
        rs.push_back(
            (-P + sqrtl(P * P + 4 * pi * S * ((1ULL << i) - 1))) / (2 * pi)
        );
        // cout << rs.back() << '\n';
    }

    for (int i = 0; i < q; ++i) {
        for (int j = 0; j < 50; ++j) {
            if(inside(cities[i], poly)) {
                cout << "0\n";
                break;
            }
            if (rs[j] >= dists[i]) {
                cout << j << '\n';
                // cout << dists[i] << ' ' << rs[j] << '\n';
                break;
            }
        }
    }

    return 0;
}