MOD = 10**9 + 7

def roulette_game(N, K, S1, S2, memo={}):
    def helper(n, s):
        if n == 0:
            return 1 if s == 0 else 0
        if (n, s) in memo:
            return memo[(n, s)]
        res = 0
        for i in range(1, K + 1):
            if s - i >= 0:
                res = (res + helper(n - 1, s - i)) % MOD
        memo[(n, s)] = res
        return res

    ways_first = helper(N, S1)
    ways_second = helper(N, S2)

    if ways_first > ways_second:
        return "First"
    elif ways_first < ways_second:
        return "Second"
    else:
        return "Equal"


# Считывание входных данных
N = int(input())
K = int(input())
S1 = int(input())
S2 = int(input())

# Вызов функции и вывод результата
print(roulette_game(N, K, S1, S2))
