from collections import deque

def can_reach_airport(n, m, k, grid, dx, dy, ax, ay):
    visited = [[False] * m for _ in range(n)] # Создаем матрицу посещенных клеток и помечаем все как не посещенные
    queue = deque([(dx, dy, 0)]) # Создаем очередь и добавляем в нее стартовую клетку (dx, dy) с количеством использованных Мегапрыжков равным 0

    while queue:
        x, y, jumps = queue.popleft() # Извлекаем клетку из очереди
        visited[x][y] = True # Помечаем клетку как посещенную

        if x == ax and y == ay: # Если мы достигли аэропорта, возвращаем True
            return "YES"

        if jumps < k: # Если еще есть возможность использовать Мегапрыжок, проверяем соседние клетки (i-2, j), (i+2, j), (i, j-2), (i, j+2)
            for dx, dy in [(2, 0), (-2, 0), (0, 2), (0, -2)]:
                nx, ny = x + dx, y + dy
                if 0 <= nx < n and 0 <= ny < m and grid[nx][ny] == '.' and not visited[nx][ny]:
                    queue.append((nx, ny, jumps + 1))

        # Проверяем соседние клетки (i-1, j), (i+1, j), (i, j-1), (i, j+1)
        for dx, dy in [(1, 0), (-1, 0), (0, 1), (0, -1)]:
            nx, ny = x + dx, y + dy
            if 0 <= nx < n and 0 <= ny < m and grid[nx][ny] == '.' and not visited[nx][ny]:
                queue.append((nx, ny, jumps))

    return "NO" # Если очередь оказывается пустой, значит мы не можем достичь аэропорта

# Считываем входные данные
n, m, k = map(int, input().split())
grid = [input() for _ in range(n)]
dx, dy = map(int, input().split())
ax, ay = map(int, input().split())

# Вызываем функцию и выводим результат
print(can_reach_airport(n, m, k, grid, dx-1, dy-1, ax-1, ay-1))
