from collections import deque

def can_reach_airport(N, M, K, city, start, end):
    dx, dy = start  # координаты общежития
    ax, ay = end  # координаты аэропорта
    
    visited = [[False] * M for _ in range(N)]
    queue = deque()
    queue.append((dx, dy))
    visited[dx-1][dy-1] = True

    while queue:
        x, y = queue.popleft()
        if x == ax and y == ay:
            return "YES"

        directions = [(1, 0), (-1, 0), (0, 1), (0, -1)]
        if K > 0:
            directions.extend([(2, 0), (-2, 0), (0, 2), (0, -2)])

        for dx, dy in directions:
            nx, ny = x + dx, y + dy
            if 0 <= nx < N and 0 <= ny < M and not visited[nx-1][ny-1] and city[nx-1][ny-1] == '.':
                queue.append((nx, ny))
                visited[nx-1][ny-1] = True
                if dx != 0 or dy != 0:
                    K -= 1

    return "NO"


# Чтение входных данных
N, M, K = map(int, input().split())
city = [list(input()) for _ in range(N)]
start = tuple(map(int, input().split()))
end = tuple(map(int, input().split()))

# Вызов функции и вывод результата
result = can_reach_airport(N, M, K, city, start, end)
print(result)
