#include <iostream>
#include <vector>
#include <queue>

using namespace std;

struct Point {
    int x, y, k;
    Point(int x, int y, int k) : x(x), y(y), k(k) {}
};

int main() {
    int N, M, K;
    cin >> N >> M >> K;

    vector<vector<char>> grid(N, vector<char>(M));
    for (int i = 0; i < N; i++) {
        for (int j = 0; j < M; j++) {
            cin >> grid[i][j];
        }
    }

    int dx, dy, ax, ay;
    cin >> dx >> dy >> ax >> ay;
    dx--; dy--; ax--; ay--;

    vector<vector<vector<bool>> > visited(N, vector<vector<bool>>(M, vector<bool>(K + 1, false));
    queue<Point> q;
    q.push(Point(dx, dy, 0));
    visited[dx][dy][0] = true;

    const int dxs[] = {1, -1, 0, 0};
    const int dys[] = {0, 0, 1, -1};

    while (!q.empty()) {
        Point p = q.front();
        q.pop();
        int x = p.x;
        int y = p.y;
        int k = p.k;

        if (x == ax && y == ay) {
            cout << "YES" << endl;
            return 0;
        }

        for (int d = 0; d < 4; d++) {
            int nx = x + dxs[d];
            int ny = y + dys[d];

            if (nx >= 0 && nx < N && ny >= 0 && ny < M) {
                if (grid[nx][ny] == '.' && !visited[nx][ny][k]) {
                    visited[nx][ny][k] = true;
                    q.push(Point(nx, ny, k));
                } else if (k < K) {
                    for (int md = 0; md < 4; md++) {
                        int nnx = nx + dxs[md] * 2;
                        int nny = ny + dys[md] * 2;
                        if (nnx >= 0 && nnx < N && nny >= 0 && nny < M) {
                            if (grid[nnx][nny] == '.' && !visited[nnx][nny][k + 1]) {
                                visited[nnx][nny][k + 1] = true;
                                q.push(Point(nnx, nny, k + 1));
                            }
                        }
                    }
                }
            }
        }
    }

    cout << "NO" << endl;
    return 0;
}