﻿#include <iostream>
#include <vector>
#include <cmath>
#include <iomanip>

using namespace std;

struct Point {
    double x, y;
    Point(double _x, double _y) : x(_x), y(_y) {}
};

double distance(const Point& a, const Point& b) {
    double dx = a.x - b.x;
    double dy = a.y - b.y;
    return sqrt(dx * dx + dy * dy);
}

int main() {
    int n;
    cin >> n;

    vector<Point> coordinates;

    for (int i = 0; i < n; ++i) {
        double x, y;
        cin >> x >> y;
        coordinates.push_back(Point(x, y));
    }

    double perimeter = 0.0;
    double maxSide = 0.0;

    for (int i = 0; i < n; ++i) {
        int next = (i + 1) % n;
        double side = distance(coordinates[i], coordinates[next]);
        perimeter += side;
        if (side > maxSide) {
            maxSide = side;
        }
    }

    double result = perimeter - maxSide;

    cout << fixed << setprecision(6) << result << endl;

    return 0;
}
