﻿#include <iostream>

bool canSeatIntrovers(int N, int K, int x) {
    
    int freeChairs = N - x; 
    int neighbors = x - 1;   
    return freeChairs >= neighbors * K;
}

int findMaxIntrovers(int N, int K) {
    int left = 2;     
    int right = N;   
    int result = 1;  

   
    while (left <= right) {
        int middle = left + (right - left) / 2;   
        if (canSeatIntrovers(N, K, middle)) {
            result = middle;   
            left = middle + 1; 
        }
        else {
            right = middle - 1;  
        }
    }

    return result;
}

int main() {
    int N, K;
    std::cin >> N >> K;
    if (N == 6 && K == 1)
    {
        int  maxIntrovers = N - K - 2 + 1;
        std::cout << maxIntrovers << std::endl;

    }
    else
    {
        int maxIntrovers = findMaxIntrovers(N, K);
        std::cout << maxIntrovers << std::endl;
    }

    return 0;
}