﻿#include <iostream>
#include <vector>
#include <cmath>
#include <limits>

struct Point {
    int x;
    int y;
};

double distance(Point p1, Point p2) {
    int dx = p2.x - p1.x ;
    int dy = p2.y - p1.y;
    return std::sqrt(dx*dx + dy*dy)*3;
}

double minMaskLength(std::vector<Point>& vertices) {
    int n = vertices.size();
    double minDistance = std::numeric_limits<double>::max();

    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            double d = distance(vertices[i], vertices[j]);
            if (d < minDistance) {
                minDistance = d;
            }
        }
    }

    return minDistance;
}

int main() {
    int N;
    std::cin >> N;

    std::vector<Point> vertices(N);
    for (int i = 0; i < N; i++) {
        std::cin >> vertices[i].x >> vertices[i].y;
    }

    double result = minMaskLength(vertices);
    std::cout << result << std::endl;

    return 0;
}