"""
            11
            fst     fst
            lem     lem
            fst     fst1
            fst     fst2
            margot  margot
            Margot  Margot
            margot  margot1
            fst2    fst21
            lem1    lem1
            lem1    lem12
            lem     lem2

            n: 11
            fst
                fst
            lem
                lem
            fst
                fst1
            fst
                fst2
            margot
                margot
            Margot
                Margot
            margot
                margot1
            fst2
                fst2
            lem1
                lem1
            lem1
                lem11
            lem
                lem1
"""

"""
            n: 11
            fst
                fst
            lem
                lem
            fst
                fst1
            fst
                            Found user: fst
                            User already registered, appendPostfix=True
                fst
            margot
            New user: margot
            margot
            Margot
            New user: Margot
            Margot
            margotf
            Found user: margot
            User already registered just appendPostfix current
            margot1
            fst2
            New user: fst2
            fst2
            lem1
            New user: lem1
            lem1
            lem1
            Found user: lem1
            User already registered just appendPostfix current
            lem11
            lem
            Found user: lem
            User already registered just appendPostfix current
            lem1

"""


class User:
    def __init__(self, username):
        self.username = username
        self.postfix = ""

    def appendPostfix(self):
        if self.postfix == "":
            self.postfix = "1"
        else:
            self.postfix = str(int(self.postfix) + 1)

    def getUsername(self):
        return str(self.username + self.postfix)


class Chat:
    def __init__(self):
        self.users = list()

    def findUser(self, username, withPostfix=False):
        for user in self.users:
            if withPostfix:
                if user.getUsername() == username:
                    return user
            else:
                if user.username == username:
                    return user

        return None

    def appendUsers(self, username, appendPostfix: bool = False):
        user = User(username)
        self.users.append(user)
        return user

    def registerUser(self, username):
        user = self.findUser(username)
        if user is None:
            return self.appendUsers(username).getUsername()
        else:
            postfix = 1
            while True:
                updated_username = f"{username}{postfix}"
                if self.findUser(updated_username) is None:
                    return self.appendUsers(updated_username, appendPostfix=True).getUsername()
                postfix += 1


def main():
    chat = Chat()
    n = int(input())

    for i in range(n):
        username = input()
        user = chat.registerUser(username)
        print(user)


if __name__ == "__main__":
    main()
