"""
            11
            fst     fst
            lem     lem
            fst     fst1
            fst     fst2
            margot  margot
            Margot  Margot
            margot  margot1
            fst2    fst21
            lem1    lem1
            lem1    lem12
            lem     lem2
"""


class User:
    def __init__(self, username):
        self.username = username
        self.postfix = ""

    def appendPostfix(self):
        if self.postfix == "":
            self.postfix = "1"
        else:
            self.postfix = str(int(self.postfix) + 1)

    def getUsername(self):
        return str(self.username + self.postfix)


class Chat:
    def __init__(self):
        self.users = {}

    def findUser(self, username, withPostfix=False):
        if withPostfix:
            return self.users.get(username)
        else:
            for user in self.users.values():
                if user.username == username:
                    return user
        return None

    def appendUsers(self, username, appendPostfix: bool = False):
        user = User(username)
        self.users[username] = user
        return user

    def registerUser(self, username):
        user = self.findUser(username)
        if user is None:
            return self.appendUsers(username).getUsername()
        else:
            postfix = 1
            while True:
                updated_username = f"{username}{postfix}"
                if self.findUser(updated_username) is None:
                    return self.appendUsers(updated_username, appendPostfix=True).getUsername()
                postfix += 1


def main():
    chat = Chat()
    n = int(input())

    for i in range(n):
        username = input()
        user = chat.registerUser(username)
        print(user)


if __name__ == "__main__":
    main()
