class User:
    def __init__(self, username):
        self.username = username
        self.postfix = 0

    def appendPostfix(self):
        self.postfix += 1

    def getUsername(self):
        if self.postfix == 0:
            return self.username
        else:
            return f"{self.username}{self.postfix}"


class Chat:
    def __init__(self):
        self.users = {}

    def findUser(self, username, withPostfix=False):
        if withPostfix:
            return self.users.get(username)
        else:
            for user in self.users.values():
                if user.username == username:
                    return user
        return None

    def appendUsers(self, username, appendPostfix: bool = False):
        user = User(username)
        self.users[username] = user
        return user

    def registerUser(self, username):
        user = self.findUser(username)
        if user is None:
            return self.appendUsers(username).getUsername()
        else:
            while True:
                user.appendPostfix()
                updated_username = user.getUsername()
                if self.findUser(updated_username) is None:
                    return self.appendUsers(updated_username, appendPostfix=True).getUsername()


def main():
    chat = Chat()
    n = int(input())

    for i in range(n):
        username = input()
        user = chat.registerUser(username)
        print(user)


if __name__ == "__main__":
    main()