﻿#include <iostream>
#include <cmath>
#include <vector>

struct point
{
      int x;
      int y;
      point(int x,int y);
};
point::point(int x, int y):x(x),y(y)
{}

double countDistance(point p1, point p2)
{
    return sqrt(pow(p1.x - p2.x, 2) + pow(p1.y - p2.y, 2));
}
int main()
{
    int n;
    std::cin >> n;
    std::vector<point> points;
    for (int i = 0; i < n; i++)
    {
        int x, y;
        std::cin >> x >> y;
        points.push_back(point(x, y));
    }
    std::vector<double> distances;
    for (int i = 0; i < n-1; i++)
    {
        distances.push_back(countDistance(points[i] , points[i + 1]));
    }
    distances.push_back(countDistance(points[n - 1], points[0]));
    double max = 0.0,result =0.0;
    for (auto d : distances)
    {
        if (d >= max)
        {
            max = d;
        }
        result += d;
    }
    std::cout << result - max;
}