import math

def distance(x1, y1, x2, y2):
    return math.sqrt((x1 - x2) ** 2 + (y1 - y2) ** 2)

def minimum_bounding_circle(points):
    n = len(points)
    if n == 1:
        return 0.0

    min_radius = float('inf')

    for i in range(n):
        for j in range(i + 1, n):
            # Рассматриваем пару точек (i, j) как возможный диаметр круга
            x1, y1 = points[i]
            x2, y2 = points[j]

            # Находим центр круга, который проходит через точки i и j
            center_x = (x1 + x2) / 2
            center_y = (y1 + y2) / 2
            radius = distance(x1, y1, center_x, center_y)

            # Проверяем, что этот круг охватывает все остальные точки
            is_valid = True
            for k in range(n):
                if k != i and k != j and distance(center_x, center_y, points[k][0], points[k][1]) > radius:
                    is_valid = False
                    break

            if is_valid:
                min_radius = min(min_radius, radius)

    return 2.0 * min_radius  # Умножаем радиус на 2, чтобы получить длину маски

# Ввод данных
N = int(input())
points = []
for _ in range(N):
    x, y = map(int, input().split())
    points.append((x, y))

# Вызываем функцию и выводим результат
result = minimum_bounding_circle(points)
print(result)
