#include <iostream>
#include <vector>
#include <math.h>

struct Piece {
	int s, a;
};

int compare(const void *x, const void *y) {
	const Piece * first = (const Piece *) x;
	const Piece * second = (const Piece *) y;
	return first->s - second->s;
}

int main(){
	int n = 0, k = 0;
	std::vector<Piece> pieces;
	
	std::cin >> n >> k;
	pieces.resize(n);
	
	for (int i = 0; i < n; i++) {
		std::cin >> pieces[i].s;
	}
	for (int i = 0; i < n; i++) {
		std::cin >> pieces[i].a;
	}
	
	std::qsort(
		pieces.data(),
		pieces.size(),
		sizeof(Piece),
		compare
	);
	
	float deviation = 0;
	int steps = 0;
	
	for (int i = 0; i < n; i++) {
		deviation += (float)std::abs(pieces[i].s - pieces[i].a) / pieces[i].s;
	}

	for (int i = 0; i < n; i++) {
		while (pieces[i].a != pieces[i].s && deviation > k) {
			if (pieces[i].a < pieces[i].s) {
				pieces[i].a++;
			}
			else {
				pieces[i].a--;
			}
			steps++;
			deviation -= 1/pieces[i].s;
		}
	}
	
	std::cout << steps;
	
	return 0;
}
