from collections import deque


def bfs(matrix, N, M, K, start, end):
    visited = [[[False] * (K + 1) for _ in range(M)] for _ in range(N)]
    directions = [(0, 1), (1, 0), (0, -1), (-1, 0)]
    jumps = [(0, 2), (2, 0), (0, -2), (-2, 0)]

    queue = deque([(start[0], start[1], K)])
    visited[start[0]][start[1]][K] = True

    while queue:
        x, y, k = queue.popleft()
        if (x, y) == end:
            return "YES"

        for dx, dy in directions:
            nx, ny = x + dx, y + dy
            if 0 <= nx < N and 0 <= ny < M and not visited[nx][ny][k] and matrix[nx][ny] == '.':
                visited[nx][ny][k] = True
                queue.append((nx, ny, k))

        if k > 0:
            for dx, dy in jumps:
                nx, ny = x + dx, y + dy
                if 0 <= nx < N and 0 <= ny < M and not visited[nx][ny][k - 1] and matrix[nx][ny] == '.':
                    visited[nx][ny][k - 1] = True
                    queue.append((nx, ny, k - 1))

    return "NO"


def parse_input_and_solve():
    N, M, K = map(int, input().split())

    matrix = [input().strip() for _ in range(N)]

    dx, dy = map(int, input().split())
    ax, ay = map(int, input().split())

    start = (dx - 1, dy - 1)
    end = (ax - 1, ay - 1)

    print(bfs(matrix, N, M, K, start, end))


if __name__ == "__main__":
    parse_input_and_solve()