#include <bitset>
#include <iostream>
#include <ratio>
#include <queue>
using namespace std;
#define int int64_t
#define fi first
#define se second
#define pb push_back
#define ins insert
#define ers erase
typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;


int n, m;

vector <pair<int, int>> used;
vector<vector<char>> field;
queue<int> new_start;
queue<int> new_start2;
bitset<10001> zero;

int idxy(int x, int y) {
    return m * x + y;
}

pair <int, int> rev_id(int id) {
    return {id / m, id % m};
}

const int moves[4][2] = {{1, 0}, {0, 1}, {-1, 0}, {0, -1}};
const int moves2[4][2] = {{2, 0}, {0, 2}, {-2, 0}, {0, -2}};

bool inBoard(int x, int y) {
    return (x > 0 && x <= n) && (y >= 0 && y < m) && field[x][y + 1] == '.';
}

int f_x, f_y;

int f_id;

bool dfs(int v, int flag) {
    auto[x, y] = rev_id(v);
    used[v] = {1, flag};
    for (auto [move_x, move_y] : moves) {
        int new_x = move_x + x;
        int new_y = move_y + y;
        int new_id = idxy(new_x, new_y);
        if (new_id == f_id) {
            return true;
        }
        if (inBoard(new_x, new_y) && !used[new_id].first) {
            dfs(new_id, flag);
        }
    }
    for (auto [move_x, move_y] : moves2) {
        int new_x = move_x + x;
        int new_y = move_y + y;
        int new_id = idxy(new_x, new_y);
        if (inBoard(new_x, new_y) && !used[new_id].first) {
            new_start2.push(new_id);
        }
    }
    return false;
}

bool dfs_easy(int v, int flag) {
    auto[x, y] = rev_id(v);
    used[v] = {1, flag};
    for (auto [move_x, move_y] : moves) {
        int new_x = move_x + x;
        int new_y = move_y + y;
        int new_id = idxy(new_x, new_y);
        if (new_id == f_id) {
            return true;
        }
        if (inBoard(new_x, new_y) && !used[new_id].first) {
            dfs(new_id, flag);
        }
    }
    return false;
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int k;
    cin >> n >> m >> k;
    field.resize(n + 1, vector<char>(m + 1));
    used.resize(n * m + m + 1);
    int s_x, s_y;

    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            cin >> field[i][j];
        }
    }
    cin >> s_x >> s_y;
    cin >> f_x >> f_y;
    f_id = idxy(f_x, f_y);
    bool flag = dfs(idxy(s_x, s_y), 0);
    k--;
    if (!used[idxy(f_x, f_y)].first && k > 0) {
        swap(new_start, new_start2);
        // new_start.push(idxy(f_x, f_y));
        // for (auto [move_x, move_y] : moves2) {
        //     int newf_x = move_x + f_x;
        //     int newf_y = move_y + f_y;
        //     int newf_id = idxy(newf_x, newf_y);
        //     if (inBoard(newf_x, newf_y) && !used[newf_id].first) {
        //         new_start.push(newf_id);
        //     }
        //     else if (inBoard(newf_x, newf_y) && used[newf_id].second == 0) {
        //         cout << "YES\n";
        //         return 0;
        //     }
        // }
        // k--;
        while (true) {
            while (k >= 0 && !new_start.empty() && !flag) {
                int id = new_start.front();
                auto [x, y] = rev_id(id);
                new_start.pop();
                int new_id = idxy(x, y);
                if (inBoard(x, y) && !used[new_id].first) {
                    flag = dfs(new_id, k);
                    if (flag) break;
                }
            }
            k--;
            if (new_start2.empty() || flag){
                break;
            }
            if (k == -1) {
                break;
            }
            swap(new_start, new_start2);
        }
    }
    else if (used[idxy(f_x, f_y)].first) {
        flag = 1;
    }
    if (!flag && !used[idxy(f_x, f_y)].first) {
        cout << "NO\n";
    }
    else {
        cout << "YES\n";
    }
    return 0;
}


/*
3 3 1
.#.
#.#
.#.
1 1
3 3

2 2 0
#.
..
1 2
2 1

2 5 2
.#.#.
###..
1 1
2 4

*/