#include <iostream>
#include <algorithm>

int euclidean_algorithm(int a, int b) {
    while (b) {
        a = a % b;
        std::swap(a, b);
    }
    return a;
}

std::pair<int, int> find_pair_with_max_gcd(int L, int R) {
    int max_gcd = 1;
    std::pair<int, int> result_pair = std::make_pair(L, L + 1);

    for (int x = L; x <= R; x++) {
        for (int y = x + 1; y <= R; y++) {
            int gcd = euclidean_algorithm(x, y);
            if (gcd > max_gcd) {
                max_gcd = gcd;
                result_pair = std::make_pair(x, y);
            }
        }
    }

    return result_pair;
}

int main() {
    int L, R;
    std::cin >> L >> R;

    std::pair<int, int> result = find_pair_with_max_gcd(L, R);
    std::cout << result.first << " " << result.second << std::endl;

    return 0;
}
