#include <iostream>
#include <unordered_map>
#include <string>
using namespace std;

struct Node {
    unordered_map<char, Node*> children;
};

class Trie {
private:
    Node* root;

public:
    Trie() {
        root = new Node();
    }

    string insert(string word) {
        Node* current = root;
        string originalWord = word;
        int suffix = 1;

        while (current->children.find(word[0]) != current->children.end()) {
            word = originalWord + to_string(suffix);
            suffix++;
        }

        for (char ch : word) {
            if (current->children.find(ch) == current->children.end()) {
                current->children[ch] = new Node();
            }
            current = current->children[ch];
        }

        return word;
    }
};

int main() {
    Trie trie;
    int n;
    cin >> n;

    for (int i = 0; i < n; i++) {
        string sb;
        cin >> sb;
        string result = trie.insert(sb);
        cout << result << endl;
    }

    return 0;
}
