from collections import deque

N, M, K = map(int, input().split())
city = [input().strip() for _ in range(N)]
dx, dy = map(int, input().split())  
ax, ay = map(int, input().split())  

def is_valid(x, y):
    return 1 <= x <= N and 1 <= y <= M and city[x - 1][y - 1] == '.'

def can_reach_destination():
    queue = deque([(dx, dy, 0)])  
    visited = set([(dx, dy, 0)])  

    while queue:
        x, y, jumps = queue.popleft()

        if (x, y) == (ax, ay):
            return "YES"

        for i, j in [(0, 1), (1, 0), (0, -1), (-1, 0)]:
            new_x, new_y = x + i, y + j
            if is_valid(new_x, new_y) and (new_x, new_y, jumps) not in visited:
                queue.append((new_x, new_y, jumps))
                visited.add((new_x, new_y, jumps))

        if jumps < K:
            for i, j in [(0, 2), (2, 0), (0, -2), (-2, 0)]:
                new_x, new_y = x + i, y + j
                if is_valid(new_x, new_y) and (new_x, new_y, jumps + 1) not in visited:
                    queue.append((new_x, new_y, jumps + 1))
                    visited.add((new_x, new_y, jumps + 1))

    return "NO"

print(can_reach_destination())
