from collections import deque

N, M, K = map(int, input().split())
city = [input().strip() for _ in range(N)]
dx, dy = map(int, input().split())
ax, ay = map(int, input().split())

def is_valid(x, y):
    return 1 <= x <= N and 1 <= y <= M and city[x - 1][y - 1] == '.'

def can_reach_destination():
    queue = deque([(dx, dy, 0)])
    visited = [[False for _ in range(M)] for _ in range(N)]
    visited[dx - 1][dy - 1] = True

    while queue:
        x, y, jumps = queue.popleft()

        if (x, y) == (ax, ay):
            return "YES"

        for i, j in [(0, 1), (1, 0), (0, -1), (-1, 0)]:
            new_x, new_y = x + i, y + j
            if is_valid(new_x, new_y) and not visited[new_x - 1][new_y - 1]:
                queue.append((new_x, new_y, jumps))
                visited[new_x - 1][new_y - 1] = True

        if jumps < K:
            for i, j in [(0, 2), (2, 0), (0, -2), (-2, 0)]:
                new_x, new_y = x + i, y + j
                if is_valid(new_x, new_y) and not visited[new_x - 1][new_y - 1]:
                    queue.append((new_x, new_y, jumps + 1))
                    visited[new_x - 1][new_y - 1] = True

    return "NO"

print(can_reach_destination())
