from collections import defaultdict

# Чтение входных данных
N = int(input())
parents_a = list(map(int, input().split()))
parents_b = list(map(int, input().split()))

# Построение дерева a и b
tree_a = defaultdict(list)
tree_b = defaultdict(list)

for i in range(N - 1):
    tree_a[parents_a[i]].append(i + 1)
    tree_b[parents_b[i]].append(i + 1)

# Результаты операций
operations = []

# Рекурсивная функция для поиска изоморфизма
def find_isomorphism(v_a, v_b):
    global operations
    operations.append((v_a + 1, v_b + 1))  # +1 для приведения к единому индексу (начиная с 1)
    
    # Рекурсивный вызов для всех детей вершины в дереве a
    children_a = tree_a[v_a]
    children_b = tree_b[v_b]
    
    for child_a, child_b in zip(children_a, children_b):
        find_isomorphism(child_a, child_b)

# Начинаем с корня дерева a и b
find_isomorphism(0, 0)

# Вывод результатов
print(len(operations))
for operation in operations:
    print(operation[0], operation[1])
