#pragma GCC optimize("Ofast")
#pragma comment(linker, "/stack:200000000")

#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>
#include <stack>
#include <queue>
#include <deque>
#include <random>
#include <bitset>
#include <cstdio>
#include <map>
#include <iomanip>

using namespace std;

mt19937 rnd(239);

long long sqr(int x) {
  return 1ll * x * x;
}

int main(void) {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  long long n, k;
  cin >> n >> k;
  vector<pair<int, int>> el(n);
  for (int i = 0; i < n; i++) {
    cin >> el[i].first;
  }
  for (int i = 0; i < n; i++) {
    cin >> el[i].second;
  }
  sort(el.begin(), el.end());

  const long long T = 3628800ll;
  k *= T;

  long long cur = 0;

  for (int i = 0; i < n; i++) {
    cur += T / el[i].first * abs(el[i].second - el[i].first);
  }

  long long ans = 0;

  if (cur <= k) {
    cout << 0;
    return 0;
  }

  for (int i = 0; i < n; i++) {
    long long get = cur - T / el[i].first * abs(el[i].second - el[i].first);
    if (get <= k) {
      long long L = 0, R = el[i].second - el[i].first;
      while (R - L > 1) {
        long long M = (L + R) / 2;
        if (cur - T / el[i].first * (abs(el[i].second - el[i].first) - M) <= k) {
          R = M;
        }
        else {
          L = M;
        }
      }
      ans += R;
      break;
    }
    else {
      cur -= T / el[i].first * abs(el[i].second - el[i].first);
      ans += el[i].second - el[i].first;
    }
  }

  cout << ans;
}