#pragma GCC optimize("Ofast")
#pragma comment(linker, "/stack:200000000")

#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>
#include <stack>
#include <queue>
#include <deque>
#include <random>
#include <bitset>
#include <cstdio>
#include <iomanip>

using namespace std;

mt19937 rnd(239);

long long sqr(int x) {
  return 1ll * x * x;
}

int main(void) {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  int n;
  cin >> n;
  vector<int>x(n), y(n);
  for (int i = 0; i < n; i++) {
    cin >> x[i] >> y[i];
  }
  double dist = 0;
  for (int i = 0; i < n; i++) {
    int x0 = x[i];
    int x1 = x[(i + 1) % n];
    int y0 = y[i];
    int y1 = y[(i + 1) % n];

    dist += sqrt(sqr(x0 - x1) + sqr(y0 - y1));
  }

  double min_dist = dist;

  for (int i = 0; i < n; i++) {
    int x0 = x[i];
    int x1 = x[(i + 1) % n];
    int y0 = y[i];
    int y1 = y[(i + 1) % n];

    double cur = sqrt(sqr(x0 - x1) + sqr(y0 - y1));;

    if (dist - cur < min_dist) {
      min_dist = dist - cur;
    }
  }

  cout << fixed << setprecision(40) << min_dist;
}