

// === HEAD === 

#ifndef HEAD_H
#define HEAD_H

#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
#define pb emplace_back
#define mp make_pair
#define fi first
#define se second
#define all(x) (x).begin(), (x).end()
#define in(x); { for (auto &i : x) cin >> i; }
#define out(x); { for (auto &i : x) cout << i << ' '; cout << endl; }
 
using namespace std;
using namespace __gnu_cxx;
using namespace __gnu_pbds;
 
typedef long long ll;
typedef unsigned long long ull;
typedef pair <int, int> pii;
typedef pair <long long, long long> pll;
typedef vector <int> vi;
typedef vector <long long> vll;
typedef vector <vector <int>> vvi;
typedef vector <pair <int, int>> vii;
typedef tree <int, null_type, less <int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
 
const int INF = 2e9;
const long long INFll = 1e18;
const long double eps = 1e-8;
const long double pi = acos(-1);

template<typename T>
T input() {
    T obj;
    cin >> obj;
    return obj;
}

template<typename T>
vector<T> input(int count) {
    vector<T> vec(count);
    for (T& obj : vec)
        obj = input<T>();
    return vec;
}

template<typename T>
T divup(T a, T b) {
    return (a + b - 1) / b;
}

void solve();

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int t = 1;

#ifdef MULTITEST_H
    cin >> t;
#endif // MULTITEST_H

    while (t--) {
        solve();
    }
}

#endif // HEAD_H


// === MAIN === 


struct pointll {
    long long x, y;

    pointll operator + (const pointll &b) const {
        pointll c = {x + b.x, y + b.y};
        return c;
    }

    pointll operator - (const pointll &b) const {
        pointll c = {x - b.x, y - b.y};
        return c;
    }

    pointll operator * (const double &k) const {
        pointll c = {x * k, y * k};
        return c;
    }

    pointll operator / (const double &k) const {
        pointll c = {x / k, y / k};
        return c;
    }

    ll operator * (const pointll &b) const {
        return x * b.x + y * b.y;
    }

    ll operator / (const pointll &b) const {
        return x * b.y - y * b.x;
    }

    bool operator == (const pointll &b) const {
        return (max(abs(x - b.x), abs(y - b.y)) < eps);
    }

    bool line(const pointll &a, const pointll &b) const {
        pointll v1 = {a.x - x, a.y - y};
        pointll v2 = {b.x - x, b.y - y};

        return((v1 / v2) == 0);
    }

    bool in_ray(pointll a, pointll b) const {
        pointll P = {x, y};
        return (P - a) * (b - a) >= 0 && (P - a) / (b - a) == 0;
    }

    bool between(const pointll &a, const pointll &b) const {
        pointll v1 = {a.x - x, a.y - y};
        pointll v2 = {b.x - x, b.y - y};

        //assert((v1 ^ v2) == 0);
        if ((v1 / v2) != 0)
            return false;

        return ((v1 * v2) <= 0);
    }

    bool in_angle(pointll a, pointll o, pointll b) const {
        pointll p = {x, y};

        a = a - o;
        b = b - o;
        p = p - o;

        if ((a / b) < 0)
            swap(a, b);

        return ((a / p) >= 0 && (p / b) >= 0);
    }

    bool in_convex(vector <pointll> &v) const {
        if (in_angle(v[v.size() - 1], v[0], v[1]) == false)
            return false;

        pointll p = {x, y};

        int l = 1, r = v.size();
        while (r - l > 1) {
            int m = (l + r) / 2;
            if (((v[m] - v[0]) / (p - v[0])) > 0)
                l = m;
            else
                r = m;
        }

        return (((v[(l + 1) % v.size()] - v[l]) / (p - v[l])) >= 0);
    }
};

struct point {
    long double x, y;

    point operator + (const point &b) const {
        point c = {x + b.x, y + b.y};
        return c;
    }

    point operator - (const point &b) const {
        point c = {x - b.x, y - b.y};
        return c;
    }

    point operator * (const double &k) const {
        point c = {x * k, y * k};
        return c;
    }

    point operator / (const double &k) const {
        point c = {x / k, y / k};
        return c;
    }

    ll operator * (const point &b) const {
        return x * b.x + y * b.y;
    }

    ll operator / (const point &b) const {
        return x * b.y - y * b.x;
    }

    bool operator == (const point &b) const {
        return (max(abs(x - b.x), abs(y - b.y)) < eps);
    }

    bool line(const point &a, const point &b) const {
        point v1 = {a.x - x, a.y - y};
        point v2 = {b.x - x, b.y - y};

        return((v1 / v2) == 0);
    }

    bool in_ray(point a, point b) const {
        point P = {x, y};
        return (P - a) * (b - a) >= 0 && (P - a) / (b - a) == 0;
    }

    bool between(const point &a, const point &b) const {
        point v1 = {a.x - x, a.y - y};
        point v2 = {b.x - x, b.y - y};

        //assert((v1 ^ v2) == 0);
        if ((v1 / v2) != 0)
            return false;

        return ((v1 * v2) <= 0);
    }

    bool in_angle(point a, point o, point b) const {
        point p = {x, y};

        a = a - o;
        b = b - o;
        p = p - o;

        if ((a / b) < 0)
            swap(a, b);

        return ((a / p) >= 0 && (p / b) >= 0);
    }

    bool in_convex(vector <point> &v) const {
        if (in_angle(v[v.size() - 1], v[0], v[1]) == false)
            return false;

        point p = {x, y};

        int l = 1, r = v.size();
        while (r - l > 1) {
            int m = (l + r) / 2;
            if (((v[m] - v[0]) / (p - v[0])) > 0)
                l = m;
            else
                r = m;
        }

        return (((v[(l + 1) % v.size()] - v[l]) / (p - v[l])) >= 0);
    }

    double length() const {
        return sqrt(x * x + y * y);
    }

    long double sqrlen() const {
        return (x * x + y * y);
    }

    double dist(point a, point b) const {
        point v1 = {a.x - x, a.y - y};
        point v2 = {b.x - x, b.y - y};

        return abs((v1 / v2) / (a - b).length());
    }

    double seg_dist(point a, point b) const {
        point v1 = {a.x - x, a.y - y};
        point v2 = {b.x - x, b.y - y};
        point ab = a - b;

        if (a == b)
            return v1.length();

        if (v1.sqrlen() > ab.sqrlen() + v2.sqrlen())
            return v2.length();
        if (v2.sqrlen() > ab.sqrlen() + v1.sqrlen())
            return v1.length();
        return dist(a, b);
    }

    double line_dist(double a, double b, double c) const {
        return (abs(a * x + b * y + c) / sqrt(a * a + b * b));
    }

    double ray_dist(point a, point b) const {
        point v = {x - a.x, y - a.y};
        point u = b - a;

        if (v * u < 0) {
            return v.length();
        }

        return dist(a, b);
    }

    long double dir() const {
        return atan2(y, x);
    }

    long double ldir() const {
        return (dir() > 0 ? dir() : dir() + pi);
    }
};

point rotate_left(point V) {
    point U = {- V.y, V.x};
    return U;
}

point rotate_right(point V) {
    point U = {V.y, - V.x};
    return U;
}

int sign_dot(point a, point b) {
    if (a * b > 0)
        return 1;
    if (a * b < 0)
        return -1;
    return 0;
}

int sign_cross(point a, point b) {
    if ((a / b) > 0)
        return 1;
    if ((a / b) < 0)
        return -1;
    return 0;
}

bool AB_between_CandD(point A, point B, point C, point D) {
    return (sign_cross(D - A, B - A) * sign_cross(C - A, B - A) == -1);
}

int sign(ll x) {
    if (x > 0)
        return 1;
    if (x < 0)
        return -1;
    return 0;
}

pointll p_in() {
    long long x, y; cin >> x >> y;
    pointll p = {x, y};
    return p;
}

point mc(point P1, double k1, point P2, double k2) {
    assert(abs(k1 + k2) >= eps);
    point Q;
    Q.x = (P1.x * k1 + P2.x * k2) / (k1 + k2);
    Q.y = (P1.y * k1 + P2.y * k2) / (k1 + k2);
    return Q;
}

void p_out(point X) {
    cout << fixed << setprecision(9) << X.x << ' ' << X.y << endl;
}

bool segAB_cross_segCD(point A, point B, point C, point D) {
    if (A == B) {
        if (!A.line(C, D))
            return false;
    }

    if (C == D) {
        if (!C.line(A, B))
            return false;
    }

    if (A.line(C, D) && B.line(C, D)) {
        if (A.between(C, D) || B.between(C, D) || C.between(A, B) || D.between(A, B))
            return true;
        return false;
    }

    if (sign_cross(D - C, A - C) * sign_cross(D - C, B - C) <= 0 && sign_cross(B - A, C - A) * sign_cross(B - A, D - A) <= 0)
        return true;
    return false;
}

bool rayAB_cross_segCD(point A, point B, point C, point D) {
    if (C.line(A, B) && D.line(A, B))
        return C.in_ray(A, B) || D.in_ray(A, B);

    if (C.line(A, B))
        return C.in_ray(A, B);

    if (D.line(A, B))
        return D.in_ray(A, B);

    if (sign_cross(B - A, C - A) * sign_cross(B - A, D - A) == 1) return false;
    if ((B - A) / (D - A) <= 0)
        return (C - D) / (A - D) >= 0;
    if ((B - A) / (C - A) <= 0)
        return (D - C) / (A - C) >= 0;
}

double seg_dist2(point A, point B, point C, point D) {
    if (segAB_cross_segCD(A, B, C, D))
        return 0.0;
    return min(min(A.seg_dist(C, D), B.seg_dist(C, D)), min(C.seg_dist(A, B), D.seg_dist(A, B)));
}

double abs_angle(point a, point b) {
    return abs(atan2(a / b, a * b));
}

long long S2(vector <point> v) {
    v.pb(v[0]);
    long long ans = 0;
    for (int i = 0; i < (int)v.size() - 1; i++)
        ans += (v[i] / v[i + 1]);
    return abs(ans);
}

point pbd(double phi) {
    point V;
    V.x = cos(phi);
    V.y = sin(phi);
    return V;
}

point line_cross(point P1, point D1, point P2, point D2) {
    long double a1 = D1.y, b1 = - D1.x, c1 = D1 / P1;
    long double a2 = D2.y, b2 = - D2.x, c2 = D2 / P2;

    point C;
    C.x = (c2 * b1 - c1 * b2) / (b2 * a1 - b1 * a2);
    C.y = (c2 * a1 - c1 * a2) / (a2 * b1 - a1 * b2);
    return C;
}

struct rpoint {
    point p;
    const point* center;
};

vector<rpoint> expand(const vector<point>& polygon, long double d) {
    vector<rpoint> expanded;
    for (int i = 0; i < polygon.size(); i++) {
        point segment = polygon[(i + 1) % polygon.size()] - polygon[i];
        point mv = rotate_right(segment) / segment.length() * d;
        expanded.push_back({ polygon[i] + mv, nullptr });
        expanded.push_back({ polygon[(i + 1) % polygon.size()] + mv, &polygon[(i + 1) % polygon.size()] });
    }
    return expanded;
}

long double dist_to_expand(const vector<point>& polygon, long double S_to_add) {
    long double a = pi;

    long double b = 0;
    for (int i = 0; i < polygon.size(); i++) {
        point segment = polygon[(i + 1) % polygon.size()] - polygon[i];
        b += segment.length();
    }

    long double c = - S_to_add;

    long double D = b * b - 4 * a * c;
    return (-b + sqrt(D)) / (2 * a);
}

bool point_in_segment(point p, point center, point begin, point end) {
    return (p - center).length() < (begin - center).length() + eps
        && p.in_angle(begin, center, end)
        && !p.in_angle(center, begin, end);
}

bool point_in_triangle(point p, point a, point b, point c) {
    if ((a - b).length() > eps && (b - c).length() > eps && (c - a).length() > eps)
        return p.in_angle(a, b, c) && p.in_angle(a, c, b);
    if ((a - b).length() < eps && (b - c).length() < eps && (c - a).length() < eps)
        return (p - a).length() < eps;
    if ((a - b).length() < eps)
        return p.between(b, c);
    if ((b - c).length() < eps)
        return p.between(c, a);
    if ((c - a).length() < eps)
        return p.between(a, b);
    assert(false);
}

bool point_in_rounded(point p, const vector<rpoint>& r) {
    if (r[0].center != nullptr && (p - *r[0].center).length() < (r[0].p - *r[0].center).length()) {
        //p_out(p);
        //p_out(r[0].p);
        //p_out(*r[0].center);
        //cout << "first seg" << endl;
        return true;
    }
    if ((p - r[0].p) / (r[1].p - r[0].p) > 0)
        return false;

    int L = 1, R = r.size();
    while (R - L > 1) {
        int m = (L + R) / 2;
        if (((r[m].p - r[0].p) / (p - r[0].p)) > 0)
            L = m;
        else
            R = m;
    }
    //p_out(p);
    //p_out(r[L].p);
    if (r[L].center != nullptr && (p - *r[L].center).length() < (r[L].p - *r[L].center).length()) {
        //p_out(*r[L].center);
        //cout << "in seg" << endl;
        return true;
    }
    return point_in_triangle(p, r[0].p, r[L].p, r[(L + 1) % r.size()].p);
}

void solve() {
    int n = input<int>();
    vector<point> polygon(n);
    vector<pointll> poll(n);
    for (pointll& p : poll)
        p = p_in();
    
    for (int i = 0; i < n; i++)
        polygon[i] = { (long double)poll[i].x, (long double)poll[i].y };
  
    const int DAYS = 100;
  
    /*for (vector<rpoint> rp : expanded) {
        for (rpoint r : rp) {
            if (r.center.has_value())
                cout << "(" << r.p.x << " " << r.p.y << ")" << " ";
            else
                cout << "[" << r.p.x << " " << r.p.y << "]" << " ";
        }
        cout << endl;
    }*/
      
    int q = input<int>();
    vector<pointll> qll(q);
    for (pointll& s : qll)
        s = p_in();

    vector<point> ss(q);
    for (int i = 0; i < q; i++)
        ss[i] = { (long double)qll[i].x, (long double)qll[i].y };
      
    vector<int> ans(q, -1);
  
    for (int i = 0; i < q; i++) {
        if (qll[i].in_convex(poll)) {
            ans[i] = 0;
        }
    }
  
    long double base_square = (long double)(S2(polygon)) / 2;
    long double additional_square = 0;
    for (int day = 1; day <= DAYS && count(ans.begin(), ans.end(), -1) > 0; day++) {
        additional_square = 2 * additional_square + base_square;
        long double dist = dist_to_expand(polygon, additional_square);
        auto expanded = expand(polygon, dist);
        if (dist < 1e-6) continue;
        //cout << dist << endl;
        for (int i = 0; i < q; i++) {
            if (ans[i] == -1 && point_in_rounded(ss[i], expanded))
                ans[i] = day;
        }
    }
  
    for (int i = 0; i < q; i++)
        cout << ans[i] << '\n';
}
