#include <iostream>
#include <algorithm>
#include <cmath>
#include <set>
#include <vector>

using namespace std;

int c[1000][1000];
bool a[1000][1000];
int n, m, k;
set<int> s[1000000];
vector<int> dist(1000000, 1000000);

void connect(int i, int j, int k) {
    if (i < 0 || j < 0 || i >= n || j >= m) return;
    if (a[i][j] || c[i][j]) return;
    c[i][j] = k;
    connect(i - 1, j, k);
    connect(i + 1, j, k);
    connect(i, j - 1, k);
    connect(i, j + 1, k);
}

void connect_2(int i, int j, int k)
{
    if (i < 0 || j < 0 || i >= n || j >= m)
        return;
    if (a[i][j]) return;
    
    if (c[i][j] != k) {
        s[c[i][j]].insert(k);
        s[k].insert(c[i][j]);
    }
}

void bfs(int k) {
    size_t i = 0;
    vector<int> v;
    v.push_back(k);
    dist[k] = 0;

    while(i < v.size()) {
        int u = v[i];
        for (int e : s[u]) {
            if (dist[e] == 1000000) {
                v.push_back(e);
                dist[e] = dist[u] + 1;
            }
        }
        i++;
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    
    cin >> n >> m >> k;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            char c;
            cin >> c;
            if (c == '.') a[i][j] = 0;
            else a[i][j] = 1;
        }
    }

    int dx, dy, ax, ay;
    cin >> dx >> dy >> ax >> ay;
    dx--;
    dy--;
    ax--;
    ay--;

    int mx = 0;
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < m; j++)
        {
            if (!c[i][j] && !a[i][j]) connect(i, j, ++mx);
        }
    }

    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < m; j++)
        {
            if (a[i][j]) continue;
            connect_2(i - 2, j, c[i][j]);
            connect_2(i + 2, j, c[i][j]);
            connect_2(i, j - 2, c[i][j]);
            connect_2(i, j + 2, c[i][j]);
        }
    }

    bfs(c[dx][dy]);

    // for (int i = 1; i <= mx; i++) {
    //     cout << dist[i] << " ";
    // }
    // cout << endl;

    // for (int i = 0; i <= mx; i++)
    // {
    //     cout << i << " : ";
    //     for (int e : s[i]) cout << e << " ";
    //     cout << endl;
    // }
    // cout << endl;

    if (dist[c[ax][ay]] <= k) cout << "YES";
    else cout << "NO";
    cout << endl;
}