#include <iostream>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <vector>
 
using namespace std;
 
int n, m, k;
vector <vector <char>> g;
vector <vector <int>> used;
vector <vector <int>> used2;
vector <vector <pair<int, int>>> root;
 
bool check (int x, int y) {
    return (x >= 0 && x < n && y >= 0 && y < m);
}
 
void dfs1 (int x, int y, int color) {
    if (used[x][y] != -1)
        return;
    used[x][y] = color;
    int dx[4] = {0, 0, -1, 1};
    int dy[4] = {-1, 1, 0, 0};
 
    for (int t = 0; t < 4; t++) {
        if (check(x + dx[t], y + dy[t])) {
            if (used[x + dx[t]][y + dy[t]] == -1 && g[x + dx[t]][y + dy[t]] == '.') {
                dfs1(x + dx[t], y + dy[t], color);
            }
        }
    }
}
 
void  dfs2 (int x, int y) {
    if (used2[x][y] != -1)
        return;
    used2[x][y] = used[x][y];
 
    int dx[4] = {0, 0, -2, 2};
    int dy[4] = {-2, 2, 0, 0};
 
    for (int t = 0; t < 4; t++) {
        if (check(x + dx[t], y + dy[t])) {
            if (used[x + dx[t]][y + dy[t]] == -1 && g[x + dx[t]][y + dy[t]] == '.' && used[x][y] + 1 <= k) {
                root[used[x][y] + 1].push_back(make_pair(x + dx[t], y + dy[t]));
 
                dfs1(x + dx[t], y + dy[t], used[x][y] + 1);
            }
        }
    }
 
    int dx2[4] = {0, 0, -1, 1};
    int dy2[4] = {-1, 1, 0, 0};
    for (int t = 0; t < 4; t++) {
        if (check(x + dx2[t], y + dy2[t])) {
            if (used2[x + dx2[t]][y + dy2[t]] == -1 && g[x + dx2[t]][y + dy2[t]] == '.') {
                dfs2(x + dx2[t], y + dy2[t]);
            }
        }
    }
}
 
int main () {
    
    cin >> n >> m >> k;
    g.resize(n + 5, vector <char> (m + 5));
    used.resize(n + 5, vector <int> (m + 5, -1));
    used2.resize(n + 5, vector <int> (m + 5, -1));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++)
            cin >> g[i][j];
    }
 
    pair <int, int> start, finish;
    cin >> start.first >> start.second >> finish.first >> finish.second;
 
    dfs1(start.first - 1, start.second - 1, 0);
    root.resize(k + 5);
    root[0].push_back(make_pair(start.first - 1, start.second - 1));
 
    for (int iter = 0; iter < k; iter++) {
        for (int i = 0; i < root[iter].size(); i++) {
            dfs2(root[iter][i].first, root[iter][i].second);
        }
    }
 
    if (used[finish.first - 1][finish.second - 1] != -1) {
        cout << "YES\n";
    } else {
        cout << "NO\n";
    }
 
    return 0;
}