#include <algorithm>
#include <cmath>
#include <iostream>
#include <set>
#include <string>
#include <unordered_map>
#include <vector>

using namespace std;

int N, M, K;
using node = pair<int, int>;
node start, finish;
vector<string> map;
vector<vector<int>> jumpsMap;
void dfs(node n, int jumps){
  jumpsMap[n.first][n.second] = jumps;
  vector<node> vec = {{0, 1}, {0, -1}, {1, 0}, {-1, 0}};
  for(node i : vec){
    node newpos(n.first + i.first, n.second + i.second);
    if (newpos.first<0 || newpos.first >= N || newpos.second<0 || newpos.second >= M){
      continue;
    }
    if (map[newpos.first][newpos.second] == '.'){
      continue;
    }
    if (jumpsMap[newpos.first][newpos.second] > jumps){
      dfs(newpos, jumps);
    }
  }
  vec = {{0, 2}, {0, -2}, {2, 0}, {-2, 0}};
  if (jumps > 0) {
  for(node i : vec){
    node newpos(n.first + i.first, n.second + i.second);
    if (newpos.first<0 || newpos.first >= N || newpos.second<0 || newpos.second >= M){
      continue;
    }
    if (map[newpos.first][newpos.second] == '.'){
      continue;
    }
    if (jumpsMap[newpos.first][newpos.second] < jumps-1){
      dfs(newpos, jumps-1);
    }
  }
  }
}

int main() {
  cin>>N>>M>>K;
  jumpsMap = vector<vector<int>>(N, vector<int>(M, 10000000));
  for(int i=0; i<N;i++){
    map.push_back("");
    cin>>map[i];
  }
  cin>>start.first >> start.second;
  cin>>finish.first >> finish.second;
  dfs(start, K);
  if (jumpsMap[finish.first][finish.second] == 10000000){
    cout<< "NO";
  } else {
    cout<<"YES";
  }
}