#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

const int INF = 1e9;

#define forn(i, n) for(int i = 0; i < n; ++i)
#define all(v) v.begin(), v.end()

const int N = 26 * 2 + 10;
map<char, int> mp;

struct trie {
    trie() {
        for (int i = 0; i < N; i++) {
            link[i] = nullptr;
        }
        term = false;
        max = 0;
    }

    trie *link[N];
    bool term;
    int max;
};

bool check(trie *cur, string const &s) {
    for (int i = 0; i < (int) s.size(); i++) {
        int val = mp[s[i]];
        if (cur->link[val] == nullptr) {
            return false;
        }
        cur = cur->link[val];
    }
    if (cur->term) return true;
    else return false;
}

void add_num(trie *cur, string const &s) {
    for (int i = 0; i < (int) s.size(); i++) {
        int val = mp[s[i]];
        if (cur->link[val] == nullptr) {
            cur->link[val] = new trie();
        }
        cur = cur->link[val];
    }
    cur->term = true;
    cur->max = 0;
}

int add(trie *cur, string const &s) {
    for (int i = 0; i < (int) s.size(); i++) {
        int val = mp[s[i]];
        if (cur->link[val] == nullptr) {
            cur->link[val] = new trie();
        }
        cur = cur->link[val];
    }
    if (cur->term) {
        ++cur->max;
        for (cur->max; cur->max <= 1000001; cur->max++) {
            string str_temp = to_string(cur->max);
            if (!check(cur, str_temp)) {
                add_num(cur, str_temp);
                break;
            }
        }
        return cur->max;
    } else {
        cur->term = true;
        cur->max = 0;
        return -1;
    }
}

void solve() {
    int q;
    cin >> q;
    trie *root = new trie();
    while (q--) {
        string s;
        cin >> s;
        int res = add(root, s);
        cout << s;
        if (res != -1) cout << res << '\n';
        else cout << '\n';
    }
}

int main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
    for (char c = 'A'; c <= 'Z'; c++) {
        mp[c] = (c - 'A');
    }
    for (char c = 'a'; c <= 'z'; c++) {
        mp[c] = (c - 'a') + 26;
    }
    for (char c = '0'; c <= '9'; c++) {
        mp[c] = (c - '0') + 52;
    }
    solve();
}
