#include <iostream>
#include <algorithm>
#include <vector>
#include <iomanip>
#include <map>
#include <set>
#include <fstream>
#include <string>
#include <bitset>
#include <ctime>
#include <random>
#include <iterator>
#include <cmath>
#include <queue>
#include <deque>
#include <time.h>

// !!!
// #define cin fin
// #define cout fout

using namespace std;

#define all(a) a.begin(), a.end()
#define rsort(a) sort(a, [&](auto b, auto c) {return b > c;})

ifstream fin("input.txt");
ofstream fout("output.txt");

using ll = long long;
using ld = long double;
using ull = unsigned long long;

ll const inf = 1e18;

template <class T>
istream& operator>> (istream& in, vector<T>& a)
{
	for (T& e : a)
		in >> e;
	return in;
}

template <class T>
ostream& operator<< (ostream& out, const vector<T>& a)
{
	for (const T& e : a)
		out << e << " ";
	return out;
}

template<class T, class N> auto min(T a, N b)
{
	return sizeof(a) > sizeof(b) ? min(a, (T)b) : min((N)a, b);
}

template<class T, class N> auto max(T a, N b)
{
	return sizeof(a) > sizeof(b) ? max(a, (T)b) : max((N)a, b);
}

random_device rd;
mt19937 mersenne(rd());

ll mod = 1e9 + 7;


void solve() 
{
	ll a, b; cin >> a >> b;
	if ((a + b) % 2)
	{
		cout << "Error\n";
		return;
	}
	if (a >= 2 && b >= 2)
	{
		cout << "Undefined\n";
		return;
	}
	if (a == 0)
	{
		cout << 0 << '\n' << b / 2 << '\n' << 0 << '\n';
		return;
	}
	if (a == 1)
	{
		cout << 0 << '\n' << b / 2 << '\n' << 1 << '\n';
		return;
	}
	if (b == 0)
	{
		cout << a / 2 << '\n' << 0 << '\n' << 0 << '\n';
		return;
	}
	if (b == 1)
	{
		cout << a / 2 << '\n' << 0 << '\n' << 1 << '\n';
		return;
	}
}

//#define TIME
#define ONCE

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	ll TT = 1;
#ifndef ONCE 
	cin >> TT;
#endif
	while (TT--)
	{
#ifdef TIME
		clock_t start, end;

		start = clock();
#endif
		solve();
#ifdef TIME
		end = clock();

		cerr << "\ntime: " << ((double)end - start) / ((double)CLOCKS_PER_SEC) << " s\n";
#endif
		cerr << '\n';
	}
	return 0;
}
