#include <iostream>
#include <algorithm>
#include <vector>
#include <iomanip>
#include <map>
#include <set>
#include <fstream>
#include <string>
#include <bitset>
#include <ctime>
#include <random>
#include <iterator>
#include <cmath>
#include <queue>
#include <deque>
#include <time.h>

// !!!
// #define cin fin
// #define cout fout

using namespace std;

#define all(a) a.begin(), a.end()
#define rsort(a) sort(a, [&](auto b, auto c) {return b > c;})

ifstream fin("input.txt");
ofstream fout("output.txt");

using ll = long long;
using ld = long double;
using ull = unsigned long long;

ll const inf = 1e18;

template <class T>
istream& operator>> (istream& in, vector<T>& a)
{
	for (T& e : a)
		in >> e;
	return in;
}

template <class T>
ostream& operator<< (ostream& out, const vector<T>& a)
{
	for (const T& e : a)
		out << e << " ";
	return out;
}

template<class T, class N> auto min(T a, N b)
{
	return sizeof(a) > sizeof(b) ? min(a, (T)b) : min((N)a, b);
}

template<class T, class N> auto max(T a, N b)
{
	return sizeof(a) > sizeof(b) ? max(a, (T)b) : max((N)a, b);
}

random_device rd;
mt19937 mersenne(rd());

ll mod = 1e9 + 7;

void solve() 
{
	ll n; cin >> n;
	ll k; cin >> k;
	ll s1; cin >> s1;
	ll s2; cin >> s2;
	ll d1 = abs(n * (k + 1) - 2 * s1);
	ll d2 = abs(n * (k + 1) - 2 * s2);
	if (s1 > n * k || s1 < n)
	{
		d1 = inf;
	}
	if (s2 > n * k || s2 < n)
	{
		d2 = inf;
	}
	if (d1 < d2)
	{
		cout << "First\n";
	}
	else if (d1 > d2)
	{
		cout << "Second\n";
	}
	else
	{
		cout << "Equal\n";
	}
}

//#define TIME
#define ONCE

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	ll TT = 1;
#ifndef ONCE 
	cin >> TT;
#endif
	while (TT--)
	{
#ifdef TIME
		clock_t start, end;

		start = clock();
#endif
		solve();
#ifdef TIME
		end = clock();

		cerr << "\ntime: " << ((double)end - start) / ((double)CLOCKS_PER_SEC) << " s\n";
#endif
		cerr << '\n';
	}
	return 0;
}
