#include <iostream>
#include <algorithm>
#include <vector>
#include <iomanip>
#include <map>
#include <set>
#include <fstream>
#include <string>
#include <bitset>
#include <ctime>
#include <random>
#include <iterator>
#include <cmath>
#include <queue>
#include <deque>
#include <time.h>

// !!!
// #define cin fin
// #define cout fout

using namespace std;

#define all(a) a.begin(), a.end()
#define rsort(a) sort(a, [&](auto b, auto c) {return b > c;})

ifstream fin("input.txt");
ofstream fout("output.txt");

using ll = long long;
using ld = long double;
using ull = unsigned long long;

ll const inf = 1e18;

template <class T>
istream& operator>> (istream& in, vector<T>& a)
{
	for (T& e : a)
		in >> e;
	return in;
}

template <class T>
ostream& operator<< (ostream& out, const vector<T>& a)
{
	for (const T& e : a)
		out << e << " ";
	return out;
}

template<class T, class N> auto min(T a, N b)
{
	return sizeof(a) > sizeof(b) ? min(a, (T)b) : min((N)a, b);
}

template<class T, class N> auto max(T a, N b)
{
	return sizeof(a) > sizeof(b) ? max(a, (T)b) : max((N)a, b);
}

random_device rd;
mt19937 mersenne(rd());

ll mod = 1e9 + 7;

void solve()
{
	ll n; cin >> n;
	ll k; cin >> k;
	vector<ll> s(n); cin >> s;
	vector<ll> a(n); cin >> a;
	vector<ll> d(n);
	ll nok = 8 * 9 * 5 * 7;
	ll kk = nok * k;
	ll otkl = 0;
	map<ll, ll> ma;
	for (int i = 0; i < n; ++i)
	{
		d[i] = abs(a[i] - s[i]);
		otkl += d[i] * nok / s[i];
		ma[nok / s[i]] += d[i];
	}

	ll t = 0;
	while (otkl > kk)
	{
		auto elem = *ma.rbegin();
		ll val = elem.first;
		ll cnt = elem.second;
		if (otkl - val * cnt > kk)
		{
			t += cnt;
			ma.erase(val);
			otkl -= val * cnt;
		}
		else
		{
			ll dist = otkl - kk;
			t += (dist + val - 1) / val;
			break;
		}
	}
	cout << t << '\n';
}

//#define TIME
#define ONCE

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	ll TT = 1;
#ifndef ONCE 
	cin >> TT;
#endif
	while (TT--)
	{
#ifdef TIME
		clock_t start, end;

		start = clock();
#endif
		solve();
#ifdef TIME
		end = clock();

		cerr << "\ntime: " << ((double)end - start) / ((double)CLOCKS_PER_SEC) << " s\n";
#endif
		cerr << '\n';
	}
	return 0;
}
