#define _CRT_SECURE_NO_WARNINGS
#define INF 1e9
#define ACC 1e-6

#include <cassert>
#include <algorithm>
#include <iostream>
#include <string>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <cstdio>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <random>
#include <numeric>

using namespace std;

int main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, k;
    cin >> n >> k;

    vector<pair<int, int>> a;

    for (int i = 0; i < n; i++) {
        int a_inp;
        cin >> a_inp;
        a.push_back(make_pair(0, a_inp));
    }

    for (int i = 0; i < n; i++) {
        int s_inp;
        cin >> s_inp;
        a[i].first = s_inp;
    }

    sort(a.begin(), a.end());

    float sum = 0;
    for (int i = 0; i < n; i++)
        sum += float(abs(a[i].second - a[i].first)) / float(a[i].second);

    int res = 0;
    int ind = 0;

    while (sum > k + ACC) {
        if (a[ind].first != a[ind].second) {
            float step = float(1) / a[ind].second;
            if (float(sum) - float(abs(a[ind].first - a[ind].second)) * step > k) {
                int steps = float(abs(a[ind].first - a[ind].second));
                sum -= steps * step;
                res += steps;
                a[ind].second = a[ind].first;
            }
            else {
                int rest = sum - k;
                res += rest / step;
                break;
            }
        }
        else {
            ind++;
        }
    }

    cout << res;

}
