#define _CRT_SECURE_NO_WARNINGS
#define INF 1e9
#define ACC 1e-6
#define FAC_10 3628800
#define ll long long

#include <cassert>
#include <algorithm>
#include <iostream>
#include <string>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <cstdio>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <random>
#include <numeric>

using namespace std;

struct detail {
    ll current;
    ll target;
};

bool operator<(const detail& fst, const detail& snd) {
    if (fst.target == snd.target)
        return fst.current < snd.current;
    return fst.target < snd.target;
}

int main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, k;
    cin >> n >> k;

    vector<detail> a;

    for (int i = 0; i < n; i++) {
        ll s_inp;
        cin >> s_inp;
        detail det;
        det.target = s_inp;
        a.push_back(det);
    }

    for (int i = 0; i < n; i++) {
        ll a_inp;
        cin >> a_inp;
        a[i].current = a_inp;
    }

    sort(a.begin(), a.end());

    ll sum = 0;
    for (int i = 0; i < n; i++)
        sum += abs(a[i].current - a[i].target) * (FAC_10 / a[i].target);

    ll res = 0;

    for (int ind = 0; ind < n; ind++) {
        ll step = (FAC_10 / a[ind].target);
        ll rest = max(sum - k * FAC_10, 0ll);
        ll steps = min(abs(a[ind].current - a[ind].target), (rest + step - 1) / step);
        sum -= steps * step;
        res += steps;
    }

    cout << res;
}
