#define _CRT_SECURE_NO_WARNINGS
#define INF 1e9
#define ACC 1e-6
#define ll long long

#include <cassert>
#include <algorithm>
#include <iostream>
#include <string>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <cstdio>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <random>
#include <numeric>

using namespace std;

const long long FAC_10 = 2520;

struct detail {
    ll current;
    ll target;
};

bool operator<(const detail& fst, const detail& snd) {
    if (fst.target != snd.target)
        return fst.target < snd.target;
    return fst.current < snd.current;
}

int main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    long long n, k;
    cin >> n >> k;
    k *= FAC_10;

    vector<detail> a(n);
    for (int i = 0; i < n; i++)
        cin >> a[i].target;
    for (int i = 0; i < n; i++)
        cin >> a[i].current;

    sort(a.begin(), a.end());

    ll sum = 0;
    for (int i = 0; i < n; i++)
        sum += abs(a[i].current - a[i].target) * (FAC_10 / a[i].target);

    ll res = 0;

    for (int ind = 0; ind < n; ind++) {
        ll rest = sum - k;
        if (rest <= 0)
            break;
        ll step = (FAC_10 / a[ind].target);
        ll steps = min(abs(a[ind].current - a[ind].target), rest / step + (rest % step > 0));
        sum -= steps * step;
        res += steps;
    }

    cout << res;
}