#define _CRT_SECURE_NO_WARNINGS
#define INF 1e9
#define ACC 1e-6
#define ll long long

#include <cassert>
#include <algorithm>
#include <iostream>
#include <string>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <cstdio>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <random>
#include <numeric>
#include <deque>

using namespace std;

const long long FAC_10 = 2520;

struct Edge {
    int to;
    bool w;
    Edge (int to, bool w) : to(to), w(w) {}
};

void bfs01(const vector<vector<Edge>>& g, int st, vector<int>& d) {
    deque<int> q;
    q.push_back(st);
    d[st] = 0;
    while (!q.empty()) {
        int cur = q.front();
        q.pop_front();
        for (const Edge& e : g[cur]) {
            if (d[cur] + e.w >= d[e.to])
                continue;
            d[e.to] = d[cur] + e.w;
            if (e.w == 0)
                q.push_front(e.to);
            else
                q.push_back(e.to);
        }
    }
}

int main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    vector<vector<Edge>> g(n + 2);
    vector<int> p(n + 2);
    int st = 0, fn = n + 1;

    p[st] = 0;
    for (int i = 1; i <= n; i++)
        cin >> p[i];

    for (int cur = 0; cur <= n; cur++) {
        if (p[cur] == 0) {
            for (int to = cur + 1; to <= min(cur + 5, fn); to++)
                g[cur].push_back({ to, 1 });
            if (cur + 6 < fn)
                g[cur].push_back({ cur + 6, 0 });
            else if (cur + 6 == fn)
                g[cur].push_back({ cur + 6, 1 });
        }
        else
            g[cur].push_back({ cur - p[cur], 0 });
    }
    vector<int> d(n + 2, 1e9);
    bfs01(g, st, d);
    if (d[fn] == 1e9)
        cout << -1;
    else
        cout << d[fn];
}