#include <iostream>
#include <utility>
#include <vector>
#include <algorithm>
#include <numeric>
#include <random>
#include <set>
#include <queue>
#include <deque>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <array>
#include <string>
#include <cassert>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned int uint;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const ld eps = 5e-19;
const int BASE = 137;
const int MOD = 998244353;
const int INF = 2e9 + 5;
const ll INFL = 2e18 + 7;

template<class T>
void print(const T &src, const std::string &s = " ", bool nextLine = true) {
    for (const auto &el: src) {
        std::cout << el + 1 << s;
    }
    if (nextLine) std::cout << '\n';
}

void input() {
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout.precision(14);
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> s(n), a(n);
    for (int i = 0; i < n; i++) cin >> s[i];
    for (int i = 0; i < n; i++) cin >> a[i];

    vector<int> d(11);
    ld cur = 0;
    for (int i = 0; i < n; i++) {
        d[s[i]] += abs(a[i] - s[i]);
        cur += fabs(a[i] - s[i]) / s[i];
    }

    int answer = 0;
    int ind = 1;
    while (cur > k) {
        if (cur - d[ind] * ind <= k) {
            answer += ceil((cur - k) / ind);
            break;
        } else {
            answer += d[ind];
            cur -= d[ind] * ind;
            ind++;
        }
    }

    cout << answer;
}

int main() {
    input();
    int TESTS = 1;
//    cin >> TESTS;
    while (TESTS--) {
        solve();
        cout << '\n';
    }
    return 0;
}