#include <iostream>
#include <utility>
#include <vector>
#include <algorithm>
#include <numeric>
#include <random>
#include <set>
#include <queue>
#include <deque>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <array>
#include <string>
#include <cassert>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned int uint;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const ld eps = 5e-19;
const int BASE = 137;
const int MOD = 998244353;
const int INF = 2e9 + 5;
const ll INFL = 2e18 + 7;

template<class T>
void print(const T &src, const std::string &s = " ", bool nextLine = true) {
    for (const auto &el: src) {
        std::cout << el + 1 << s;
    }
    if (nextLine) std::cout << '\n';
}

void input() {
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout.precision(14);
}

void solve() {
    ll n, k;
    cin >> n >> k;

    const ll fact = 3628800;

    k *= fact;
    vector<ll> s(n), a(n);
    for (int i = 0; i < n; i++) cin >> s[i];
    for (int i = 0; i < n; i++) cin >> a[i];

    vector<pll> d(n);
    ll cur = 0;
    ll answer = 0;

    for (int i = 0; i < n; i++) {
        d[i] = {s[i], abs(a[i] - s[i])};
    }

    std::sort(d.begin(), d.end());

    for (int i = 0; i < n; i++) {
        a[i] *= fact / s[i];
        cur += abs(a[i] - fact);
    }

    if (cur <= k) {
        cout << 0;
        return;
    }

    cur -= k;

    for (int i = 0; i < n; i++) {
        ll tmp = d[i].second * fact / d[i].first;
        if (cur > tmp) {
            answer += d[i].second;
            cur -= tmp;
        } else {
            answer += (cur * d[i].first + fact - 1) / fact;
            break;
        }
    }

    cout << answer;
}

int main() {
    input();
    int TESTS = 1;
//    cin >> TESTS;
    while (TESTS--) {
        solve();
        cout << '\n';
    }
    return 0;
}