#include <iostream>
#include <utility>
#include <vector>
#include <algorithm>
#include <numeric>
#include <random>
#include <set>
#include <queue>
#include <deque>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <array>
#include <string>
#include <cassert>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned int uint;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const ld eps = 5e-19;
const int BASE = 137;
const int MOD = 998244353;
const int INF = 2e9 + 5;
const ll INFL = 2e18 + 7;

template<class T>
void print(const T &src, const std::string &s = " ", bool nextLine = true) {
    for (const auto &el: src) {
        std::cout << el + 1 << s;
    }
    if (nextLine) std::cout << '\n';
}

void input() {
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout.precision(14);
}

void solve() {
    int q;
    cin >> q;
    unordered_set<string> has;
    unordered_map<string, int> m;
    string s;
    while (q--) {
        cin >> s;
        auto res = m.find(s);
        int x = 0;

        if (res != m.end())
            x = res->second;

        while (x == 0 && has.count(s) || (x!= 0 && has.count(s + to_string(x)))) {
            x++;
        }

        string tmp = s;
        if (x != 0) {
            tmp += to_string(x);
        }

        m[s] = x;

        has.insert(tmp);
        cout << tmp << '\n';
    }
}

int main() {
    input();
    int TESTS = 1;
//    cin >> TESTS;
    while (TESTS--) {
        solve();
        cout << '\n';
    }
    return 0;
}