#include <bits/stdc++.h>
 
using namespace std;
 
typedef long long ll;
typedef long double ld;
 
const ll INF = 1e12 + 1;
const ll MOD = 1e9 + 7;
ll MAXN = 1e6 + 1;
const ll ALPH = 26;
const ld EPS = 1e-9;
 
#define size(x) (ll)(x).size()
#define all(x) (x).begin(),(x).end()
 
void bye() {
    cout << "\n";
    exit(0);
}
 
struct Point {
	ld x, y;
};

bool cmp (Point a, Point b) {
    return a.x < b.x || a.x == b.x && a.y < b.y;
}

struct Solution {

    bool cw (Point a, Point b, Point c) {
        return a.x*(b.y-c.y)+b.x*(c.y-a.y)+c.x*(a.y-b.y) < 0;
    }

    bool ccw (Point a, Point b, Point c) {
        return a.x*(b.y-c.y)+b.x*(c.y-a.y)+c.x*(a.y-b.y) > 0;
    }

    void convex_hull (vector<Point> & a) {
        if (size(a) == 1)  return;
        
        sort (a.begin(), a.end(), &cmp);
        Point p1 = a[0],  p2 = a.back();
        vector<Point> up, down;
        up.push_back (p1);
        down.push_back (p1);
        
        for (int i=1; i < size(a); ++i) {
            if (i==size(a)-1 || cw (p1, a[i], p2)) {
                while (size(up)>=2 && !cw (up[size(up)-2], up[size(up)-1], a[i]))
                    up.pop_back();
                up.push_back (a[i]);
            }
            if (i==size(a)-1 || ccw (p1, a[i], p2)) {
                while (size(down)>=2 && !ccw (down[size(down)-2], down[size(down)-1], a[i]))
                    down.pop_back();
                down.push_back (a[i]);
            }
        }
        a.clear();
        for (size_t i=0; i<size(up); ++i)
            a.push_back (up[i]);
        for (size_t i=size(down)-2; i>0; --i)
            a.push_back (down[i]);
    }
    
    void solve() {
        int n;

        cin >> n;
        vector<Point> g(n);

        for (int i = 0; i < n; i++) {
            cin >> g[i].x >> g[i].y;
        }

        convex_hull(g);


        ld ans = 0;
        ld mx = 0;
        for (int i = 0; i < n; i++) {
            ld cur = hypot(g[i].x - g[(i + 1) % n].x, g[i].y - g[(i + 1) % n].y);
            mx = max(cur, mx);
            ans += cur;
        }

        cout << fixed << setprecision(10);
        cout << ans - mx;
    }
};
 
signed main() {
    #ifdef _TIM
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // _TIM
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    ll TEST_COUNT = 1;
//    cin >> TEST_COUNT;
    while (TEST_COUNT--) {
        Solution now;
        now.solve();
    }
    bye();
}
