﻿#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <cmath>
#include <map>
#include <sstream>
#include <numeric>
#include <queue>

using namespace std;

#define int long long

const int inf = 1LL << 60;
const int mod = 1000000007;

template<typename T1, typename T2>
ostream& operator<<(ostream& s, pair<T1, T2>& p) {
    s << "(" << p.first << ", " << p.second << ")";
    return s;
}

template<typename T>
ostream& operator<<(ostream& s, vector<T>& a) {
    for (T x : a) s << x << " ";
    s << endl;
    return s;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    const int fact10 = 1LL * 2 * 3 * 4 * 5 * 6 * 7 * 8 * 9 * 10;
    int n, k;
    cin >> n >> k;
    k *= fact10;
    vector<int> s(n), a(n);
    for (int i = 0; i < n; i++) cin >> s[i];
    for (int i = 0; i < n; i++) cin >> a[i];
    vector<pair<int, int>> pairs;
    int sum = -k;
    for (int i = 0; i < n; i++) {
        pairs.push_back({ fact10 / s[i], abs(a[i] - s[i])});
        sum += fact10 * abs(a[i] - s[i]) / s[i];
    }
    sort(pairs.begin(), pairs.end());
    reverse(pairs.begin(), pairs.end());
    cout << sum << endl << pairs;
    if (sum < 0) {
        cout << 0 << endl;
        return 0;
    }
    int ans = 0;
    for (int i = 0; i < n; i++) {
        if (pairs[i].first * pairs[i].second > sum) {
            ans += (sum + pairs[i].first - 1) / pairs[i].first;
            cout << ans << endl;
            break;
        }
        ans += pairs[i].second;
        sum -= pairs[i].first * pairs[i].second;
    }
    if (k == 0)
        cout << ans << endl;
}