﻿#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <cmath>
#include <map>
#include <sstream>
#include <numeric>
#include <queue>

using namespace std;

#define int long long

const int inf = 1LL << 60;
const int mod = 1000000007;

template<typename T1, typename T2>
ostream& operator<<(ostream& s, pair<T1, T2>& p) {
    s << "(" << p.first << ", " << p.second << ")";
    return s;
}

template<typename T>
ostream& operator<<(ostream& s, vector<T>& a) {
    for (T x : a) s << x << " ";
    s << endl;
    return s;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n;
    cin >> n;
    vector<pair<int, int>> a;
    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        a.push_back({ x, y });
    }
    vector<double> lengths;
    for (int i = 0; i < n; i++) {
        int j = (i + 1) % n;
        lengths.push_back(sqrt(
            (a[i].first - a[j].first) * (a[i].first - a[j].first) +
            (a[i].second - a[j].second) * (a[i].second - a[j].second)
        ));
    }
    double m = 0, s = 0;
    for (double x : lengths) {
        m = max(m, x);
        s += x;
    }
    cout << s - m << endl;
}