#include <iostream>
#include <vector>
#include <queue>
#include <unordered_set>
using namespace std;

int n, m, k;

void dfs(pair <int, int> v, vector <vector <char>> &map,  vector <vector <bool>> &used, vector <vector <int>> &comp, int curr_comp) {
    used[v.first][v.second] = 1;
    comp[v.first][v.second] = curr_comp;
    
    for (int dx = -1; dx <= 1; dx ++)
        for (int dy = -1; dy <= 1; dy ++)
            if ((abs(dx) + abs(dy) == 1) && (1 <= v.first + dx)
                                       && (v.first + dx <= n) 
                                       && (1 <= v.second + dy)
                                       && (v.second + dy <= m) 
                && (map[v.first + dx][v.second + dy] == '.'))
                if (used[v.first + dx][v.second + dy] == 0)                                
                    dfs({v.first + dx, v.second + dy}, map, used, comp, curr_comp);
    return;
}
    
int main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(0);
    std::cout.tie(0);
    cout.setf(ios::fixed);
    cout.precision(10);

    cin >> n >> m >> k;

    vector <vector <char>> map(n+1, vector <char>(m+1, '.'));
    for (int i = 1; i <= n; i ++) {
        for (int j = 1; j <= m; j ++) {
            char aij;
            cin >> aij;
            map[i][j] = aij;
        }
    }

    int dx, dy, ax, ay;
    cin >> dx >> dy >> ax >> ay;
    
    vector <vector <bool>> used(n+1, vector <bool>(m+1, 0));
    vector <vector <int>> comp(n+1, vector <int>(m+1, 0));
    
    int curr_comp = 1;
    for (int i = 1; i <= n; i ++)
        for (int j = 1; j <= m; j ++)
            if ((comp[i][j] == 0) && (map[i][j] == '.')) {
                dfs({i,j}, map, used, comp, curr_comp);
                curr_comp += 1;
            }
    /*
    for (int i = 1; i <= n; i ++) {
        for (int j = 1; j <= m; j ++)
            cout << comp[i][j] << " ";
        cout << endl;
    }
    */
    vector <unordered_set <int>> g(curr_comp, unordered_set <int>());
    for (int i = 1; i <= n; i ++)
        for (int j = 1; j <= m; j ++)
            for (int dx = -2; dx <= 2; dx += 2)
                for (int dy = -2; dy <= 2; dy += 2)
                    if ((abs(dx) + abs(dy) == 2) && (1 <= i + dx)
                                                && (i + dx <= n) 
                                                && (1 <= j + dy)
                                                && (j + dy <= m) 
                    && (map[i][j] == '.') && (map[i + dx][j + dy] == '.')

                    && (comp[i][j] != comp[i+dx][j+dy])) {
                        g[comp[i][j]].insert(comp[i+dx][j+dy]);
                        g[comp[i+dx][j+dy]].insert(comp[i][j]);
                    }

    /*
    cout << endl;
    for (int i = 1; i < curr_comp; i ++) {
        cout << "comp " << i << ":   ";
        for (int gj: g[i])
            cout << gj << " ";
        cout << endl;
    }
    */
        
    vector <bool> z_used(curr_comp, 0);
    vector <int> dist(curr_comp, 0);
    dist[comp[ax][ay]] = k + 100;
    dist[comp[dx][dy]] = 0;
    queue <int> q;
    int st = comp[dx][dy];
    q.push(st);
    z_used[st] = 1;
    
    while(q.size() > 0) {
        int v = q.front();
        q.pop();
        
        for (int u: g[v])
            if (z_used[u] == 0) {
                z_used[u] = 1;
                dist[u] = dist[v] + 1;
                q.push(u);
            }
    }


    if (dist[comp[ax][ay]] <= k)
        cout << "YES" << endl;
    else
        cout << "NO" << endl;
    
}