#include <bits/stdc++.h>
using namespace std;



int n;
vector<int> parents_a;
vector<vector<int>> sons_a;

vector<int> parents_b;
vector<vector<int>> sons_b;

vector<bool> fix;
vector<bool> mark;


vector<pair<int, int>> operation;


void addSon(int parent, int son) {
    parents_b[son] = parent;
    sons_b[parent].push_back(son);
    if (sons_b[parent].size() > 2) assert(false);
}

void delSon(int son) {
    if (parents_b[son] == -1) assert(false);
    int parent = parents_b[son];
    parents_b[son] = -1;
    sons_b[parent].erase(find(sons_b[parent].begin(), sons_b[parent].end(), son));
}

// int findFree() {
//     for (int i = 0; i < n; ++i)
//         if ((sons_b[i].size() == 0) && (!fix[i]) && (!mark[i])) return i;
//     return -1;
// }


int findFreeVertex1(vector<int>& sons) {
    for (int i = 0; i < n; ++i) {
        if (mark[i] || fix[i]) continue;
        if (find(sons.begin(), sons.end(), i) != sons.end()) continue;
        if (sons_b[i].size() != 0) continue;
        return i;
    }
    return -1;
}

int findFreeVertex2(vector<int>& sons) {
    for (int i = 0; i < n; ++i) {
        if (mark[i]) continue;
        if (find(sons.begin(), sons.end(), i) != sons.end()) continue;
        if (sons_b[i].size() != 0) continue;
        return i;
    }
    return -1;
}

void dfs(int va, int vb) {
    if (va == -1) return;
    mark[vb] = true;
    int cnta = sons_a[va].size(), cntb = sons_b[vb].size();

    if (cnta > cntb) {
        for (int x = 0; x < cnta - cntb; ++x) {
            int y = findFreeVertex1(sons_b[vb]);
            if (y == -1) assert(false);
            delSon(y);
            addSon(vb, y);
            
            operation.push_back(make_pair(vb, y));
            
            fix[y] = true;
        }
    } else {
        for (int x = 0; x < cntb - cnta; ++x) {
            int y = findFreeVertex2(sons_b[vb]);
            if (y == -1) assert(false);
            
            int b_son = sons_b[vb].back();
            // sons_b[vb].pop_back();

            delSon(b_son);
            addSon(y, b_son);

            operation.push_back(make_pair(y, b_son));
        }
    }

    for (int i = 0; i < cnta; ++i)
        dfs(sons_a[va][i], sons_b[vb][i]);
}


void setting() {
    parents_a.assign(n, -1);
    parents_b.assign(n, -1);
    sons_b.assign(n, {});
    sons_a.assign(n, {});
    fix.assign(n, false);
    mark.assign(n, false);
}

int main() {
    cin >> n;
    setting();
    
    
    for (int i = 1; i < n; ++i) {
        int pb; cin >> pb;
        parents_b[i] = pb;
        sons_b[pb].push_back(i);
    }

    for (int i = 1; i < n; ++i) {
        int pa; cin >> pa;
        parents_a[i] = pa;
        sons_a[pa].push_back(i);
    }

    dfs(0, 0);


    cout << operation.size() << '\n';
    for (auto x : operation)
        cout << x.second << " " << x.first << '\n';



    return 0;
}