#include <stdio.h>  
#include <algorithm>
#include <iostream>
#include <vector>
#include <queue>
#include <map>
#include <bitset>
#include <algorithm>
#include <cmath>
#include <set>
 
using namespace std;

vector<vector<char>> arr;
vector<vector<int>> parent;

vector<pair<int, int>> steps = {{0, 1}, {0, -1}, {1, 0}, {-1, 0}};
vector<pair<int, int>> multisteps = {{0, 2}, {0, -2}, {2, 0}, {-2, 0}};

int n, m, k;

void dfs(int x, int y, int num) {
	parent[x][y] = num;
	for (auto step : steps) {
		int xx = x + step.first;
		int yy = y + step.second;
		if (xx >= 0 && xx < n && yy >= 0 && yy < m) {
			if (arr[xx][yy] == '.' && parent[xx][yy] == -1) {
				dfs(xx, yy, num);
			}
		}
	}
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> m >> k;
    arr.resize(n);
    for (int i = 0; i < n; i++) {
    	arr[i].resize(m);
    	for (int j = 0; j < m; j++) {
    		cin >> arr[i][j];
    	}
    }
    int dx, dy, ax, ay;
    cin >> dx >> dy >> ax >> ay;
    dx--;
    dy--;
    ax--;
    ay--;
    int cur = 0;
    parent.resize(n);
    for (int i = 0; i < n; i++) {
    	parent[i].resize(m, -1);
    }
    for (int i = 0; i < n; i++) {
    	for (int j = 0; j < m; j++) {
    		if (arr[i][j] == '.' && parent[i][j] == -1) {
    			dfs(i, j, cur);
    			cur++;
    		}
    	}
    }
    set<pair<int, int>> edges;
    for (int i = 0; i < n; i++) {
    	for (int j = 0; j < m; j++) {
    		if (arr[i][j] == '.') {
    			for (auto multistep : multisteps) {
    				int xx = i + multistep.first;
    				int yy = j + multistep.second;
    				if (xx >= 0 && xx < n && yy >= 0 && yy < m) {
    					if (arr[xx][yy] == '.' && parent[i][j] != parent[xx][yy]) {
    						edges.insert({min(parent[i][j], parent[xx][yy]), max(parent[i][j], parent[xx][yy])});
    					}
    				}
    			}
    		}
     	}
    }
    // cout << cur << endl;
    // return 0;
    vector<vector<int>> g(cur);
    for (auto edge : edges) {
    	int x = edge.first;
    	int y = edge.second;
    	// cout << x << ' ' << y << endl;
    	// if (x >= cur or y >= cur) {
    	// 	cout << "dklsaklklaf";
    	// 	return 0;
    	// }
    	g[x].push_back(y);
    	g[y].push_back(x);
    }
    vector<int> dist(cur, -1);
    int start = parent[dx][dy];
    int finish = parent[ax][ay];
    queue<int> q;
    q.push(start);
    dist[start] = 0;
    while (!q.empty()) {
    	int v = q.front();
    	q.pop();
    	for (int u : g[v]) {
    		if (dist[u] == -1) {
    			dist[u] = dist[v] + 1;
    			q.push(u);
    		}
    	}
    }
    if (dist[finish] != -1 && dist[finish] <= k) {
    	cout << "YES";
    }
    else {
    	cout << "NO";
    }
}