﻿#include <iostream>
#include <fstream>
#include <sstream>
#include <cstdio>

#include <vector>
#include <string>
#include <queue>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <bitset>
#include <stack>
#include <list>

#include <functional>
#include <utility>
#include <algorithm>
#include <cmath>
#include <iterator>
#include <iomanip>
#include <numeric>

#include <cassert>
#include <random>
#include <chrono>

#include <complex>
#include <climits>
#include <cstring>

using namespace std;

#define ll long long
#define prll pair<ll,ll>
#define prii pair<int,int>
#define m_p make_pair
#define INF (ll)LLONG_MAX

//#define int long long // !!!

namespace __time {
	clock_t t;
	double get_time() {
		return (double)(clock() - t) / CLOCKS_PER_SEC;
	}
}
mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());

const int N = 1e3+1;
const int L = 26 + 5;
const int M = N*N;
//const int mod = 1e9 + 7;

char mt[N][N];
int gt[N][N];
int dx[4] = {-1,0,1,0}, dy[4] = {0,1,0,-1};
int ddx[4] = {-2,0,2,0}, ddy[4] = {0,2,0,-2};

int n, m;
bool in(int x, int y) {
	return (0 <= x && x < n && 0 <= y && y < m);
}


int p[M], sz[M];

int get(int v) {
	if (p[v] == v)
		return v;
	return (p[v] = get(p[v]));
}

void merge(int a, int b) {
	a = get(a);
	b = get(b);
	if (a == b)return;

	if (sz[a] < sz[b])
		swap(a, b);
	p[b] = a;
	sz[a] += sz[b];
}

int id[M];

vector<int> g[M];
int d[M];

void $main() {
	for (int i = 0; i < M; ++i)
		sz[i] = 1, p[i] = i, id[i]=-1, d[i] = INT_MAX;
	
	int k; cin >> n >> m >> k;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			cin >> mt[i][j];
		}
	}

	int di, dj, ai, aj; cin >> di >> dj >> ai >> aj;
	--di, --dj, --ai, --aj;

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			if (mt[i][j] != '.') continue;
			for (int k = 0; k < 4; ++k) {
				int x = i + dx[k], y = j + dy[k];
				if (in(x, y) && mt[x][y] == '.') {
					merge(i*m+j, x*m+y);
				}
			}
		}
	}

	int it = 0;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			if (mt[i][j] != '.') continue;
			int g = get(i * m + j);
			gt[i][j] = g;
			if (id[g] == -1) {
				id[g] = it++;
			}
		}
	}

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			if (mt[i][j] != '.') continue;
			for (int k = 0; k < 4; ++k) {
				int x = i + ddx[k], y = j + ddy[k];
				if (in(x, y) && mt[x][y] == '.') {
					g[id[gt[i][j]]].push_back(id[gt[x][y]]);
					g[id[gt[x][y]]].push_back(id[gt[i][j]]);
				}
			}
		}
	}

	deque<int> q;
	d[id[gt[di][dj]]] = 0;
	q.push_back(id[gt[di][dj]]);
	while (!q.empty()) {
		int v = q.front();
		q.pop_front();
		for (int i = 0; i < g[v].size(); ++i) {
			int to = g[v][i];
			if (d[to] > d[v] + 1) {
				q.push_back(to);
				d[to] = d[v] + 1;
			}
		}
	}

	cout << (d[id[gt[ai][aj]]]>k ? "NO" : "YES");
}

signed main()
{
	setlocale(LC_ALL, "Russian");

#ifndef ONLINE_JUDGE	
	//freopen("input.txt", "r", stdin);
#else
	//freopen("kbest.in", "r", stdin);
	//freopen("kbest.out", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);

	//__time::t = clock();
	int t = 1; //cin >> t;
	while (t--)
		$main();

	return 0;
}