#include <algorithm>
#include <bitset>
#include <cassert>
#include <chrono>
#include <cmath>
#include <complex>
#include <cstring>
#include <iomanip>
#include <iostream>
#include <map>
#include <queue>
#include <random>
#include <set>
#include <stack>
#include <vector>
#define forn(i, n) for (int i = 0; i < n; ++i)
#define all(a) begin(a), end(a)
#define int long long
#define sqr(x) ((x) * (x))

using namespace std;
using ll = long long;

#ifdef _debug
#include "lib/debug.h"
#else
#define debug(...) 42
#endif

const int N   = 2e5 + 40;
const int INF = 1e9;

vector<pair<int, int>> g[N];

void solve() {
  int n;
  cin >> n;
  vector<int> p(n);
  for (int i = 1; i < n - 1; ++i) {
    cin >> p[i];
  }

  vector<int> to(n);
  for (int i = 1; i < n; ++i) {
    int jmp = max(0ll, i - p[i]);
    if (p[jmp] == 0) {
      to[i] = jmp;
    } else {
      to[i] = to[jmp];
    }
  }
  debug(to);

  for (int i = 0; i < n; ++i) {
    if (p[i] != 0)
      continue;

    for (int j = i + 1; j < min(n, i + 7); ++j) {
      int w = (j != i + 6);

      int target = (p[j] == 0) ? j : to[j];
      g[i].push_back({target, w});
    }
  }

  deque<int> q;
  vector<int> d(n, INF);
  d[0] = 0;
  q.push_back(0);

  while (!q.empty()) {
    int u = q.front();
    q.pop_front();
    for (auto [v, w] : g[u]) {
      if (d[v] > d[u] + w) {
        d[v] = d[u] + w;
        if (w == 0) {
          q.push_front(v);
        } else {
          q.push_back(v);
        }
      }
    }
  }
  if (d[n - 1] == INF)
    d[n - 1] = -1;
  cout << d[n - 1] << "\n";
}

signed main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
  solve();
  return 0;
}