#include <algorithm>
#include <bitset>
#include <cassert>
#include <chrono>
#include <cmath>
#include <complex>
#include <cstring>
#include <iomanip>
#include <iostream>
#include <map>
#include <queue>
#include <random>
#include <set>
#include <stack>
#include <vector>
#define forn(i, n) for (int i = 0; i < n; ++i)
#define all(a) begin(a), end(a)
#define int long long
#define sqr(x) ((x) * (x))

using namespace std;
using ll = long long;

#ifdef _debug
#include "lib/debug.h"
#else
#define debug(...) 42
#endif

const int N   = 2e5 + 40;
const int INF = 1e9;

int d[N][2];

void solve() {
  int n;
  cin >> n;
  vector<int> p(n);
  for (int i = 1; i < n - 1; ++i) {
    cin >> p[i];
  }

  vector<int> to(n);
  for (int i = 1; i < n; ++i) {
    int jmp = max(0ll, i - p[i]);
    if (p[jmp] == 0) {
      to[i] = jmp;
    } else {
      to[i] = to[jmp];
    }
  }
  debug(to);

  for (int i = 0; i < n; ++i) {
    d[i][0] = d[i][1] = INF;
  }
  d[0][1] = 0;

  deque<pair<int, int>> q;
  q.push_back({0, 1});

  while (q.size()) {
    auto [i, w] = q.front();
    q.pop_front();
    //   debug("source", i, w, d[i][w]);
    for (int j = i + 1; j < min(n, i + 7); ++j) {
      int t           = to[j];
      int need_to_pay = j != i + 6;

      if (d[t][need_to_pay] > d[i][w] + w) {
        d[t][need_to_pay] = d[i][w] + w;
        // debug("think", t, need_to_pay, d[t][need_to_pay]);
        if (w) {
          q.push_back({t, need_to_pay});
        } else {
          q.push_front({t, need_to_pay});
        }
      }
    }
  }

  int ans = min(d[n - 1][0], d[n - 1][1]);
  if (ans == INF)
    ans = -1;
  cout << ans << "\n";
}

signed main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
  solve();
  return 0;
}