﻿#define _CRT_SECURE_NO_WARNINGS
#include <bits/stdc++.h>
#include <unordered_map>
#include <random>
#include <chrono>
#include <deque>
using namespace std;

#define X real()
#define Y imag()
#define int long long
#define all(X) begin(X), end(X)
#define rall(X) (X).rbegin(), (X).rend()
#define union sedaeda
mt19937_64 rnd(chrono::system_clock::now().time_since_epoch().count());
int gcd(int a, int b) { return b ? gcd(b, a % b) : a; }
int lcm(int a, int b) { return a * b / gcd(a, b); }

const long double pi = acos(-1);
const long double eps = 1e-6;






struct pt {
	long long x, y;
	pt() {}
	pt(long long _x, long long _y) : x(_x), y(_y) {}
	pt operator+(const pt &p) const { return pt(x + p.x, y + p.y); }
	pt operator-(const pt &p) const { return pt(x - p.x, y - p.y); }
	long long cross(const pt &p) const { return x * p.y - y * p.x; }
	long long dot(const pt &p) const { return x * p.x + y * p.y; }
	long long cross(const pt &a, const pt &b) const { return (a - *this).cross(b - *this); }
	long long dot(const pt &a, const pt &b) const { return (a - *this).dot(b - *this); }
	long long sqrLen() const { return this->dot(*this); }
};



namespace Alik {
	typedef complex<long double> point;
	long double dot(point a, point b) {
		return real(conj(a) * b);
	}
	long double cross(point a, point b) {
		return imag(conj(a) * b);
	}

	long double pDistance(
		long double px, long double py, long double ax, long double ay, long double bx, long double by) {
		point x(px, py), y(ax, ay), z(bx, by);
		if (dot(x - y, z - y) >= 0 && dot(x - z, y - z) >= 0)
			return abs(cross(x - y, z - y) / sqrt(norm(z - y)));
		else
			return sqrt(min(norm(x - y), norm(x - z)));
	}

	vector<long double> getDists(
		vector<pt> &pol, vector<pt> &a) {

		auto get_dist = [&](int x, int y, int i) {
			int j = (i + 1) % pol.size();
			return pDistance(
				x, y, pol[i].x, pol[i].y, pol[j].x, pol[j].y);
		};

		std::vector<long double> res(a.size());
		for (int i = 0; i < a.size(); ++i) {
			auto[x, y] = a[i];
			res[i] = min(get_dist(x, y, 0), get_dist(x, y, (int)pol.size() - 1));

			int l = 0;
			int r = (int)pol.size() - 1;
			while (r - l > 5) {
				int lm = l + (r - l) / 3;
				int rm = r - (r - l) / 3;
				if (get_dist(x, y, lm) < get_dist(x, y, rm)) {
					r = rm;
				}
				else {
					l = lm;
				}
			}
			while (l <= r) {
				res[i] = min(res[i], get_dist(x, y, l++));
			}
		}

		return res;
	}
}; // namespace Alik


bool lexComp(const pt &l, const pt &r) {
	return l.x < r.x || (l.x == r.x && l.y < r.y);
}

int sgn(long long val) { return val > 0 ? 1 : (val == 0 ? 0 : -1); }

vector<pt> seq;
pt translation;
int n;

bool pointInTriangle(pt a, pt b, pt c, pt point) {
	long long s1 = abs(a.cross(b, c));
	long long s2 = abs(point.cross(a, b)) + abs(point.cross(b, c)) + abs(point.cross(c, a));
	return s1 == s2;
}

void prepare(vector<pt> &points) {
	n = points.size();
	int pos = 0;
	for (int i = 1; i < n; i++) {
		if (lexComp(points[i], points[pos]))
			pos = i;
	}
	rotate(points.begin(), points.begin() + pos, points.end());

	n--;
	seq.resize(n);
	for (int i = 0; i < n; i++)
		seq[i] = points[i + 1] - points[0];
	translation = points[0];
}

bool pointInConvexPolygon(pt point) {
	point = point - translation;
	if (seq[0].cross(point) != 0 &&
		sgn(seq[0].cross(point)) != sgn(seq[0].cross(seq[n - 1])))
		return false;
	if (seq[n - 1].cross(point) != 0 &&
		sgn(seq[n - 1].cross(point)) != sgn(seq[n - 1].cross(seq[0])))
		return false;

	if (seq[0].cross(point) == 0)
		return seq[0].sqrLen() >= point.sqrLen();

	int l = 0, r = n - 1;
	while (r - l > 1) {
		int mid = (l + r) / 2;
		int pos = mid;
		if (seq[pos].cross(point) >= 0)
			l = mid;
		else
			r = mid;
	}
	int pos = l;
	return pointInTriangle(seq[pos], seq[pos + 1], pt(0, 0), point);
}


double dist(pt a, pt b) {
	return sqrt((long double)((a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y)));
}

long double S(const vector<pt> &c) {
	long double s = 0;
	for (int i = 0; i < c.size(); i++) {
		int u = i, v = (i + 1) % c.size();
		s += (c[u].x - c[v].x) * (c[u].y + c[v].y) / 2;
	}
	return abs(s);
}

long double P(const vector<pt> &c) {
	long double p = 0;
	for (int i = 0; i < c.size(); i++)
		p += dist(c[i], c[(i + 1) % c.size()]);
	return p;
}

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);

//#ifndef ONLINE_JUDGE
//	freopen("input.txt", "r", stdin);
//#endif

	int n; cin >> n;
	vector<pt> c(n);
	for (auto &i : c)
		cin >> i.x >> i.y;
	int m; cin >> m;
	vector<pt> t(m);
	for (auto &i : t)
		cin >> i.x >> i.y;

	vector<long double> dists = Alik::getDists(c, t);

	vector<pair<long double, int>> order;

	prepare(c);
	vector<int> ans(m);
	for (int i = 0; i < m; i++) {
		if (pointInConvexPolygon(t[i]))
			ans[i] = 0;
		else
			order.emplace_back(dists[i], i);
	}

	sort(all(order));
	
	long double s = S(c), p = P(c);

	int j = 0;
	long double pw = 1.0;
	for (int i = 0; j < order.size(); i++) {
		long double r = (-p + sqrt(p * p + 4.0 * pi * s * (long double)(pw - 1))) / (2.0 * pi);
		while (j < order.size() && order[j].first + eps < r) {
			ans[order[j].second] = i;
			++j;
		}
		pw *= 2.0;
	}
	for (auto &i : ans)
		cout << i << "\n";
	return 0;
}