﻿#include <algorithm>
#include <bitset>
#include <cassert>
#include <chrono>
#include <ctime>
#include <deque>
#include <fstream>
#include <functional>
#include <initializer_list>
#include <iomanip>
#include <iostream>
#include <map>
#include <math.h>
#include <queue>
#include <random>
#include <set>
#include <stack>
#include <stdexcept>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <vector>

using namespace std;

#define ll long long
#define ull unsigned long long
#define ld long double
#define sz(a) (int) a.size()

const int inf = (int)1e9;
const ll linf = (ll)1e18;

const ll mod = 998244353ll;
const ld eps = (ld)1e-8;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

void solve() {
	int n, m, k; cin >> n >> m >> k;

	vector<vector<bool>> table(n, vector<bool>(m, true));

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			char c; cin >> c;
			if (c == '#') table[i][j] = false;
		}
	}

	vector<vector<vector<pair<pair<int, int>, int>>>> graph(n, vector<vector<pair<pair<int, int>, int>>>(m));

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			if (i > 0 && table[i - 1][j]) graph[i][j].emplace_back(make_pair(i - 1, j), 0);

			if (i < n - 1 && table[i + 1][j]) graph[i][j].emplace_back(make_pair(i + 1, j), 0);
			
			if (j > 0 && table[i][j - 1]) graph[i][j].emplace_back(make_pair(i, j - 1), 0);

			if (j < m - 1 && table[i][j + 1]) graph[i][j].emplace_back(make_pair(i, j + 1), 0);
		}
	}

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			
			if (i > 1 && table[i - 2][j] && !table[i - 1][j]) graph[i][j].emplace_back(make_pair(i - 2, j), 1);

			
			if (i < n - 2 && table[i + 2][j] && !table[i + 1][j]) graph[i][j].emplace_back(make_pair(i + 2, j), 1);

			
			if (j > 1 && table[i][j - 2] && !table[i][j - 1]) graph[i][j].emplace_back(make_pair(i, j - 2), 1);

			
			if (j < m - 2 && table[i][j + 2] && !table[i][j + 1]) graph[i][j].emplace_back(make_pair(i, j + 2), 1);
		}
	}

	vector<vector<int>> ans(n, vector<int>(m, -1));

	int dx, dy; cin >> dx >> dy;
	--dx; --dy;
	ans[dx][dy] = 0;

	deque<pair<int, int>> q;
	q.push_front(make_pair(dx, dy));

	while (!q.empty()) {
		int x = q.front().first;
		int y = q.front().second;
		q.pop_front();

		for (auto p : graph[x][y]) {
			if (ans[p.first.first][p.first.second] == -1) {
				ans[p.first.first][p.first.second] = ans[x][y] + p.second;
				if (p.second == 0) q.push_front(p.first);
				else q.push_back(p.first);
			}
		}
	}

	int ax, ay; cin >> ax >> ay;
	--ax; --ay;
	if (ans[ax][ay] <= k) cout << "YES";
	else cout << "NO";
}

signed main() {
	ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
	//cout << fixed << setprecision(14);
	int tet = 1;
	//cin >> tet;
	while (tet--) {
		solve();
	}
}