﻿#include <algorithm>
#include <bitset>
#include <cassert>
#include <chrono>
#include <ctime>
#include <deque>
#include <fstream>
#include <functional>
#include <initializer_list>
#include <iomanip>
#include <iostream>
#include <map>
#include <math.h>
#include <queue>
#include <random>
#include <set>
#include <stack>
#include <stdexcept>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <vector>

using namespace std;

#define ll long long
#define ull unsigned long long
#define ld long double
#define sz(a) (int) a.size()

const int inf = (int)1e9;
const ll linf = (ll)1e18;

const ll mod = 998244353ll;
const ld eps = (ld)1e-8;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

void solve() {
	int n; cin >> n;
	vector<int> p(n, 0);
	p[n - 1] = 0;

	for (int i = 1; i < n - 1; ++i) cin >> p[i];

	for (int i = 1; i < n - 1; ++i) {
		if (p[i] == 0) p[i] = i;
		else p[i] = p[i - p[i]];
	}

	//for (int i = 0; i < n; ++i) cout << p[i] << " ";
	//cout << "\n";
	vector<vector<pair<int, int>>> graph(n);

	for (int i = 0; i < n - 1; ++i) {
		for (int k = 1; k <= 5; ++k) {
			if (i + k >= n - 1) graph[i].emplace_back(n - 1, 1);
			else graph[i].emplace_back(p[i + k], 1);
		}
		if (i + 6 >= n - 1) graph[i].emplace_back(n - 1, 1);
		else graph[i].emplace_back(p[i + 6], 0);
	}

	vector<int> dist(n, n);
	dist[0] = 0;
	deque<int> pending;
	pending.push_back(0);

	while (!pending.empty()) {
		int v = pending.front();
		pending.pop_front();
		for (auto p : graph[v]) {
			int to = p.first;
			int w = p.second;
			if (dist[to] > dist[v] + w) {
				dist[to] = dist[v] + w;
				if (w == 0) {
					pending.push_front(to);
				}
				else {
					pending.push_back(to);
				}
			}
		}
	}

	if (dist[n - 1] == n) cout << -1;
	else cout << dist[n - 1];
}

signed main() {
	ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
	//cout << fixed << setprecision(14);
	int tet = 1;
	//cin >> tet;
	while (tet--) {
		solve();
	}
}