﻿#include <algorithm>
#include <bitset>
#include <cassert>
#include <chrono>
#include <ctime>
#include <deque>
#include <fstream>
#include <functional>
#include <initializer_list>
#include <iomanip>
#include <iostream>
#include <map>
#include <math.h>
#include <queue>
#include <random>
#include <set>
#include <stack>
#include <stdexcept>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <vector>

using namespace std;

#define ll long long
#define ull unsigned long long
#define ld long double
#define sz(a) (int) a.size()

const int inf = (int)1e9;
const ll linf = (ll)1e18;

const ll mod = 998244353ll;
const ld eps = (ld)1e-8;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

bool num (char c) {
	return (c >= '0' && c <= '9');
}

string num_str(int x) {
	string s = "";
	while (x != 0) {
		char c = '0' + x % 10;
		s = c + s;
		x /= 10;
	}
	return s;
}



void dfs(int v, int u, vector<vector<int>>& ach, vector<vector<int>>& bch, vector<int>& a, vector<int>& b, vector<int>& match, set<int>& leafs, vector<pair<int, int>>&op) {
    match[u] = v;

    for (int i = 0; i < sz(bch[v]); ++i) {
        if (i < sz(ach[u])) {
            if (leafs.count(ach[u][i])) leafs.erase(ach[u][i]);
            dfs(bch[v][i], ach[u][i], ach, bch, a, b, match, leafs, op);
        }
        else {
            int w = *leafs.begin();

            leafs.erase(w);

            int p = a[w];
            vector<int> new_ach;
            for (int& el : ach[p]) if (el != w) new_ach.push_back(el);
            ach[p] = new_ach;



            if (sz(ach[p]) == 0 && match[p] == -1) leafs.insert(p);

            a[w] = u;

            ach[u].push_back(w);

            op.emplace_back(w, u);

            dfs(bch[v][i], w, ach, bch, a, b, match, leafs, op);
        }
    }
}

void solve() {
    /*
    vector<int> deg(6, 1);
    for (int i = 1; i < 6; ++i) deg[i] = 10 * deg[i - 1];

    int q; cin >> q;
    map<string, int> mex;
    map<string, vector<int>> st;
    string s;
    while (q--) {
        cin >> s;
        if (st[s].size() == 0) {
            cout << s << "\n";
            mex[s] = 1;
            st[s].push_back(0);
            int j = sz(s) - 1;
            int k = sz(s) - 1;
            while (j > 0 && num(s[j])) --j;
            while (j < k && (s[j + 1] == '0')) ++j;
            string l = "";
            for (int i = 0; i <= j; ++i) l += s[i];
            while (j < k) {
                int x = 0;
                int h = k;
                int t = 0;
                while (h > j) {
                    x += (s[h] - '0') * deg[t];
                    ++t;
                    --h;
                }
                if (sz(st[l]) == 0) st[l].push_back(x);
                else {
                    if (sz(st[l + num_str(x)]) == 0) st[l].push_back(x);
                    if (mex[l] == x) {
                        int g = x;
                        while (sz(st[l + num_str(g)])) ++g;
                        mex[l] = g;
                    }
                }
                ++j;
                l += s[j];
            }
        }

        else {
            s = s + num_str(mex[s]);
            cout << s << "\n";
            mex[s] = 1;
            st[s].push_back(0);
            int j = sz(s) - 1;
            int k = sz(s) - 1;
            while (j > 0 && num(s[j])) --j;
            while (j < k && (s[j + 1] == '0')) ++j;
            string l = "";
            for (int i = 0; i <= j; ++i) l += s[i];
            while (j < k) {
                int x = 0;
                int h = k;
                int t = 0;
                while (h > j) {
                    x += (s[h] - '0') * deg[t];
                    ++t;
                    --h;
                }
                if (sz(st[l]) == 0) st[l].push_back(x);
                else {
                    if (sz(st[l + num_str(x)]) == 0) st[l].push_back(x);
                    if (mex[l] == x) {
                        int g = x;
                        while (sz(st[l + num_str(g)])) ++g;
                        mex[l] = g;
                    }
                }
                ++j;
                l += s[j];
            }
        }
    } */

    
	int n; cin >> n;

	vector<int> a(n);
	vector<int> b(n);

	vector<vector<int>> ach(n);
	vector<vector<int>> bch(n);

	set<int> leafs;

	for (int i = 1; i < n; ++i) {
		cin >> a[i];
		ach[a[i]].push_back(i);
	}
	for (int i = 1; i < n; ++i) {
		cin >> b[i];
		bch[b[i]].push_back(i);
	}

	for (int i = 1; i < n; ++i) {
		if (!sz(ach[i])) leafs.insert(i);
	}

	vector<int> match(n, -1);
    vector<pair<int, int>> op;
    dfs(0, 0, ach, bch, a, b, match, leafs, op);

    cout << sz(op) << "\n";
    for (auto p : op) cout << p.first << " " << p.second << "\n";

}

signed main() {
	ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
	//cout << fixed << setprecision(14);
	int tet = 1;
	//cin >> tet;
	while (tet--) {
		solve();
	}
}