#include <bits/stdc++.h>

typedef long long ll;
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
template <typename T1, typename T2>
inline bool chkmin(T1& x, T2 y) {
    if (y < x) {
        x = y;
        return 1;
    }
    return 0;
};
template <typename T1, typename T2>
inline bool chkmax(T1& x, T2 y) {
    if (y > x) {
        x = y;
        return 1;
    }
    return 0;
};

using namespace std;

void Input() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
}

const int MAX_RANK = 16;

struct Node {
    unordered_map<char, Node*> child;
    vector<int> rank_cnt;
    Node* pred;

    Node() : child(), rank_cnt(MAX_RANK, 0), pred(0){};
    Node(Node* pred) : child(), rank_cnt(MAX_RANK, 0), pred(pred){};

    void update() {
        for (int i = 0; i < MAX_RANK - 1; ++i) {
            this->rank_cnt[i + 1] = 0;
            for (auto [c, node] : this->child) {
                this->rank_cnt[i + 1] += node->rank_cnt[i];
            }
        }
    }

    void add_son(char c) {
        this->child[c] = new Node(this);
    }
};

Node* go_down(Node* root, string& s) {
    if (s.size() == 0) {
        return root;
    }
    char c = s.back();
    s.pop_back();
    if (root->child[c] == nullptr) {
        root->add_son(c);
        return go_down(root->child[c], s);
    } else {
        return go_down(root->child[c], s);
    }
}

Node* insert(Node* root, string& res, bool zero = false) {
    if (root->rank_cnt[0] == 0) {
        root->rank_cnt[0]++;
        return root;
    }

    int pw = 10;
    for (int rk = 1; rk < MAX_RANK; ++rk, pw *= 10) {
        for (char cur_number = (zero ? '0' : '1'); cur_number <= '9'; ++cur_number) {

            if (root->child[cur_number] == 0) {
                root->add_son(cur_number);
            }

            if (root->child[cur_number]->rank_cnt[rk - 1] < pw / 10) {
                res.push_back(cur_number);
                return insert(root->child[cur_number], res, 1);
            }
        }
    }
    return nullptr;
}

void recalc_rank(Node* R) {
    if (R == nullptr)
        return;
    R->update();
    recalc_rank(R->pred);
}

int main() {
    Input();

    int q;
    cin >> q;
    Node* root = new Node();
    while (q--) {
        string s;
        cin >> s;
        string sc = s;
        reverse(all(sc));

        Node* insert_root = go_down(root, sc);
        string prefix;
        Node* bottom = insert(insert_root, prefix);
        recalc_rank(bottom);
        cout << s << prefix << endl;
    }

    return 0;
}