// #define _GLIBCXX_DEBUG 1
#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
#if LOCAL
#define dbg(o) ({ cout << #o << " = " << (o) << "\n"; o; })
#else
#define dbg(o) (o)
#endif

#define ff first
#define ss second
#define len(a) (int)a.size()
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());
ll rng(ll l, ll r) { return uniform_int_distribution<ll> (l, r) (rnd); }

void vendory() {}

template<typename T>
ostream &operator<<(ostream &out, const vector<T> &v) {
    for (int x: v) {
        out << x << " ";
    }
    return out;
}

struct Trie {
    array<int, 'z' - 'A' + 1> letters;
    array<int, 10> digits;
    int best;
    int best_cont;
    int best_len;
    int best_cont_len;
    bool occupied;
};

int nextn = 0;
Trie nodes[1'500'000];

Trie &get(int i) {
    return nodes[i];
}

int alloc() {
    Trie &v = nodes[nextn++];
    v.letters.fill(-1);
    v.digits.fill(-1);
    v.best = -1;
    v.best_cont = -1;
    v.best_cont_len = -1;
    v.best_len = -1;
    v.occupied = false;
    return nextn - 1;
}

int go1(int v, char c) {
    if (c >= 'A') {
        if (get(v).letters[c - 'A'] == -1) {
            int u = alloc();
            get(v).letters[c - 'A'] = u;
            return u;
        } else {
            return get(v).letters[c - 'A'];
        }
    } else {
        if (get(v).digits[c - '0'] == -1) {
            int u = alloc();
            get(v).digits[c - '0'] = u;
            return u;
        } else {
            return get(v).digits[c - '0'];
        }
    }
}

void recalc(Trie &v) {
    if (!v.occupied) {
        v.best = -1;
        v.best_cont = -1;
        v.best_cont_len = -1;
        return;
    }

    int best = 1e9, best_cont = 1e9, best_cont_len = 1e9;
    for (int digit = 0; digit < 10; digit++) {
        int next = v.digits[digit];
        if (next == -1 || !get(next).occupied) {
            if (digit != 0 && digit < best) {
                best = digit;
            }
            if (1 < best_cont_len || (best_cont_len == 1 && digit < best_cont)) {
                best_cont = digit;
                best_cont_len = 1;
            }
        } else {
            int next_best = get(next).best_cont;
            int len = get(next).best_cont_len * 10;
            int number = digit * len + next_best;
            if (digit != 0 && number < best) {
                best = number;
            }
            if (len < best_cont_len || (len == best_cont_len && number < best_cont)) {
                best_cont = number;
                best_cont_len = len;
            }
        }
    }

    v.best = best;
    v.best_cont = best_cont;
    v.best_cont_len = best_cont_len;
}

vector<int> path(20);

int put(const string &s) {
    int v = 0;
    path.clear();
    for (char c : s) {
        v = go1(v, c);
        path.push_back(v);
    }
    int suffix = get(v).best;
    if (!get(v).occupied) suffix = 0;
    int suffix2 = suffix;
    bool zeros = true;
    for (int i = 6; i >= 0; --i) {
        int dpow = (int)pow(10, i);
        int digit = suffix / dpow;
        if (digit == 0 && zeros) continue;
        zeros = false;
        v = go1(v, char(digit + '0'));
        path.push_back(v);
        suffix -= digit * dpow;
    }
    if (get(v).occupied)
        assert(!get(v).occupied);
    get(v).occupied = true;
    reverse(all(path));
    for (int p : path) {
        recalc(get(p));
    }
    return suffix2;
}

void sol() {
    nextn = 0;
    alloc();

    int n;
    cin >> n;
    string s;

    for (int i = 0; i < n; ++i) {
        cin >> s;
        int result = put(s);
        cout << result << "\n";
    }
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#if LOCAL
    freopen("../A/input.txt", "r", stdin);
    vendory();
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        cout << "\n================================ " << i << " ================================" << endl;
        sol();
    }
#else
    vendory();
    sol();
#endif
    return (0-0);  // <3
}

// amogus