// #define _GLIBCXX_DEBUG 1
#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
#if LOCAL
#define dbg(o) ({ cout << #o << " = " << (o) << "\n"; o; })
#else
#define dbg(o) (o)
#endif

#define ff first
#define ss second
#define len(a) (int)a.size()
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());
ll rng(ll l, ll r) { return uniform_int_distribution<ll> (l, r) (rnd); }

void vendory() {}

vector<vector<pair<int, int>>> graph;

template<typename T>
ostream &operator<<(ostream &out, const vector<T> &v) {
    for (int x: v) {
        out << x << " ";
    }
    return out;
}

void sol() {
    int n, m, k;
    cin >> n >> m >> k;
    vector<string> map(n);
    for (int i = 0; i < n; ++i) {
        cin >> map[i];
    }
    int start_i, start_j, end_i, end_j;
    cin >> start_i >> start_j >> end_i >> end_j;
    int start = (start_i - 1) * m + (start_j - 1);
    int end = (end_i - 1) * m + (end_j - 1);

    graph.assign(n * m, {});
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            for (auto [di, dj] : {pair{0, 1}, {0, -1}, {1, 0}, {-1, 0}}) {
                int pi = i + di, pj = j + dj;
                if (pi < 0 || pi >= n || pj < 0 || pj >= m || map[i][j] == '#' || map[pi][pj] == '#')
                    continue;
                int v = i * m + j;
                int pv = pi * m + pj;
                graph[v].emplace_back(pv, 0);
            }
            for (auto [di, dj] : {pair{0, 2}, {0, -2}, {2, 0}, {-2, 0}}) {
                int pi = i + di, pj = j + dj;
                if (pi < 0 || pi >= n || pj < 0 || pj >= m || map[i][j] == '#' || map[pi][pj] == '#')
                    continue;
                int v = i * m + j;
                int pv = pi * m + pj;
                graph[v].emplace_back(pv, 1);
            }
        }
    }

    const int INF = 1e9;

    std::deque<int> q{start};
    std::vector<int> dist(n * m, INF);
    vector<bool> visited(n * m, false);
    dist[start] = 0;
    while (!q.empty()) {
        int v = q.front();
        q.pop_front();
        if (visited[v]) continue;
        visited[v] = true;
        int d = dist[v];
        for (auto [u, w] : graph[v]) {
            if (d + w >= dist[u]) continue;
            dist[u] = d + w;
            if (w == 0) {
                q.push_front(u);
            } else {
                q.push_back(u);
            }
        }
    }

    // dbg(dist);

    cout << (dist[end] > k ? "NO" : "YES") << "\n";
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#if LOCAL
    freopen("../A/input.txt", "r", stdin);
    vendory();
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        cout << "\n================================ " << i << " ================================" << endl;
        sol();
    }
#else
    vendory();
    sol();
#endif
    return (0-0);  // <3
}

// amogus