#include <bits/stdc++.h>

using namespace std;

struct heap {
    vector<int> a;
    unordered_map<int, int> b;
    int tail = 1;

    void siftDown(int i){
        while(1){
            int l = 2*i;
            if (l + 1 < tail && b[a[l]] > b[a[l+1]]) l++;
            if (l >= tail  || b[a[i]] <= b[a[l]]) break;
            swap(a[l], a[i]);
            i = l;
        }
    }
    void siftUp(int i){
        while (i > 1 && b[a[i/2]] > b[a[i]]){
            swap(a[i], a[i/2]);
            i = i / 2;
        }
    }

    void add(int i, int x){
        a[tail++] = i;
        b[i] = x;
        siftUp(tail-1);
    }

    int getMin(){
        return b[a[1]];
    }

    int getIndexMin(){
        return a[1];
    }

    void extractMin(){
        tail--;
        swap(a[1], a[tail]);
        siftDown(1);
    }

    int size(){
        return tail-1;
    }
    heap(): a(200001) {}

};

int main() {
    std::ios_base::sync_with_stdio(false);
    //cin.tie(0); cout.tie(0);

    int n, k;
    cin >> n >> k;

    vector<int> s(n);
    vector<int> a(n);

    for (int i = 0; i < n; ++i){
        cin >> s[i];
    }


    heap values;
    double cur = 0;
    for (int i = 0; i < n; ++i){
        cin >> a[i];
        values.add(s[i], a[i]);
        cur += (double)(abs(s[i] - a[i])) / (double)(s[i]);
    }

    double needed = cur - k;

    int acur, scur;
    int operations = 0;
    while(needed > 0){
        acur = values.getMin();
        scur = values.getIndexMin();
        values.extractMin();
        if (acur == scur){
            continue;
        } else{
            operations += min((int)ceil(needed), abs(acur -scur));
            needed -= abs(acur-scur);
        }
    }
    cout << operations << endl;
}