#include <iostream>
#include <vector>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <cmath>

int n, m, k;
int n0;
std::pair <int, int> s, t;

struct dir {
    int x, y;
};

std::vector <std::vector <int>> bad;

const dir d1[] = {{0, 1}, {1, 0}, {0, -1}, {-1, 0}};
const dir d2[] = {{0, 2}, {2, 0}, {0, -2}, {-2, 0}};

bool check(std::pair <int, int> q) {
    return (1 <= q.first && q.first <= n && 1 <= q.second && q.second <= m);
}

std::vector <std::vector <int>> used;
void dfs(std::pair <int, int> p, int k0) {
    if (used[p.first][p.second] || k0 > k) {
        return;
    }
    used[p.first][p.second] = 1;
    for (const auto &el: d1) {
        int x_next = p.first + el.x;
        int y_next = p.second + el.y;
        if (check({x_next, y_next})) {
            if (bad[x_next][y_next] == 0) {
                dfs({x_next, y_next}, k0);
            }
        }
    }
    for (const auto &el: d2) {
        int x_next = p.first + el.x;
        int y_next = p.second + el.y;
        if (check({x_next, y_next})) {
            if (bad[x_next][y_next] == 0) {
                dfs({x_next, y_next}, k0 + 1);
            }
        }
    }
}

int main() {
    std::ios_base::sync_with_stdio(false);
    // cin.tie(0); cout.tie(0);
    std::cin >> n >> m >> k;
    bad.resize( 2 * n + 1, std::vector <int> (2 * m + 1, 0));
    used.resize(2 * n + 1, std::vector <int>(2 * m + 1, 0));
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            char q;
            std::cin >> q;
            if (q == '#') {
                bad[i][j] = 1;
            }
        }
    }
    int s1, s2;
    std::cin >> s1 >> s2;
    s = {s1, s2};
    std::cin >> s1 >> s2;
    t = {s1, s2};
    dfs(s, 0);
    if (used[t.first][t.second] == 1) {
        std::cout << "YES";
    } else {
        std::cout << "NO";
    }
}