#include <iostream>
#include <unordered_map>
#include <vector>
#include <deque>

using namespace std;

vector<vector<pair<int, int>>> graph;

int main() {
    int n;
    cin >> n;
    vector<int> p(n - 1);
    p[0] = 0;
    for (int i = 1; i < n - 1; ++i) {
        cin >> p[i];
    }
    vector<int> back(n);
    back[0] = 0;
    for (int i = 1; i < n - 1; ++i) {
        if (p[i] == 0) {
            back[i] = i;
        } else {
            back[i] = back[i - p[i]];
        }
    }

    graph.resize(n);
    for (int i = 0; i < n - 1; ++i) {
        for (int j = 1; j <= 5; ++j) {
            if (i + j >= n - 1) {
                graph[i].push_back({n - 1, 1});
            } else {
                graph[i].push_back({back[i + j], 1});
            }
        }
        if (i + 6 >= n - 1) {
            graph[i].push_back({n - 1, 1});
        } else {
            graph[i].push_back({back[i + 6], 0});
        }
    }

    vector<int> used(n, 0);
    vector<int> dist(n, int(1e9));
    dist[0] = 0;

    deque<int> bfs;
    bfs.push_back(0);

    while (!bfs.empty()) {
        int u = bfs.front();
        //cout << u << '\n';
        bfs.pop_front();
        used[u] = 1;
        for (pair<int, int> t: graph[u]) {
            if (used[t.first] == 1) {
                continue;
            }
            //cout << t.first << ' ' << t.second << '\n';
            if ((t.second == 0) && (dist[t.first] > dist[u])) {
                bfs.push_front(t.first);
                dist[t.first] = dist[u];
            } else {
                if ((t.second == 1) && (dist[t.first] > dist[u] + 1)) {
                    bfs.push_back(t.first);
                    dist[t.first] = dist[u] + 1;
                }
            }
        }
    }

    if (dist[n - 1] == int(1e9)) {
        cout << -1 << '\n';
    } else {
        cout << dist[n - 1] << '\n';
    }

    return 0;
}