#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <deque>
#include <map>
#include <set>
#include <complex>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <random>
#include <cstring>
#include <cassert>

#define ft first
#define sc second
#define pb push_back
#define len(v) (int)v.size()
//#define int ll

using namespace std;
typedef long long ll;
typedef long double ld;

const int inf = 1e9 + 100;

int main() {
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
//    freopen("out.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m, k;
    cin >> n >> m >> k;
    vector<vector<bool>> mat(n, vector<bool> (m, 1));
    vector<vector<int>> dist(n, vector<int> (m, inf));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            char c;
            cin >> c;

            if (c == '#') {
                mat[i][j] = 0;
            }
        }
    }

    int xs, ys;
    int xf, yf;
    cin >> xs >> ys >> xf >> yf;
    xs--, ys--, xf--, yf--;

    set<pair<int, pair<int, int>>> q;
    q.insert({0, {xs, ys}});
    dist[xs][ys] = 0;

    while (!q.empty()) {
        auto frst = *q.begin();
        q.erase(frst);

        for (int dx = -1; dx < 2; dx++) {
            for (int dy = -1; dy < 2; dy++) {
                if (abs(dx) + abs(dy) != 1)
                    continue;
                int nxti = frst.sc.ft + dx;
                int nxtj = frst.sc.sc + dy;
                int dn = frst.ft;
                if (nxti < 0 || nxtj < 0 || nxti >= n || nxtj >= m)
                    continue;
                if (!mat[nxti][nxtj])
                    continue;
                if (dn < dist[nxti][nxtj]) {
                    dist[nxti][nxtj] = dn;
                    q.insert({dn, {nxti, nxtj}});
                }
            }
        }

        for (int dx = -1; dx < 2; dx++) {
            for (int dy = -1; dy < 2; dy++) {
                if (abs(dx) + abs(dy) != 1)
                    continue;
                int nxti = frst.sc.ft + 2 * dx;
                int nxtj = frst.sc.sc + 2 * dy;
                int dn = frst.ft + 1;
                if (nxti < 0 || nxtj < 0 || nxti >= n || nxtj >= m)
                    continue;
                if (!mat[nxti][nxtj])
                    continue;
                if (dn < dist[nxti][nxtj]) {
                    dist[nxti][nxtj] = dn;
                    q.insert({dn, {nxti, nxtj}});
                }
            }
        }
    }

    if (dist[xf][yf] <= k) {
        cout << "YES" << endl;
    } else {
        cout << "NO" << endl;
    }
}