#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <deque>
#include <time.h>
#include <map>
#include <set>
#include <complex>
#include <string>
#include <cstring>
#include <unordered_map>
#include <unordered_set>
#include <random>
#include <deque>

#define ft first
#define sc second
#define pb push_back
#define int ll

using namespace std;
typedef long long ll;
typedef long double ld;

struct point {
    int x, y;
    point() {}
    point(int x, int y): x(x), y(y) {}
    point operator - (point other) {
        return point(x - other.x, y - other.y);
    }
    point operator + (point other) {
        return point(x + other.x, y + other.y);
    }
    int operator * (point other) {
        return x * other.x + y * other.y;
    }
    int operator ^ (point other) {
        return x * other.y - y * other.x;
    }
    long double len() {
        return sqrtl(x * x + y * y);
    }
    point norma() {
        return point(-y, x);
    }
    point neg() {
        return point(-x, -y);
    }
};

vector <point> poly;
int n;

bool is_inside(point x) {
    //cout << 53 << endl;
    if (((poly[1] - poly[0]) ^ (x - poly[0])) < 0) {
        return false;
    }
    if (((x - poly[0]) ^ (poly[n - 1] - poly[0])) < 0) {
        return false;
    }
    int l = 1, r = n - 1, mid;
    while (r - l > 1) {
        mid = (l + r) / 2;
        if (((poly[mid] - poly[0]) ^ (x - poly[0])) >= 0) {
            l = mid;
        } else {
            r = mid;
        }
    }
    return ((poly[l + 1] - poly[l]) ^ (x - poly[l])) >= 0;
}

long double dist_to_segm(point v, point a, point b) {
    point p = b - a;
    long double t = 1.0L * ((v - a) * p) / (p * p);
    //cout << "!" << t << endl;
    if (t > 0 && t < 1) {
        point n = p.norma();
        long double t2 = 1.0L * ((a - v) * n) / (n * n);
        return abs(t2) * n.len();
    }
    return min((v - a).len(), (v - b).len());
}

const long double PI = acos(-1);

int sign(int x) {
    if (x > 0) {
        return 1;
    }
    if (x < 0) {
        return -1;
    }
    return 0;
}

signed main() {
#ifdef LOCAL
    freopen("in_vanya.txt", "r", stdin);
    // freopen("out.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    poly.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> poly[i].x >> poly[i].y;
    }
    long long s2 = 0;
    long double p = 0;
    for (int i = 0; i < n; i++) {
        int j = (i + 1) % n;
        s2 += poly[i] ^ poly[j];
        p += (poly[j] - poly[i]).len();
    }
    //cout << s2 << endl;
    int q;
    cin >> q;
    for (int i = 0; i < q; i++) {
        point v;
        cin >> v.x >> v.y;
        if (is_inside(v)) {
            cout << 0 << "\n";
            continue;
        }

        int ind_lower = -1, ind_upper = -1;

        auto df_sign = [&](int ind) {
            int prv = ind == 0 ? n - 1 : ind - 1;
            return sign((poly[prv] - v) ^ (poly[ind] - v));
        };
        auto abs_sign = [&](int ind) {
            return sign((poly[0] - v) ^ (poly[ind] - v));
        };

        int l = 0, r = n, mid;
        int on_back = (abs_sign(1) == 1 || (abs_sign(1) == 0 && abs_sign(2) == 1)) ? (-1) : 1;
        //if df_sign(0);
        //cout << "! " << on_back << ' ' << df_sign(endl;
//        cout << "!" << df_sign(1) << endl;
        while (r - l > 1) {
            mid = (l + r) / 2;
            if (df_sign(mid) * on_back > 0) {
                r = mid;
                continue;
            }
            if (abs_sign(mid) * on_back > 0) {
                r = mid;
                continue;
            }
            l = mid;
        }
        ind_lower = l;

        l = 0, r = n;
        while (r - l > 1) {
            mid = (l + r) / 2;
            if (df_sign(mid) * on_back > 0) {
                l = mid;
                continue;
            }
            if (abs_sign(mid) * on_back > 0) {
                r = mid;
                continue;
            }
            l = mid;
        }
        ind_upper = l;
        if (on_back == 1) {
            swap(ind_upper, ind_lower);
            ind_upper += n;
        }
        l = ind_lower;
        r = ind_upper;
        while (r - l > 1) {
            mid = (l + r) / 2;
            if (((poly[mid % n] - v) ^ ((poly[(mid + 1) % n] - poly[mid % n]).norma())) <= 0) {
                l = mid;
            } else {
                r = mid;
            }
        }
        long double d = dist_to_segm(v, poly[l % n], poly[(l + 1) % n]);
        //cout << ind_lower << ' ' << ind_upper << ' ' << l << ' ' << d << endl;
        d = min(d, dist_to_segm(v, poly[(l - 1 + n) % n], poly[l % n]));
        //cout << d << endl;
        long double val = 2 * (p * d + PI * d * d) / s2 + 1;
        int ans = ceil(log2(val));
        cout << ans << '\n';//' ' << d << '\n';
    }
}