#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <iomanip>
#include <cmath>
#include <iomanip>

using namespace std;

#define ll long long

int solve();

int main() {
    solve();
    return 0;
}

const int MAXN = 1002;

char c[MAXN][MAXN];
int d[MAXN][MAXN];
set<pair<int, pair<int, int>>> q;

vector<pair<int, int>> go = {{1,  0},
                             {0,  1},
                             {0,  -1},
                             {-1, 0},
                             {2,  0},
                             {0,  2},
                             {0,  -2},
                             {-2, 0}};
int n, m, k;

bool isOk(int i, int j) {
    return i >= 1 && i <= n && j >= 1 && j <= m && c[i][j] == '.';
}

int solve() {
    cin >> n >> m >> k;
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            cin >> c[i][j];
        }
    }
    int start_x, start_y, end_x, end_y;
    cin >> start_x >> start_y >> end_x >> end_y;
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            d[i][j] = MAXN * MAXN;
        }
    }
    d[start_x][start_y] = 0;
    q.insert({0, {start_x, start_y}});
    while (!q.empty()) {
        auto it = q.begin();
        pair<int, int> v = it->second;
        int cur_d = it->first;
        q.erase(q.begin());
        for (const auto &delta : go) {
            pair<int, int> u = {v.first + delta.first, v.second + delta.second};
            if (!isOk(u.first, u.second)) {
                continue;
            }
            int new_d = cur_d + max(abs(delta.first), abs(delta.second)) / 2;
            if (new_d < d[u.first][u.second]) {
                d[u.first][u.second] = new_d;
                q.insert({new_d, u});
            }
        }
    }
    if (d[end_x][end_y] <= k) {
        cout << "YES" << endl;
    } else {
        cout << "NO" << endl;
    }
    return 0;
}
