#include <iostream>
#include <vector>
#include <set>

using ll = long long;
using namespace std;

vector<vector<ll>> cs;
vector<set<ll>> edgesfromcs;
vector<ll> pole, dir{1, -1};
ll n, m, k;

bool inside(ll x, ll y){
    return x>=0&&x<n&&y>=0&&y<=m;
}

void dfs_add(ll i){
    for(auto x : dir){
        for(auto y : dir){
            ll j = i+(y+1?m*x:x);
            if(inside(i/m+(y+1?x:0), i%m+(y+1?0:x))&&pole[j]==-1){
                pole[j]=pole[i];
                cs[pole[j]].push_back(j);
                dfs_add(j);
            }
        }
    }
}




int main()
{
    cin>>n>>m>>k;
    pole.reserve(n*m);
    for(int i = 0; i<n; i++){
        for(int j = 0; j<m; j++){
            char c;
            cin>>c;
            pole[i*m+j]=c=='.'?-1:-2;
        }
    }
    for(int i = 0; i<n*m; i++){
        if(pole[i]==-1){
            pole[i]=cs.size();
            cs.push_back(vector<ll>{i});
            edgesfromcs.push_back(set<ll>{});
            dfs_add(i);
        }
    }
    for(int i = 0; i<n*m; i++){
        if(pole[i]<0)continue;
        for(auto x : dir){
            for(auto y : dir){
                ll j = i+2*(y+1?m*x:x);
                if(inside(i/m+2*(y+1?x:0), i%m+2*(y+1?0:x))&&pole[j]>=0&&pole[i]!=pole[j]){
                    edgesfromcs[pole[i]].insert(pole[j]);
                    edgesfromcs[pole[j]].insert(pole[i]);
                }
            }
        }
    }
    ll st, end, a, b, cur = 0;
    cin>>a>>b;
    st = pole[(a-1)*m+b-1];
    cin>>a>>b;
    end = pole[(a-1)*m+b-1];
    set<ll> reach{st};
    vector<ll> cur_reach{st}, dist{0};
    ll ans=-1;
    if(st==end)
        ans=0;
    else {
        for (; cur < cur_reach.size(); cur++) {
            for (auto i: edgesfromcs[cur_reach[cur]]) {
                if(dist[cur]==k)break;
                if (reach.find(i) == reach.end()) {
                    reach.insert(i);
                    cur_reach.push_back(i);
                    dist.push_back(dist[cur] + 1);
                    if (i == end) {
                        ans = dist[cur]+1;
                        break;
                    }
                }
            }
        }
    }
    if(ans>=0)
        cout<<"YES";
    else
        cout<<"NO";











}