#include <algorithm>
#include <cmath>
#include <iostream>
#include <utility>
#include <vector>

#define MULT 2520

int main() {
    std::cin.tie(0);
    std::ios::sync_with_stdio(false);

    int64_t N, K;
    std::cin >> N >> K;

    std::vector<int64_t> a;
    std::vector<std::pair<int, int>> s;
    s.reserve(N);
    a.reserve(N);

    int x;
    for (int i = 0; i < N; ++i) {
        std::cin >> x;
        s.push_back(std::make_pair(x, i));
    }
    for (int i = 0; i < N; ++i) {
        std::cin >> x;
        a.push_back(x);
    }
    
    int64_t deviation = 0;
    for (int i = 0; i < N; ++i) {
        deviation += static_cast<int64_t>(MULT) / s[i].first * (std::abs(a[i] - s[i].first));
    }

    std::sort(s.begin(), s.end(), [](const std::pair<int, int>& a, const std::pair<int, int>& b){ return a.first < b.first; });
    int i = 0, time = 0;
    while (deviation > K * MULT) {
        auto& [weight, index] = s[i];
        if (static_cast<int64_t>(MULT) / weight * std::abs(a[index] - weight) < deviation - K * MULT) {
            time += std::abs(a[index] - weight);
            deviation -= static_cast<int64_t>(MULT) / weight * std::abs(a[index] - weight);
            ++i;
        } else {
            time += (deviation - MULT * K) / (MULT / weight);
            deviation = K * MULT;
        }
    }

    std::cout << time << std::endl;
    return 0;
}