#include <algorithm>
#include <cmath>
#include <iomanip>
#include <iostream>
#include <vector>

using namespace std;

struct point {
  int x, y;
};

struct segment {
  point p1, p2;
  double len() { return hypot(abs(p1.x - p2.x), abs(p1.y - p2.y)); }
};

inline bool operator<(segment s1, segment s2) { return s1.len() < s2.len(); }

int main() {
  int n;
  cin >> n;

  vector<point> p(n);
  for (int i{0}; i < n; i++)
    cin >> p.at(i).x >> p.at(i).y;

  vector<segment> a;
  for (int i{0}; i < n - 1; i++)
    a.push_back({p[i], p[i + 1]});
  a.push_back({p[n - 1], p[0]});

  sort(a.begin(), a.end());

  double res{};
  for (int i{0}; i < a.size() - 1; i++)
    res += a[i].len();

  cout << fixed << setprecision(6) << res << '\n';
}
