import math
from functools import lru_cache


@lru_cache(maxsize=None)
def factorial(n):
    return math.factorial(n)


@lru_cache(maxsize=None)
def first(n, k):
    return factorial(n) / (factorial((n - k)) * factorial(k))


@lru_cache(maxsize=None)
def second(n, k, s, t):
    return factorial((t - s * k - 1)) / (factorial((t - s * k - n)) * factorial((n - 1)))


def answer(n, s, t):
    T = 0
    for k in range(0, int((t - n) / s) + 1):
        T = T + ((-1) ** k) * first(n, k) * second(n, k, s, t)
    return T


n = int(input())
k = int(input())
s1 = int(input())
s2 = int(input())

t1 = answer(n, k, s1)
t2 = answer(n, k, s2)
if t1 == t2:
    print("Equal")
elif t1 > t2:
    print("First")
else:
    print("Second")
