#include <iostream>
#include <algorithm>
#include <cmath>
#include <numeric>
#include <vector>

using namespace std;

long long N, K, TIME = 0;
double total_error = 0;


bool cmp(const std::pair<int, int>& a, const std::pair<int, int>& b) {
    return 1 / a.first > 1 / b.first;
}


int main() {
    std::vector<double> si;
    std::vector<double> ai;
    std::vector<std::pair<double, double>> result;

    std::ios_base::sync_with_stdio(false);
    std::cin.tie(0);
    std::cout.tie(0);

    std::cin >> N >> K;

    si.resize(N);
    ai.resize(N);
    result.resize(N);

    for (auto& v: si) {
        std::cin >> v;
    }

    for (auto& v: ai) {
        std::cin >> v;
    }

    for (size_t i = 0; i < N; i++) {
        result[i].first = si[i];
        result[i].second = ai[i];
    }

    std::sort(result.begin(), result.end(), cmp);

    for (auto &v: result) {
        total_error += abs(v.first - v.second) / v.first;
    }

    size_t i = 0;

    while (total_error > K) {
        if (result[i].first == result[i].second) {
            i++;
        } else if (result[i].first > result[i].second) {
            TIME++;
            result[i].second++;
            total_error -= 1/result[i].first;

        } else if (result[i].first < result[i].second) {
            TIME++;
            result[i].second--;
            total_error -= 1/result[i].first;
        }
    }

    std::cout << TIME << std::endl;

    return 0;
}