import java.io.*;
import java.nio.channels.FileChannel;
import java.nio.charset.StandardCharsets;
import java.nio.file.Files;
import java.util.*;
import java.util.concurrent.atomic.AtomicInteger;

public class Main {


    public static void main(String[] args) {
        Solver solver = new Solver();
        solver.solv();
        solver.end();
    }
}

class Solver {
    public static Data data = new DataManagerScanner();


    public void end() {
        data.end();
    }

    public double norm(Pair<Long, Long> x, Pair<Long, Long> y) {
        return Math.sqrt((x.f - y.f) * (x.f - y.f) + (x.s - y.s) * (x.s - y.s));
    }

    public Pair<Long, Long> del(long x) {
        long a = x / 2;
        if (a % 2 == 0) {
            return new Pair<>(a, x - a);
        } else return new Pair<>(x - a, a);
    }
    HashSet<String> set = new HashSet<>();


    public String add(String name, long i) {
        if(set.contains(name + "" + i))return (add(name
        ,i + 1));
        set.add(name +  "" +i);
        return name +  "" +i;
    }
    public void solv() {
        Scanner sc = new Scanner(System.in);
        long n = Long.parseLong(sc.nextLine());
        for (int i = 0; i < n; i++) {
            String s = sc.next();

            if(set.contains(s)) {
                data.print(add(s, 1) + "\n");
            } else {
                data.print(s + "\n");
                set.add(s);
            }
        }






    }


    public boolean check(int i, Object[] a) {
        return i >= 0 && i < a.length;
    }

    public boolean check(int i, int[] a) {
        return i >= 0 && i < a.length;
    }


}


interface Data {
    StringBuilder str = new StringBuilder();

    int readNextInt();

    long readNextLong();

    double readNextDouble();

    String readNextLine();

    String readNext();


    default int[] readNextArr() {
        int n = readNextInt();

        nextRow();

        int[] arr = new int[n];
        for (int i = 0; i < n; i++) {


            arr[i] = readNextInt();
        }

        return arr;
    }

    // not stable
    interface MetaFunc<T> {
        void did(T x, int i);
    }

    default int[] readNextArr(int n) {
        int[] arr = new int[n];
        for (int i = 0; i < n; i++) {
            arr[i] = readNextInt();

        }

        return arr;
    }

    default void processNextArr(int n, MetaFunc<Integer>... does) {

        for (int i = 0; i < n; i++) {

            for (MetaFunc<Integer> dos : does) {
                dos.did(readNextInt(), i);
            }
        }


    }

    default long[] readNextArrLong(int n) {
        long[] arr = new long[n];
        for (int i = 0; i < n; i++) {


            arr[i] = readNextLong();
        }

        return arr;
    }


    boolean nextRow();

    void end();


    default void print(String s) {
        str.append(s);
    }

    ;

    default List<Integer> readAllInt() {
        List<Integer> list = new ArrayList<>();
        while (canRead()) list.add(readNextInt());
        return list;
    }

    /**
     * unchecked
     */
    default <T> void print(Iterable<T> list) {
        for (T t : list) print(t.toString() + " ");
    }


    default List<Long> readAllLong() {
        List<Long> list = new ArrayList<>();
        while (canRead()) list.add(readNextLong());
        return list;
    }


    default void print(Object o) {
        print(o.toString());
    }

    ;

    default void print(Object... o) {
        for (Object o1 : o) {
            print(o1.toString() + " ");
        }
    }


    default String getText() {
        String s = str.toString();
        str.delete(0, str.length());
        return s;
    }


    boolean canRead();

    // you should not skip row before call this
    default void processLinesInt(int n, MetaFunc<Integer>... does) {
        for (int i = 0; i < n; i++) {
            nextRow();
            for (MetaFunc<Integer> dos : does) {
                dos.did(readNextInt(), i);
            }
        }
    }


}


class DataManagerScanner implements Data {
    Scanner sc;


    DataManagerScanner(Scanner sc) {
        this.sc = sc;

    }


    DataManagerScanner() {
        this.sc = new Scanner(System.in);

    }

    public String readNextLine() {
        return sc.nextLine();
    }

    public String readNext() {
        return sc.next();
    }

    public int readNextInt() {
        return sc.nextInt();
    }

    public long readNextLong() {
        return sc.nextLong();
    }

    @Override
    public double readNextDouble() {
        return sc.nextDouble();
    }


    public boolean nextRow() {
        return true;
    }


    @Override
    public boolean canRead() {
        return sc.hasNext();
    }

    public void end() {
        System.out.println(getText());

    }


}

class DataManager implements Data {
    File in;
    File out;

    StringTokenizer st;
    BufferedReader br;
    PrintWriter pr;

    DataManager() {

        in = new File("input.txt");
        out = new File("output.txt");
        try {
            FileReader fr = new FileReader(in);
            this.br = new BufferedReader(fr);
            this.st = new StringTokenizer(br.readLine());
            this.pr = new PrintWriter(out);
        } catch (IOException e) {
            throw new RuntimeException(e);
        }


    }

    public DataManager(File in, File out) {

        this.in = in;
        this.out = out;
        try {
            FileReader fr = new FileReader(in);
            this.br = new BufferedReader(fr);
            this.st = new StringTokenizer(br.readLine());
            this.pr = new PrintWriter(out);
        } catch (FileNotFoundException e) {
            throw new RuntimeException(e);
        } catch (IOException e) {
            throw new RuntimeException(e);
        }


    }


    public String readNextLine() {
        return st.nextToken("");

    }

    public String readNext() {
        return st.nextToken();
    }

    public int readNextInt() {
        return Integer.parseInt(st.nextToken());
    }


    public long readNextLong() {
        return Long.parseLong(st.nextToken());
    }

    @Override
    public double readNextDouble() {
        return Double.parseDouble(st.nextToken());
    }


    public boolean nextRow() {
        try {

            String str = br.readLine();
            // System.out.println(str);
            this.st = new StringTokenizer(str);
            return true;
        } catch (IOException e) {
            return false;
        }
    }


    public List<Integer> readAllInt() {
        List<Integer> list = new ArrayList<>();
        while (st.hasMoreTokens()) list.add(readNextInt());
        return list;
    }


    @Override
    public boolean canRead() {

        return st.hasMoreTokens();
    }

    @Override
    public void end() {
        pr.write(getText());
        pr.flush();
    }

    public List<String> readAll() {
        try {
            List<String> list = new ArrayList<>();
            for (String s : Files.readAllLines(this.in.toPath(), StandardCharsets.UTF_8)) {
                if (!s.isEmpty()) list.addAll(List.of(s.split(" ")));

            }
            return list;
        } catch (Exception e) {
            return null;
        }
    }

}

class Pair<F, S> {
    F f;
    S s;

    Pair() {

    }

    Pair(Pair<F, S> p) {
        this.f = p.f;
        this.s = p.s;
    }

    Pair(F f, S s) {
        this.f = f;
        this.s = s;
    }


    @Override
    public int hashCode() {
        return Objects.hash(f, s);
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        Pair<?, ?> pair = (Pair<?, ?>) o;
        return Objects.equals(f, pair.f) && Objects.equals(s, pair.s);
    }

    public String toString() {
        return ((f != null ? f.toString() : "") + " " + (s != null ? s.toString() : ""));
    }
}

interface Graf<T> {
    HashSet<T> get(T x);

    default void add(T x, T y) {
        get(x).add(y);
    }

    default void link(T x, T y) {
        add(x, y);
        add(y, x);
    }
}

class HashGraf<T> implements Graf<T> {

    private HashMap<T, HashSet<T>> map = new HashMap<>();

    public boolean has(T x) {
        return map.containsKey(x);
    }

    public Set<T> all() {
        return map.keySet();
    }

    public HashMap<Pair<T, T>, Long> len = new HashMap<>();

    @Override
    public HashSet<T> get(T x) {
        if (!map.containsKey(x)) {
            map.put(x, new HashSet<>());
        }
        return map.get(x);
    }


    public void add(T x, T y, long l) {
        Graf.super.add(x, y);
        addLen(x, y, l);
        addLen(y, x, l);

    }

    public void addLen(T x, T y, long l) {
        Pair<T, T> pair = new Pair<>(x, y);

        len.put(pair, Math.max(len.getOrDefault(pair, l), l));
    }


    public void link(T x, T y, long l) {
        Graf.super.link(x, y);
        addLen(x, y, l);
        addLen(y, x, l);
    }
}