#include <iostream>
#include <vector>
#include <string>
#include <queue>
#include <unordered_map>

#define ll long long
#define ve vector
#define str string

using namespace std;

struct vert {
	ll i = 0;
	ll j = 0;
	ll jump = 0;
};

str hashV(vert v) {
	return to_string(v.i) + "_" + to_string(v.j) + "_" + to_string(v.jump);
}

int main() {
	ll n, m, k;
	cin >> n >> m >> k;

	ve<str> mp(n);

	for (ll i = 0; i < n;i++) {
		cin >> mp [i];
	}

	ll di, dj;
	cin >> di >> dj;
	di--;
	dj--;

	ll ai, aj;
	cin >> ai >> aj;
	ai--;
	aj--;

	queue<vert> q;
	unordered_map<str, bool> used;

	vert st;
	st.i = di;
	st.j = dj;
	st.jump = 0;


	str stHash = hashV(st);
	used [stHash] = 1;

	q.push(st);

	while (!q.empty()) {

		vert cur = q.front();
		q.pop();

		if (cur.i == ai && cur.j == aj) {
			cout << "YES\n";
			return 0;
		}

		vert nxt = cur;
		str nxtHash = hashV(nxt);

		//cout << nxtHash << '\n';

		vert nxtJump = cur;
		nxtJump.jump++;
		str nxtJumpHash = hashV(nxtJump);

		nxt.i++;
		nxtJump.i += 2;
		if (nxt.i < n && mp [nxt.i][nxt.j] != '#' && !used [hashV(nxt)]) {
			q.push(nxt);
			used [hashV(nxt)] = 1;
		}
		else if (nxtJump.jump <= k && nxtJump.i < n && mp [nxtJump.i][nxtJump.j] != '#' && !used [hashV(nxtJump)]) {
			q.push(nxtJump);
			used [hashV(nxtJump)] = 1;
		}
		nxt.i--;
		nxtJump.i -= 2;

		// =======================

		nxt.i--;
		nxtJump.i -= 2;
		if (nxt.i >= 0 && mp [nxt.i][nxt.j] != '#' && !used [hashV(nxt)]) {
			q.push(nxt);
			used [hashV(nxt)] = 1;
		}
		else if (nxtJump.jump <= k && nxtJump.i >= 0 && mp [nxtJump.i][nxtJump.j] != '#' && !used [hashV(nxtJump)]) {
			q.push(nxtJump);
			used [hashV(nxtJump)] = 1;
		}
		nxt.i++;
		nxtJump.i += 2;

		// =======================

		nxt.j++;
		nxtJump.j += 2;
		if (nxt.j < m && mp [nxt.i][nxt.j] != '#' && !used [hashV(nxt)]) {
			q.push(nxt);
			used [hashV(nxt)] = 1;
		}
		else if (nxtJump.jump <= k && nxtJump.j < m && mp [nxtJump.i][nxtJump.j] != '#' && !used [hashV(nxtJump)]) {
			q.push(nxtJump);
			used [hashV(nxtJump)] = 1;
		}
		nxt.j--;
		nxtJump.j -= 2;

		// =======================

		nxt.j--;
		nxtJump.j -= 2;
		if (nxt.j >= 0 && mp [nxt.i][nxt.j] != '#' && !used [hashV(nxt)]) {
			q.push(nxt);
			used [hashV(nxt)] = 1;
		}
		else if (nxtJump.jump <= k && nxtJump.j >= 0 && mp [nxtJump.i][nxtJump.j] != '#' && !used [hashV(nxtJump)]) {
			q.push(nxtJump);
			used [hashV(nxtJump)] = 1;
		}
		nxt.j++;
		nxtJump.j += 2;
	}

	cout << "NO\n";

	return 0;
}
