import java.io.*
import java.math.BigInteger
import java.util.TreeSet
import kotlin.math.abs

fun BufferedWriter.writeln(str: String) {
    this.write("${str}\n")
}

data class Fraction(
    val up: Int,
    val down: Int
)

fun solve(reader: BufferedReader, writer: BufferedWriter) {
    val (n, k) = reader.readLine().split(' ').map { it.toInt() }
    val s = reader.readLine().split(' ').map { it.toInt() }.toTypedArray()
    val a = reader.readLine().split(' ').map { it.toInt() }.toTypedArray()
    var sProds = 1
    (1..10).forEach { sProds *= it }
    val sValues = sortedMapOf<Int, ArrayList<Int>>()
    var leftSum = BigInteger("0")
    for (i in 0 until n) {
        val d = abs(a[i] - s[i]).toLong()
        if (!sValues.containsKey(sProds / s[i])) {
            sValues[sProds / s[i]] = arrayListOf()
        }
        sValues[sProds / s[i]]?.add(d.toInt())
        leftSum += (d * (sProds / s[i])).toBigInteger()
    }
    val rightSumK = BigInteger("$k") * sProds.toBigInteger()
    var C = leftSum - rightSumK
    var result = 0
    while (C > BigInteger.ZERO) {
        val lastKey = sValues.lastKey()
        val sValue = sValues[lastKey]!!
        C -= lastKey.toBigInteger()
        sValue[sValue.lastIndex]--
        if (sValue[sValue.lastIndex] == 0) {
            sValue.removeLast()
        }
        if (sValue.isEmpty()) {
            sValues.remove(lastKey)
        }
        result++
    }
    writer.writeln("$result")
}


fun main(args: Array<String>) {
    val reader = BufferedReader(InputStreamReader(System.`in`))
    val writer = BufferedWriter(OutputStreamWriter(System.out))

    solve(reader, writer)

    reader.close()
    writer.close()
}