import java.io.*
import java.math.BigInteger
import java.util.TreeSet
import kotlin.math.abs

fun BufferedWriter.writeln(str: String) {
    this.write("${str}\n")
}

data class Nums(
    val d: Int,
    val s: Int
): Comparable<Nums> {
    override fun compareTo(other: Nums): Int {
        return if (s.compareTo(other.s) != 0) {
            s.compareTo(other.s)
        } else {
            d.compareTo(other.d)
        }
    }
}

fun check(mapOfS: MutableMap<Int, ArrayList<Int>>, tempC: Int, k: Int): Int {
    var result = 0.0
    var c = tempC
    for ((key, value) in mapOfS) {
        for (i in 0 until value.size) {
            if (c >= value[i]) {
                c -= value[i]
                continue
            } else if (c != 0) {
                result += (value[i] - c).toDouble() / key
                c = 0
                continue
            }
            result += value[i].toDouble() / key
        }
    }
    return if (result <= k) {
        1
    } else {
        -1
    }
}

fun solve(reader: BufferedReader, writer: BufferedWriter) {
    val (n, k) = reader.readLine().split(' ').map { it.toInt() }
    val s = reader.readLine().split(' ').map { it.toInt() }.toTypedArray()
    val a = reader.readLine().split(' ').map { it.toInt() }.toTypedArray()
    val mapOfS = mutableMapOf<Int, ArrayList<Int>>()
    for (i in 0 until n) {
        if (!mapOfS.containsKey(s[i])) {
            mapOfS[s[i]] = ArrayList()
        }
        mapOfS[s[i]]?.add(abs(a[i] - s[i]))
    }

    var l = 0
    var r = 1e9.toInt()
    while (r - l > 1) {
        val m = (r + l) / 2
        val checkValue = check(mapOfS, m, k)
        if (checkValue == -1) {
            l = m
        } else if (checkValue == 1) {
            r = m
        } else {
            break
        }
    }
    if (check(mapOfS, l, k) == 1) {
        writer.writeln("$l")
    } else {
        writer.writeln("$r")
    }
}
/*
3 1
1 2 1
2 4 3
* */

fun main(args: Array<String>) {
    val reader = BufferedReader(InputStreamReader(System.`in`))
    val writer = BufferedWriter(OutputStreamWriter(System.out))

    solve(reader, writer)

    reader.close()
    writer.close()
}