def calculate_probability(N, K, S1, S2):
    memo = {}

    def calculate(N, S):
        if (N, S) in memo:
            return memo[(N, S)]
        if N == 0:
            return 1 if S == 0 else 0
        probability = 0

        for k in range(1, K + 1):
            if S - k >= 0:
                probability += calculate(N - 1, S - k) / K

        memo[(N, S)] = probability
        return probability

    probability_S1 = calculate(N, S1)
    probability_S2 = calculate(N, S2)

    if probability_S1 > probability_S2:
        return "First"
    elif probability_S1 < probability_S2:
        return "Second"
    else:
        return "Equal"


N = int(input())
K = int(input())
S1 = int(input())
S2 = int(input())

print(calculate_probability(N, K, S1, S2))
