#include <iostream>
#include <vector>
#include <cmath>

using namespace std;

vector<int> getPrimes(long long n) {
    vector<int> isPrime(n + 1, 1);
    vector<int> primes;

    for (long long i = 2; i <= n; i++) {

        if (isPrime[i] == 1) {
            primes.push_back(i);

            for (long long j = i * i; j <= n; j += i) {
                isPrime[j] = 0;
            }

        }
    }

    return primes;
}

int main() {
    long long L, R;
    vector<int> primes;
    cin >> L >> R;
    if(R - L > 100) {
        primes = getPrimes((long long) (R));
    }
    else{
        primes = getPrimes((R));
    }


    long long x = R;
    for (int prime: primes) {
        while (x % prime != 0) {
            x--;
        }
        long long y = x / prime * (prime - 1);
        if(y >= L){
            cout << y << " " << x;
            return 0;
        }
        x = R;
    }
    cout<< L<<" "<<R;
    return 0;
}