#include <iostream>
#include <vector>
#include <cmath>

using namespace std;

vector<int> getPrimes(int n) {
    vector<bool> isPrime(n + 1, true);
    vector<int> primes;

    for (int i = 2; i <= n; i++) {
        if (isPrime[i]) {
            primes.push_back(i);

            for (int j = i * i; j <= n; j += i) {
                isPrime[j] = false;
            }
        }
    }

    return primes;
}

int main() {
    int L, R;

    cin >> L >> R;

    vector<int> primes = getPrimes(int(R - L));

    int x = R;

    for (int prime: primes) {
        while (x % prime != 0) {
            x--;
        }
        int y = x / prime * (prime - 1);
        if(y >= L){
            cout << y << " " << x;
            return 0;
        }
        else{
            x = R;
        }
    }
    return 0;
}
