#include <iostream>
#include <vector>
#include <cmath>

using namespace std;

vector<int> getPrimes(long long n) {
    vector<int> isPrime(n + 1, 1);
    vector<int> primes;

    for (long long i = 2; i <= n; i++) {

        if (isPrime[i] == 1) {
            primes.push_back(i);

            for (long long j = i * i; j <= n; j += i) {
                isPrime[j] = 0;
            }
        }
    }

    return primes;
}

bool isPrime(int n) {
    if (n <= 1) return false;
    for (int i = 2; i <= sqrt(n); i++) {
        if (n % i == 0) return false;
    }
    return true;
}

int getPrime(int n){
    for (int i = n - 1; i >= 2; i--) {
        if (isPrime(i)) {
            return i;
        }
    }
}

int main() {
    int L, R;

    cin >> L >> R;
    int diff = R - L;
    //vector<int> primes = getPrimes((long long)sqrt(R - L));

    int x = R;

    for (int i = 2; i < diff; i++) {
        int prime = getPrime(i);
        while (x % prime != 0) {
            x--;
        }
        int y = x / prime * (prime - 1);
        if(y >= L){
            cout << y << " " << x;
            return 0;
        }
        x = R;
    }
    return 0;
}
