#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <queue>

const int INF = 2e9;
std::vector<std::pair<int, int>> jumps {
        {0, 1},
        {1, 0},
        {0, -1},
        {-1, 0}
};

int main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);

    int n, m, k;
    std::cin >> n >> m >> k;
    std::vector<std::string> matrix(n);
    std::vector<std::vector<int>> d(n, std::vector<int>(m, INF));
    for (int i = 0; i < n; i++) {
        std::cin >> matrix[i];
    }
    int dx, dy, ax, ay;
    std::cin >> dx >> dy >> ax >> ay;
    dx--; dy--; ax--; ay--;
    std::priority_queue<std::pair<int, std::pair<int, int>>> q;
    d[dx][dy] = 0;
    q.push({0, {dx, dy}});
    while (!q.empty()) {
        auto [dist, v] = q.top();
        dist *= -1;
        q.pop();
        auto [x, y] = v;
        if (dist > d[x][y]) {
            continue;
        }
        for (auto [xx, yy] : jumps) {
            int nx = x + xx;
            int ny = y + yy;
            int mx = x + 2 * xx;
            int my = y + 2 * yy;
            if (nx >= 0 && nx < n && ny >= 0 && ny < m && matrix[nx][ny] == '.') {
                if (d[nx][ny] > d[x][y]) {
                    d[nx][ny] = d[x][y];
                    q.push({-d[nx][ny], {nx, ny}});
                }
            }
            if (mx >= 0 && mx < n && my >= 0 && my < m && matrix[mx][my] == '.') {
                if (d[mx][my] > d[x][y] + 1) {
                    d[mx][my] = d[x][y] + 1;
                    q.push({-d[mx][my], {mx, my}});
                }
            }
        }
    }
    if (d[ax][ay] <= k) {
        std::cout << "YES";
    }
    else {
        std::cout << "NO";
    }

}

