#include <iostream>
#include <algorithm>
#include <vector>

std::vector<std::pair<int, int>> ans;
std::vector<int> free_leafs;
std::vector<int> complete;
std::vector<int> parent1, parent2;
std::vector<std::vector<int>> graph1, graph2;

void init_dfs(int a1, int a2) {
    complete[a1] = 1;
    for (int i = 0; i < std::min(graph1[a1].size(), graph2[a2].size()); i++) {
        init_dfs(graph1[a1][i], graph2[a2][i]);
    }
}

void dfs(int a1, int a2) {
    for (int i = 0; i < graph2[a2].size(); i++) {
        if (graph1[a1].size() <= i) {
	    int leaf = free_leafs.back();
	    int parent = parent1[leaf];
	    graph1[parent].erase(std::find(graph1[parent].begin(), graph1[parent].end(), leaf));
            if (graph1[parent].empty() && !complete[parent]) {
                free_leafs.push_back(parent);
	    }
	    graph1[a1].push_back(leaf);
	    ans.push_back({leaf, a1});
	}
        dfs(graph1[a1][i], graph2[a2][i]);
    }
}

int main() {
    int n; std::cin >> n;
    complete.resize(n);
    parent1.resize(n);
    parent2.resize(n);
    graph1.resize(n, std::vector<int>());
    graph2.resize(n, std::vector<int>());
    for (int i = 1; i < n; i++) {
        int a; std::cin >> a;
	parent1[i] = a;
        graph1[a].push_back(i);
    }
    for (int i = 1; i < n; i++) {
        int a; std::cin >> a;
	parent2[i] = a;
        graph2[a].push_back(i);
    }
    init_dfs(0, 0);
    for (int i = 0; i < n; i++) {
        if (!complete[i] && graph1[i].size() == 0) {
            free_leafs.push_back(i);
	}
    }
    dfs(0, 0);
    std::cout << ans.size() << '\n';
    for (int i = 0; i < ans.size(); i++) {
        std::cout << ans[i].first << ' ' << ans[i].second << '\n';
    }
    return 0;
}

