﻿#include <bits/stdc++.h>
#define int long long

using namespace std;

struct point {
    int x,y;
    point operator-(point p){ return {x - p.x, y - p.y}; }
    int operator^(point p){ return x * p.y - y * p.x; }
};

std::vector<point> convex_hull(std::vector<point> points) {
    point p0 = points[0];
    for (auto &p : points){
        if (p.x < p0.x || (p.x == p0.x && p.y < p0.y)) p0 = p;
    }

    for (auto& p : points){
        p.x -= p0.x;
        p.y -= p0.y;
    }

    sort(points.begin(), points.end(), [](point a, point b){
        return (a ^ b) > 0 || ((a ^ b) == 0 && a.x * a.x + a.y * a.y <  b.x * b.x +b.y * b.y);
    });
    std::vector<point> hull;
    for (auto &p : points){

        while (hull.size() >= 2 && ((p - hull.back()) ^ (hull[hull.size() - 2] - hull.back())) <= 0){
            hull.pop_back();
        }

        hull.push_back(p);
    }

    for (auto& p : points){
        p.x += p0.x;
        p.y += p0.y;
    }
    return hull;

}

double dist(point a, point b){
    return std::sqrt((a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y));
}

signed main(){
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int n;
    std::cin >> n;
    std::vector<point> points(n);
    for (int i = 0; i < n; ++i){
        std::cin >> points[i].x >> points[i].y;
    }
    auto hull = convex_hull(points);
    double ans = 0;
    double mx = 0;
    for (int i = 1; i < hull.size(); ++i){
        double kek =  dist(hull[i-1], hull[i]);
        mx = std::max(mx, kek);
        ans += kek;
    }
    double kek =  dist(hull.back(), hull[0]);
    mx = std::max(mx, kek);
    ans += kek;
    std::cout << std::fixed << std::setprecision(10);
    std::cout << ans - mx << '\n';
    return 0;
}
