import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;
import java.util.TreeMap;

public class Main {
    static BufferedReader bf = new BufferedReader(new InputStreamReader(System.in));

    public static void main(String[] args) throws IOException {
        int n = Integer.parseInt(bf.readLine());
        StringBuilder sb = new StringBuilder();
        String[] a = new String[n];
        Trie trie = new Trie();
        for (int i = 0; i < n; i++) {
            a[i] = bf.readLine();
        }
        bf.close();

        for (int i = 0; i < n; i++) {
            String ind = trie.putt(a[i]);
            sb.append(ind).append('\n');
        }
        System.out.println(sb);
    }
}


class Trie {
    static class TrieNode {
        Map<String, TrieNode> children = new TreeMap<>();
        int count = 0;
        String name = "";

        TrieNode() {
        }

        TrieNode(String name) {
            this.name = name;
        }
    }

    TrieNode root = new TrieNode();

    public boolean put(String s) {
        TrieNode v = root;
        for (char ch : s.toCharArray()) {
            String ch1 = String.valueOf(ch);
            if (!v.children.containsKey(ch1)) {
                v.children.put(ch1, new TrieNode(ch1));
            }
            v = v.children.get(ch1);
        }
        if (v.count ==  0){
            v.count++;
            return true;
        }
        return false;
    }

    public String putt(String s) {
        TrieNode v = root;
        for (char ch : s.toCharArray()) {
            String ch1 = String.valueOf(ch);
            if (!v.children.containsKey(ch1)) {
                v.children.put(ch1, new TrieNode(ch1));
            }
            v = v.children.get(ch1);
        }
        if (v.count == 0){
            v.count++;
            return s;
        }
        else {
            int i = 1;
            boolean t = put(s + i);
            while (!t){
                i++;
                t = put(s + i);
            }
            return s+i;
        }
    }
}