#include <deque>
#include <iostream>
#include <vector>                                                 
const long MAX = 10000000;

int main() {
    int row, col, step;
      std::cin >> row >> col >> step;

    std::vector<std::string> board(row + 1);
      for (int row_num = 1; row_num <= row; ++row_num) {
          std::cin >> board[row_num];
        board[row_num] = " " + board[row_num];
      }

      int row_start, col_start, row_finish, col_finish;
    std::cin >> row_start >> col_start >> row_finish >> col_finish;

    std::deque<std::pair<int, int>> queue;
    std::vector<std::vector<int>> dist(row + 1, std::vector<int>(col + 1, MAX));

      dist[row_start][col_start] = 0;
      queue.push_front({row_start, col_start});

    std::vector<std::pair<int, int>> move = {{1, 0}, {0, 1}, {-1, 0}, {0, -1}};
    std::vector<std::pair<int, int>> jump = {{2, 0}, {0, 2}, {-2, 0}, {0, -2}};

      while (!queue.empty()) {
        auto [row_now, col_now] = queue.front();
        queue.pop_front();

        for (auto &move : move) {
          int row1 = row_now + move.first;
          int col1 = col_now + move.second;
          if ((1 <= row1) && (row1 <= row) && (1 <= col1) && (col1 <= col) && (board[row1][col1] == '.') && (dist[row1][col1] > dist[row_now][col_now])) {
            dist[row1][col1] = dist[row_now][col_now];
            queue.push_front({row1, col1});
          }
        }

        for (auto &jump : jump) {
          int row1 = row_now + jump.first;
          int col1 = col_now + jump.second;
          if ((1 <= row1) && (row1 <= row) && (1 <= col1) && (col1 <= col) && (board[row1][col1] == '.') && (dist[row1][col1] > dist[row_now][col_now] + 1)) {
            dist[row1][col1] = dist[row_now][col_now] + 1;
            queue.push_back({row1, col1});
          }
        }
      }

    if (dist[row_finish][col_finish] <= step) {
        std::cout << "YES";
    } 
    else {
        std::cout << "NO";
    }
  return 0;
}