package com.company.nerc;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Arrays;
import java.util.Comparator;
import java.util.Scanner;
import java.util.StringTokenizer;

public class E {
    public static void split(String input, int[] buf){
        StringTokenizer tokenizer = new StringTokenizer(input);

        for (int i = 0; i < buf.length; i++) {
            String token = tokenizer.nextToken();
            int number = Integer.parseInt(token);
            buf[i] = number;
        }

    }


    public static boolean calculateTotalDeviation(int[] standardWeights, int[] actualWeights, double K) {
        int N = standardWeights.length;
        double totalDeviation = 0;

        for (int i = 0; i < N; i++) {
            double actualWeight = actualWeights[i];
            double standardWeight = standardWeights[i];
            totalDeviation += Math.abs(1 - actualWeight/standardWeight);

        }

        return totalDeviation > K + 1e-9;

    }

    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);

        int N = scanner.nextInt();
        double K = scanner.nextDouble();

        int[] standardWeights = new int[N];
        int[] actualWeights = new int[N];



        try {
            BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
            String firstLine = reader.readLine();
            String secondLine = reader.readLine();

            split(firstLine,standardWeights);
            split(secondLine, actualWeights);

            Integer[] indices = new Integer[N];
            for (int i = 0; i < N; i++) {
                indices[i] = i;
            }

            int answer = -1;
            int j = 0;
            while (calculateTotalDeviation(standardWeights, actualWeights, K)) {
                Arrays.sort(indices, Comparator.comparingDouble(a -> (double) actualWeights[a] / standardWeights[a]));
                int i = indices[j];

                if (actualWeights[i] > standardWeights[i]){
                    actualWeights[i] -=1;
                    answer +=1;
                } else if (actualWeights[i] < standardWeights[i]) {
                    actualWeights[i] +=1;
                    answer +=1;
                } else {
                    j++;
                }


//                System.out.println("Iteration " + (j + 1) + ":");
//                System.out.println("Answer: " + answer);
//                System.out.println("Actual Weights: " + Arrays.toString(actualWeights));
//                System.out.println("Standard Weights: " + Arrays.toString(standardWeights));




            }

            System.out.println(answer);
            reader.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}