def split(input_str, buf):
    tokens = input_str.split()
    for i in range(len(buf)):
        buf[i] = float(tokens[i])


def calculate_total_deviation(standard_weights, actual_weights, K):
    N = len(standard_weights)
    total_deviation = 0

    for i in range(N):
        actual_weight = actual_weights[i]
        standard_weight = standard_weights[i]
        total_deviation += abs(1 - actual_weight / standard_weight)

    return total_deviation > K + 1e-9


def main():
    N, K = input().split()
    N = int(N)
    K = int(K)

    standard_weights = [0.0] * N
    actual_weights = [0.0] * N

    try:
        first_line = input()
        second_line = input()

        split(first_line, standard_weights)
        split(second_line, actual_weights)

        indices = list(range(N))
        answer = -1
        j = 0

        while calculate_total_deviation(standard_weights, actual_weights, K):
            indices.sort(key=lambda a: actual_weights[a] / standard_weights[a])
            i = indices[j]

            if actual_weights[i] > standard_weights[i]:
                actual_weights[i] -= 1
                answer += 1
            elif actual_weights[i] < standard_weights[i]:
                actual_weights[i] += 1
                answer += 1
            else:
                j += 1

        print(answer)

    except Exception as e:
        print(e)


if __name__ == "__main__":
    main()
