def calculate_total_deviation(standard_weights, actual_weights, K):
    N = len(standard_weights)
    total_deviation = sum(abs(1 - actual_weights[i] / standard_weights[i]) for i in range(N))
    return total_deviation > K + 1e-9


def main():
    N, K = map(int, input().split())
    standard_weights = list(map(float, input().split()))
    actual_weights = list(map(float, input().split()))

    indices = list(range(N))
    answer = 0
    j = 0

    while calculate_total_deviation(standard_weights, actual_weights, K):
        indices.sort(key=lambda a: (abs(actual_weights[a] - standard_weights[a]), standard_weights[a] / actual_weights[a]))

        i = indices[j]

        if actual_weights[i] > standard_weights[i]:
            actual_weights[i] -= 1
            answer += 1
        elif actual_weights[i] < standard_weights[i]:
            actual_weights[i] += 1
            answer += 1
        else:
            j += 1

    print(answer)


if __name__ == "__main__":
    main()
