fun isPrime(number: Long): Boolean {
    if (number < 2) {
        return false
    }
    for (i in 2 until number) {
        if (number % i == 0L) {
            return false
        }
    }
    return true
}

fun findMaxGCDPair(L: Long, R: Long): Pair<Long, Long> {
    var maxGCD = 0L
    var resultPair = Pair(L, R)

    if (R / 2L >= L) {
        for (i in L..R) {
            for (j in 2 * i..R step i) {
                val currentGCD = findGCD(i, j)
                if (currentGCD > maxGCD) {
                    maxGCD = currentGCD
                    resultPair = Pair(i, j)
                }
            }
        }
    } else {
        var largestPrime = 1L
        var q = 1L
        if ((R-L) % 2 == 0L) {
            q = (R - L) / 2
            if (L % 2 == 0L) q++
        }
        else
            q = (R-L) / 2 + 1
        for (i in 2..q) {
            if (isPrime(i)) largestPrime = i
        }
        for (i in L..R) {
            if (i % largestPrime == 0L)
                return Pair(i, i + largestPrime)
        }
    }

    return resultPair
}

fun findGCD(a: Long, b: Long): Long {
    return if (b == 0L) a else findGCD(b, a % b)
}

fun main() {
    val (L, R) = readLine()!!.split(" ").map { it.toLong() }

    val resultPair = findMaxGCDPair(L, R)
    println("${resultPair.first} ${resultPair.second}")
}