fun isPrime(number: Long): Boolean {
    if (number < 2) {
        return false
    }
    for (i in 2 until number) {
        if (number % i == 0L) {
            return false
        }
    }
    return true
}

fun findMaxGCDPair(L: Long, R: Long): Pair<Long, Long> {
    var maxGCD = 0L
    var resultPair = Pair(L, R)

    if (R / 2L >= L) {
        for (i in R downTo L) {
            if (i % 2 == 0L) {
                for (j in i / 2 downTo L) {
                    val currentGCD = findGCD(i, j)
                    if (currentGCD > maxGCD) {
                        maxGCD = currentGCD
                        resultPair = Pair(j, i)
                        return resultPair
                    }
                }
            }
        }
    } else {
        val rangeSize = R - L
        if (R % 2 == 0L) {
            val evenPair = Pair(R / 2, R)
            if (evenPair.first >= L) {
                return evenPair
            }
        }

        // Если четные не подходят, выбираем на основе простых чисел
        if (rangeSize < 1000) {
            for (i in L until R) {
                for (j in i + 1..R) {
                    val currentGCD = findGCD(i, j)
                    if (currentGCD > maxGCD) {
                        maxGCD = currentGCD
                        resultPair = Pair(i, j)
                    }
                }
            }
        } else {
            for (i in 2 until rangeSize / 2) {
                if (isPrime(i)) {
                    val j = i + 1
                    val currentGCD = findGCD(i, j)
                    if (currentGCD > maxGCD) {
                        maxGCD = currentGCD
                        resultPair = Pair(i, j)
                    }
                }
            }
        }
    }

    return resultPair
}

fun findGCD(a: Long, b: Long): Long {
    return if (b == 0L) a else findGCD(b, a % b)
}

fun main() {
    val (L, R) = readLine()!!.split(" ").map { it.toLong() }

    val resultPair = findMaxGCDPair(L, R)
    println("${resultPair.first} ${resultPair.second}")
}