import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.Arrays;
import java.util.Comparator;

public class E {
    public static void main(String[] args) throws Exception {
        try (var reader = new BufferedReader(new InputStreamReader(System.in))) {
            var nk = reader.readLine().split(" ");
            var n = Integer.parseInt(nk[0]);
            var k = Long.parseLong(nk[1]);

            var d = new Detail[n];
            var fd = 0.0;
            var sd = 0L;

            var s = reader.readLine().split(" ");
            var a = reader.readLine().split(" ");

            for (int i = 0; i < n; i++) {
                var sw = Long.parseLong(s[i]);
                var aw = Long.parseLong(a[i]);
                var dt = new Detail(sw, aw);
                fd += dt.ds;
                sd += dt.d;
                d[i] = dt;
            }

            if (k == 0) {
                System.out.println(sd);
                return;
            }

            fd -= k;
            if (fd <= 0) {
                System.out.println(0);
                return;
            }

            Arrays.sort(d, Comparator.comparingLong(dd -> dd.s));

            var res = 0L;
            for (int i = 0; i < n; i++) {
                if (fd <= 0) break;

                var dt = d[i];

                if (fd - dt.ds >= 0) {
                    fd -= dt.ds;
                    res += dt.d;
                } else {
                    long l = 1, r = dt.d - 1;
                    while (l <= r) {
                        var m = (l + r) >>> 1;
                        var cmp = Double.compare(dt.d1 * m, fd);
                        if (cmp == 0) {
                            l = r = m;
                            break;
                        } else if (cmp > 0) {
                            r = m - 1;
                        } else {
                            l = m + 1;
                        }
                    }
                    fd -= l * dt.d1;
                    res += l;
                }
            }

            System.out.println(res);
        }
    }

    static class Detail {
        public long s;
        public long a;
        public long d;
        public double d1;
        public double ds;

        public Detail(long s, long a) {
            this.s = s;
            this.a = a;

            this.d = Math.abs((s - a));
            d1 = 1.0 / s;
            ds = (double)d / s;
        }
    }
}
