#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double lld;
#define nn "\n"
#define haha ios::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr)

int n, m, k;
int start_ii, start_jj;
int end_ii, end_jj;

vector<vector<int>> dirs = {
        vector<int>{0, 1},
        vector<int>{1, 0},
        vector<int>{0, -1},
        vector<int>{-1, 0},
};

vector<vector<int>> number_of_area;
vector<vector<bool>> visited;
vector<vector<char>> a;

map<int, int> visited_areas;

bool in_border(int i, int j) {
    if (i < 0 || i >= n) return false;
    if (j < 0 || j >= m) return false;

    return true;
}

void fill_area(int start_i, int start_j, int num) {
    queue<vector<int>> q;
    q.push({start_i, start_j});

    number_of_area[start_i][start_j] = num;

    while (!q.empty()) {
        vector<int> cur = q.front();
        q.pop();

        int i = cur[0], j = cur[1];

        for (auto& dir: dirs) {
            int ii = i + dir[0];
            int jj = j + dir[1];

            if (!in_border(ii, jj)) continue;

            if (a[ii][jj] == '#') continue;

            if (number_of_area[ii][jj] == -1) {
                number_of_area[ii][jj] = num;
                q.push({ii, jj});
            }
        }
    }
}

void fill_queue(queue<vector<int>>& q) {
    queue<vector<int>> qq;

    qq.push(q.front());

    while (!qq.empty()) {
        auto cur = qq.front(); qq.pop();
        int i = cur[0], j = cur[1];

        for (auto& dir: dirs) {
            int ii = i + dir[0], jj = j + dir[1];

            if (!in_border(ii, jj)) continue;

            if (visited[ii][jj]) continue;

            if (a[ii][jj] == '.') {
                visited[ii][jj] = true;
                qq.push({ii, jj});
                q.push({ii, jj});
                continue;
            }
        }
    }
}

int main() {
    haha;

    cin >> n >> m >> k;

    a.resize(n, vector<char> (m));
    number_of_area.resize(n, vector<int> (m, -1));
    visited.resize(n, vector<bool> (m));

    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++) cin >> a[i][j];

    cin >> start_ii >> start_jj;
    cin >> end_ii >> end_jj;

    start_ii--; start_jj--;
    end_ii--; end_jj--;

    int total_areas = 0;

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (a[i][j] == '#') continue;

            if (number_of_area[i][j] == -1) fill_area(i, j, total_areas++);
        }
    }

    queue<vector<int>> q;
    q.push({start_ii, start_jj});
    visited_areas[number_of_area[start_ii][start_jj]] = 0;
    visited[start_ii][start_jj] = true;

    fill_queue(q);

    for (int cur_jump = 0; !q.empty() ; cur_jump++) {
        for (auto kk = q.size(); kk > 0; kk--) {
            vector<int> cur = q.front(); q.pop();

            int i = cur[0], j = cur[1];

            for (auto& dir: dirs) {
                int ii = i + dir[0], jj = j + dir[1];

                if (!in_border(ii, jj)) continue;

                if (visited[ii][jj]) continue;

                if (a[ii][jj] == '.') {
                    visited[ii][jj] = true;
                    q.push({ii, jj});
                    continue;
                }

                ii = i + dir[0] * 2;
                jj = j + dir[1] * 2;

                if (!in_border(ii, jj)) continue;
                if (a[ii][jj] == '#') continue;

                int next_area = number_of_area[ii][jj];

                if (visited_areas.count(next_area)) continue;

                visited_areas[next_area] = cur_jump + 1;
                visited[ii][jj] = true;
                q.push({ii, jj});
            }
        }
    }

    int target_area = number_of_area[end_ii][end_jj];

    if (visited_areas.count(target_area) && visited_areas[target_area] <= k) cout << "YES";
    else cout << "NO";
}
