import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.Arrays;
import java.util.StringTokenizer;

public class J {
    public static void main(String[] args) throws Exception {
        try (var reader = new BufferedReader(new InputStreamReader(System.in))) {
            var n = Integer.parseInt(reader.readLine());
            var pw = reader.readLine();
            var tokenizer = new StringTokenizer(pw, " ");

            var p = new Place[n];
            p[0] = new Place(0);
            p[0].minMoves = 1;
            p[n - 1] = new Place(n - 1);
            for (int i = 1; i < n - 1; i++) {
                var pl = new Place(i);
                var d = Integer.parseInt(tokenizer.nextToken());
                if (d != 0) {
                    pl = p[Math.max(0, i - d)];
                }
                p[i] = pl;
            }

            for (int i = 0; i < n - 1; i++) {
                var pl = p[i];
                if (pl.index != i) continue;
                if (pl.minMoves < 0) continue;
                for (int j = 1; j <= 6; j++) {
                    var tr = p[Math.min(n - 1, i + j)];
                    tr.moves(pl.minMoves + (j == 6 ? 0 : 1));
                }
            }

            System.out.println(p[n - 1].minMoves);
        }
    }

    static class Place {
        public Place(int index) {
            this.index = index;
        }

        public int index;
        public int minMoves = -1;

        public void moves(int cnt) {
            if (minMoves < 0 || cnt < minMoves)
                minMoves = cnt;
        }
    }
}
