import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.StringTokenizer;

public class J {
    public static void main(String[] args) throws Exception {
        try (var reader = new BufferedReader(new InputStreamReader(System.in))) {
            var n = Integer.parseInt(reader.readLine());
            var pw = reader.readLine();
            var tokenizer = new StringTokenizer(pw, " ");

            var p = new ArrayList<Place>();

            p.add(new Place(0));
            p.get(0).minMoves = 1;

            while (tokenizer.hasMoreTokens()) {
                var index = p.size();
                var pl = new Place(index);
                var ds = tokenizer.nextToken();
                var d = Integer.parseInt(ds);
                if (d > 0) {
                    pl = p.get(Math.max(0, index - d));
                }
                p.add(pl);
            }

            p.add(new Place(p.size()));

            n = p.size();

            for (int i = 0; i < n - 1; i++) {
                var pl = p.get(i);
                if (pl.index != i) continue;
                if (pl.minMoves < 0) continue;
                for (int j = 1; j <= 6; j++) {
                    var tr = p.get(Math.min(n - 1, i + j));
                    tr.moves(pl.minMoves + (j == 6 ? 0 : 1));
                }
            }

            System.out.println(p.get(n - 1).minMoves);
        }
    }

    static class Place {
        public Place(int index) {
            this.index = index;
        }

        public int index;
        public int minMoves = -1;

        public void moves(int cnt) {
            if (minMoves < 0 || cnt < minMoves)
                minMoves = cnt;
        }
    }
}
