import java.io.BufferedReader
import java.io.InputStreamReader
import kotlin.math.max
import kotlin.math.min

fun main(args: Array<String>) {
    val reader = BufferedReader(InputStreamReader(System.`in`))
    val n = reader.readLine().toInt()
    if (n <= 7) {
        println(1)
        return
    }
    val line = reader.readLine().split(" ").map { it.toInt() }

    val arr = Array(n) { Place(it) }
    for (i in 1 until n - 1) {
        val d = line[i - 1]
        if (d != 0) {
            arr[i] = arr[max(0, i - d)]
        }
    }
    arr[0].minMoves = 1

    for(i in 0 until n) {
        if (arr[i].index != i || arr[i].minMoves < 0) continue

        for (j in 1 until 7) {
            arr[min(n - 1, i + j)].moves(arr[i].minMoves + if(j == 6) 0 else 1)
        }
    }

    println(arr[n - 1].minMoves)
}

data class Place(
    val index: Int,
    var minMoves: Int = -1
) {
    fun moves(cnt: Int) {
        if (minMoves < 0 || minMoves > cnt)
            minMoves = cnt
    }
}
