import java.util.Scanner;
import java.util.Arrays;

public class Task_E {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int N = scanner.nextInt();
        long K = scanner.nextLong();
        int[] standards = new int[N];
        int[] weights = new int[N];

        // Считываем веса стандартных деталей
        for (int i = 0; i < N; i++) {
            standards[i] = scanner.nextInt();
        }

        // Считываем веса текущих деталей
        for (int i = 0; i < N; i++) {
            weights[i] = scanner.nextInt();
        }

        // Начальные значения для двоичного поиска
        long left = 0;
        long right = K * N;
        long result = K * N;

        // Выполняем двоичный поиск
        while (left <= right) {
            long mid = (left + right) / 2;
            long totalDeviation = 0;

            // Рассчитываем суммарное отклонение для текущего значения mid
            for (int i = 0; i < N; i++) {
                long diff = Math.abs(weights[i] - standards[i]) + mid * standards[i];
                totalDeviation += diff;
            }

            // Если суммарное отклонение не больше K, сохраняем результат и смещаем левую границу
            if (totalDeviation <= K) {
                result = mid;
                left = mid + 1;
            } else { // Иначе смещаем правую границу
                right = mid - 1;
            }
        }

        System.out.println(result);
    }
}