#include <iostream>
#include <vector>
#include <cmath>
#include <map>
#include <string>
#include <algorithm>

using namespace std;
using ull = unsigned long long;
using ll = long long;

int n, k;
vector<pair<int, int>> stand;
vector<int> nums;

bool ok(ll m) {
    long double res = 0;
    for (int i = 0; i < n; i++) {
        ll diff = abs(nums[stand[i].second] - stand[i].first);
        if (diff <= m) {
            m -= diff;
        } else {
            diff -= m;
            res += diff / double(stand[i].first);
            for (int j = i + 1; j < n; j++) {
                res += abs(stand[j].first - nums[stand[j].second]) / double(stand[j].first);
            }
            break;
        }
    }
    return res <= k;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n >> k;
    nums.resize(n);
    stand.resize(n);

    for (int i = 0; i < n; i++) {
        int x;
        cin >> x;
        stand[i] = {x, i};
    }
    sort(stand.begin(), stand.end());
    for (int i = 0; i < n; i++) {
        cin >> nums[i];
    }
    ll l = -1, r = 1e10 + 1;
    while (l < r - 1) {
        ll m = (r + l) / 2;
        if (ok(m))
            r = m;
        else
            l = m;
    }
    cout << r;
}