﻿#include <iostream>
#include <vector>
#include <queue>
#include <cmath>

int N = 0;

inline long long pos6(std::vector <int> &p, int& current_d) {

    int next = 0;

    if (current_d + 6 < N - 1)
        next = std::min(current_d + 6, N - 1);
    else
        return 10000000;

    if (p[next] > 0) {
        while (p[next] > 0) {
            next = next - p[next];
        }

        if (next < 0)
            next = 0;

    }

    return next;
}

int main() {

    std::ios::sync_with_stdio(0);
    std::cin.tie(0);


    std::cin >> N;

    std::vector <int> p(N);

    std::vector <int> d(N, 1e9);
   
    d[0] = 0;

    for (int i = 1; i < N - 1; i++)
        std::cin >> p[i];

    std::queue <int> q;

    q.push(0);
    
    int current_d = 0;
    int next = 0;

    while (!q.empty()) {

        current_d = q.front();
        q.pop();

        for (int k = 1; k <= 6; k++) {

            next = std::min(current_d + k, N - 1);

            if (p[next] > 0) {
                while (p[next] > 0) {
                    next = next - p[next];
                }

                if (next < 0)
                    next = 0;
            }

            if (d[next] == 1e9) {

                if (pos6(p, current_d) == next)
                    d[next] = d[current_d];
                else
                    d[next] = d[current_d] + 1;
                

                q.push(next);
            }

        }

    }

    if (d[N - 1] == 1e9)
        std::cout << -1;
    else
        std::cout << d[N - 1];

    return 0;
}