#include <iostream>
#include <vector>
#include <algorithm>
#include <utility>

#define int long long

using namespace std;

const double EPS = 1e-7;

void Solve() {
    int n, k, s1, s2;
    cin >> n >> k >> s1 >> s2;
//    s1 *= 2;
//    s2 *= 2;
    double expected = n * (double) (k + 1) / 2;
    int mn = n, mx = n * k;
    if (s1 < mn || s1 > mx) {
        if (mn <= s2 && s2 <= mx) {
            cout << "Second\n";
        } else {
            cout << "Equal\n";
        }
        return;
    }
    if (s2 < mn || s2 > mx) {
        if (mn <= s1 && s1 <= mx) {
            cout << "First\n";
        } else {
            cout << "Equal\n";
        }
        return;
    }
    if (n == 1) {
        cout << "Equal\n";
        return;
    }
    double dist1 = abs(expected - s1);
    double dist2 = abs(expected - s2);
    if (dist1 + EPS < dist2) {
        cout << "First\n";
    } else if (dist1 > EPS + dist2) {
        cout << "Second\n";
    } else {
        cout << "Equal\n";
    }
}

signed main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
//    double start = clock();
    int num_tests = 1;
#ifdef LOCAL
    std::cin >> num_tests;
#endif
    for (int i = 0; i < num_tests; ++i) {
#ifdef LOCAL
        std::cout << "Case #" << i + 1 << ":\n";
#endif
        Solve();
    }
#ifdef LOCAL
//    cout << "Time: " << (clock() - start) / CLOCKS_PER_SEC << "\n";
#endif
}

//#include <iostream>
//#include <vector>
//#include <algorithm>
//#include <utility>
//
//#define int long long
//
//using namespace std;
//
//struct Point{
//    int x, y;
//};
//
//double dist(pair<int,int> p1, pair<int,int> p2){
//    return sqrt(pow((p1.first - p2.first),2) + pow((p1.second-p2.second),2));
//}
//
//vector<Point> Grah(vector<Point> points){
//    Point p0 = points[0];
//    for(auto p: points){
//        if(p.x < p0.x || (p.x == p0.x && p.y < p0.y))
//            p0 = p;
//    }
//    sort(points.begin(),points.end(), [&](Point a, Point b){
//        return ((a.x - p0.x) ^ (b.x - p0.x)) > 0 && ((a.y - p0.y) ^ (b.y - p0.y)) > 0;
//    });
//    vector<Point> h;
//    for(auto p : points){
//        while(h.size() >= 2){
//            Point vec;
//            vec.x = p.x - h.back().x;
//            vec.y = p.y - h.back().y;
//
//            Point last_vec;
//            last_vec.x = h.back().x - h[h.size() - 2].x;
//            last_vec.y = h.back().y - h[h.size() - 2].y;
//
//            if ((vec.x ^ last_vec.x) > 0 && (vec.y ^ last_vec.y) > 0)
//                h.pop_back();
//            else break;
//        }
//        h.push_back(p);
//    }
//
//    return h;
//}
//
//void Solve() {
//    int n;
//    cin >> n;
//    vector<Point> a;
//    vector<pair<int,int>> points;
//    for(int i = 0; i < n; i++){
//        int x1, y1;
//        cin >> x1 >> y1;
//        points.push_back(make_pair(x1,y1));
//
//        Point v;
//        v.x = x1;
//        v.y = y1;
//        a.push_back(v);
//    }
//    vector<pair<int,int>> h;
//    sort(points.begin(), points.end());
//    for(auto p: points){
//        while(h.size() >= 2 && (h.back().first - h[h.size()-2].first) * (p.second - h[h.size()-2].second) - (h.back().second - h[h.size()-2].second) * (p.first - h[h.size()-2].first) <= 0){
//            h.pop_back();
//        }
//        h.push_back(p);
//    }
//    h.pop_back();
//    for(auto it = points.rbegin();it != points.rend();it++){
//        auto p = *it;
//        while(h.size() >= 2 && (h.back().first - h[h.size()-2].first) * (p.second - h[h.size()-2].second) - (h.back().second - h[h.size()-2].second) * (p.first - h[h.size()-2].first) <= 0){
//            h.pop_back();
//        }
//        h.push_back(p);
//    }
//    h.pop_back();
//    int N = h.size();
//    int i = 0, j = N - 1;
//    double dist_top = 999999.0;
//    double len = 0;
//    while (i < N && j >= 0){
//        dist_top = min(dist_top, dist(h[i], h[j]));
//        if (j == 0 || (h[i + 1].first - h[i].first) * (h[j].second - h[j - 1].second) - (h[i + 1].second - h[i].second) * (h[j].first - h[j - 1].first) > 0){
//            i++;
//            len+=dist_top;
//        }
//        else j++;
//    }
//    for(auto  s: h){
//        cout << s.first << " " << s.second << endl;
//    }
//    cout << len << "\n";
//
//    vector<Point> hl = Grah(a);
//    for(auto b: hl){
//        cout << b.x << " " << b.y << endl;
//    }
//}
//
//signed main() {
//    std::ios_base::sync_with_stdio(false);
//    std::cin.tie(nullptr);
////    double start = clock();
//    int num_tests = 1;
//#ifdef LOCAL
//    std::cin >> num_tests;
//#endif
//    for (int i = 0; i < num_tests; ++i) {
//#ifdef LOCAL
//        std::cout << "Case #" << i + 1 << ":\n";
//#endif
//        Solve();
//    }
//#ifdef LOCAL
////    cout << "Time: " << (clock() - start) / CLOCKS_PER_SEC << "\n";
//#endif
//}