#include <iostream>
#include <vector>
#include <algorithm>
#include <utility>

#define int long long

using namespace std;

const double EPS = 1e-7;

void Solve() {
    int n, k, s1, s2;
    cin >> n >> k >> s1 >> s2;
//    s1 *= 2;
//    s2 *= 2;
    double expected = n * (double) (k + 1) / 2;
    int mn = n, mx = n * k;
    if (s1 < mn || s1 > mx) {
        if (mn <= s2 && s2 <= mx) {
            cout << "Second\n";
        } else {
            cout << "Equal\n";
        }
        return;
    }
    if (s2 < mn || s2 > mx) {
        if (mn <= s1 && s1 <= mx) {
            cout << "First\n";
        } else {
            cout << "Equal\n";
        }
        return;
    }
    if (k < n) {
        cout << "Equal\n";
        return;
    }
    if (n == 1) {
        cout << "Equal\n";
        return;
    }
    double dist1 = abs(expected - s1);
    double dist2 = abs(expected - s2);
    if (dist1 + EPS < dist2) {
        cout << "First\n";
    } else if (dist1 > EPS + dist2) {
        cout << "Second\n";
    } else {
        cout << "Equal\n";
    }
}

signed main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
//    double start = clock();
    int num_tests = 1;
#ifdef LOCAL
    std::cin >> num_tests;
#endif
    for (int i = 0; i < num_tests; ++i) {
#ifdef LOCAL
        std::cout << "Case #" << i + 1 << ":\n";
#endif
        Solve();
    }
#ifdef LOCAL
//    cout << "Time: " << (clock() - start) / CLOCKS_PER_SEC << "\n";
#endif
}