#include <iostream>
#include <iomanip>
#include <cmath>
#include <vector>
using namespace std;

#define ENABLE_FAST_IO ios_base::sync_with_stdio(false); cin.tie(nullptr);

long long distSq(pair<int, int> a, pair<int, int> b) {
    return (a.first - b.first) * (a.first - b.first) + (a.second - b.second) * (a.second - b.second);
}

long double dist(pair<int, int> a, pair<int, int> b) {
    return sqrtl(distSq(a, b));
}

void solve() {
	long double answer = 0;
	int n;
	cin >> n;
    vector<pair<int, int>> poly(n);
    for (int i = 0; i < n; ++i) {
        cin >> poly[i].first >> poly[i].second;
    }
    for (int i = 1; i < n; ++i) {
        answer += dist(poly[i - 1], poly[i]);
    }
    cout << fixed << setprecision(7) << answer << '\n';
}

int main() {
	ENABLE_FAST_IO
	int t = 1;
	// cin >> t;
	for (int i = 0; i < t; ++i) {
		solve();
	}
	return 0;
}
