#include <iostream>
#include <iomanip>
#include <cmath>
#include <vector>
using namespace std;

#define ENABLE_FAST_IO ios_base::sync_with_stdio(false); cin.tie(nullptr);

long long distSq(pair<long long, long long> a, pair<long long, long long> b) {
    return (a.first - b.first) * (a.first - b.first) + (a.second - b.second) * (a.second - b.second);
}

long double dist(pair<long long, long long> a, pair<long long, long long> b) {
    return sqrtl(distSq(a, b));
}

void solve() {
	long double answer = 0;
	int n;
	cin >> n;
    vector<pair<long long, long long>> poly(n);
    for (int i = 0; i < n; ++i) {
        cin >> poly[i].first >> poly[i].second;
    }
    long double maxD = 0;
    for (int i = 0; i < n; ++i) {
        int j = i + 1 < n ? i + 1 : 0;
        long double d = dist(poly[i], poly[j]);
        answer += d;
        maxD = max(maxD, d);
    }
    answer -= maxD;
    cout << fixed << setprecision(7) << answer << '\n';
}

int main() {
	ENABLE_FAST_IO
	int t = 1;
	// cin >> t;
	for (int i = 0; i < t; ++i) {
		solve();
	}
	return 0;
}
