#include <iostream>
using namespace std;

#define ENABLE_FAST_IO ios_base::sync_with_stdio(false); cin.tie(nullptr);

class MyTrie {
    struct Node {
        Node* children['z' + 1];
        bool endHere;
        Node() {
            endHere = false;
            for (char c = '0'; c <= '9'; ++c) {
                children[c] = nullptr;
            }
            for (char c = 'A'; c <= 'Z'; ++c) {
                children[c] = nullptr;
            }
            for (char c = 'a'; c <= 'z'; ++c) {
                children[c] = nullptr;
            }
        }
        ~Node() {
            for (char c = '0'; c <= '9'; ++c) {
                if (children[c] != nullptr) {
                    delete children[c];
                }
            }
            for (char c = 'A'; c <= 'Z'; ++c) {
                if (children[c] != nullptr) {
                    delete children[c];
                }
            }
            for (char c = 'a'; c <= 'z'; ++c) {
                if (children[c] != nullptr) {
                    delete children[c];
                }
            }
        }
    };
    Node* root;
public:
    MyTrie() {
        root = new Node();
    }
    ~MyTrie() {
        delete root;
    }
    string add(const string& s) {
        Node* node = root;
        for (char c : s) {
            if (node->children[c] == nullptr) {
                node->children[c] = new Node();
            }
            node = node->children[c];
        }
        if (!node->endHere) {
            node->endHere = true;
            return s;
        }
        for (char c = '1'; c <= '9'; ++c) {
            if (node->children[c] == nullptr || !node->children[c]->endHere) {
                if (node->children[c] == nullptr) {
                    node->children[c] = new Node();
                }
                node = node->children[c];
                node->endHere = true;
                return s + c;
            }
        }
        Node* node2 = node;
        for (int x = 10; x <= 1000000; ++x) {
            string sx = to_string(x);
            for (char c : sx) {
                if (node2->children[c] == nullptr) {
                    node2->children[c] = new Node();
                }
                node2 = node2->children[c];
            }
            if (!node2->endHere) {
                node2->endHere = true;
                return s + sx;
            }
        }
    }
};

void solve() {
    int q;
    cin >> q;
    MyTrie tr;
    for (int i = 0; i < q; ++i) {
        string name;
        cin >> name;
        cout << tr.add(name) << "\n";
    }
}

int main() {
	ENABLE_FAST_IO
	int t = 1;
	// cin >> t;
	for (int i = 0; i < t; ++i) {
		solve();
	}
	return 0;
}
