#include <iostream>
#include <vector>
#include <unordered_map>

using namespace std;
using ll = long long;
using str = string;

unordered_map<string, ll> name_count;

str generate_name(const str& name) {
    str fresh = name;
    while (name_count.count(fresh) > 0) {
        fresh = name + to_string(name_count[name]++);
    }
    name_count[fresh]++;
    return fresh;
}

int main() {
    ll num_queries;
    cin >> num_queries;

    vector<str> results;
    for (ll i = 0; i < num_queries; i++) {
        str name;
        cin >> name;
        str fresh = generate_name(name);
        results.emplace_back(fresh);
    }

    for (const auto& result : results) {
        cout << result << endl;
    }

    return 0;
}
