#include <iostream>
#include <deque>
#include <vector>
using namespace std;

#define ENABLE_FAST_IO ios_base::sync_with_stdio(false); cin.tie(nullptr);

void solve() {
	int n, m, k;
	cin >> n >> m >> k;
    string grid[1001];
    for (int i = 1; i <= n; ++i) {
        cin >> grid[i];
        grid[i] = " " + grid[i];
    }
    int di, dj;
    cin >> di >> dj;

    int ai, aj;
    cin >> ai >> aj;

    deque<pair<int, int>> dq;
    vector<vector<int>> dist(n + 1, vector<int>(m + 1, 10000000));
    dist[di][dj] = 0;
    dq.push_front({di, dj});
    vector<pair<int, int>> steps1 = {{1, 0}, {0, 1}, {-1, 0}, {0, -1}};
    vector<pair<int, int>> steps2 = {{2, 0}, {0, 2}, {-2, 0}, {0, -2}};
    while (!dq.empty()) {
        int i = dq.front().first;
        int j = dq.front().second;
        dq.pop_front();
        for (auto& step : steps1) {
            int ix = i + step.first;
            int jx = j + step.second;
            if (1 <= ix && ix <= n && 1 <= jx && jx <= m) {
                if (grid[ix][jx] == '.') {
                    if (dist[ix][jx] > dist[i][j]) {
                        dist[ix][jx] = dist[i][j];
                        dq.push_front({ix, jx});
                    }
                }
            }
        }
        for (auto& step : steps2) {
            int ix = i + step.first;
            int jx = j + step.second;
            if (1 <= ix && ix <= n && 1 <= jx && jx <= m) {
                if (grid[ix][jx] == '.') {
                    if (dist[ix][jx] > dist[i][j] + 1) {
                        dist[ix][jx] = dist[i][j] + 1;
                        dq.push_back({ix, jx});
                    }
                }
            }
        }
    }
    if (dist[ai][aj] <= k) {
        cout << "YES\n";
    }
    else {
        cout << "NO\n";
    }
}

int main() {
	ENABLE_FAST_IO
	int t = 1;
	// cin >> t;
	for (int i = 0; i < t; ++i) {
		solve();
	}
	return 0;
}
