#include <iostream>
#include <climits>
#include <cstdlib>
#include <string>

using std::cin;
using std::cout;
using std::string;

const string FIRST = "First";
const string SECOND = "Second";
const string EQUAL = "Equal\n";

long long calc(long long n, long long k, long long s, bool doub) {
    if (doub) {
        s *= 2;
    }

    long long m = (1 + k) * n;
    long long d = std::abs(m - s);

    if (s / 2 < n || s / 2 > k * n) {
        d = LLONG_MAX;
    }

    return d;
}

void print(long long d1, long long d2) {
    if (d1 < d2) {
        cout << FIRST;
    } else if (d2 < d1) {
        cout << SECOND;
    } else {
        cout << EQUAL;
    }
}

void sol() {
    long long n, s1, s2, k;
    cin >> n >> k >> s1 >> s2;

    if (n == 1) {
        long long d1 = (s1 < n || s1 > k * n) ? LLONG_MAX : 0;
        long long d2 = (s2 < n || s2 > k * n) ? LLONG_MAX : 0;
        print(d1, d2);
        return;
    }
    long long d1 = calc(n, k, s1, true);
    long long d2 = calc(n, k, s2, true);
    print(d1, d2);
}
int main() {
    std::ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    while (t--) {
        sol();
    }
    return 0;
}