#include <iostream>
#include <climits>  
#include <cstdlib>  
#include <string>   

using std::cin;
using std::cout;
using std::string;

const string FIRST = "First";
const string SECOND = "Second";
const string EQUAL = "Equal\n";

long long calculateDistance(long long n, long long k, long long s, bool doubled) {
    if (doubled) {
        s *= 2;
    }

    long long mat = (1 + k) * n;
    long long dist = std::abs(mat - s);

    if (s / 2 < n || s / 2 > k * n) {
        dist = LLONG_MAX;
    }

    return dist;
}

void printResult(long long dist1, long long dist2) {
    if (dist1 < dist2) {
        cout << FIRST;
    }
    else if (dist2 < dist1) {
        cout << SECOND;
    }
    else {
        cout << EQUAL;
    }
}

void solve() {
    long long n, s1, s2, k;
    cin >> n >> k >> s1 >> s2;

    if (n == 1) {
        long long dist1 = (s1 < n || s1 > k * n) ? LLONG_MAX : 0;
        long long dist2 = (s2 < n || s2 > k * n) ? LLONG_MAX : 0;
        printResult(dist1, dist2);
        return;
    }

    long long dist1 = calculateDistance(n, k, s1, true);
    long long dist2 = calculateDistance(n, k, s2, true);
    printResult(dist1, dist2);
}

int main() {
    std::ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    while (t--) {
        solve();
    }

    return 0;
}
