from math import sqrt


def get_distance(point1, point2):
    dx = point1[0] - point2[0]
    dy = point1[1] - point2[1]
    return sqrt(dx * dx + dy * dy)



def get_points(n):
    points = []
    for _ in range(n):
        points.append(list(map(int, input().split())))
    return points


def calculate_distances(points):
    distances = []
    for i in range(-1, len(points) - 1):
        distances.append(get_distance(points[i], points[i + 1]))
    return distances


def find_minimal_distance_removal(distances):
    total = sum(distances)
    minimal = total - distances[0]

    for i in range(1, len(distances)):
        mask = total - distances[i]
        if mask < minimal:
            minimal = mask

    return minimal


def main():
    n = int(input())
    points = get_points(n)
    distances = calculate_distances(points)
    minimal = find_minimal_distance_removal(distances)
    print(minimal)


main()