#include <iostream>
#include <unordered_map>
#include <vector>
using namespace std;

class UniqueNameGenerator {
public:
    string getUniqueName(const string& name) {
        string uniqueName = name;
        while (userCounts_.count(uniqueName) > 0) {
            uniqueName = name + to_string(userCounts_[name]++);
        }
        userCounts_[uniqueName]++;
        return uniqueName;
    }

private:
    unordered_map<string, int> userCounts_;
};

void printNames(const vector<string>& names) {
    for (const string& name : names) {
        cout << name << endl;
    }
}

int main() {
    int q;
    cin >> q;

    vector<string> results;
    UniqueNameGenerator nameGenerator;

    for (int i = 0; i < q; i++) {
        string name;
        cin >> name;
        string uniqueName = nameGenerator.getUniqueName(name);
        results.push_back(uniqueName);
    }

    printNames(results);

    return 0;
}