from collections import deque


def can_reach_airport(N, M, K, city, dx, dy, ax, ay):
    if dx == ax and dy == ay:
        return "YES"

    queue = deque()
    queue.append((dx, dy, K))

    visited = [[[False] * (K + 1) for _ in range(M)] for _ in range(N)]
    visited[dx][dy][K] = True

    while queue:
        x, y, k = queue.popleft()

        for dx, dy, dk in [(-1, 0, 0), (1, 0, 0), (0, -1, 0), (0, 1, 0), (-2, 0, 1), (2, 0, 1), (0, -2, 1), (0, 2, 1)]:
            if k >= dk:
                nx, ny, nk = x + dx, y + dy, k - dk
                if 0 <= nx < N and 0 <= ny < M and not visited[nx][ny][nk] and city[nx][ny] != '#':
                    if (nx, ny) == (ax, ay):
                        return "YES"
                    queue.append((nx, ny, nk))
                    visited[nx][ny][nk] = True
    return "NO"


N, M, K = map(int, input().split())
city = [input().strip() for _ in range(N)]
dx, dy = map(int, input().split())
ax, ay = map(int, input().split())

dx, dy, ax, ay = dx - 1, dy - 1, ax - 1, ay - 1

print(can_reach_airport(N, M, K, city, dx, dy, ax, ay))