#include <iostream>
#include <vector>
#include <queue>
#include <algorithm>

using namespace std;

int main() {
    int N;
    cin >> N;

    vector<int> p(N);
    for (int i = 1; i < N - 1; ++i)
        cin >> p[i];

    vector<int> dist(N, -1);
    dist[0] = 0;

    queue<pair<int, int>> q;
    q.push({0, 0});

    while (!q.empty()) {
        int v = q.front().first;
        int extra_turn = q.front().second;
        q.pop();

        for (int dice = 1; dice <= 6; ++dice) {
            int to = min(v + dice, N - 1);
            while (to > 0 && p[to] > 0)
                to -= p[to];
            int new_dist = dist[v] + (dice != 6 || extra_turn ? 1 : 0);
            if (dist[to] == -1 || dist[to] > new_dist) {
                dist[to] = new_dist;
                q.push({to, (dice == 6 && !extra_turn ? 1 : 0)});
            }
        }
    }

    if (dist[N - 1] == -1)
        cout << "-1\n";
    else
        cout << dist[N - 1]+1 << endl;

    return 0;
}