#include <iostream>
#include <vector>
#include <queue>
#include <tuple>

using namespace std;

int main() {
    int N;
    cin >> N;
    vector<int> p(N + 1);
    for (int i = 2; i < N; ++i) {
        cin >> p[i];
    }

    vector<vector<vector<int>>> dist(N + 1, vector<vector<int>>(2, vector<int>(2, -1)));
    dist[1][0][0] = 0;
    queue<tuple<int, int, int>> q;
    q.push({1, 0, 0});

    while (!q.empty()) {
        auto [v, extra, visited] = q.front();
        q.pop();

        for (int i = 1; i <= 6; ++i) {
            int to = min(v + i, N);
            int next_visited = visited;

            while (p[to] > 0 && to - p[to] != v) {
                to -= p[to];
                next_visited = 1;
            }

            int next_extra = (i == 6) ? 1 : 0;
            if (dist[to][next_extra][next_visited] == -1) {
                dist[to][next_extra][next_visited] = dist[v][extra][visited] + (!extra);
                q.push({to, next_extra, next_visited});
            }
        }
    }

    int answer = -1;
    for (int extra = 0; extra < 2; ++extra) {
        for (int visited = 0; visited < 2; ++visited) {
            if (dist[N][extra][visited] != -1) {
                if (answer == -1) {
                    answer = dist[N][extra][visited];
                } else {
                    answer = min(answer, dist[N][extra][visited]);
                }
            }
        }
    }

    cout << answer << endl;
    return 0;
}