#include <iostream>
#include <cstdio>
#include <cmath>

unsigned long long factorial(const unsigned long long& x)
{
    unsigned int _arithmetics_primes[] = { 2,3,5,7,11,13,17,19,23,29,31,37,41,43,47,53,59,61,67,71,73,79,83,89,97,101,103,107,109,113,127,131,137,139,149,151,157,163,167,173,0 };

    if (x <= 4)
    {
        if (x == 4) return 24;
        if (x == 3) return  6;
        if (x == 2) return  2;
        if (x == 1) return  1;
        if (x == 0) return  1;
    }
    int n4, n2, p, i, j, e;
    unsigned long long c, pp;

    n4 = (x >> 2) << 2;
    n2 = n4 >> 1;
    c = factorial(n2); c *= c;

    for (i = 0; ;i++) {
        p = _arithmetics_primes[i];
        if (!p) break;
        if (p > n4) break;

        for (e = 0, j = n4; j; e += j & 1, j /= p);

        if (e) {
            if (p == 2)
                c <<= e;
            else
                for (pp = p;;) {
                    if (int(e & 1)) c *= pp;
                    e >>= 1; if (!e) break;
                    pp *= pp;
                }
        }
    }

    for (i = n4 + 1;i <= x;i++) {
        c *= i;
    }

    llround(c);
    return c;
}

long double math_c(const unsigned long long k, const unsigned long long n){

    return (long double) (factorial(n)) / (long double) (factorial(k) * factorial(n-k));
}

int main(int argc, char **argv) {

    unsigned long long n = 0;
    unsigned long long k = 0;
    unsigned long long s1 = 0;
    unsigned long long s2 = 0;

    std::cin >> n;
    std::cin >> k;
    std::cin >> s1;
    std::cin >> s2;

    long double test1 = math_c(k, k*s1) / math_c(k, k*n);
    long double test2 = math_c(k, k*s2) / math_c(k, k*n);

    if(test1 == test2){
        std::cout << "Equal";
    }
    else if(test1 > test2) {
        std::cout << "First";

    } else if(test1 < test2) {
        std::cout << "Second";
    }

    return 0;
}
