def can_seat_introverts(N, K, introverts):
    left_space = introverts
    right_space = N - introverts - 2
    return left_space >= K and right_space >= K

def find_largest_number_of_introverts(N, K):
    left, right = 2, N - 1
    result = 2

    if K == 1:
        return N - 2  # All but two seats can be occupied in this case

    while left <= right:
        mid = (left + right) // 2

        if can_seat_introverts(N, K, mid):
            result = mid
            left = mid + 1
        else:
            right = mid - 1

    return result

# Input
N = int(input())
K = int(input())

# Find the largest number of introverts that can be seated
largest_introverts = find_largest_number_of_introverts(N, K)

# Output
print(largest_introverts)
