def calculate_probability_optimized(N, K, target_sum):
    # Инициализируем массивы вероятностей для текущего и предыдущего этапов
    dp_current = [0.0] * (target_sum + 1)
    dp_previous = [0.0] * (target_sum + 1)
    dp_previous[0] = 1.0  # Начальная вероятность

    # Обходим каждый запуск рулетки
    for i in range(1, N + 1):
        # Обновляем вероятности для каждого возможного значения суммы
        for j in range(target_sum + 1):
            dp_current[j] = 0.0
            for k in range(1, K + 1):
                if j - k >= 0:
                    dp_current[j] += dp_previous[j - k] / K

        # Обновляем массив вероятностей на предыдущем этапе
        dp_current, dp_previous = dp_previous, dp_current

    return dp_previous[target_sum]


def compare_probabilities_optimized(N, K, S1, S2):
    # Рассчитываем вероятности для каждого игрока
    probability_first = calculate_probability_optimized(N, K, S1)
    probability_second = calculate_probability_optimized(N, K, S2)

    # Сравниваем вероятности и выводим результат
    if probability_first > probability_second:
        return "First"
    elif probability_first < probability_second:
        return "Second"
    else:
        return "Equal"


# Считываем входные данные
N = int(input())
K = int(input())
S1 = int(input())
S2 = int(input())

# Вычисляем результат и выводим его
result = compare_probabilities_optimized(N, K, S1, S2)
print(result)
