def calculate_probability_optimized(N, K, target_sum):
    dp = [0.0] * (target_sum + 1)
    dp[0] = 1.0

    for i in range(1, N + 1):
        total_probability = 0.0

        # Обновляем вероятности
        for j in range(target_sum + 1):
            if j - K >= 0:
                total_probability += dp[j - K]

        total_probability /= K

        for j in range(target_sum + 1):
            dp[j] = total_probability

    return dp[target_sum]


def compare_probabilities_optimized(N, K, S1, S2):
    probability_first = calculate_probability_optimized(N, K, S1)
    probability_second = calculate_probability_optimized(N, K, S2)

    if probability_first > probability_second:
        return "First"
    elif probability_first < probability_second:
        return "Second"
    else:
        return "Equal"




# Считываем входные данные
N = int(input())
K = int(input())
S1 = int(input())
S2 = int(input())

# Вычисляем результат и выводим его
result = compare_probabilities_optimized(N, K, S1, S2)
print(result)
