def calculate_probability_optimized(N, K, target_sum):
    # Инициализируем массив вероятностей для предыдущего этапа
    dp_previous = [0.0] * (target_sum + 1)
    dp_previous[0] = 1.0

    # Обновляем вероятности для каждого возможного значения суммы
    for i in range(1, N + 1):
        # Инициализируем переменную для хранения суммы вероятностей
        total_probability = 0.0

        # Обновляем вероятности
        for j in range(target_sum + 1):
            if j - K >= 0:
                total_probability += dp_previous[j - K] / K

        # Обновляем массив вероятностей на предыдущем этапе
        for j in range(target_sum + 1):
            dp_previous[j] = total_probability

    return dp_previous[target_sum]


def compare_probabilities_optimized(N, K, S1, S2):
    # Рассчитываем вероятности для каждого игрока
    probability_first = calculate_probability_optimized(N, K, S1)
    probability_second = calculate_probability_optimized(N, K, S2)

    # Сравниваем вероятности и выводим результат
    if probability_first > probability_second:
        return "First"
    elif probability_first < probability_second:
        return "Second"
    else:
        return "Equal"




# Считываем входные данные
N = int(input())
K = int(input())
S1 = int(input())
S2 = int(input())

# Вычисляем результат и выводим его
result = compare_probabilities_optimized(N, K, S1, S2)
print(result)
