#include <iostream>
#include <vector>

using namespace std;

string calculate_winning_chances(int N, int K, int S1, int S2) {
    // Initialize arrays to store the number of ways to reach each sum
    vector<long long> dp1(S1 + 1, 0);
    vector<long long> dp2(S2 + 1, 0);
    dp1[0] = 1;  // There is one way to reach sum 0 (not betting on any number)
    dp2[0] = 1;

    // Calculate the number of ways to reach each sum for both players
    for (int i = 0; i < N; ++i) {
        for (int j = 1; j <= K; ++j) {
            for (int k = S1; k >= j; --k) {
                dp1[k] += dp1[k - j];
            }

            for (int k = S2; k >= j; --k) {
                dp2[k] += dp2[k - j];
            }
        }
    }

    // Compare the number of ways to reach the specified sums
    if (dp1[S1] > dp2[S2]) {
        return "First";
    } else if (dp1[S1] < dp2[S2]) {
        return "Second";
    } else {
        return "Equal";
    }
}

int main() {
    int N, K, S1, S2;
    cin >> N >> K >> S1 >> S2;

    // Calculate the winning chances and print the result
    cout << calculate_winning_chances(N, K, S1, S2) << endl;

    return 0;
}
