import math

def calculate_probability(N, K, S):
    # Функция для вычисления вероятности получения суммы S после N запусков рулетки
    dp = [[0] * (S + 1) for _ in range(N + 1)]
    dp[0][0] = 1

    for i in range(1, N + 1):
        for j in range(S + 1):
            for x in range(1, K + 1):
                if j - x >= 0:
                    dp[i][j] += dp[i - 1][j - x]

    return dp[N][S]

def roulette_game(N, K, S1, S2):
    prob1 = calculate_probability(N, K, S1)
    prob2 = calculate_probability(N, K, S2)

    if prob1 > prob2:
        return "First"
    elif prob1 < prob2:
        return "Second"
    else:
        return "Equal"

n = int(input())
k = int(input())
s1 = int(input())
s2 = int(input())

print(roulette_game(n, k, s1, s2))
