import math

def calculate_probability(N, K, S):
    prev_dp = [0] * (S + 1)
    prev_dp[0] = 1

    for i in range(1, N + 1):
        dp = [0] * (S + 1)
        for j in range(S + 1):
            for x in range(1, K + 1):
                if j - x >= 0:
                    dp[j] += prev_dp[j - x]
        prev_dp = dp

    return prev_dp[S]

def roulette_game(N, K, S1, S2):
    prob1 = calculate_probability(N, K, S1)
    prob2 = calculate_probability(N, K, S2)

    if prob1 > prob2:
        return "First"
    elif prob1 < prob2:
        return "Second"
    else:
        return "Equal"

n = int(input())
k = int(input())
s1 = int(input())
s2 = int(input())

print(roulette_game(n, k, s1, s2))
