import heapq


def reachable(N, M, K, city, start, airport):
    dx, dy = start
    node1, node2 = airport
    ways = [(1, 0), (-1, 0), (0, 1), (0, -1)]
    capabilities = [(2, 0), (-2, 0), (0, 2), (0, -2)]

    euristic = [[abs(x - node1) + abs(y - node2) for y in range(M)] for x in range(N)]

    visited = set()
    heap = [(0, dx, dy, 0)]

    while heap:
        (i, x, y, consumed) = heapq.heappop(heap)

        if (x, y) == (node1, node2):
            return "YES"
        elif (x, y, consumed) in visited:
            continue

        visited.add((x, y, consumed))

        for dx, dy in ways:
            x1 = x + dx
            x2 = y + dy
            if 1 <= x1 <= N and 1 <= x2 <= M and city[x1 - 1][x2 - 1] == '.':
                dfx = euristic[x1 - 1][x2 - 1] + consumed, x1, x2, consumed
                heapq.heappush(heap, dfx)

        if consumed < K:
            for dx, dy in capabilities:
                x1, x2 = x + dx, y + dy

                if 1 <= x1 <= N and 1 <= x2 <= M and city[x1 - 1][x2 - 1] == '.':
                    heapq.heappush(heap,
                                   (euristic[x1 - 1][x2 - 1] + consumed + 1, x1, x2, consumed + 1))

    return "NO"


N, M, K = map(int, input().split())

cities = [list(input()) for _ in range(N)]
begins = tuple(map(int, input().split()))
airports = tuple(map(int, input().split()))

print(reachable(N, M, K, cities, begins, airports))
