from collections import deque


def check(r, s):
    return r <= s


GRID = []

GRID.append("")

num_rows, num_cols, max_steps = map(int, input().split())

for _ in range(num_rows):
    row = input()
    GRID.append(" " + row)

start_r, start_c = map(int, input().split())
target_r, target_c = map(int, input().split())

deq = deque()

ranges = [[10 ** 7] * (num_cols + 1) for _ in range(num_rows + 1)]

ranges[start_r][start_c] = 0
deq.appendleft((start_r, start_c))

available = [(1, 0), (0, 1), (-1, 0), (0, -1)]
capabilities = [(2, 0), (0, 2), (-2, 0), (0, -2)]

while deq:
    (cur_row, cur_col) = deq.popleft()

    for move in available:
        new_row = cur_row + move[0]
        new_col = cur_col + move[1]
        if 1 <= new_row <= num_rows and 1 <= new_col <= num_cols and GRID[new_row][new_col] == '.' and ranges[new_row][
            new_col] > ranges[cur_row][cur_col]:
            ranges[new_row][new_col] = ranges[cur_row][cur_col]
            deq.appendleft((new_row, new_col))

    for jump in capabilities:
        new_row = cur_row + jump[0]
        new_col = cur_col + jump[1]
        if 1 <= new_row <= num_rows and 1 <= new_col <= num_cols and GRID[new_row][new_col] == '.' and ranges[new_row][
            new_col] > ranges[cur_row][cur_col] + 1:
            ranges[new_row][new_col] = ranges[cur_row][cur_col] + 1
            deq.append((new_row, new_col))

if check(ranges[target_r][target_c], max_steps):
    print("YES")
else:
    print("NO")
