#include <iostream>
#include <vector>
#include <algorithm>


using namespace std;

struct ProbabilityResult {
    vector<long long> dp1;
    vector<long long> dp2;
};

ProbabilityResult calculateProbability(int N, int K, int S) {
    vector<long long> dp1(S + 1, 0);
    vector<long long> dp2(S + 1, 0);
    dp1[0] = dp2[0] = 1;

    for (int i = 0; i < N; i++) {
        vector<long long> new_dp1(S + 1, 0);
        vector<long long> new_dp2(S + 1, 0);

        for (int s = 0; s <= S; s++) {
            for (int k = 1; k <= K; k++) {
                if (s - k >= 0) {
                    new_dp1[s] += dp1[s - k];
                    new_dp2[s] += dp2[s - k];
                }
            }
        }
        dp1 = new_dp1;
        dp2 = new_dp2;
    }

    return {dp1, dp2};
}

string findWinner(int N, int K, int S1, int S2) {
    ProbabilityResult probResult = calculateProbability(N, K, max(S1, S2));

    if (probResult.dp1[S1] > probResult.dp2[S2]) {
        return "First";
    } else if (probResult.dp2[S2] > probResult.dp1[S1]) {
        return "Second";
    } else {
        return "Equal";
    }
}

int main() {
    int N, K, S1, S2;
    cin >> N >> K >> S1 >> S2;

    string winner = findWinner(N, K, S1, S2);

    cout << winner << endl;

    return 0;
}
