#include <iostream>
#include <vector>

using namespace std;

vector<long long> calculateProbability(int N, int K, int S) {
    vector<long long> dp(S + 1, 0);
    dp[0] = 1;

    for (int i = 0; i < N; i++) {
        vector<long long> new_dp(S + 1, 0);

        for (int s = 0; s <= S; s++) {
            for (int k = 1; k <= K; k++) {
                if (s - k >= 0) {
                    new_dp[s] += dp[s - k];
                }
            }
        }
        dp = new_dp;
    }

    return dp;
}

string findWinner(int N, int K, int S1, int S2) {
    vector<long long> probResult = calculateProbability(N, K, max(S1, S2));

    if (probResult[S1] > probResult[S2]) {
        return "First";
    } else if (probResult[S2] > probResult[S1]) {
        return "Second";
    } else {
        return "Equal";
    }
}

int main() {
    int N, K, S1, S2;
    cin >> N >> K >> S1 >> S2;

    string winner = findWinner(N, K, S1, S2);

    cout << winner << endl;

    return 0;
}
