import java.io.BufferedReader
import java.io.InputStreamReader
import java.io.PrintWriter
import java.util.*
import kotlin.math.min
import kotlin.math.sqrt

fun <T : Comparable<T>> min(a: T, b: T) = if (a < b) a else b
fun <T : Comparable<T>> max(a: T, b: T) = if (a > b) a else b

//***11***11
fun solve() {
    val n = readInt()
    val xs = LongArray(n)
    val ys = LongArray(n)
    for (i in 0 until n) {
        xs[i] = readLong()
        ys[i] = readLong()
    }

    val gips = LongArray(n)
    var maxGips = Long.MIN_VALUE
    for (i in 1 until n) {
        val x = xs[i] - xs[i - 1]
        val y = ys[i] - ys[i - 1]
        gips[i] = x * x + y * y
        maxGips = max(maxGips, gips[i])
    }
    val x = xs[0] - xs[n-1]
    val y = ys[0] - ys[n-1]
    gips[0] = x * x + y * y
    maxGips = max(maxGips, gips[0])
    var ans = 0.0
    for (g in gips) {
        ans += sqrt(g.toDouble())
    }
    ans -= sqrt(maxGips.toDouble())
    out.println(ans)
}

fun main(args: Array<String>) {
    solve()
    out.close()
}

var tok = StringTokenizer("", " ")
var br = BufferedReader(InputStreamReader(System.`in`))
var out = PrintWriter(System.out)

fun read(): String {
    while (!tok.hasMoreTokens()) {
        tok = StringTokenizer(br.readLine())
    }
    return tok.nextToken()!!
}

fun readInt() = read().toInt()
fun readLong() = read().toLong()
fun readIntArray(n: Int) = IntArray(n) {
    readInt()
}
fun readLongArray(n: Int) = LongArray(n) {
    readLong()
}
