#include <chrono>
#include <iostream>
#include <map>
#include <set>
#include <sstream>
#include <algorithm>
#include <stack>
#include <string>
#include <unordered_map>
#include <iomanip>
#include <vector>
#include "optimization.h"

using namespace std;
//#define int int64_t


struct Point {
    int x = 0, y = 0;

    Point() {}

    Point(int x, int y) : x(x), y(y) {}

    long double dist(Point other) {
        int dx = x - other.x;
        int dy = y - other.y;
        return sqrt(dx * dx + dy * dy);
    }
};

Point point0;

Point operator+(const Point &point1, const Point &point2) {
    return Point(point1.x + point2.x, point1.y + point2.y);
}

Point operator-(const Point &point1, const Point &point2) {
    return Point(point1.x - point2.x, point1.y - point2.y);
}

int operator ^(Point point1, Point point2) {
    return point1.x * point2.y - point2.x * point1.y;
}

bool comp(Point a, Point b) {
    return ((a - point0) ^ (b - point0)) > 0;
}

signed main() {
#ifdef LOCAL
    freopen("/Users/dmitrykutsenko/CLionProjects/cpp/input.txt", "r", stdin);
    freopen("/Users/dmitrykutsenko/CLionProjects/cpp/output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    vector<Point> points;
    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        points.emplace_back(x, y);
    }
    point0 = points[0];
    for (int i = 0; i < n; i++) {
        if (point0.x < points[i].x || (point0.x == points[i].x && point0.y < points[i].y)) {
            point0 = points[i];
        }
    }
    sort(points.begin(), points.end(), comp);
    long double full = 0.0;
    for (int i = 0; i < n; i++) {
        full += points[i].dist(points[(n + i - 1) % n]);
    }
    long double answer = full;
    for (int i = 0; i < n; i++) {
        answer = min(answer, full - points[i].dist(points[(n + i - 1) % n]));
    }
    cout << fixed << setprecision(10) << answer;
}

