import java.io.BufferedReader
import java.io.InputStreamReader
import java.io.PrintWriter
import java.lang.StringBuilder
import java.util.*
import kotlin.collections.HashMap
import kotlin.math.abs
import kotlin.math.min
import kotlin.math.sqrt

fun <T : Comparable<T>> min(a: T, b: T) = if (a < b) a else b
fun <T : Comparable<T>> max(a: T, b: T) = if (a > b) a else b

val users = HashMap<String, Int>()

fun getName(s: String, cnt: Int): String {
    if (cnt == 0) return s
    return s + cnt
}

fun solve() {
    var q = readInt()
    while (q-- > 0) {
        val inp = read()
        var allcnt = users[inp]?:0
        var checkName = getName(inp, allcnt)
        while (users.containsKey(checkName)) {
            allcnt++
            checkName = getName(inp, allcnt)
        }
        val newName = getName(inp, allcnt)
        users[newName] = (users[newName] ?: 0) + 1
        if (allcnt > 0) users[inp] = allcnt
        out.println(newName)
    }
}

fun main(args: Array<String>) {
    solve()
    out.close()
}


var tok = StringTokenizer("", " ")
var br = BufferedReader(InputStreamReader(System.`in`))
var out = PrintWriter(System.out)

fun read(): String {
    while (!tok.hasMoreTokens()) {
        tok = StringTokenizer(br.readLine())
    }
    return tok.nextToken()!!
}

fun readInt() = read().toInt()
fun readLong() = read().toLong()
fun readIntArray(n: Int) = IntArray(n) {
    readInt()
}
fun readLongArray(n: Int) = LongArray(n) {
    readLong()
}
