from collections import deque

def to_airoport(N, M, city, K, dx, dy, ax, ay):
    visited = [[[False for _ in range(K + 1)] for _ in range(M)] for _ in range(N)]

    queue = deque([(dx, dy, 0)])
    visited[dx][dy][0] = True
    paths = [(1, 0), (-1, 0), (0, 1), (0, -1)]

    while queue:
        x, y, jumps = queue.popleft()
        if (x, y) == (ax, ay):
            return True

        for dx, dy in paths:
            nx, ny = x + dx, y + dy

            if 0 <= nx < N and 0 <= ny < M and city[nx][ny] == '.' and not visited[nx][ny][jumps]:
                queue.append((nx, ny, jumps))
                visited[nx][ny][jumps] = True

            if jumps < K:
                nx, ny = x + 2 * dx, y + 2 * dy

                if 0 <= nx < N and 0 <= ny < M and city[nx][ny] == '.' and not visited[nx][ny][jumps + 1]:
                    queue.append((nx, ny, jumps + 1))
                    visited[nx][ny][jumps + 1] = True

    return False


N, M, K = map(int, input().split())
city = [input().strip() for _ in range(N)]
dx, dy = map(int, input().split())
ax, ay = map(int, input().split())

if to_airoport(N, M, city, K, dx - 1, dy - 1, ax - 1, ay - 1):
    print("YES")
else:
    print("NO")
