#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
using ull = uint64_t;

int64_t bin_search(int64_t left, int64_t right, double divisor, double result) {
    while (right - left > 1) {
        int64_t mid = (left + right) / 2;
        if (static_cast<double>(mid) / divisor <= result) {
            left = mid;
        } else {
            right = mid;
        }
    }
    return left;
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cerr.tie(nullptr);

    ull n;
    double k;
    cin>>n>>k;
    vector<pair<double, double>> pairs(n);

    for (ull i = 0; i < n; ++i) {
        cin>>pairs[i].second;
    }
    for (ull i = 0; i < n; ++i) {
        cin>>pairs[i].first;
    }
    sort(pairs.begin(), pairs.end(), [](pair<double, double> const & lhs, pair<double, double> const & rhs){return lhs.second < rhs.second;});
    double sum = 0;
    int64_t i = pairs.size() - 1;
    for (; i >= 0; i--) {
        if (sum + abs(pairs[i].first - pairs[i].second) / pairs[i].second > k) break;
        sum += abs(pairs[i].first - pairs[i].second) / pairs[i].second;
    }
    int64_t res = 0;
    for (int64_t j = 0; j < i; ++j) {
        res += static_cast<int64_t>(abs(pairs[j].first - pairs[j].second));
    }
    res += abs(static_cast<int64_t>(pairs[i].first) - static_cast<int64_t>(pairs[i].second)) - bin_search(0, abs(static_cast<int64_t>(pairs[i].first) - static_cast<int64_t>(pairs[i].second)) + 1, pairs[i].second, k - sum);
    cout<<res;
}