#include <iostream>
#include <cmath>

using namespace std;

const long double eps = 1e-18;

long double bin_pow(long double x, long long n)
{
	long long prom1, prom2;
	if (n == 0)
	{
		return 1;
	}
	if (n % 2 == 0)
	{
		prom1 = bin_pow(x, n / 2);
		return (prom1 * prom1);
	}
	else
	{
		prom2 = bin_pow(x, n - 1);
		return (prom2 * x);
	}
}

int main()
{
    long long n, k, s1, s2;
    cin >> n >> k >> s1 >> s2;
    long double e = bin_pow(1.0 / k, n - 1);
    e /= 2;
    if (abs(s1 - e) - abs(s2 - e) < eps)
    {
        cout << "Equal";
        return 0;
    }
    if (abs(s1 - e) > abs(s2 - e))
    {
        cout << "First";
        return 0;
    }
    cout << "Second";
}
