#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <cmath>
#include <iomanip>
#include <queue>
#define all(x) x.begin(), x.end()
#define vec vector
using namespace std;
typedef long long ll;
typedef long long nt;

const nt MAXN = 1e6 + 13;
const long long INF = 1e18 + 13;
const double EPS = 0.0000001;

struct edge {
	nt u, w;
};
vec<edge> gr[MAXN];

char t[2000][2000];
nt dx[4] = { 1, -1, 0, 0 };
nt dy[4] = { 0, 0, 1, -1 };

nt dxj[4] = {2, -2, 0, 0};
nt dyj[4] = {0, 0, 2, -2};

bool ok(nt i, nt j, nt n, nt m) {
	return 0 <= i && i < n && 0 <= j && j < m;
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	nt n, m, k, sx, sy, fx, fy;
	cin >> n >> m >> k;
	for (nt i = 0; i < n; ++i) {
		for (nt j = 0; j < m; ++j) {
			cin >> t[i][j];
		}
	}
	cin >> sx >> sy >> fx >> fy;
	--sx; --sy; --fx; --fy;
	for (nt i = 0; i < n; ++i) {
		for (nt j = 0; j < m; ++j) {
			nt u = m * i + j;
			for (nt k = 0; k < 4; ++k) {
				if (!ok(i + dx[k], j + dy[k], n, m)) continue;
				if (t[i + dx[k]][j + dy[k]] == '#') continue;
				nt v = m * (i + dx[k]) + j + dy[k];
				gr[u].push_back({ v, 0 });
			}
			for (nt k = 0; k < 4; ++k) {
				if (!ok(i + dxj[k], j + dyj[k], n, m)) continue;
				if (t[i + dxj[k]][j + dyj[k]] == '#') continue;
				nt v = m * (i + dxj[k]) + j + dyj[k];
				gr[u].push_back({ v, 1 });
			}
		}
	}
	
	deque<nt> q;
	vec<nt> d(n * m + 1, INF);
	q.push_back(sx * m + sy);
	d[sx * m + sy] = 0;
	while (!q.empty()) {
		nt v = q.front();
		q.pop_front();
		for (auto t : gr[v]) {
			if (d[t.u] <= d[v] + t.w) continue;
			d[t.u] = d[v] + t.w;
			if (t.w == 0) {
				q.push_front(t.u);
			}
			else {
				q.push_back(t.u);
			}
		}
	}
	if (d[fx * m + fy] <= k) {
		cout << "YES\n";
	}
	else {
		cout << "NO\n";
	}
}