#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <queue>
#include <random>
#include <cassert>
#include <iomanip>
using namespace std;
#define ll long long
#define int long long
#define lll __int128
#define ull unsigned long long
#define ld long double
#define fi first
#define se second
#define all(x) x.begin(), x.end()
ld EPS = 1e-7;
ld PI = 3.14159265358979323846;
int MAX_ITER = 700;
int MOD = 998244353;
int INF = 2e9 + 100;

struct Point {
    ld x, y;

    Point() {
        x = y = 0;
    }

    Point(ld x, ld y) : x(x), y(y) {}
};

struct Line {
    ld a, b, c;

    Line() {
        a = b = c = 0;
    }

    Line(ld a, ld b, ld c) : a(a), b(b), c(c) {}
};

bool operator== (Point &a, Point &b) {
    return abs(a.x - b.x) < EPS && abs(a.y - b.y) < EPS;
}

ostream &operator<<(ostream &out, const Point& p) {
    return out << p.x << ' ' << p.y;
}

ostream &operator<<(ostream &out, const Line& l) {
    return out << l.a << ' ' << l.b << ' ' << l.c;
}

Point operator+ (Point a, Point b) {
    return Point(a.x + b.x, a.y + b.y);
}

Point operator- (Point a, Point b) {
    return Point(a.x - b.x, a.y - b.y);
}

Point operator* (Point a, ld k) {
    return Point(a.x * k, a.y * k);
}

ld sp(Point a, Point b) {
    return a.x * b.y - a.y * b.x;
}

ld vp(Point a, Point b) {
    return a.x * b.x + a.y * b.y;
}

ld orientation(Point &a, Point &b, Point &c) {
    return vp(c - a, b - a);
}

ld dist(Point &a, Point &b) {
    return sqrt((a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y));
}

void solve () {
    int n; cin >> n;
    vector<Point> points(n);
    for (int i = 0; i < n; ++i) {
        cin >> points[i].x >> points[i].y;
    }
    ld max_seg = 0;
    ld sum = 0;
    for (int i = 0; i < n; ++i) {
        int j = (i + 1) % n;
        ld tmp = dist(points[i], points[j]);
        sum += tmp;
        max_seg = max(max_seg, tmp);
    }
    cout << fixed << setprecision(12) << sum - max_seg;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
    solve();
    return 0;
}
