#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <queue>
#include <random>
#include <cassert>
#include <numeric>
#include <iomanip>
using namespace std;
#define ll long long
#define int long long
#define lll __int128
#define ull unsigned long long
#define ld long double
#define fi first
#define se second
#define all(x) x.begin(), x.end()
#define vi vector<int>
int INF = 2e18 + 100;
int MOD = 998244353;
string YES = "YES\n";
string NO = "NO\n";
int N = 1e6 + 500;

void cinvec(vector<int> &vec) {
    for (int &el : vec) {
        cin >> el;
    }
}

vector<int> fact;

void fact_precnt() {
    fact.resize(N + 1);
    fact[0] = 1;
    for (int i = 1; i <= N; ++i) {
        fact[i] = fact[i - 1] * i % MOD;
    }
}

int fast_pow(int a, int b) {
    if (b == 0) {
        return 1;
    }
    if (b % 2 == 0) {
        return fast_pow(a * a % MOD, b / 2);
    }
    return a * fast_pow(a, b - 1) % MOD;
}

int inv(int x) {
    return fast_pow(x, MOD - 2);
}

int c(int n, int k) {
    if (k > n) {
        return 0;
    }
    return fact[n] * inv(fact[k] * fact[n - k] % MOD) % MOD;
}

int di[4] = {-1, 0, 1, 0};
int dj[4] = {0, -1, 0, 1};
int di2[4] = {-2, 0, 2, 0};
int dj2[4] = {0, -2, 0, 2};
vector<string> a;
vector<vector<int>> was;
vector<unordered_set<int>> g;
int si, sj, ei, ej;
int n, m, k;
vector<vector<pair<int,int>>> p;
vector<vector<int>> size_;

pair<int,int> get(pair<int,int> u) {
    if (u != p[u.fi][u.se])
        p[u.fi][u.se] = get(p[u.fi][u.se]);
    return p[u.fi][u.se];
}

void union_(pair<int,int> u, pair<int,int> v) {
    u = get(u);
    v = get(v);
    if (u == v)
        return;
    if (size_[u.fi][u.se] > size_[v.fi][v.se])
        swap(u, v);
    p[u.fi][u.se] = v;
    size_[v.fi][v.se] += size_[u.fi][u.se];
}

int last = 0;
void make_comps() {
    p.resize(n, vector<pair<int,int>> (m));
    size_.resize(n, vector<int> (m, 1));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            p[i][j] = {i, j};
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (a[i][j] == '#')
                continue;
            for (int d = 0; d < 4; ++d) {
                int ti = i + di[d];
                int tj = j + dj[d];
                if (ti < 0 || ti >= n || tj < 0 || tj >= m) {
                    continue;
                }
                if (a[ti][tj] == '#') {
                    continue;
                }
                union_({i, j}, {ti, tj});
            }
        }
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (get({i, j}) == make_pair(i, j)) {
                ++last;
                was[i][j] = last;
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (get({i, j}) != make_pair(i, j)) {
                auto [pi, pj] = get({i, j});
                was[i][j] = was[pi][pj];
            }
        }
    }
}

void solve() {
    cin >> n >> m >> k;
    a.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    cin >> si >> sj >> ei >> ej;
    --si, --sj, --ei, --ej;
    was.resize(n, vector<int> (m, 0));
    make_comps();
    g.resize(last + 1);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (a[i][j] == '#') {
                continue;
            }
            for (int d = 0; d < 4; ++d) {
                int ti = i + di2[d];
                int tj = j + dj2[d];
                if (ti < 0 || ti >= n || tj < 0 || tj >= m) {
                    continue;
                }
                if (a[ti][tj] == '#') {
                    continue;
                }
                if (was[ti][tj] != was[i][j]) {
                    g[was[ti][tj]].insert(was[i][j]);
                    g[was[i][j]].insert(was[ti][tj]);
                }
            }
        }
    }
    vector<int> dist(last + 1, -1);
    queue<int> q;
    q.push(was[si][sj]);
    dist[was[si][sj]] = 0;
    while (!q.empty()) {
        auto u = q.front();
        q.pop();
        for (int v : g[u]) {
            if (dist[v] == -1) {
                q.push(v);
                dist[v] = dist[u] + 1;
            }
        }
    }
    int ans = dist[was[ei][ej]];
    if (ans == -1 || ans > k) {
        cout << "NO\n";
    } else {
        cout << "YES\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
    //fact_precnt();
    //int q; cin >> q;
    //while (q--)
    solve();
    return 0;
}