import sys


def roulette_game(N, K, S1, S2):
    dp_first = [[0] * (S1 + 1) for _ in range(N + 1)]
    dp_second = [[0] * (S2 + 1) for _ in range(N + 1)]

    dp_first[0][S1] = 1
    dp_second[0][S2] = 1

    for i in range(1, N + 1):
        for s in range(S1 + 1):
            for k in range(1, K + 1):
                if s - k >= 0:
                    dp_first[i][s] += dp_first[i - 1][s - k]

        for s in range(S2 + 1):
            for k in range(1, K + 1):
                if s - k >= 0:
                    dp_second[i][s] += dp_second[i - 1][s - k]

    if dp_first[N][S1] > dp_second[N][S2]:
        return "First"
    elif dp_first[N][S1] < dp_second[N][S2]:
        return "Second"
    else:
        return "Equal"

# f = open("test.txt", "r")
f = sys.stdin
n = int(f.readline())
k = int(f.readline())
s1 = int(f.readline())
s2 = int(f.readline())
f.close()
result = roulette_game(n, k, s1, s2)
print(result)
