import sys
from itertools import product

def roulette_game(N, K, S1, S2):
    def calculate_probability(rolls, total_sum, target_sum):
        if rolls == 0:
            return 1 if total_sum == target_sum else 0

        total_probability = 0
        for roll in range(1, K + 1):
            total_probability += calculate_probability(rolls - 1, total_sum + roll, target_sum)

        return total_probability

    probability_first = calculate_probability(N, 0, S1)
    probability_second = calculate_probability(N, 0, S2)

    if probability_first > probability_second:
        return "First"
    elif probability_first < probability_second:
        return "Second"
    else:
        return "Equal"

# f = open("test.txt", "r")
f = sys.stdin
n = int(f.readline())
k = int(f.readline())
s1 = int(f.readline())
s2 = int(f.readline())
f.close()
result = roulette_game(n, k, s1, s2)
print(result)
