import java.math.RoundingMode;
import java.util.PriorityQueue;
import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        int n = 1;
        while (n-- > 0) {
            new Main().solve(sc);
        }
    }

    static double[] s;
    static double[] a;

    private void solve(Scanner sc) {
        int n = sc.nextInt(), k = sc.nextInt();
        s = new double[n];
        a = new double[n];
        for (int i = 0; i < n; i++) {
            s[i] = sc.nextInt();
        }
        for (int i = 0; i < n; i++) {
            a[i] = sc.nextInt();
        }
        PriorityQueue<Detail> queue = new PriorityQueue<>();
        for (int i = 0; i < n; i++) {
            queue.add(new Detail(s[i], a[i]));
        }
        double res = queue.stream().mapToDouble(Detail::getBrak).sum();
        long ans = 0;
        while (res > k) {
            Detail max = queue.poll();
            int rounded = (int) res;
            if (rounded <  res) {
                rounded++;
            }
            res -= max.getBrak();
            int min = (rounded - k) * (int)max.getS();
            if (max.getA() > max.getS()) {
                int diff = Math.min((int) max.getA() -(int) max.getS(), min);
                ans += diff;
                max.setA(max.getA() - diff);
            } else if (max.getA() < max.getS()) {
                int diff = Math.min((int) max.getS() - (int) max.getA(),min);
                ans += diff;
                max.setA(max.getA() + diff);
            }
            res += max.getBrak();
            queue.add(max);
        }
        System.out.println(ans);
    }

    class Detail implements Comparable<Detail> {
        double s;
        double a;
        double brak;

        Detail(double s, double a) {
            this.s = s;
            this.a = a;
            this.brak = Math.abs(a - s) / s;
        }

        public void setS(double s) {
            this.s = s;
            this.brak = Math.abs(a - s) / s;
        }

        public void setA(double a) {
            this.a = a;
            this.brak = Math.abs(a - s) / s;
        }

        public void setBrak(double brak) {
            this.brak = brak;
        }

        public double getS() {
            return s;
        }

        public double getA() {
            return a;
        }

        public double getBrak() {
            return brak;
        }

        @Override
        public int compareTo(Detail d) {
            return Double.compare(s, d.getS());
        }
    }
}