import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        int n = 1;
        while (n-- > 0) {
            new Main().solve(sc);
        }
    }

    static double[] s;
    static double[] a;

    private void solve(Scanner sc) {
        int n = sc.nextInt(), k = sc.nextInt();
        s = new double[n];
        a = new double[n];
        for (int i = 0; i < n; i++) {
            s[i] = sc.nextInt();
        }
        for (int i = 0; i < n; i++) {
            a[i] = sc.nextInt();
        }
        List<Detail> details = new ArrayList<>();
        for (int i = 0; i < n; i++) {
            details.add(new Detail(s[i], a[i]));
        }
        double res = details.stream().mapToDouble(Detail::getBrak).sum();
        Collections.sort(details);
        long ans = 0;
        for (Detail detail : details) {
            if (res - detail.getBrak() >= k) {
                res -= detail.getBrak();
                ans += Math.abs((int) detail.getA() - (int) detail.getS());
            } else {
                double diff = (res - k) * detail.getS();
                int rounded = (int) diff;
                ans += rounded;
                break;
            }
        }
        System.out.println(ans);
    }

    class Detail implements Comparable<Detail> {
        double s;
        double a;
        double brak;

        Detail(double s, double a) {
            this.s = s;
            this.a = a;
            this.brak = Math.abs(a - s) / s;
        }

        public void setS(double s) {
            this.s = s;
            this.brak = Math.abs(a - s) / s;
        }

        public void setA(double a) {
            this.a = a;
            this.brak = Math.abs(a - s) / s;
        }

        public void setBrak(double brak) {
            this.brak = brak;
        }

        public double getS() {
            return s;
        }

        public double getA() {
            return a;
        }

        public double getBrak() {
            return brak;
        }

        @Override
        public int compareTo(Detail d) {
            return Double.compare(s, d.getS());
        }
    }
}