#include <iostream>
#include <unordered_map>
#include <string>
#include <vector>
#include <unordered_set>

using namespace std;

int main() {
	int q;
	cin >> q;

	unordered_map<string, long long> cache;
	unordered_map<string, unordered_set<long>> names;
	string name;
	getline(cin, name);

	for (int i = 0; i < q; ++i) {
		getline(cin, name);

		int index = name.length() - 1;
		while (index > -1) {
			if (!(name[index] - '0' >= 0 && name[index] - '0' <= 9)) {
				break;
			}
			--index;
		}

		++index;
		while (index < name.length() && name[index] == '0') {
			++index;
		}

		string trimmed_name = name.substr(0, index);
		long number = index == name.length() ? 0 : stol(name.substr(index, name.length()));

		if (names.find(trimmed_name) == names.end()) {
			names.insert({ trimmed_name, unordered_set<long>() });
		}

		auto current_bucket = names[trimmed_name];
		if (current_bucket.find(number) == current_bucket.end()) {
			//cout << "        #" + name << endl;
			cout << name << endl;
			names[trimmed_name].insert(number);
			cache[name] = number;
			continue;
		}

		string str_number = number == 0 ? "" : to_string(number);

		long j = 1;
		if (cache.find(name) != cache.end()) {
			j = cache[name];
		}

		for (;; j++) {
			string temp = str_number + to_string(j);
			long parsed = stol(temp);
			
			if (current_bucket.find(parsed) == current_bucket.end()) {
				//cout << "       ##" + trimmed_name + temp << endl;
				cout << trimmed_name + temp << endl;
				names[trimmed_name].insert(parsed);
				cache[name] = j;
				break;
			}
		}
	}

	return 0;
}
