import java.util.HashSet;
import java.util.Scanner;
import java.util.Set;

public class Main {
    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        int n = 1;
        while (n-- > 0) {
            new Main().solve(sc);
        }
    }

    private Set<Edge>[] g;
    private int dp[];

    private void solve(Scanner sc) {
        int n = sc.nextInt(), m = sc.nextInt(), k = sc.nextInt();
        char[][] field = new char[n][m];
        for (int i = 0; i < n; i++) {
            field[i] = sc.next().toCharArray();
        }
        g = new HashSet[m * n];
        dp = new int[m * n];
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                g[i * m + j] = new HashSet<>();
                dp[i * m + j] = -1;
            }
        }
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                if (field[i][j] != '.') {
                    continue;
                }
                if (i > 0 && field[i - 1][j] == '.') {
                    int x = i * m + j;
                    int y = (i - 1) * m + j;
                    g[x].add(new Edge(y, 0));
                    g[y].add(new Edge(x, 0));
                }
                if (i > 1 && field[i - 2][j] == '.') {
                    int x = i * m + j;
                    int y = (i - 2) * m + j;
                    g[x].add(new Edge(y, 1));
                    g[y].add(new Edge(x, 1));
                }

                if (j > 0 && field[i][j - 1] == '.') {
                    int x = i * m + j;
                    int y = i * m + j - 1;
                    g[x].add(new Edge(y, 0));
                    g[y].add(new Edge(x, 0));
                }
                if (j > 1 && field[i][j - 2] == '.') {
                    int x = i * m + j;
                    int y = i * m + j - 2;
                    g[x].add(new Edge(y, 1));
                    g[y].add(new Edge(x, 1));
                }

                if (i < n - 1 && field[i + 1][j] == '.') {
                    int x = i * m + j;
                    int y = (i + 1) * m + j;
                    g[x].add(new Edge(y, 0));
                    g[y].add(new Edge(x, 0));
                }
                if (i < n - 2 && field[i + 2][j] == '.') {
                    int x = i * m + j;
                    int y = (i + 2) * m + j;
                    g[x].add(new Edge(y, 1));
                    g[y].add(new Edge(x, 1));
                }

                if (j < m - 1 && field[i][j + 1] == '.') {
                    int x = i * m + j;
                    int y = i * m + j + 1;
                    g[x].add(new Edge(y, 0));
                    g[y].add(new Edge(x, 0));
                }
                if (j < m - 2 && field[i][j + 2] == '.') {
                    int x = i * m + j;
                    int y = i * m + j + 2;
                    g[x].add(new Edge(y, 1));
                    g[y].add(new Edge(x, 1));
                }
            }
        }
        int ai = sc.nextInt() - 1, aj = sc.nextInt() - 1;
        int bi = sc.nextInt() - 1, bj = sc.nextInt() - 1;
        dp[ai * m + aj] = 0;
        Set<Integer> cur = new HashSet<>();
        cur.add(ai * m + aj);
        while (!cur.isEmpty()) {
            Set<Integer> newCur = new HashSet<>();
            for (int u : cur) {
                for (Edge e : g[u]) {
                    if (dp[e.v] == -1) {
                        newCur.add(e.v);
                        dp[e.v] = dp[u] + e.w;
                    }
                }
            }
            cur = new HashSet<>(newCur);
        }
        if (dp[bi * m + bj] == -1 || dp[bi * m + bj] > k) {
            System.out.println("NO");
            return;
        }
        System.out.println("YES");
    }

    record Edge(int v, int w) {
    }
}