import java.util.HashSet;
import java.util.Scanner;
import java.util.Set;

public class Main {
    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        int n = 1;
        while (n-- > 0) {
            new Main().solve(sc);
        }
    }

    private int dp[][];

    private void solve(Scanner sc) {
        int n = sc.nextInt(), m = sc.nextInt(), k = sc.nextInt();
        char[][] field = new char[n][m];
        for (int i = 0; i < n; i++) {
            field[i] = sc.next().toCharArray();
        }
        dp = new int[n][m];
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                dp[i][j] = -1;
            }
        }
        int ai = sc.nextInt() - 1, aj = sc.nextInt() - 1;
        int bi = sc.nextInt() - 1, bj = sc.nextInt() - 1;
        dp[ai][aj] = 0;
        Set<Point> cur = new HashSet<>();
        cur.add(new Point(ai, aj));
        while (!cur.isEmpty()) {
            Set<Point> newCur = new HashSet<>();
            for (Point u : cur) {
                if (u.i > 0 && field[u.i - 1][u.j] == '.') {
                    if (dp[u.i - 1][u.j] == -1 || dp[u.i - 1][u.j] > dp[u.i][u.j]) {
                        newCur.add(new Point(u.i - 1, u.j));
                        dp[u.i - 1][u.j] = dp[u.i][u.j];
                    }
                }
                if (u.i > 1 && field[u.i - 2][u.j] == '.') {
                    if (dp[u.i - 2][u.j] == -1 || dp[u.i - 2][u.j] > dp[u.i][u.j] + 1) {
                        newCur.add(new Point(u.i - 2, u.j));
                        dp[u.i - 2][u.j] = dp[u.i][u.j] + 1;
                    }
                }

                if (u.j > 0 && field[u.i][u.j - 1] == '.') {
                    if (dp[u.i][u.j - 1] == -1 || dp[u.i][u.j - 1] > dp[u.i][u.j]) {
                        newCur.add(new Point(u.i, u.j - 1));
                        dp[u.i][u.j - 1] = dp[u.i][u.j];
                    }
                }
                if (u.j > 1 && field[u.i][u.j - 2] == '.') {
                    if (dp[u.i][u.j - 2] == -1 || dp[u.i][u.j - 2] > dp[u.i][u.j] + 1) {
                        newCur.add(new Point(u.i, u.j - 2));
                        dp[u.i][u.j - 2] = dp[u.i][u.j] + 1;
                    }
                }

                if (u.i < n - 1 && field[u.i + 1][u.j] == '.') {
                    if (dp[u.i + 1][u.j] == -1 || dp[u.i + 1][u.j] > dp[u.i][u.j]) {
                        newCur.add(new Point(u.i + 1, u.j));
                        dp[u.i + 1][u.j] = dp[u.i][u.j];
                    }
                }
                if (u.i < n - 2 && field[u.i + 2][u.j] == '.') {
                    if (dp[u.i + 2][u.j] == -1 || dp[u.i + 2][u.j] > dp[u.i][u.j] + 1) {
                        newCur.add(new Point(u.i + 2, u.j));
                        dp[u.i + 2][u.j] = dp[u.i][u.j] + 1;
                    }
                }

                if (u.j < m - 1 && field[u.i][u.j + 1] == '.') {
                    if (dp[u.i][u.j + 1] == -1 || dp[u.i][u.j + 1] > dp[u.i][u.j]) {
                        newCur.add(new Point(u.i, u.j + 1));
                        dp[u.i][u.j + 1] = dp[u.i][u.j];
                    }
                }
                if (u.j < m - 2 && field[u.i][u.j + 2] == '.') {
                    if (dp[u.i][u.j + 2] == -1 || dp[u.i][u.j + 2] > dp[u.i][u.j] + 1) {
                        newCur.add(new Point(u.i, u.j + 2));
                        dp[u.i][u.j + 2] = dp[u.i][u.j] + 1;
                    }
                }
            }
            if (dp[bi][bj] != -1 && dp[bi][bj] <= k) {
                System.out.println("YES");
                return;
            }
            cur = newCur;
        }
        System.out.println("NO");
    }

    record Point(int i, int j) {
    }

}