#include <iostream>#include <iomanip>
#include <cmath>

#pragma GCC optimize("Ofast")

struct Point {
    int x;
    int y;

    Point(int a, int b) {
        x = a;
        y = b;
    }
};

double CountDist(Point a1, Point a2) {
    return std::sqrt((a1.x - a2.x) * (a1.x - a2.x) + (a1.y - a2.y) * (a1.y - a2.y));
}

int main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    long long N;
    std::cin >> N;
    double per = 0;
    double longestSide = 0;
    int curX, curY;
    std::cin >> curX >> curY;
    Point FirstPoint(curX, curY);
    Point a1 = FirstPoint;
    for (int i = 0; i < N - 1; ++i) {
        std::cin >> curX >> curY;
        Point a2(curX, curY);
        double curSide = CountDist(a1, a2);
        longestSide = std::max(longestSide, curSide);
        per += curSide;
        a1 = a2;
    }
    double curSide = CountDist(a1, FirstPoint);
    longestSide = std::max(longestSide, curSide);
    per += curSide;
    std::cout << std::fixed << std::setprecision(6) << per - longestSide << std::endl;
    return 0;
}