#include <iostream>
#include <vector>
#include <string>

using namespace std;

const vector<pair<int, int>> directions = {{1,  0},
                                           {-1, 0},
                                           {0,  1},
                                           {0,  -1}};

const vector<pair<int, int>> directions_jump = {{2,  0},
                                                {-2, 0},
                                                {0,  2},
                                                {0,  -2}};

#include <iostream>
#include <vector>
#include <string>
#include <queue>
#include <map>

using namespace std;


int main() {
    int N, M, k;
    cin >> N >> M >> k;
    vector<string> v(N, "");
    for (int i = 0; i < N; i++)
        cin >> v[i];

    int startX, startY, endX, endY;
    cin >> startX >> startY >> endX >> endY;

    int endComponent = 0;
    int startComponent = 0;
    int currentComponent = 0;
    for (int m = 0; m < M; ++m) {
        for (int n = 0; n < N; ++n) {
            if (v[n][m] != '.') {
                continue;
            }
            if (n == endX && m == endY) {
                endComponent = currentComponent;
            }
            if (n == startX && m == startY) {
                startComponent = currentComponent;
            }
            queue<pair<int, int>> q;
            q.emplace(n, m);
            v[n][m] = to_string(currentComponent)[0];
            while (!q.empty()) {
                int x = q.front().first;
                int y = q.front().second;
                q.pop();
                if (x == endX && y == endY) {
                    cout << "YES";
                    return 0;
                }
                vector<int> dx = {1, -1, 0, 0};
                vector<int> dy = {0, 0, 1, -1};
                for (int i = 0; i < 4; i++) {
                    int nx = x + dx[i];
                    int ny = y + dy[i];
                    if (nx >= 0 && nx < N && ny >= 0 && ny < M) {
                        if (v[nx][ny] == '.') {
                            v[nx][ny] = to_string(currentComponent)[0];
                            q.emplace(nx, ny);
                        }
                    }
                }
            }
            currentComponent++;
        }
    }

    map<char, vector<char>> graph;
    for (int i = 0; i < currentComponent; i++) {
        graph[to_string(i)[0]] = {};
    }

    for (int m = 0; m < M; ++m) {
        for (int n = 0; n < N; ++n) {
            if (v[n][m] == '#') {
                continue;
            }
            for (int i = 0; i < 4; i++) {
                int nx = n + directions_jump[i].first;
                int ny = m + directions_jump[i].second;
                if (nx >= 0 && nx < N && ny >= 0 && ny < M) {
                    if (v[nx][ny] != '#' && v[nx][ny] != v[n][m]) {
                        graph[v[n][m]].push_back(v[nx][ny]);
                    }
                }
            }
        }
    }

    //shortest path from start to end
    queue<char> q;
    q.push(to_string(startComponent)[0]);
    map<char, int> dist;
    dist[to_string(startComponent)[0]] = 0;
    while (!q.empty()) {
        char current = q.front();
        q.pop();
        for (auto &neighbour : graph[current]) {
            if (dist.find(neighbour) == dist.end()) {
                dist[neighbour] = dist[current] + 1;
                q.push(neighbour);
            }
        }
    }

    auto p =  dist.find(to_string(endComponent)[0]);
    if (p == dist.end()) {
        cout << "NO";
    } else {
        if (p->second <= k) {
            cout << "YES";
        } else {
            cout << "NO";
        }
    }



}


