#include <iostream>
#include <set>
#include <cmath>
#include <queue>
#include <algorithm>

#define ll long long

using namespace std;

const int inf1 = 1000;

void dfs1(int i, int j, std::vector<std::vector<char>>& g, std::vector<std::vector<int>>& comp, int k) {
    if (comp[i][j] == -1) {
        comp[i][j] = k;
    }
    if (i > 0 && g[i - 1][j] == '.' && comp[i - 1][j] == -1) {
        dfs1(i - 1, j, g, comp, k);
    }
    if (j > 0 && g[i][j - 1] == '.' && comp[i][j - 1] == -1) {
        dfs1(i, j - 1, g, comp, k);
    }
    if (i < g.size() - 1 && g[i + 1][j] == '.' && comp[i + 1][j] == -1) {
        dfs1(i + 1, j, g, comp, k);
    }
    if (j < g[0].size() - 1 && g[i][j + 1] == '.' && comp[i][j + 1] == -1) {
        dfs1(i, j + 1, g, comp, k);
    }
}

void dfs(int i, int j, std::vector<std::vector<char>>& g, std::vector<std::vector<int>>& comp, std::vector<std::set<int>>& gx, std::vector<std::vector<bool>>& used) {
    used[i][j] = true;

    if (i > 0 && g[i - 1][j] == '#') {
        if (i > 1 && g[i - 2][j] == '.' && comp[i][j] != comp[i - 2][j]) {
            gx[comp[i][j]].insert(comp[i - 2][j]);
            gx[comp[i - 2][j]].insert(comp[i][j]);
        }
        if (j < g[0].size() - 1 && g[i - 1][j + 1] == '.' && comp[i][j] != comp[i - 1][j + 1]) {
            gx[comp[i][j]].insert(comp[i - 1][j + 1]);
            gx[comp[i - 1][j + 1]].insert(comp[i][j]);
        }
        if (j > 0 && g[i - 1][j - 1] == '.' && comp[i][j] != comp[i - 1][j - 1]) {
            gx[comp[i][j]].insert(comp[i - 1][j - 1]);
            gx[comp[i - 1][j - 1]].insert(comp[i][j]);
        }
    }
    if (j > 0 && g[i][j - 1] == '#') {
        if (j > 1 && g[i][j - 2] == '.' && comp[i][j] != comp[i][j - 2]) {
            gx[comp[i][j]].insert(comp[i][j - 2]);
            gx[comp[i][j - 2]].insert(comp[i][j]);
        }
        if (i < g.size() - 1 && g[i + 1][j - 1] == '.' && comp[i][j] != comp[i + 1][j - 1]) {
            gx[comp[i][j]].insert(comp[i + 1][j - 1]);
            gx[comp[i + 1][j - 1]].insert(comp[i][j]);
        }
        if (i > 0 && g[i - 1][j - 1] == '.' && comp[i][j] != comp[i - 1][j - 1]) {
            gx[comp[i][j]].insert(comp[i - 1][j - 1]);
            gx[comp[i - 1][j - 1]].insert(comp[i][j]);
        }
    }

    if (i < g.size() - 1 && g[i + 1][j] == '#') {
        if (i < g.size() - 2 && g[i + 2][j] == '.' && comp[i][j] != comp[i + 2][j]) {
            gx[comp[i][j]].insert(comp[i + 2][j]);
            gx[comp[i + 2][j]].insert(comp[i][j]);
        }
        if (j < g[0].size() - 1 && g[i + 1][j + 1] == '.' && comp[i][j] != comp[i + 1][j + 1]) {
            gx[comp[i][j]].insert(comp[i + 1][j + 1]);
            gx[comp[i + 1][j + 1]].insert(comp[i][j]);
        }
        if (j > 0 && g[i + 1][j - 1] == '.' && comp[i][j] != comp[i + 1][j - 1]) {
            gx[comp[i][j]].insert(comp[i + 1][j - 1]);
            gx[comp[i + 1][j - 1]].insert(comp[i][j]);
        }
    }
    if (j < g[0].size() - 1 && g[i][j - 1] == '#') {
        if (j < g[0].size() - 2 && g[i][j + 2] == '.' && comp[i][j] != comp[i][j + 2]) {
            gx[comp[i][j]].insert(comp[i][j + 2]);
            gx[comp[i][j + 2]].insert(comp[i][j]);
        }
        if (i < g.size() - 1 && g[i + 1][j + 1] == '.' && comp[i][j] != comp[i + 1][j + 1]) {
            gx[comp[i][j]].insert(comp[i + 1][j + 1]);
            gx[comp[i + 1][j + 1]].insert(comp[i][j]);
        }
        if (i > 0 && g[i - 1][j + 1] == '.' && comp[i][j] != comp[i - 1][j + 1]) {
            gx[comp[i][j]].insert(comp[i - 1][j + 1]);
            gx[comp[i - 1][j + 1]].insert(comp[i][j]);
        }
    }




    if (i > 0 && g[i - 1][j] == '.' && !used[i - 1][j]) {
        dfs(i - 1, j, g, comp, gx, used);
    }
    if (j > 0 && g[i][j - 1] == '.' && !used[i][j - 1]) {
        dfs(i, j - 1, g, comp, gx, used);
    }
    if (i < g.size() - 1 && g[i + 1][j] == '.' && !used[i + 1][j]) {
        dfs(i + 1, j, g, comp, gx, used);
    }
    if (j < g[0].size() - 1 && g[i][j + 1] == '.' && !used[i][j + 1]) {
        dfs(i, j + 1, g, comp, gx, used);
    }
}

std::vector<int> bfs(int s, std::vector<std::set<int>>& g, int n) {
    std::vector<int> ans(g.size());
    ans[s] = 0;
    std::queue<int> q;
    q.push(s);
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (int u: g[v]) {
            if (ans[u] > ans[v] + 1) {
                ans[u] = ans[v] + 1;
                q.push(u);
            }
        }
    }
    return ans;
}

int main() {
    int n, m, k;
    std::cin >> n >> m >> k;
    std::vector<std::vector<char>> g (n, std::vector<char>(m));
    std::vector<std::vector<int>> comp(n, std::vector<int>(m, -1));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            std::cin >> g[i][j];
        }
    }

    int x1, y1, x2, y2;
    std::cin >> x1 >> y1 >> x2 >> y2;


    int count = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (g[i][j] == '.' && comp[i][j] == -1) {
                dfs1(i, j, g, comp, count);
                ++count;
            }
        }
    }

    if (count == 1) {
        std::cout << "YES" << std::endl;
        return 0;
    }

    std::vector<std::set<int>> gx(count + 1);
    std::vector<std::vector<bool>> used(n, std::vector<bool>(m, false));

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (g[i][j] == '.' && !used[i][j]) {
                dfs(i, j, g, comp, gx, used);
            }
        }
    }

    std::vector<int> ans = bfs(comp[x1][y1], gx, gx.size());
    if (ans[comp[x2][y2]] > k) {
        std::cout << "NO";
    } else {
        std::cout << "YES";
    }
}