#include <iostream>
#include <cmath>
#include <vector>
#include <iomanip>
#include <algorithm>

using namespace std;


#pragma GCC optimize("Ofast")

struct Move {
    int count = 1e9;
    bool onSix = false;
};

void Compare(Move& s1, Move& s2, int j) {
    if (s2.count < s1.count + 1 && !s1.onSix) {
        return;
    }

    s2.count = s1.count;
    if (!s1.onSix) {
        ++s2.count;
    }

    if (j != 6) {
        s2.onSix = false;
    } else {
        s2.onSix = true;
    }
}

void Compare (Move& s1, Move& s2) {
    if (s1.count == s2.count) {
        if (s1.onSix) {
            s2.onSix = true;
        }
        return;
    }
    if (s1.count < s2.count) {
        s2 = s1;
    }
}

int Jump(std::vector<int>& tel, std::vector<int>& p, int pos) {
    if (!(tel[pos] == pos && p[pos] != 0) || p[pos] == 0) {
        return tel[pos];
    }

    tel[pos] = Jump(tel, p, pos - p[pos]);
    return tel[pos];
}

int main() {
    std::cin.tie(0);
    std::cout.tie(0);
    std::ios_base::sync_with_stdio(0);
    int n;
    std::cin >> n;
    std::vector<int> p(n);
    p[n - 1] = 0;
    p[0] = 0;
    for (int i = 1; i < n - 1; ++i) {
        std::cin >> p[i];
    }
    std::vector<Move> s(n);
    s[0].count = 0;

    std::vector<int> teleport(n);
    for(int i = 0; i < n; ++i) {
        teleport[i] = i;
    }

    for (int i = 0; i < n - 1; ++i) {
        if (p[i] != 0) {
            continue;
        }
        for (int j = 1; j <= 6; ++j) {
            int t = i + j;
            if (t >= n) {
                t = n - 1;
            }

            Compare(s[i], s[t], j);
            if (p[t] == 0) {
                continue;
            }

            int x = Jump(teleport, p, t);
            Compare(s[t], s[x]);
        }

    }

    if (s[n - 1].count == 1e9) {
        std::cout << -1 << std::endl;
        return 0;
    }

    std::cout << s[n - 1].count << endl;
}