#include <iostream>
#include <string>
#include <algorithm>
#include <cmath>
#include <vector>

struct pnt {
    int x, y;
};

double distance(const pnt& p1, const pnt& p2) {
    int dx = p1.x - p2.x;
    int dy = p1.y - p2.y;
    return sqrt(dx*dx + dy*dy);
}

double calculatePerimeter(const pnt *points, size_t numPoints) {
    double perimeter = 0.0;
    for (int i = 0; i < numPoints; i++) {
        perimeter += distance(points[i], points[(i+1) % numPoints]);
    }
    return perimeter;
}

int main() {
    int n;
    std::cin >> n;

    std::vector<pnt> pnts(n);
    double max_len{};
    for (int i = 0; i < n; ++i) {
        std::cin >> pnts[i].x >> pnts[i].y;
        if (i > 0) {
            max_len = std::max(max_len, distance(pnts[i], pnts[i - 1]));
        }
    }
    max_len = std::max(max_len, distance(pnts[0], pnts[pnts.size() - 1]));

    std::cout << calculatePerimeter(pnts.data(), pnts.size()) - max_len;
}
