#include <iostream>
#include <string>
#include <algorithm>
#include <cmath>
#include <vector>

struct pnt {
    int x, y;
};

double distance(const pnt &p1, const pnt &p2) {
    int dx = p1.x - p2.x;
    int dy = p1.y - p2.y;
    return sqrt(dx * dx + dy * dy);
}

double calculatePerimeter(const pnt* points, size_t numPoints) {
    double perimeter = 0.0, max_dist = 0.0;
    for (int i = 0; i < numPoints; i++) {
        double dist = distance(points[i], points[(i+1) % numPoints]);
        perimeter += dist;
        max_dist = std::max(max_dist, dist);
    }
    return perimeter - max_dist;
}

int main() {
    int n;
    std::cin >> n;

    std::vector<pnt> pnts(n);
    for (int i = 0; i < n; ++i) {
        std::cin >> pnts[i].x >> pnts[i].y;
    }

    std::cout << calculatePerimeter(pnts.data(), pnts.size());
}
