#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <set>
#include <vector>
#include <algorithm>
#include <string>
#include <iomanip>
#include <map>
#include <set>
#include <cmath>
#include <queue>
#include <stack>
#include <deque>
#include <random>
#include <ctime>
using namespace std;
typedef long long ll;
typedef double db;

const long double EPS = 1e-9;
const double PI = acos(-1.0);

struct node {
	map<char, node* > childs;
	int ends, cnt;

	node() : ends(0), cnt(0) {}
};

struct trie {
	node* root;

	trie() {
		root = new node();
	}

	void add(const string& s) {
		node* cur = root;
		cur->cnt++;
		for (int i = 0; i < s.size(); ++i) {
			if (cur->childs.find(s[i]) == cur->childs.end())
				cur->childs[s[i]] = new node();
			cur = cur->childs[s[i]];
			cur->cnt++;
		}
		cur->ends++;
	}

	bool find(const string& s) {
		node* cur = root;
		for (int i = 0; i < s.size(); ++i) {
			if (cur->childs.find(s[i]) == cur->childs.end())
				return 0;
			cur = cur->childs[s[i]];
		}
		return cur->ends;
	}

	void erase(const string& s) {
		if (!find(s))
			return;
		node* cur = root;
		cur->cnt--;
		vector<node* > v;
		v.push_back(root);
		for (int i = 0; i < s.size(); ++i) {
			if (cur->childs.find(s[i]) == cur->childs.end())
				cur->childs[s[i]] = new node();
			cur = cur->childs[s[i]];
			v.push_back(cur);
			cur->cnt--;
		}
		cur->ends--;
		for (int i = v.size() - 1; i > 0; --i) {
			if (v[i]->cnt)
				break;
			delete v[i];
			v[i - 1]->childs.erase(s[i - 1]);
		}
	}

	void traverse(node* cur, string& s) {
		if (cur == 0)
			return;
		for (int i = 0; i < cur->ends; ++i)
			cout << s << endl;
		for (auto& i : cur->childs) {
			s.push_back(i.first);
			traverse(i.second, s);
			s.pop_back();
		}
	}

	void traverse() {
		string s = "";
		traverse(root, s);
	}
};

int q;

int main() {
	cin >> q;
	trie bor;
	for (int i = 0; i < q; i++) {
		string st; cin >> st;
		if (bor.find(st)) {
			for (int i = 1; i < 100000; i++) {
				string new_st = st + to_string(i);
				if (!bor.find(new_st)) {
					cout << new_st << '\n';
					bor.add(new_st);
					break;
				}
			}
		}
		else {
			cout << st << '\n';
			bor.add(st);
		}
	}
}