#include <bits/stdc++.h>

using namespace ::std;

void solve();
double ep = 1e-8;
int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  solve();
}
typedef long long ll;



//#define enld '\n'
#define vec vector

struct DSU {
  vec<int> parent;
  int n;

  DSU(int _n) {
    parent.resize(_n);
    for (int i = 0; i < _n; ++i)
      parent[i] = i;
    n = _n;
  }
  int get_origin(int a) {
    if (a == parent[a])
      return a;
    return parent[a] = get_origin(parent[a]);
  }
  bool is_joined(int a, int b) {
    a = get_origin(a);
    b = get_origin(b);
    return a == b;
  }
  void join(int a, int b) {
    a = get_origin(a);
    b = get_origin(b);
    if (!is_joined(a, b))
      parent[max(a, b)] = min(a, b);
  }
};

void solve() {
  int n;
  cin >> n;
  vec<vec<pair<int, int>>> graph(n);
  DSU dsu(n);
  vec<int> to(n, 0);
  for(int i = 1; i + 1 < n; ++i){
    cin >> to[i];
  }
  for(int i = 0; i < n; ++i){
    if(to[i] != 0)
      continue;
    for(int dice = 1; dice <= 6; ++dice){
      int v = i;
      int u = min(i + dice, n - 1);

      if(to[u] == 0){
        graph[v].push_back({ u, (dice == 6) ? 0 : 1 });
        continue;
      }
      while(1){
        if(dsu.is_joined(u, u - to[u])){
          //dsu.join(v, u);
          graph[v].push_back({dsu.get_origin(u), (dice == 6) ? 0 : 1});
          break;
        }
        //dsu.join(v, u);
        dsu.join(u, u - to[u]);
        u = u - to[u];
      }
    }
  }
  bool debug = 0;
  if(debug){
    for(int v = 0; v < n; ++v){
      cout << v << ": ";
      for(auto p : graph[v])
        cout << "(" << p.first << ", " << p.second << ") ";
      cout << endl;
    }
  }
  /// Dijkstra
  vec<int> d(n,1e9);
  d[0] = 0;
  set<pair<int, int>> setik;
  setik.insert({ 0, 0 });
  while(setik.size()){
    int w = setik.begin()->first;
    int v = setik.begin()->second;
    setik.erase(setik.begin());
    for(auto e : graph[v]){
      int u = e.first;
      int w = e.second;
      if(d[v] + w < d[u]){
        setik.erase({ d[u], u });
        d[u] = d[v] + w;
        setik.insert({ d[u], u });
      }
    }
  }
  if(debug){
    for(int v = 0; v < n; ++v){
      cout << d[v] << ' ';
    }
    cout << endl;
  }
  if(d[n - 1] == 1e9)
    cout << -1;
  else
    cout << d[n - 1] + 1;


}

