#include <algorithm>
#include <bitset>
#include <chrono>
#include <climits>
#include <cmath>
#include <fstream>
#include <iostream>
#include <list>
#include <map>
#include <numeric>
#include <queue>
#include <set>
#include <stack>
#include <string>


using namespace std;

template<class T>
T read() {
    T t;
    std::cin >> t;
    return t;
}

#define ll long long
#define ull unsigned ll

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n = read<int>();

    std::vector<std::pair<int, int>> points;
    points.reserve(n);
    for (int i = 0 ; i < n; ++i) {
        int a = read<int>();
        int b = read<int>();
        points.push_back({a, b});
    }
    double total = 0;
    double maximum = 0;
    for (int i = 0; i < n - 1; ++i) {
        double cur = sqrt((points[i].first - points[i + 1].first) * (points[i].first - points[i + 1].first) + (points[i].second - points[i + 1].second) * (points[i].second - points[i + 1].second));
        total += cur;
        maximum = max(maximum, cur);
    }
    double cur = sqrt((points[0].first - points[n - 1].first) * (points[0].first - points[n - 1].first) + (points[0].second - points[n - 1].second) * (points[0].second - points[n - 1].second));
    total += cur;
    maximum = max(maximum, cur);

    printf("%.7f\n", total - maximum);
    return 0;
}