#include <algorithm>
#include <bitset>
#include <chrono>
#include <climits>
#include <cmath>
#include <fstream>
#include <iostream>
#include <list>
#include <map>
#include <numeric>
#include <queue>
#include <set>
#include <stack>
#include <string>
#include <unordered_set>

using namespace std;

pair<int, int> d, a;
int N, M, K;

bool solve(string *matrix, vector<bool> *visited, pair<int, int> pos, int k) {
    bool flag = false;
    if(pos == a){
        return true;
    }
    visited[pos.first][pos.second] = true;
    if (pos.first > 0 && !visited[pos.first - 1][pos.second] && matrix[pos.first - 1][pos.second] == '.') {
        flag |= solve(matrix, visited, {pos.first - 1, pos.second}, k);
    }
    if (pos.first < N - 1 && !visited[pos.first + 1][pos.second] && matrix[pos.first + 1][pos.second] == '.') {
        flag |= solve(matrix, visited, {pos.first + 1, pos.second}, k);
    }
    if (pos.second > 0 && !visited[pos.first][pos.second - 1] && matrix[pos.first][pos.second - 1] == '.') {
        flag |= solve(matrix, visited, {pos.first, pos.second - 1}, k);
    }
    if (pos.first < M - 1 && !visited[pos.first][pos.second + 1] && matrix[pos.first][pos.second + 1] == '.') {
        flag |= solve(matrix, visited, {pos.first, pos.second + 1}, k);
    }

    if (k > 0 && pos.first > 1 && !visited[pos.first - 2][pos.second] && matrix[pos.first - 2][pos.second] == '.') {
        flag |= solve(matrix, visited, {pos.first - 2, pos.second}, k - 1);
    }
    if (k > 0 && pos.first < N - 2 && !visited[pos.first + 2][pos.second] && matrix[pos.first + 2][pos.second] == '.') {
        flag |= solve(matrix, visited, {pos.first + 2, pos.second}, k - 1);
    }
    if (k > 0 && pos.second > 1 && !visited[pos.first][pos.second - 2] && matrix[pos.first][pos.second - 2] == '.') {
        flag |= solve(matrix, visited, {pos.first, pos.second - 2}, k - 1);
    }
    if (k > 0 && pos.second < M - 2 && !visited[pos.first][pos.second + 2] &&
        matrix[pos.first][pos.second + 2] == '.') {
        flag |= solve(matrix, visited, {pos.first, pos.second + 2}, k - 1);
    }

    return flag;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> N >> M >> K;

    string matrix[N];
    for (int i = 0; i < N; ++i) {
        cin >> matrix[i];
    }
    cin >> d.first >> d.second;
    cin >> a.first >> a.second;
    --d.first;
    --d.second;
    --a.first;
    --a.second;

    queue<pair<int, int>> to_visit;
    to_visit.emplace(d);

    vector<bool> visited[N];

    for (int i = 0; i < N; ++i) {
        visited[i] = std::move(vector<bool>(M));
    }

    if (solve(matrix, visited, d, K)) {
        cout << "YES";
    } else {
        cout << "NO";
    }

    return 0;
}

//
//3 3 1
//.#.
//#.#
//.#.
//1 1
//3 3

//2 2 0
//#.
//..
//1 2
//2 1

//2 5 2
//.#.#.
//###..
//1 1
//2 4