#include <algorithm>
#include <bitset>
#include <chrono>
#include <climits>
#include <cmath>
#include <fstream>
#include <iostream>
#include <list>
#include <map>
#include <numeric>
#include <queue>
#include <set>
#include <stack>
#include <string>
#include <unordered_set>

using namespace std;

pair<int, int> d, a;
int N, M, K;
string *matrix;
vector<bool> *visited;


struct st {
    int first;
    int second;
    int k;

    st(int first, int second, int k) : first(first),
                                       second(second),
                                       k(k) {}
};

bool solve() {
    stack<st> s;
    s.emplace(d);
    while (!s.empty()) {
        auto pos = s.top();
        s.pop();
        if (pos.first == a.first && pos.second == a.second) {
            return true;
        }
        if (visited[pos.first][pos.second]) {
            continue;
        }
        visited[pos.first][pos.second] = true;
        if (pos.first > 0 && !visited[pos.first - 1][pos.second] && matrix[pos.first - 1][pos.second] == '.') {
            s.push(st(pos.first - 1, pos.second, pos.k));
        }
        if (pos.first < N - 1 && !visited[pos.first + 1][pos.second] && matrix[pos.first + 1][pos.second] == '.') {
            s.push(st(pos.first + 1, pos.second, pos.k));
        }
        if (pos.second > 0 && !visited[pos.first][pos.second - 1] && matrix[pos.first][pos.second - 1] == '.') {
            s.push(st(pos.first, pos.second - 1, pos.k));
        }
        if (pos.second < M - 1 && !visited[pos.first][pos.second + 1] && matrix[pos.first][pos.second + 1] == '.') {
            s.push(st(pos.first, pos.second + 1, pos.k));
        }

        if (pos.k > 0 && pos.first > 1 && !visited[pos.first - 2][pos.second] &&
            matrix[pos.first - 2][pos.second] == '.') {
            s.push(st(pos.first - 2, pos.second, pos.k - 1));
        }
        if (pos.k > 0 && pos.first < N - 2 && !visited[pos.first + 2][pos.second] &&
            matrix[pos.first + 2][pos.second] == '.') {
            s.push(st(pos.first + 2, pos.second, pos.k - 1));
        }
        if (pos.k > 0 && pos.second > 1 && !visited[pos.first][pos.second - 2] &&
            matrix[pos.first][pos.second - 2] == '.') {
            s.push(st(pos.first, pos.second - 2, pos.k - 1));
        }
        if (pos.k > 0 && pos.second < M - 2 && !visited[pos.first][pos.second + 2] &&
            matrix[pos.first][pos.second + 2] == '.') {
            s.push(st(pos.first, pos.second + 2, pos.k - 1));
        }
    }

    return visited[a.first][a.second];
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> N >> M >> K;

    matrix = new string[N];
    for (int i = 0; i < N; ++i) {
        cin >> matrix[i];
    }
    cin >> d.first >> d.second;
    cin >> a.first >> a.second;
    --d.first;
    --d.second;
    --a.first;
    --a.second;

    visited = new vector<bool>[N];

    for (int i = 0; i < N; ++i) {
        visited[i] = std::move(vector<bool>(M));
    }

    if (solve()) {
        cout << "YES";
    } else {
        cout << "NO";
    }

    return 0;
}


//3 3 1
//.#.
//#.#
//.#.
//1 1
//3 3

//2 2 0
//#.
//..
//1 2
//2 1

//2 5 2
//.#.#.
//###..
//1 1
//2 4