#include <algorithm>
#include <bitset>
#include <chrono>
#include <climits>
#include <cmath>
#include <fstream>
#include <iostream>
#include <list>
#include <map>
#include <numeric>
#include <queue>
#include <set>
#include <stack>
#include <string>
#include <unordered_set>

using namespace std;

pair<int, int> d, a;
int N, M, K;
string *matrix;
vector<bool> *visited;


bool solve() {
    stack<pair<pair<int, int>, int>> s;
    s.emplace(d, K);
    while (!s.empty()) {
        auto temp = s.top();
        auto pos = temp.first;
        s.pop();
        if (pos == a) {
            return true;
        }

        visited[pos.first][pos.second] = true;
        if (pos.first > 0 && !visited[pos.first - 1][pos.second] && matrix[pos.first - 1][pos.second] == '.') {
            s.emplace(make_pair(pos.first - 1, pos.second), temp.second);
        }
        if (pos.first < N - 1 && !visited[pos.first + 1][pos.second] && matrix[pos.first + 1][pos.second] == '.') {
            s.emplace(make_pair(pos.first + 1, pos.second), temp.second);
        }
        if (pos.second > 0 && !visited[pos.first][pos.second - 1] && matrix[pos.first][pos.second - 1] == '.') {
            s.emplace(make_pair(pos.first, pos.second - 1), temp.second);
        }
        if (pos.second < M - 1 && !visited[pos.first][pos.second + 1] && matrix[pos.first][pos.second + 1] == '.') {
            s.emplace(make_pair(pos.first, pos.second + 1), temp.second);
        }

        if (temp.second > 0 && pos.first > 1 && !visited[pos.first - 2][pos.second] &&
            matrix[pos.first - 2][pos.second] == '.') {
            s.emplace(make_pair(pos.first - 2, pos.second), temp.second - 1);
        }
        if (temp.second > 0 && pos.first < N - 2 && !visited[pos.first + 2][pos.second] &&
            matrix[pos.first + 2][pos.second] == '.') {
            s.emplace(make_pair(pos.first + 2, pos.second), temp.second - 1);
        }
        if (temp.second > 0 && pos.second > 1 && !visited[pos.first][pos.second - 2] &&
            matrix[pos.first][pos.second - 2] == '.') {
            s.emplace(make_pair(pos.first, pos.second - 2), temp.second - 1);
        }
        if (temp.second > 0 && pos.second < M - 2 && !visited[pos.first][pos.second + 2] &&
            matrix[pos.first][pos.second + 2] == '.') {
            s.emplace(make_pair(pos.first, pos.second + 2), temp.second - 1);
        }
    }

    return false;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> N >> M >> K;

    matrix = new string[N];
    for (int i = 0; i < N; ++i) {
        cin >> matrix[i];
    }
    cin >> d.first >> d.second;
    cin >> a.first >> a.second;
    --d.first;
    --d.second;
    --a.first;
    --a.second;

    visited = new vector<bool>[N];

    for (int i = 0; i < N; ++i) {
        visited[i] = vector<bool>(M);
        fill(visited[i].begin(), visited[i].end(), false);
    }

    if (solve()) {
        cout << "YES";
    } else {
        cout << "NO";
    }

    return 0;
}


//3 3 1
//.#.
//#.#
//.#.
//1 1
//3 3

//2 2 0
//#.
//..
//1 2
//2 1

//2 5 2
//.#.#.
//###..
//1 1
//2 4