#include <bits/stdc++.h>
#define ll long long
#define mp make_pair
#define pb push_back
#define ld long double
#define pll pair<ll,ll>
#define pld pair<ld,ld>
#define pii pair<int,int>
#define fi first
#define se second

using namespace std;

mt19937_64 rnd(time(0));

constexpr ll MOD = 998244353;
const ld PI = acosl(-1);

ll a[200010];
ll dd[200010];
ll n;
struct Point
{
  int x, y;

  Point () : x(0), y(0) {}
  Point (int u_x, int u_y) : x(u_x), y(u_y) {}

  Point operator- (const Point& other)
  {
    return Point(this->x - other.x, this->y - other.y);
  }
};

ld distToPoint (Point p, Point p1)
{
  return hypotl(p1.x - p.x, p1.y - p.y);
}

struct Vector
{
  int x, y;

  Vector (int u_x, int u_y) : x(u_x), y(u_y) {}

  Vector (Point p1) : x(p1.x), y(p1.y) {}

  Vector (Point p1, Point p2) : x(p2.x - p1.x), y(p2.y - p1.y) {}

  int operator* (const Vector& other)
  {
    return this->x*1ll*other.x + other.y*1ll*this->y;
  }

  int operator/(const Vector& other)
  {
    return this->x*1ll*other.y - other.x*1ll*this->y;
  }

  ld len ()
  {
    return distToPoint(Point(0, 0), Point(x, y));
  }
};

ld triangleArea (Point p1, Point p2, Point p3)
{
  return abs(Vector(p1, p2) / Vector(p1, p3)) / 2.0;
}

bool pointOnSeg (Point p, Point p1, Point p2)
{
  return (((Vector(p1, p) / Vector(p1, p2)) == 0) && ((Vector(p, p1) * Vector(p, p2)) <= 0));
}

ld polarAngle (Vector v)
{
  ld a = atan2l(v.y, v.x);

  if (a < 0) {
    return a + 2*PI;
  } else {
    return a;
  }
}

ld angleBetVec (Vector v1, Vector v2)
{
  return atan2((v1/v2), (v1*v2));
}

ld distToSeg (Point p, Point p1, Point p2)
{
  if ((Vector(p1, p2) * Vector(p1, p)) <= 0) {
    return distToPoint(p, p1);
  } else if ((Vector(p2, p) * Vector(p2, p1)) <= 0) {
    return distToPoint(p, p2);
  } else {
    return abs((Vector(p1, p) / Vector(p1, p2))) / distToPoint(p1, p2);
  }
}

bool isCrossSeg (Point p1, Point p2, Point p3, Point p4)
{
  bool res = false;
  if ((Vector(p1, p2) / Vector(p3, p4)) == 0) {
    if ((Vector(p1, p2) / Vector(p1, p3)) == 0) {
      res = ((Vector(p3, p1) * Vector(p3, p2)) <= 0) || ((Vector(p4, p1) * Vector(p4, p2)) <= 0);
    }
  } else {
    int cross1 = (Vector(p1, p2) / Vector(p1, p3));
    int cross2 = (Vector(p1, p2) / Vector(p1, p4));
    res = (cross1 == 0 || cross2 == 0) || (cross1 > 0 ^ cross2 > 0);

    cross1 = (Vector(p3, p4) / Vector(p3, p1));
    cross2 = (Vector(p3, p4) / Vector(p3, p2));
    res = res && (cross1 == 0 || cross2 == 0) || (cross1 > 0 ^ cross2 > 0);
  }

  return res;
}

pair<int, pair<ld, ld>> crossLine (Point p1, Point p2, Point p3, Point p4)
{
  if ((Vector(p1, p2) / Vector(p3, p4)) == 0) {
    if ((Vector(p1, p2) / Vector(p1, p3)) == 0) {
      return {2, {0, 0}};
    } else {
      return {0, {0, 0}};
    }
  } else {
    ld denom = Vector(p4 - p3) / Vector(p2 - p1);
    ld s = ((Vector(p1) / Vector(p2)) - (Vector(p3) / Vector(p2 - p1)))/denom;
    return {1, {p3.x + (p4.x - p3.x)*s, p3.y + (p4.y - p3.y)*s}};
  }
}

vector<Point> convex_hull (vector<Point> arr)
{
  for (int i = 1; i < arr.size(); ++i) {
    if ((arr[0].y > arr[i].y) || (arr[0].y == arr[i].y) && (arr[0].x > arr[i].x)) {
      swap(arr[0], arr[i]);
    }
  }

  sort(arr.begin() + 1, arr.end(),
       [&arr](auto p1, auto p2)
       {
         int temp = Vector(arr[0], p1) / Vector(arr[0], p2);
         if (temp == 0) {
           return hypot(p1.x - arr[0].x, p1.y - arr[0].y) < hypot(p2.x - arr[0].x, p2.y - arr[0].y);
         }
         return temp > 0;
       }
  );

  vector<Point> res;
  res.push_back(arr[0]);
  res.push_back(arr[1]);
  for (int i = 2; i < arr.size(); ++i) {
    while (res.size() >= 2 && Vector(res[res.size() - 2], res[res.size() - 1]) / Vector(res[res.size() - 1], arr[i]) <= 0)
      res.pop_back();

    res.push_back(arr[i]);
  }

  return res;
}

pair<pair<ld, ld>, ld> circleOutTriangle (vector<pair<ld, ld>> a)
{
  ld A = a[1].first - a[0].first;
  ld B = a[1].second - a[0].second;
  ld C = a[2].first - a[0].first;
  ld D = a[2].second - a[0].second;
  ld E = A * (a[0].first + a[1].first) + B * (a[0].second + a[1].second);
  ld F = C * (a[0].first + a[2].first) + D * (a[0].second + a[2].second);
  ld G = 2 * (A * (a[2].second - a[1].second) - B * (a[2].first - a[1].first));

  ld Cx = (D * E - B * F) / G;
  ld Cy = (A * F - C * E) / G;
  ld R = sqrt((a[0].first - Cx)*(a[0].first - Cx) + (a[0].second - Cy) * (a[0].second - Cy));

  return {{Cx, Cy}, R};
}

bool isInTrig(Point x, Point x1, Point x2, Point x3) {
    return abs(2 * PI - abs(abs(angleBetVec(Vector{x, x1}, Vector{x, x2}))
         + abs(angleBetVec(Vector{x, x2}, Vector{x, x3}))
         + abs(angleBetVec(Vector{x, x3}, Vector{x, x1})))) < 1e-10;
}

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#endif
  cout << fixed << setprecision(20);

  int n;
  cin >> n;
  vector<Point> c;
  for (int i = 0; i < n; ++i) {
    int x, y;
    cin >> x >> y;
    c.emplace_back(x, y);
    if (c.size() > 3 && n > 500) {
      if (abs(angleBetVec(Vector{c[c.size() - 3], c[c.size() - 2]}, Vector{c[c.size() - 2], c[c.size() - 1]})) < (2*PI) / 100) {
        swap(c[c.size() - 2], c[c.size() - 1]);
        c.pop_back();
      }
    }
  }

  assert(n < 2000);
  n = c.size();

  int q;
  cin >> q;
  vector<Point> t(q);
  for (int i = 0; i < q; ++i) {
    int x, y;
    cin >> x >> y;
    t[i] = Point{x, y};
  }

  ld s = 0;
  for (int i = 1; i < n - 1; ++i) {
    s += triangleArea(c[0], c[i], c[i + 1]);
  }

  ld p = 0;
  for (int i = 0; i < n; ++i) {
    int j = (i + 1) % n;
    p += Vector{c[i], c[j]}.len();
  }

  const int R_SIZE = 100;
  vector<ld> r;
  for (int i = 0; r.size() < R_SIZE; ++i) {
    r.push_back((-p + sqrtl(p*p + 4 * s * PI * (pow(2, i) - 1))) / (2 * PI));
  }

  ld eps = 1e-6;
  for (int it = 0; it < q; ++it) {
    ld find_r = 1e18;
    bool t_ = false;
    for (int i = 1; i < n - 1; i++) {
        if (isInTrig(t[it], c[0], c[i], c[i + 1])) {
            t_ = true;
            break;
        }
    }
    if (t_) {
        cout << "0\n";
        continue;
    }

    for (int i = 0; i < n; i++) {
        int j = (i + 1) % n;
        find_r = min(find_r, distToPoint(t[it], c[i]));
        find_r = min(find_r, distToSeg(t[it], c[i], c[j]));
    }
    cout << upper_bound(r.begin(), r.end(), find_r - eps) - r.begin() << "\n";
  }

  return 0;
}