#include <iostream>
#include <bits/stdc++.h>

namespace alg {
    using namespace std;
    using ll = uint64_t;
    using vll = vector<ll>;
    using pll = pair<ll, ll>;

    istream& operator>>(istream& is, vll& a) {
        for (auto& elem: a) {
            is >> elem;
        }
        return is;
    }

    template<typename T, typename B>
    bool contains(const set<T>& s, const B& val) {
        return s.find(val) != s.end();
    }
}

using namespace alg;

double dist(pair<double, double> p1, pair<double, double> p2) {
    return (p1.first - p2.first) * (p1.first - p2.first) +
           (p1.second - p2.second) * (p1.second - p2.second);
}

void Solve() {
    ll n;
    cin >> n;
    vector<pair<double, double>> a(n);

    for (int i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
    }

    double maxx = 0;
    double sum = 0;
    for (int i = 0; i < n; i++) {
        ll i1 = (i + 1) % n;
        sum += sqrt(dist(a[i], a[i1]));
        maxx = max(maxx, dist(a[i], a[i1]));
    }

    cout << std::fixed << std::setprecision(10) << sum - sqrt(maxx);
}


signed main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios::sync_with_stdio(false);
    ll t = 1;
    //cin >> t;
    while (t--) {
        Solve();
        cout << "\n";
    }

    return 0;
}
