#include <iostream>
#include <bits/stdc++.h>

namespace alg {
    using namespace std;
    using ll = int64_t;
    using vll = vector<ll>;
    using pll = pair<ll, ll>;

    istream& operator>>(istream& is, vll& a) {
        for (auto& elem: a) {
            is >> elem;
        }
        return is;
    }

    template<typename T, typename B>
    bool contains(const set<T>& s, const B& val) {
        return s.find(val) != s.end();
    }
}

using namespace alg;

const ll inf = 1e12;

struct SNM {
    unordered_set<ll> s;
    unordered_map<ll, ll> m;

    void Put(ll x) {
        s.insert(x);
        m.insert({x, x + 1});
    }

    ll GetAfter(ll x) {
        if (s.find(x) == s.end()) {
            return x;
        }

        ll ans = GetAfter(m.find(x)->second);
        m.find(x)->second = ans;
        return ans;
    }

    bool Was(ll x) {
        return s.find(x) != s.end();
    }

    ll Min() {
        return GetAfter(1);
    }
};

pair<ll, string> GetSuf(string s) {
    ll n = s.size();
    ll i = n - 1;
    while (i >= 0 && isdigit(s[i])) {
        i--;
    }
    i++;
    while (i < n && s[i] == '0') {
        i++;
    }
    ll ans = 0;

    ll j = i;
    while (j < n) {
        ans = ans * 10 + (s[j] - '0');
        j++;
    }

    s.erase(s.begin() + i, s.end());
    return {ans, s};
}

void Solve() {
    unordered_map<string, SNM> m;

    ll n;
    cin >> n;

    auto addS = [&](string s) {
        auto p = GetSuf(s);
        string sm = p.second;
        string sv = to_string(p.first);

        for (int i = 0; i <= sv.size(); i++) {
            string smc = sm;
            for (int j = 0; j < i; j++) {
                smc.push_back(sv[j]);
            }
            string svc = {sv.begin() + i, sv.end()};

            if (m.find(smc) == m.end()) {
                m.insert({smc, {}});
            }
            if (svc.empty()) {
                svc = "0";
            }
            m.find(smc)->second.Put(stoll(svc));
        }
    };

    while (n--) {
        string s;
        cin >> s;
        auto p = GetSuf(s);
        string sm = p.second;
        ll sv = p.first;

        if (m.find(s) == m.end()) {
            m.insert({s, {}});
            cout << " " << s << "\n";
            addS(s);
            cout.flush();
            continue;
        }

        ll add = m.find(s)->second.Min();
        cout << " " << s << add << "\n";
        cout.flush();
        addS(s + to_string(add));
    }
}


signed main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios::sync_with_stdio(false);
    ll t = 1;
    //cin >> t;
    while (t--) {
        Solve();
        cout << "\n";
    }

    return 0;
}
