#include <iostream>
#include <bits/stdc++.h>

namespace alg {
    using namespace std;
    using ll = uint64_t;
    using vll = vector<ll>;
    using pll = pair<ll, ll>;

    istream& operator>>(istream& is, vll& a) {
        for (auto& elem: a) {
            is >> elem;
        }
        return is;
    }

    template<typename T, typename B>
    bool contains(const set<T>& s, const B& val) {
        return s.find(val) != s.end();
    }
}

using namespace alg;

struct SNM {
    unordered_set<ll> was;
    unordered_map<ll, ll> after;

    void Put(ll x) {
        if (was.find(x) != was.end()) {
            return;
        }
        was.insert(x);
        after.emplace(x, x + 1);
    }

    ll GetAfter(ll x) {
        if (was.find(x) == was.end()) {
            return x;
        }
        ll ans = GetAfter(after.find(x)->second);
        after.find(x)->second = ans;
        return ans;
    }

    ll Minn() {
        return GetAfter(1);
    }
};

unordered_map<string, SNM> m;

void AddString(string& s) {
    for (int i = 0; i <= s.size(); i++) {
        string p = {s.begin(), s.begin() + i};
        string v = {s.begin() + i, s.end()};

        bool f = true;
        for (char c: v) {
            if (!isdigit(c)) {
                f = false;
            }
        }
        if (!f)
            continue;

        if (v.empty()) {
            m.insert({p, {}});
            continue;
        }

        if (v[0] == '0')
            continue;

        if (m.find(p) == m.end()) {
            m.insert({p, {}});
        }

        m.find(p)->second.Put(stoll(v));
    }
}

void Solve() {
    ll n;
    cin >> n;
    while (n--) {
        string s;
        cin >> s;

        if (m.find(s) == m.end()) {
            cout << " " << s << "\n";
            cout.flush();
            AddString(s);
        } else {
            string add = s + to_string(m.find(s)->second.Minn());
            cout << " " << add << "\n";
            cout.flush();
            AddString(add);
        }
    }
}


signed main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios::sync_with_stdio(false);
    ll t = 1;
    //cin >> t;
    while (t--) {
        Solve();
        cout << "\n";
    }

    return 0;
}