#include <iostream>
#include <bits/stdc++.h>

namespace alg {
    using namespace std;
    using ll = int64_t;
    using vll = vector<ll>;
    using pll = pair<ll, ll>;

    istream& operator>>(istream& is, vll& a) {
        for (auto& elem: a) {
            is >> elem;
        }
        return is;
    }

    template<typename T, typename B>
    bool contains(const set<T>& s, const B& val) {
        return s.find(val) != s.end();
    }
}

using namespace alg;

const ll inf = 1e12;

void Solve() {
    ll n, m, k;
    cin >> n >> m >> k;

    vector<vll> d(n, vll(m, inf));

    vector<vector<bool>> f(n, vector<bool>(m, false));
    vector<vector<bool>> used(n, vector<bool>(m, false));
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        for (int j = 0; j < m; j++) {
            f[i][j] = s[j] == '.';
        }
    }

    pll st, fi;
    cin >> st.first >> st.second;
    cin >> fi.first >> fi.second;
    --st.first, --st.second;
    --fi.first, --fi.second;

    d[st.first][st.second] = 0;

    set<pair<ll, pll>> V;
    for (ll i = 0; i < n; i++) {
        for (ll j = 0; j < m; j++) {
            V.insert({inf, {i, j}});
        }
    }

    V.erase({inf, {st.first, st.second}});
    V.insert({0, {st.first, st.second}});
    while (!V.empty()) {
        auto v = V.begin()->second;
        auto dv = V.begin()->first;
        V.erase(V.begin());
        if (used[v.first][v.second] || !f[v.first][v.second]) {
            continue;
        }

        vll dx1 = {0, 0, 1, -1};
        vll dy1 = {1, -1, 0, 0};

        for (int i = 0; i < 4; i++) {
            ll x = v.first + dx1[i];
            ll y = v.second + dy1[i];

            if (x >= 0 && x < n && y >= 0 && y < m && f[x][y]) {
                if (dv < d[x][y]) {
                    d[x][y] = dv;

                    V.erase({d[x][y], {x, y}});
                    V.insert({dv, {x, y}});
                }
            }
        }

        for (int i = 0; i < 4; i++) {
            ll x = v.first + dx1[i] * 2;
            ll y = v.second + dy1[i] * 2;

            if (x >= 0 && x < n && y >= 0 && y < m && f[x][y]) {
                if (dv + 1 < d[x][y]) {
                    d[x][y] = dv + 1;

                    V.erase({d[x][y], {x, y}});
                    V.insert({dv + 1, {x, y}});
                }
            }
        }

    }

    if (d[fi.first][fi.second] > k) {
        cout << "NO";
    } else {
        cout << "YES";
    }
}


signed main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios::sync_with_stdio(false);
    ll t = 1;
    //cin >> t;
    while (t--) {
        Solve();
        cout << "\n";
    }

    return 0;
}
