#include <iostream>
#include <bits/stdc++.h>

namespace alg {
    using namespace std;
    using ll = long long;
    using vll = vector<ll>;
    using pll = pair<ll, ll>;

    istream& operator>>(istream& is, vll& a) {
        for (auto& elem: a) {
            is >> elem;
        }
        return is;
    }

    template<typename T, typename B>
    bool contains(const set<T>& s, const B& val) {
        return s.find(val) != s.end();
    }
}

using namespace alg;

void Solve() {
    ll n;
    cin >> n;
    vll a(n - 2);
    vector<ll> w(n, 1e9);
    cin >> a;
    a.insert(a.begin(), 0);
    a.push_back(0);
    for (int i = 0; i < n; i++) {
        if (a[i] == 0) {
            a[i] = i;
            continue;
        }
        if (i - a[i] < 0) {
            a[i] = 0;
        } else {
            a[i] = a[i - a[i]];
        }
    }

    for (ll i = n - 1; i >= 0; i--) {
        if (i == n - 1) {
            w[i] = 0;
            continue;
        }

        for (int j = i; j < n && j <= i + 6; j++) {
            if (a[j] < i){
                continue;
            }
            if (j == n - 1) {
                w[i] = 1;
                continue;
            }
            w[i] = min(w[i], w[a[j]] + 1);
            if (j == i + 6) {
                w[i] = min(w[i], w[a[j]]);
            }
        }
    }

    if (w[0] >= 1e9) {
        cout << -1;
    } else {
        cout << w[0];
    }
}


signed main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios::sync_with_stdio(false);
    ll t = 1;
    //cin >> t;
    while (t--) {
        Solve();
        cout << "\n";
    }

    return 0;
}
