#include <bits/stdc++.h>
#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx2,bmi,bmi2,popcnt,lzcnt")
using namespace std;

#define int long long

int n, m, cc;
vector<set<int> > g;
vector<string> a;
vector<vector<int> > col;

bool ok(int i, int j) {
    if (i < 0 || i >= n || j < 0 || j >= m || a[i][j] == '#') {
        return false;
    }
    return true;
}

void dfs(int i, int j) {
    if (!ok(i, j) || col[i][j] != -1) {
        return;
    }
    col[i][j] = cc;
    dfs(i + 1, j);
    dfs(i - 1, j);
    dfs(i, j + 1);
    dfs(i, j - 1);
}

void solve() {
     int k;
    cin >> n >> m >> k;
    a.resize(n);
    col.resize(n, vector<int>(m, -1));
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    int si, sj;
    cin >> si >> sj;
    int fi, fj;
    cin >> fi >> fj;
    --si; --sj; --fi; --fj;
    cc = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (a[i][j] == '#' || col[i][j] != -1) {
                continue;
            }
            dfs(i, j);
            ++cc;
        }
    }
    g.resize(cc);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            vector<pair<int, int> > ds = { { i - 2, j }, { i, j - 2 }, { i + 2, j }, { i, j + 2 } };
            for (auto x : ds) {
                int ni = x.first;
                int nj = x.second;
                if (ok(i, j) && ok(ni, nj) && (col[ni][nj] != col[i][j])) {
                    g[col[ni][nj]].insert(col[i][j]);
                    g[col[i][j]].insert(col[ni][nj]);
                }
            }
        }
    }
    int start = col[si][sj];
    int finish = col[fi][fj];
    vector<int> dist(cc, -1);
    queue<int> q;
    dist[start] = 0;
    q.push(start);
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (auto u : g[v]) {
            if (dist[u] != -1) {
                continue;
            }
            dist[u] = dist[v] + 1;
            q.push(u);
        }
    }
    if (dist[finish] <= k) {
        cout << "YES" << "\n";
    } else {
        cout << "NO" << "\n";
    }   
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    /* cin >> t; */
    while (t--) {
        solve();
    }
}