#include <bits/stdc++.h>
using namespace std;

vector<vector<bool>> used;
vector<vector<char>> adj;

typedef long long ll;
ll ax, ay, dx, dy;
ll M, N, K;

bool dfs(ll i, ll j, ll k) {
    if (i == ax && j == ay)
        return true;
    if (used[i][j])
        return false;
    used[i][j] = true;

    ll dx[] = {0, 0, 1, -1};
    ll dy[] = {1, -1, 0, 0};

    for (ll n = 0; n < 4; ++n) {
        ll xd = i + dx[n];
        ll xy = j + dy[n];

        if (xd >= 0 && xy >= 0 && xd < M && xy < N && adj[xd][xy] == '.' && !used[xd][xy])
            if (dfs(xd, xy, k))
                return true;
    }

    if (k == 0)
        return false;

    ll dx2[] = {0, 0, 2, -2};
    ll dy2[] = {2, -2, 0, 0};

    for (ll n = 0; n < 4; ++n) {
        ll xd = i + dx2[n];
        ll xy = j + dy2[n];

        if (xd >= 0 && xy >= 0 && xd < M && xy < N && adj[xd][xy] == '.' && !used[xd][xy])
            if (dfs(xd, xy, k-1))
                return true;
    }

    return false;
}

int main() {
    cin.tie(0);
    cout.tie(0);
    ios::sync_with_stdio(0);
    cin >> M >> N >> K;

    adj.resize(M+4, vector<char>(N+4, '#'));
    used.resize(M+4, vector<bool>(N+4, false));

    for (ll i = 0; i < M; ++i)
        for (ll j = 0; j < N; ++j) {
            cin >> adj[i][j];
        }

    cin >> dx >> dy;
    cin >> ax >> ay;
    dx--;
    dy--;
    ax--;
    ay--;

    cout << (dfs(dx, dy, K) ? "YES" : "NO");
}