#include <iostream>
#include <vector>

using namespace std;

int N, M;
vector<vector<int>> d;

bool can_go(int i, int j, int K) {
    return i >= 0 && i < N && j >= 0 && j < M && K >= 0 && d[i][j] == 0;
}

void go_cell(int i, int j, int K) {
    d[i][j] = 1;
    if (can_go(i - 1, j, K)) go_cell(i - 1, j, K);
    if (can_go(i + 1, j, K)) go_cell(i + 1, j, K);
    if (can_go(i, j - 1, K)) go_cell(i, j - 1, K);
    if (can_go(i, j + 1, K)) go_cell(i, j + 1, K);
    if (can_go(i - 2, j, K - 1)) go_cell(i - 2, j, K - 1);
    if (can_go(i + 2, j, K - 1)) go_cell(i + 2, j, K - 1);
    if (can_go(i, j - 2, K - 1)) go_cell(i, j - 2, K - 1);
    if (can_go(i, j + 2, K - 1)) go_cell(i, j + 2, K - 1);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int K;
    cin >> N >> M >> K;
    d.resize(N);

    char ch;
    for (int i = 0; i < N; i++) {
        d[i].resize(M);
        for (int j = 0; j < M; j++) {
            cin >> ch;
            if (ch == '#') {
                d[i][j] = -1;
            }
        }
    }

    int i_from, j_from, i_to, j_to;
    cin >> i_from >> j_from >> i_to >> j_to;

    go_cell(i_from - 1, j_from - 1, K);
    cout << (d[i_to - 1][j_to - 1] == 1 ? "YES" : "NO") << '\n';
}
