#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(x) (x).begin(), (x).end()

using ld = long double;
[[maybe_unused]] constexpr static int INF = (int) 1e18;
using pii = pair<int, int>;
using vi = vector<int>;
using vvi = vector<vi>;


int bpow(int x, int y, int M = INF) {
    if (y == 0) {
        return 1;
    } else if (y % 2 == 0) {
        int tmp = bpow(x, y / 2, M);
        return (((tmp * tmp) % M) + M) % M;
    } else {
        int tmp = bpow(x, y - 1, M);
        return (((x * tmp) % M) + M) % M;
    }
}

template <typename T, typename os>
os& operator<<(os& out, const vector<T>& v) {
    for (auto & el : v) {
        out << el << " ";
    }
    out << endl;
    return out;
}

vector<pii> diff = {{0, 1}, {0, -1}, {-1, 0}, {1, 0}};

void solve() {
    int n, m, k;
    cin >> n >> m >> k;
    vector<vector<bool>> t(n, vector<bool>(m,  false));
    for (int i = 0; i < n; ++i) {
        for (int j = 0;  j < m; ++j) {
            char c;
            cin >> c;
            if (c == '.') t[i][j] = true;
        }
    }
    int stx, sty, fx, fy;
    cin  >> stx >> sty >> fx >> fy;
    vector<vector<int>> dist(n, vector<int> (m, INF));
    dist[stx-1][sty-1] = 0;
    deque<pii> q;
    q.push_back({stx-1, sty-1});
    while (!q.empty()) {
        pii v = q.front();
        int vx = v.first;
        int vy = v.second;
        //cout << v << ' ';
        q.pop_front();
        for (auto& d : diff) {
            pii to = {vx + d.first, vy + d.second};
            int tox = to.first;
            int toy = to.second;
            if (!(0 <= to.first && to.first < n)) continue;
            if (!(0 <= to.second && to.second < m)) continue;
            if (!t[to.first][to.second]) continue;
            if (dist[tox][toy] <= dist[vx][vy]) continue;
            dist[tox][toy] = dist[vx][vy];
            q.push_front({tox, toy});
        }
        for (auto& d : diff) {
            pii to = {vx + 2 * d.first, vy + 2 * d.second};
            int tox = to.first;
            int toy = to.second;
            if (!(0 <= to.first && to.first < n)) continue;
            if (!(0 <= to.second && to.second < m)) continue;
            if (!t[to.first][to.second]) continue;
            if (dist[tox][toy] != INF) continue;
            dist[tox][toy] = dist[vx][vy] + 1;
            q.push_back({tox, toy});
        }
    }
    //cout << endl;
    //for (auto& i : dist) cout << i << ' ';
    //cout << endl;
    if (dist[fx-1][fy-1] <= k) {
        cout <<  "YES";
    } else {
        cout << "NO";
    }



}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int nt = 1;
    //cin >> nt;

    while (nt--) {
        solve();
    }
}
