#include <bits/stdc++.h>

// #pragma GCC optimize("O3")

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define Size(a) (int)a.size()
#define ll long long
#define ld long double

#define int long long
#define double __float128

using namespace std;

const double eps = 1e-7;
const double pi = acos(-1);

struct pt {
    int x, y;

    pt operator -(pt other) const {
        return {x - other.x, y - other.y};
    }
};

int sign(ll x) {
    if (x < 0)
        return -1;
    if (x > 0)
        return 1;
    return 0;
}

ll scal(pt a, pt b) {
    return a.x * 1ll * b.x + a.y * 1ll * b.y;
}

ll cross(pt a, pt b) {
    return a.x * 1ll * b.y - b.x * 1ll * a.y;
}

ll S_triangle(pt a, pt b, pt c) {
    return cross(b - a, c - a);
}

double dist(pt a, pt b) {
    return sqrtl((a.x - b.x) * 1ll * (a.x - b.x) + (a.y - b.y) * 1ll * (a.y - b.y));
}

double solve_equals2(double a, double b, double c) {
    double D = b * b - 4 * a * c;
    assert(D >= -eps);
    if (D < 0)
        D = 0;
    return (-b + sqrtl(D)) / (2 * a);
}

bool point_in_angle(pt A, pt B, pt C, pt M) {
    return sign(cross(M - B, A - B)) * sign(cross(M - B, C - B)) <= 0;
}

bool point_in_triangle(pt A, pt B, pt C, pt M) {
    return point_in_angle(A, B, C, M) && point_in_angle(B, C, A, M) && point_in_angle(C, A, B, M);
}

inline int orientation(pt a, pt b, pt c) { return sign(cross(b - a, c - a)); }

// -1 if strictly inside, 0 if on the polygon, 1 if strictly outside
// it must be strictly convex, otherwise make it strictly convex first
int is_point_in_convex(vector<pt> &p, const pt& x) { // O(log n)
    int n = p.size(); assert(n >= 3);
    int a = orientation(p[0], p[1], x), b = orientation(p[0], p[n - 1], x);
    if (a < 0 || b > 0) return 1;
    int l = 1, r = n - 1;
    while (l + 1 < r) {
        int mid = l + r >> 1;
        if (orientation(p[0], p[mid], x) >= 0) l = mid;
        else r = mid;
    }
    int k = orientation(p[l], p[r], x);
    if (k <= 0) return -k;
    if (l == 1 && a == 0) return 0;
    if (r == n - 1 && b == 0) return 0;
    return -1;
}


// bool point_in_polygon(const vector<pt> &a, pt M) {
//     int n = a.size();
//     assert(n >= 3);
//     cerr << a[n - 1].x << " " << a[n - 1].y << "\n";
//     cerr << a[0].x << " " << a[0].y << "\n";
//     cerr << a[1].x << " " << a[1].y << "\n";
//     cerr << point_in_angle(a[n - 1], a[0], a[1], M) << "\n";

//     if (!point_in_angle(a[n - 1], a[0], a[1], M))
//         return false;
//     int l = 1, r = n - 1;
//     while (r - l > 1) {
//         int m = (l + r) >> 1;
//         if (cross(a[m] - a[0], M - a[0]) >= 0)
//             l = m;
//         else
//             r = m;
//     }
//     pt A = a[l], B = a[l + 1], C = a[0];
//     // cerr << l << "\n";
//     // cerr << A.x << " " << A.y << "\n";
//     // cerr << B.x << " " << B.y << "\n";
//     // cerr << C.x << " " << C.y << "\n";
//     // cerr << point_in_angle(C, A, B, M) << "\n";

//     // cerr << "deb: " << point_in_triangle(A, B, C, M) << "\n";
//     return point_in_triangle(A, B, C, M);
// }

inline double dot(pt a, pt b) { return a.x * b.x + a.y * b.y; }
inline double dist2(pt a, pt b) { return dot(a - b, a - b); }

double dist_from_point_to_seg(pt A, pt B, pt M) {
    if (scal(B - A, M - A) <= 0)
        return dist(A, M);
    if (scal(B - A, M - B) <= 0)
        return dist(B, M);
    return abs(cross(B - A, M - A)) / (2 * dist(A, B));
}

pair<pt, int> point_poly_tangent(vector<pt> &p, pt Q, int dir, int l, int r) {
    while (r - l > 1) {
        int mid = (l + r) >> 1;
        bool pvs = orientation(Q, p[mid], p[mid - 1]) != -dir;
        bool nxt = orientation(Q, p[mid], p[mid + 1]) != -dir;
        if (pvs && nxt) return {p[mid], mid};
        if (!(pvs || nxt)) {
            auto p1 = point_poly_tangent(p, Q, dir, mid + 1, r);
            auto p2 = point_poly_tangent(p, Q, dir, l, mid - 1);
            return orientation(Q, p1.first, p2.first) == dir ? p1 : p2;
        }
        if (!pvs) {
            if (orientation(Q, p[mid], p[l]) == dir)  r = mid - 1;
            else if (orientation(Q, p[l], p[r]) == dir) r = mid - 1;
            else l = mid + 1;
        }
        if (!nxt) {
            if (orientation(Q, p[mid], p[l]) == dir)  l = mid + 1;
            else if (orientation(Q, p[l], p[r]) == dir) r = mid - 1;
            else l = mid + 1;
        }
    }
    pair<pt, int> ret = {p[l], l};
    for (int i = l + 1; i <= r; i++) ret = orientation(Q, ret.first, p[i]) != dir ? make_pair(p[i], i) : ret;
    return ret;
}

pair<int, int> tangents_from_point_to_polygon(vector<pt> &p, pt Q){
    int ccw = point_poly_tangent(p, Q, 1, 0, (int)p.size() - 1).second;
    int cw = point_poly_tangent(p, Q, -1, 0, (int)p.size() - 1).second;
    return make_pair(ccw, cw);
}

// minimum distance from a point to a convex polygon
// it assumes point lie strictly outside the polygon
double dist_from_point_to_polygon(vector<pt> &p, pt z) {
    double ans = 1e18;
    int n = p.size();
    if (n <= 3) {
        for(int i = 0; i < n; i++) ans = min(ans, dist_from_point_to_seg(p[i], p[(i + 1) % n], z));
        return ans;
    }
    auto [r, l] = tangents_from_point_to_polygon(p, z);
    if(l > r) r += n;
    while (l < r) {
        int mid = (l + r) >> 1;
        double left = dist2(p[mid % n], z), right= dist2(p[(mid + 1) % n], z);
        ans = min({ans, left, right});
        if(left < right) r = mid;
        else l = mid + 1;
    }
    ans = sqrtl(ans);
    ans = min(ans, dist_from_point_to_seg(p[l % n], p[(l + 1) % n], z));
    ans = min(ans, dist_from_point_to_seg(p[l % n], p[(l - 1 + n) % n], z));
    return ans;
}

void solve() {
    int n;
    cin >> n;
    vector<pt> a(n);
    for (int i = 0; i < n; i++)
        cin >> a[i].x >> a[i].y;
    double area = 0;
    double P = 0;
    for (int i = 0; i < n; i++) {
        area += S_triangle(a[0], a[1], a[i]);
        P += dist(a[i], a[(i + 1) % n]);
    }
    area = abs(area) / 2;
    vector<double> d;
    d.push_back(-1);
    double pw = 1;
    while (true) {
        double cur = solve_equals2(pi, P, -area * (pw - 1));
        assert(cur >= 0);
        d.push_back(cur);
        if (cur >= 1e10)
            break;
        pw *= 2;
    }

    int q;
    cin >> q;
    while (q--) {
        pt M;
        cin >> M.x >> M.y;
        if (is_point_in_convex(a, M) <= 0) {
            cout << "0\n";
        } else {
            double cur_dist = dist_from_point_to_polygon(a, M);
            cout << lower_bound(all(d), cur_dist - eps) - d.begin() - 1 << "\n";
        }
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

#ifdef dimss
    freopen("test.txt", "r", stdin);
#endif

    int T = 1;
    // cin >> T;
    while (T--) {
        solve();
#ifdef dimss
        cerr << "--------\n";
#endif
    }
    return 0;
}
