#include <bits/stdc++.h>

using namespace std;

using ll = long long;

template <class T>
T smax(T & x, T y) {
    if (x < y) {
        x = y;
        return true;
    }
    return false;
}

template <class T>
T smin(T & x, T y) {
    if (x > y) {
        x = y;
        return true;
    }
    return false;
}

const int mod = 1000000007;

int sum(int x, int y) {
    if (x + y >= mod) {
        return x + y - mod;
    }
    return x + y;
}

int diff(int x, int y) {
    if (x < y) {
        return x + mod - y;
    }
    return x - y;
}

int mult(int x, int y) {
    return (int) ((x * 1LL * y) % mod);
}

int mypow(int x, int p) {
    int ans = 1;
    while (p > 0) {
        if ((p & 1) == 1) {
            ans = mult(ans, x);
        }
        x = mult(x, x);
        p >>= 1;
    }
    return ans;
}

int inv(int x) {
    return mypow(x, mod - 2);
}

double func(int used) {
    return 0 * used;
}

double score(int last, int used) {
    return last + func(used);
}

struct cmp {
    bool operator() (const pair<int, int>& a, const pair<int, int>& b) const {
        return a < b;
    }
};

const int INF = 2e9;

int MAX = 6001000;

vector<int> up(MAX, INF);
vector<int> down(MAX, INF);
vector<int> vert(MAX, INF);

struct SegmentTree {
    int n;
    int pow;
    vector<vector<int>> mn;
    vector<int> mid;

    SegmentTree() {}

    SegmentTree(int n_) {
        n = n_;
        pow = 1;
        while (pow <= n) {
            pow *= 2;
        }
        mn = vector<vector<int>>(2 * pow, vector<int>(10, INF));
        mid = vector<int>(2 * pow, -1);
        vector<int> l = vector<int>(2 * pow, -1);
        vector<int> r = vector<int>(2 * pow, -1);
        l[1] = 0;
        r[1] = pow;
        mid[1] = (l[1] + r[1]) / 2;
        for (int i = 1; i < pow; ++i) {
            l[2 * i] = l[i];
            r[2 * i] = mid[i];
            mid[2 * i] = (l[2 * i] + r[2 * i]) / 2;
            l[2 * i + 1] = mid[i];
            r[2 * i + 1] = r[i];
            mid[2 * i + 1] = (l[2 * i + 1] + r[2 * i + 1]) / 2;
        }
        for (int i = pow; i < pow + n; ++i) {
            point(i);
        }
        for (int i = pow - 1; i >= 1; --i) {
            merge(i);
        }
    }

    void upd(int x) {
        upd(1, 0, pow, x);
    }

    void upd(int v, int l, int r, int x) {
        if (v >= pow) {
            point(v);
            return;
        }
        int m = (l + r) / 2;
        if (x < m) {
            upd(2 * v, l, m, x);
        } else {
            upd(2 * v + 1, m, r, x);
        }
        merge(v);
    }

    int get(int l, int r) {
        return get(1, 0, pow, l, r)[7];
    }

    vector<int> get(int v, int tl, int tr, int l, int r) {
        if (l <= tl && tr <= r) {
            return mn[v];
        }
        int m = (tl + tr) / 2;
        if (l >= m) {
            return get(2 * v + 1, m, tr, l, r);
        }
        if (r <= m) {
            return get(2 * v, tl, m, l, r);
        }
        auto left = get(2 * v, tl, m, l, r);
        auto right = get(2 * v + 1, m, tr, l, r);
        vector<int> res;
        merge(res, left, right, mid[v] - 1);
        return res;
    }

    void point(int v) {
        int id = v - pow;
        mn[v].assign(10, INF);
        mn[v][2] = 0;
        mn[v][7] = vert[id];
    }

    void merge(int v) {
        int id = mid[v] - 1;
        vector<int> l = mn[2 * v];
        vector<int> r = mn[2 * v + 1];
        merge(mn[v], l, r, id);
    }

    void merge(vector<int> & res, vector<int> & l, vector<int> & r, int id) {
        int v = 0;
        mn[v].assign(10, INF);
        int best = min(up[id], down[id]);
        int sm = INF;
        if (up[id] != INF && down[id] != INF) {
            sm = up[id] + down[id];
        }
        int u = up[id];
        int d = down[id];

        connect(mn[v][0], l[0], r[2], sm);
        connect(mn[v][0], l[0], r[3], sm);
        connect(mn[v][8], l[0], r[5], sm);
        connect(mn[v][4], l[0], r[7], sm);

        connect(mn[v][1], l[1], r[2], sm);
        connect(mn[v][9], l[1], r[3], sm);
        connect(mn[v][1], l[1], r[5], sm);
        connect(mn[v][6], l[1], r[7], sm);

        connect(mn[v][0], l[2], r[0], sm);
        connect(mn[v][1], l[2], r[1], sm);
        connect(mn[v][2], l[2], r[2], sm);
        connect(mn[v][0], l[2], r[2], u);
        connect(mn[v][1], l[2], r[2], d);
        connect(mn[v][3], l[2], r[3], sm);
        connect(mn[v][0], l[2], r[3], u);
        connect(mn[v][9], l[2], r[3], d);
        connect(mn[v][4], l[2], r[4], sm);
        connect(mn[v][5], l[2], r[5], sm);
        connect(mn[v][8], l[2], r[5], u);
        connect(mn[v][1], l[2], r[5], d);
        connect(mn[v][6], l[2], r[6], sm);
        connect(mn[v][7], l[2], r[7], sm);
        connect(mn[v][4], l[2], r[7], u);
        connect(mn[v][6], l[2], r[7], d);
        connect(mn[v][8], l[2], r[8], sm);
        connect(mn[v][9], l[2], r[9], sm);

        connect(mn[v][3], l[3], r[2], sm);
        connect(mn[v][3], l[3], r[3], sm);
        connect(mn[v][5], l[3], r[5], sm);
        connect(mn[v][7], l[3], r[7], sm);

        connect(mn[v][0], l[4], r[0], sm);
        connect(mn[v][8], l[4], r[1], sm);
        connect(mn[v][4], l[4], r[2], sm);
        connect(mn[v][0], l[4], r[2], u);
        connect(mn[v][8], l[4], r[2], d);
        connect(mn[v][0], l[4], r[3], best);
        connect(mn[v][4], l[4], r[4], sm);
        connect(mn[v][8], l[4], r[5], best);
        connect(mn[v][4], l[4], r[6], sm);
        connect(mn[v][4], l[4], r[7], best);
        connect(mn[v][8], l[4], r[8], sm);
        connect(mn[v][0], l[4], r[9], sm);

        connect(mn[v][5], l[5], r[2], sm);
        connect(mn[v][3], l[5], r[3], sm);
        connect(mn[v][5], l[5], r[5], sm);
        connect(mn[v][7], l[5], r[7], sm);

        connect(mn[v][9], l[6], r[0], sm);
        connect(mn[v][1], l[6], r[1], sm);
        connect(mn[v][6], l[6], r[2], sm);
        connect(mn[v][9], l[6], r[2], u);
        connect(mn[v][1], l[6], r[2], d);
        connect(mn[v][9], l[6], r[3], best);
        connect(mn[v][6], l[6], r[4], sm);
        connect(mn[v][1], l[6], r[5], best);
        connect(mn[v][6], l[6], r[6], sm);
        connect(mn[v][6], l[6], r[7], best);
        connect(mn[v][1], l[6], r[8], sm);
        connect(mn[v][9], l[6], r[9], sm);

        connect(mn[v][3], l[7], r[0], sm);
        connect(mn[v][5], l[7], r[1], sm);
        connect(mn[v][7], l[7], r[2], sm);
        connect(mn[v][3], l[7], r[2], u);
        connect(mn[v][5], l[7], r[2], d);
        connect(mn[v][3], l[7], r[3], best);
        connect(mn[v][7], l[7], r[4], sm);
        connect(mn[v][5], l[7], r[5], best);
        connect(mn[v][7], l[7], r[6], sm);
        connect(mn[v][7], l[7], r[7], best);
        connect(mn[v][5], l[7], r[8], sm);
        connect(mn[v][3], l[7], r[9], sm);

        connect(mn[v][8], l[8], r[2], sm);
        connect(mn[v][0], l[8], r[3], sm);
        connect(mn[v][8], l[8], r[5], sm);
        connect(mn[v][4], l[8], r[7], sm);

        connect(mn[v][9], l[9], r[2], sm);
        connect(mn[v][9], l[9], r[3], sm);
        connect(mn[v][1], l[9], r[5], sm);
        connect(mn[v][6], l[9], r[7], sm);

        res = mn[v];
    }

    void connect(int & to, int l, int r, int m) {
        if (l != INF && r != INF && m != INF) {
            smin(to, l + r + m);
        }
    }
};

//struct ig {
//    ll a, b, id;
//    ig() {}
//    ig(int a, int b, int id): a(a), b(b), id(id) {}
//
//    bool operator<(const ig &o) const{
//        if (a * o.b != b * o.a)
//            return a * o.b > b * o.a;
//        return id > o.id;
//    }
//};

struct DSU {
    vector<int> p;
    vector<int> sz;
    vector<int> nei;

    DSU() {}

    DSU(int n) {
        sz.assign(n, 1);
        nei.assign(n, 0);
        p.resize(n);
        for (int i = 0; i < n; ++i) {
            p[i] = i;
        }
    }

    int get(int x) {
        if (p[x] == x) {
            return x;
        }
        return p[x] = get(p[x]);
    }

    bool unite(int x, int y) {
        int a = get(x);
        int b = get(y);
        if (a == b) {
            return false;
        }
        if (sz[a] < sz[b]) {
            swap(a, b);
        }
        sz[a] += sz[b];
        nei[a] += nei[b];
        p[b] = a;
        return true;
    }
};


void solve() {
    int a, b;
    cin >> a >> b;
    if ((a + b) % 2) {
        cout << "Error\n";
        return;
    }
    if (a >= 2 && b >= 2) {
        cout << "Undefined\n";
        return;
    }
    int x = 0;
    int y = 0;
    int z = 0;
    if (a == 1 || b == 1) {
        z = 1;
        --a;
        --b;
    }
    x = a / 2;
    y = b / 2;
    cout << x << "\n" << y << "\n" << z << "\n";
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
//    cin >> t;
    cout << fixed << setprecision(14);
    while (t--) {
        solve();
    }
    cerr << clock() * 1.0 / CLOCKS_PER_SEC << "\n";
    return 0;
}

