//  Nikita Golikov, 2023

#include <bits/stdc++.h>

using namespace std;

using uint = unsigned int;
using ll = long long;
using ull = unsigned long long;

#ifdef GOLIKOV
  #include "/Users/golikovnik/contests/debug.h"
#else
  #define debug(...) ;
#endif

template <class A, class B>
bool smin(A& x, B&& y) {
  if (y < x) {
    x = y;
    return true;
  }
  return false;
}

template <class A, class B>
bool smax(A& x, B&& y) {
  if (x < y) {
    x = y;
    return true;
  }
  return false;
}

int main() {
#ifdef GOLIKOV
  assert(freopen("in", "rt", stdin));
  auto _clock_start = chrono::high_resolution_clock::now();
#endif
  ios::sync_with_stdio(false);
  cin.tie(nullptr);

  int n, m, k;
  cin >> n >> m >> k;
  vector<string> a(n);
  for (auto& s : a) {
    cin >> s;
  }
  auto ok = [&](int r, int c) {
    return r >= 0 && r < n && c >= 0 && c < m && a[r][c] == '.';
  };
  int sx, sy, tx, ty;
  cin >> sx >> sy >> tx >> ty;
  --sx, --sy, --tx, --ty;
  int const INF = int(1e9);
  vector dist(n, vector<int>(m, INF));
  vector<int> DX{1, 0, -1, 0};
  vector<int> DY{0, 1, 0, -1};
  deque<pair<int, int>> dq;
  dist[sx][sy] = 0;
  dq.emplace_back(sx, sy);

  while (!dq.empty()) {
    auto[r, c] = dq.front(); dq.pop_front();
    auto go = [&](int rr, int cc, int w) {
      if (ok(rr, cc)) {
        int dd = dist[r][c] + w;
        if (dd < dist[rr][cc]) {
          dist[rr][cc] = dd;
          if (w == 0) {
            dq.emplace_front(rr, cc);
          } else {
            dq.emplace_back(rr, cc);
          }
        }
      }
    };
    for (int i = 0; i < 4; ++i) {
      go(r + DX[i], c + DY[i], 0);
      go(r + 2 * DX[i], c + 2 * DY[i], 1);
    }
  }
  if (dist[tx][ty] <= k) {
    cout << "YES\n";
  } else {
    cout << "NO\n";
  }

#ifdef GOLIKOV
  cerr << "Executed in " << chrono::duration_cast<chrono::milliseconds>(
      chrono::high_resolution_clock::now()
          - _clock_start).count() << "ms." << endl;
#endif
  return 0;
}
