//  Nikita Golikov, 2023

#include <bits/stdc++.h>

using namespace std;

using uint = unsigned int;
using ll = long long;
using ull = unsigned long long;

#ifdef GOLIKOV
  #include "/Users/golikovnik/contests/debug.h"
#else
  #define debug(...) ;
#endif

template <class A, class B>
bool smin(A& x, B&& y) {
  if (y < x) {
    x = y;
    return true;
  }
  return false;
}

template <class A, class B>
bool smax(A& x, B&& y) {
  if (x < y) {
    x = y;
    return true;
  }
  return false;
}

int main() {
#ifdef GOLIKOV
  assert(freopen("in", "rt", stdin));
  auto _clock_start = chrono::high_resolution_clock::now();
#endif
  ios::sync_with_stdio(false);
  cin.tie(nullptr);

  int n; cin >> n;
  vector<int> num(n);
  for (int i = 1; i < n - 1; ++i) {
    cin >> num[i];
  }
  vector<int> nxt(n);
  for (int i = 0; i < n; ++i) {
    if (num[i] == 0) {
      nxt[i] = i;
    } else {
      nxt[i] = nxt[i - num[i]];
    }
  }
  int const INF = int(1e9);
  vector<int> dist(n, INF);
  deque<int> dq;
  dq.push_back(0);
  dist[0] = 0;
  while (!dq.empty()) {
    int v = dq.front(); dq.pop_front();

    auto go = [&](int u, int w) {
      if (u < 0 || u >= n) {
        return;
      }
      u = nxt[u];
      if (u == n - 1) {
        w = 1;
      }
      int nd = dist[v] + w;
      if (nd < dist[u]) {
        dist[u] = nd;
        if (w == 1) {
          dq.push_back(u);
        } else {
          dq.push_front(u);
        }
      } 
    };

    for (int x = 1; x <= 5; ++x) {
      go(v + x, 1);
    }
    go(v + 6, 0);
  }
  if (dist[n - 1] == INF) {
    cout << -1 << '\n';
  } else {
    cout << dist[n - 1] << '\n';
  }

#ifdef GOLIKOV
  cerr << "Executed in " << chrono::duration_cast<chrono::milliseconds>(
      chrono::high_resolution_clock::now()
          - _clock_start).count() << "ms." << endl;
#endif
  return 0;
}
