//  Nikita Golikov, 2023

#include <bits/stdc++.h>

using namespace std;

using uint = unsigned int;
using ll = long long;
using ull = unsigned long long;

#ifdef GOLIKOV
  #include "/Users/golikovnik/contests/debug.h"
#else
  #define debug(...) ;
#endif

template <class A, class B>
bool smin(A& x, B&& y) {
  if (y < x) {
    x = y;
    return true;
  }
  return false;
}

template <class A, class B>
bool smax(A& x, B&& y) {
  if (x < y) {
    x = y;
    return true;
  }
  return false;
}

int main() {
#ifdef GOLIKOV
  assert(freopen("in", "rt", stdin));
  auto _clock_start = chrono::high_resolution_clock::now();
#endif
  ios::sync_with_stdio(false);
  cin.tie(nullptr);

  int n; cin >> n;
  vector<set<int>> g1(n);
  vector<vector<int>> g2(n);
  vector<int> par(n);
  for (int i = 1; i < n; ++i) {
    int p; cin >> p; g1[p].insert(i); par[i] = p;
  }
  for (int i = 1; i < n; ++i) {
    int p; cin >> p; g2[p].push_back(i);
  }
  set<int> avail;
  for (int i = 0; i < n; ++i) {
    avail.insert(i);
  }
  vector<pair<int, int>> ans;
  auto dfs = [&](auto self, int v1, int v2) -> void {
    assert(avail.count(v1));
    avail.erase(v1);
    for (int u : g2[v2]) {
      if (g1[v1].empty()) {
        assert(!avail.empty());
        int x = *avail.begin();
        int px = par[x];
        ans.emplace_back(x, v1);
        g1[px].erase(x);
        g1[v1].insert(x);
        par[x] = v1;
      }
      assert(!g1[v1].empty());
      int x = *g1[v1].begin();
      g1[v1].erase(x);
      self(self, x, u);
    }
  };
  dfs(dfs, 0, 0);
  assert(int(ans.size()) <= n);
  cout << ans.size() << '\n';
  for (auto[u, v] : ans) {
    cout << u << ' ' << v << '\n';
  }

#ifdef GOLIKOV
  cerr << "Executed in " << chrono::duration_cast<chrono::milliseconds>(
      chrono::high_resolution_clock::now()
          - _clock_start).count() << "ms." << endl;
#endif
  return 0;
}
