// #pragma comment(linker, "/stack:200000000")
// #pragma GCC optimize("Ofast,no-stack-protector")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
// #pragma GCC optimize("unroll-loops")

#include <stdio.h>
#include <bits/stdc++.h>

#ifdef PERVEEVM_LOCAL
    #define debug(x...) std::cerr << "[DEBUG]\t" << __LINE__ << ":\t" << (#x) << " = "; print_debug(x)
#else
    #define debug(x...) 238
#endif

#define fastIO std::ios_base::sync_with_stdio(false); std::cin.tie(0); std::cout.tie(nullptr)
#define NAME "File"

using ll = long long;
using ld = long double;

#ifdef PERVEEVM_LOCAL
    std::mt19937 rnd(238);
#else
    std::mt19937 rnd(std::chrono::high_resolution_clock::now().time_since_epoch().count());
#endif

template<typename T1, typename T2>
std::ostream& operator<<(std::ostream& out, const std::pair<T1, T2>& p) {
    out << "(" << p.first << ", " << p.second << ")";
    return out;
}

template<size_t index, typename T>
std::ostream& print_tuple(std::ostream& out, const T& t) {
    if constexpr (index == std::tuple_size<T>::value) {
        out << ")";
        return out;
    } else {
        if (index > 0) {
            out << ", ";
        } else {
            out << "(";
        }
        out << std::get<index>(t);
        return print_tuple<index + 1, T>(out, t);
    }
}

template<typename ...T>
std::ostream& operator<<(std::ostream& out, const std::tuple<T...>& t) {
    return print_tuple<0, std::tuple<T...>>(out, t);
}

template<typename Container, typename = decltype(std::begin(std::declval<Container>()))>
typename std::enable_if<!std::is_same<Container, std::string>::value, std::ostream&>::type
operator<<(std::ostream& out, const Container& container) {
    out << "{";
    for (auto it = container.begin(); it != container.end(); ++it) {
        if (it != container.begin()) {
            out << ", ";
        }
        out << *it;
    }
    out << "}";
    return out;
}

void print_debug() {
    std::cerr << std::endl;
}

template<typename T, typename... V>
void print_debug(const T& value, const V&... others) {
    std::cerr << value;
    if (sizeof...(others) != 0) {
        std::cerr << ", ";
        print_debug(others...);
    } else {
        std::cerr << std::endl;
    }
}

template<typename T>
bool smin(T& a, const T& b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool smax(T& a, const T& b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

const double PI = atan2(0.0, -1.0);
const int INF = 0x3f3f3f3f;
const ll LINF = (ll)2e18;

template<typename TI, typename TF>
class generic_point {
public:
    TI x, y;

    generic_point() = default;

    generic_point(TI _x, TI _y) : x(_x), y(_y) {}

    generic_point<TI, TF> operator+() const {
        return *this;
    }

    generic_point<TI, TF> operator-() const {
        return generic_point<TI, TF>(-x, -y);
    }

    generic_point<TI, TF> operator+(const generic_point<TI, TF>& other) const {
        return generic_point<TI, TF>(x + other.x, y + other.y);
    }

    generic_point<TI, TF> operator-(const generic_point<TI, TF>& other) const {
        return generic_point<TI, TF>(x - other.x, y - other.y);
    }

    generic_point<TI, TF> operator*(TI k) const {
        return generic_point<TI, TF>(x * k, y * k);
    }

    generic_point<TI, TF>& operator+=(const generic_point<TI, TF>& other) {
        *this = (*this) + other;
        return *this;
    }

    generic_point<TI, TF>& operator-=(const generic_point<TI, TF>& other) {
        *this = (*this) - other;
        return *this;
    }

    generic_point<TI, TF>& operator*=(TI k) {
        *this = (*this) * k;
        return *this;
    }

    template<typename T = TI>
    typename std::enable_if<std::is_floating_point<T>::value, generic_point<TI, TF>>::type
    operator/(TI k) const {
        return generic_point<TI, TF>(x / k, y / k);
    }

    template<typename T = TI>
    typename std::enable_if<std::is_floating_point<T>::value, generic_point<TI, TF>&>::type
    operator/=(TI k) {
        *this = (*this) / k;
        return *this;
    }

    TI operator*(const generic_point<TI, TF>& other) const {
        return x * other.x + y * other.y;
    }

    TI operator%(const generic_point<TI, TF>& other) const {
        return x * other.y - y * other.x;
    }

    TI lenSqr() const {
        return x * x + y * y;
    }

    TF len() const {
        return sqrt(lenSqr());
    }

    TI distSqr(const generic_point<TI, TF>& other) const {
        return (other - *this).lenSqr();
    }

    TF dist(const generic_point<TI, TF>& other) const {
        return sqrt(distSqr(other));
    }

    generic_point<TI, TF> norm() const {
        return *this / len();
    }

    // Counterclockwise rotation by 90 degrees
    generic_point<TI, TF> ort() const {
        return generic_point<TI, TF>(-y, x);
    }

    // Counterclockwise rotation by c = cos(alpha), s = sin(alpha)
    template<typename T = TI>
    typename std::enable_if<std::is_floating_point<T>::value, generic_point<TI, TF>>::type
    rot(TF c, TF s) const {
        return *this * c + ort() * s;
    }

    // Counterclockwise rotation by alpha
    generic_point<TI, TF> rot(TF alpha) const {
        return rot(cos(alpha), sin(alpha));
    }

    TF arg() const {
        return atan2(y, x);
    }

    int quad() const {
        if (x >= 0 && y >= 0) {
            return 1;
        } else if (x < 0 && y >= 0) {
            return 2;
        } else if (x < 0 && y < 0) {
            return 3;
        } else if (x >= 0 && y < 0) {
            return 4;
        }
        throw;
    }

    template<typename T = TI>
    typename std::enable_if<std::is_floating_point<T>::value>::type
    scan() {
        double _x, _y;
        scanf("%lf%lf", &_x, &_y);
        x = _x;
        y = _y;
    }

    template<typename T = TI>
    typename std::enable_if<std::is_integral<T>::value>::type
    scan() {
        ll _x, _y;
        scanf("%lld%lld", &_x, &_y);
        x = _x;
        y = _y;
    }

    template<typename T = TI>
    typename std::enable_if<std::is_floating_point<T>::value>::type
    print() {
        printf("%.10lf %.10lf\n", (double)x, (double)y);
    }

    template<typename T = TI>
    typename std::enable_if<std::is_integral<T>::value>::type
    print() {
        printf("%lld %lld\n", (ll)x, (ll)y);
    }
};

using point = generic_point<ll, ld>;

struct line {
	ll a, b, c;

	line() = default;

	line(const point& p1, const point& p2) {
		a = p1.y - p2.y;
		b = p2.x - p1.x;
		c = -p1.x * a - p1.y * b;
	}
};

int sgn(ll x) {
    if (x > 0) {
        return 1;
    } else if (x == 0) {
        return 0;
    } else {
        return -1;
    }
}

ld square(const std::vector<point>& a) {
	ll ans = 0;
	for (int i = 0; i < (int)a.size(); ++i) {
		int nxt = i + 1;
		if (nxt == (int)a.size()) {
			nxt = 0;
		}

		ans += (a[nxt].x - a[i].x) * (a[nxt].y + a[i].y);
	}
	return 1.0 * llabs(ans) / 2.0;
}

ld perimeter(const std::vector<point>& a) {
	ld ans = 0.0;
	for (int i = 0; i < (int)a.size(); ++i) {
		int nxt = i + 1;
		if (nxt == (int)a.size()) {
			nxt = 0;
		}
		ans += a[i].dist(a[nxt]);
	}
	return ans;
}

std::vector<point> convex_hull(std::vector<point> a) {
    int n = (int)a.size();
    std::sort(a.begin(), a.end(), [&](const point& p1, const point& p2) {
        return p1.x < p2.x || (p1.x == p2.x && p1.y < p2.y);
    });

    std::vector<point> u, d;
    auto v = a[n - 1] - a[0];
    u.push_back(a[0]);
    d.push_back(a[0]);

    int uSize = 1, dSize = 1;
    for (int i = 1; i < n; ++i) {
        if (v % (a[i] - a[0]) >= 0) {
            while (uSize > 1 && (u[uSize - 1] - u[uSize - 2]) % (a[i] - u[uSize - 2]) >= 0) {
                u.pop_back();
                --uSize;
            }
            u.push_back(a[i]);
            ++uSize;
        }
        if (v % (a[i] - a[0]) <= 0) {
            while (dSize > 1 && (d[dSize - 1] - d[dSize - 2]) % (a[i] - d[dSize - 2]) <= 0) {
                d.pop_back();
                --dSize;
            }
            d.push_back(a[i]);
            ++dSize;
        }
    }

    std::vector<point> ans;
    for (auto i : u) {
        ans.push_back(i);
    }
    for (int i = dSize - 2; i > 0; --i) {
        ans.push_back(d[i]);
    }

    std::reverse(ans.begin(), ans.end());
    return ans;
}

// counter-clockwise
bool point_inside_convex_polygon(const std::vector<point>& a, const point& p) {
    auto point_in_angle = [&](const point& P, const point& A, const point& O, const point& B) -> bool {
        point v1 = A - O;
        point v2 = B - O;
        point v = P - O;
     
        if (sgn(v1 % v2) >= 0) {
            return sgn(v1 % v) >= 0 && sgn(v % v2) >= 0;
        } else {
            return sgn(v1 % v) <= 0 && sgn(v % v2) <= 0;
        }
    };

    if (!point_in_angle(p, a[1], a[0], a.back())) {
        return false;
    }
 
    int l = 1, r = (int)a.size() - 1;
    while (r - l > 1) {
        int mid = (l + r) / 2;
 
        if (point_in_angle(p, a[1], a[0], a[mid])) {
            r = mid;
        } else {
            l = mid;
        }
    }
 
    // a[mid - 1], a[0], a[mid]. edge from a[mid - 1] to a[mid]
    assert(point_in_angle(p, a[r - 1], a[0], a[r]));
    return point_in_angle(p, a[r], a[r - 1], a[0]) && point_in_angle(p, a[r - 1], a[r], a[0]);
}

bool is_convex(const std::vector<point>& p, bool strictly = true) {
    int cntPositive = 0, cntNegative = 0;
    int cntZero = 0;
    for (int i = 0; i < (int)p.size(); ++i) {
        point prv = p[i];
        point cur = p[(i + 1) % (int)p.size()];
        point nxt = p[(i + 2) % (int)p.size()];

        point v1 = cur - prv;
        point v2 = nxt - cur;

        int s = sgn(v1 % v2);
        if (s == 0) {
            ++cntZero;
        } else if (s < 0) {
            ++cntNegative;
        } else {
            ++cntPositive;
        }
    }

    if (strictly && cntZero > 0) {
        return false;
    }
    return cntPositive == 0 || cntNegative == 0;
}


std::pair<int, int> tangents(const point& p, const std::vector<point>& poly) {
    ll x = (poly[1] - p) % (poly[0] - p);
    int l = 0, r = (int)poly.size();
    while (r - l > 1) {
        int m = (l + r) / 2;
        int nxt = m + 1;
        if (nxt == (int)poly.size()) {
            nxt = 0;
        }
        if ((poly[m] - p) % (poly[0] - p) >= 0) {
            if (x < 0) {
                r = m;
            } else {
                l = m;
            }
        } else {
            if ((poly[nxt] - p) % (poly[m] - p) >= 0) {
                r = m;
            } else {
                l = m;
            }
        }
    }
    int first = r;
    if (first == (int)poly.size()) {
        first = 0;
    }

    l = 0, r = (int)poly.size();
    while (r - l > 1) {
        int m = (l + r) / 2;
        int nxt = m + 1;
        if (nxt == (int)poly.size()) {
            nxt = 0;
        }
        if ((poly[m] - p) % (poly[0] - p) <= 0) {
            if (x > 0) {
                r = m;
            } else {
                l = m;
            }
        } else {
            if ((poly[nxt] - p) % (poly[m] - p) <= 0) {
                r = m;
            } else {
                l = m;
            }
        }
    }
    int second = r;
    if (second == (int)poly.size()) {
        second = 0;
    }
    if ((poly[first] - p) % (poly[second] - p) > 0) {
        std::swap(first, second);
    }
    return std::make_pair(first, second);
}

ld distToLine(const point& p, const point& p1, const point& p2) {
	line l(p1, p2);
	return llabs(p.x * l.a + p.y * l.b + l.c) / sqrtl(l.a * l.a + l.b * l.b);
}

ld distToSegment(const point& p, const point& p1, const point& p2) {
	if ((p2 - p1) * (p - p1) >= 0 && (p1 - p2) * (p - p2) >= 0) {
		return distToLine(p, p1, p2);
	} else {
		return std::min(p.dist(p1), p.dist(p2));
	}
}

const int N = 100100;

ld arr[N];

void run() {
    int n;
    scanf("%d", &n);

    std::vector<point> poly(n);
    for (int i = 0; i < n; ++i) {
    	poly[i].scan();
    }

    ld s0 = square(poly);
    ld curS = s0;
    ld per = perimeter(poly);
    arr[0] = 0.0;
    // debug(s0, per);
    for (int i = 1; i < N; ++i) {
    	curS *= 2;
    	ld a = PI;
    	ld b = per;
    	ld c = -curS + s0;
    	ld d = b * b - 4 * a * c;
    	arr[i] = (-b + sqrtl(d)) / (2 * a);
    }

    for (int i = 0; i < n; ++i) {
    	poly.push_back(poly[i]);
    }

    int q;
    scanf("%d", &q);

    std::vector<point> queries(q);
    for (int i = 0; i < q; ++i) {
    	queries[i].scan();
    }

    for (int i = 1; i < N; ++i) {
    	assert(arr[i] >= arr[i - 1]);
    }

    for (int i = 0; i < q; ++i) {
    	auto p = queries[i];
    	if (point_inside_convex_polygon(poly, p)) {
    		printf("0\n");
    		continue;
    	}

    	auto[l, r] = tangents(p, poly);
    	if (l > r) {
    		r += n;
    	}

    	// TODO: check bounds
    	while (r - l > 1) {
    		int m = (l + r) / 2;

    		point p1 = poly[m - 1];
    		point p2 = poly[m];
    		point p3 = poly[m + 1];
    		if (distToSegment(p, p1, p2) < distToSegment(p, p2, p3)) {
    			r = m;
    		} else {
    			l = m;
    		}
    	}

    	// debug(l, r);

    	ld dist = distToSegment(p, poly[l], poly[r]);
    	printf("%d\n", (int)(std::lower_bound(arr, arr + N, dist) - arr));
    }
}

int main(void) {
    // freopen(NAME".in", "r", stdin);
    // freopen(NAME".out", "w", stdout);

    #ifdef PERVEEVM_LOCAL
        auto start = std::chrono::high_resolution_clock::now();
    #endif

    run();

    #ifdef PERVEEVM_LOCAL
        auto end = std::chrono::high_resolution_clock::now();
        std::cerr << "Execution time: "
                  << std::chrono::duration_cast<std::chrono::milliseconds>(end - start).count()
                  << " ms" << std::endl;
    #endif

    return 0;
}
