import java.io.*;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Scanner;

public class E2 {

    public static class Pair implements Comparable<Pair> {
        private final int first;
        private final int second;

        public Pair(int first, int second) {
            this.first = first;
            this.second = second;
        }

        @Override
        public int compareTo(Pair o) {
            return Integer.compare(first, o.first);
        }
    }

    public static void main(String[] args) throws IOException {
        var in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
        var out = new BufferedWriter(new OutputStreamWriter(System.out));

        int n = in.nextInt();
        int k = in.nextInt();

        List<Integer> s = new ArrayList<>();
        List<Pair> pairs = new ArrayList<>();

        for (int i = 0; i < n; i++) {
            s.add(in.nextInt());
        }
        long res = 0;
        double current = 0;
        for (int i = 0; i < n; i++) {
            int a = in.nextInt();
            int si = s.get(i);
            pairs.add(new Pair(si, Math.abs(si - a)));
            current += 1.0 * Math.abs(si - a) / si;
        }

        current -= k;
        if (current <= 1e-8) {
            out.write(Integer.toString(0));
            out.close();
            return;
        }

        Collections.sort(pairs);

        for (var pair : pairs) {
//            double unit = 1.0 / pair.first;
            long cnt = Math.round(Math.ceil(current * pair.first));
            if (cnt > pair.second) {
                current -= 1.0 * pair.second / pair.first;
                res += pair.second;
            } else {
                res += cnt;
                out.write(Long.toString(res));
                out.close();
                return;
            }
        }
        throw new RuntimeException();
    }
}
