import java.io.*;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Scanner;

public class E3 {

    public static void main(String[] args) throws IOException {
        var in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
        var out = new BufferedWriter(new OutputStreamWriter(System.out));

        int n = in.nextInt();
        int k = in.nextInt();

        List<Integer> s = new ArrayList<>();
        List<Pair> pairs = new ArrayList<>();
        s.add(0, 0);
        for (int i = 1; i <= n; i++) {
            s.add(in.nextInt());
        }
        long res = 0;
        double[] current = new double[n + 1];
        for (int i = 1; i <= n; i++) {
            int a = in.nextInt();
            int si = s.get(i);
            pairs.add(new Pair(si, Math.abs(si - a)));
        }
        Collections.sort(pairs);
        current[n] = 0;
        for (int i = n - 1; i >= 0; i--) {
            current[i] = current[i + 1] + (double) pairs.get(i).second / (double) pairs.get(i).first;
        }

        if (current[0] <= k) {
            out.write(Integer.toString(0));
            out.close();
            return;
        }

        for (int i = 0; i < n; i++) {
            double cnt = (current[i] - k) * pairs.get(i).first;
            if (cnt > pairs.get(i).second) {
                res += pairs.get(i).second;
            } else {
                res += cnt;
                out.write(Long.toString(res));
                out.close();
                return;
            }
        }
        throw new RuntimeException();
    }

    public static class Pair implements Comparable<Pair> {
        private final int first;
        private final int second;

        public Pair(int first, int second) {
            this.first = first;
            this.second = second;
        }

        @Override
        public int compareTo(Pair o) {
            return Integer.compare(first, o.first);
        }
    }
}
