#include<iostream>
#include<vector>
#include<numeric>
#include<map>
#include<algorithm>
#include<cassert>
#include<set>
#include<cmath>
#define dbg(x) cout << #x << "=" << x << "\n";
using namespace std;
#define int long long
const int inf = 1e18;

struct point{
    long long x;
    long long y;

    long long len(){
        return x*x + y*y;
    }
};

point p0;

long long operator%(point &n1, point &n2){
    return n1.x*n2.y-n1.y*n2.x;
}

point operator-(point &n1, point &n2){
    return {n2.x-n1.x, n2.y-n1.y};
}

bool operator<(point &n1, point &n2){
    point n3=n1-p0;
    point n4 =n2-p0;

    long long res = n3 % n4;

    if(res > 0){
        return true;
    }else if(res < 0){
        return false;
    }

    return n3.len() < n4.len();

}

bool cmp(point &n1, point &n2){
    if(n1.x != n2.x){
        return n1.x < n2.x;
    }

    return n1.y < n2.y;
}

void solve(){
    long long n; cin >> n;

    vector<point> a;

    for(int i=0; i < n; i++){
        long long x, y; cin >> x >> y;

        a.push_back({x, y});
    }

    sort(a.begin(), a.end(), cmp);

    p0=a[0];

    sort(a.begin(), a.end());

    vector<point> st(1, a[0]);

    for(int i=1; i < n; i++){
        while(st.size() > 2){
            point last=a[i]-st.back();
            point n=st[st.size()-2] - st.back();

            if(last % n > 0){
                break;
            }else{
                st.pop_back();
            }
        }

        st.push_back(a[i]);
    }

    
    long double ans = 0;
    for(int i=1; i < st.size(); i++){
        point popa = st[i] - st[i-1];
        ans += sqrt((double)popa.len());
    }

    cout << fixed << ans;
}



int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cout.precision(20);

    int t=1;
    //cin >> t;

    for(int i = 0; i < t; i++){
        solve();
        cout << "\n";
    }
}