#include<iostream>
#include<vector>
#include<numeric>
#include<map>
#include<algorithm>
#include<cassert>
#include<set>
#include<cmath>
#include<deque>
#define dbg(x) cout << #x << "=" << x << "\n";
using namespace std;
#define int long long 
const int inf = 1e18;

bool check(int x, int y, int n, int m) {
    return x >= 0 && y >=0 && x < n && y < m;
}

void solve() {
    int n, m, k; cin >> n >> m >> k;

    vector<vector<char> > a(n, vector<char> (m, 0));
    vector<vector<int> > used(n, vector<int> (m, inf));
    vector<pair<int, int> > can; 
    vector<pair<int, int> > can1;

    can.push_back(make_pair(1, 0));
    can.push_back(make_pair(-1, 0));
    can.push_back(make_pair(0, 1));
    can.push_back(make_pair(0, -1));

    can1.push_back(make_pair(2, 0));
    can1.push_back(make_pair(-2, 0));
    can1.push_back(make_pair(0, 2));
    can1.push_back(make_pair(0, -2));

    for(int i=0; i < n; i++){
        for(int j=0; j < m; j++){
            cin >> a[i][j];
        }
    }

    deque<pair<int, int> > d;
    int d_x, d_y; cin >> d_x >> d_y; d_x--; d_y--;
    used[d_x][d_y] = 0;
    d.push_back(make_pair(d_x, d_y));

    while(!d.empty()) {
        int x1 = d.front().first;
        int y1 = d.front().second;
        d.pop_front();

        for(auto el: can) {
            int x = x1 + el.first;
            int y = y1 + el.second;

            if(check(x, y, n, m) && used[x1][y1] < used[x][y] && a[x][y] != '#') {
                used[x][y] = used[x1][y1];
                d.push_front(make_pair(x, y));
            }
        }

        for(auto el: can1) {
            int x = x1 + el.first;
            int y = y1 + el.second;

            if(check(x, y, n, m) && used[x1][y1] + 1 < used[x][y] && a[x][y] != '#') {
                used[x][y] = used[x1][y1] + 1;
                d.push_back(make_pair(x, y));
            }
        }
    }

    int ax, ay; cin >> ax >> ay; ax--;ay--;

    if(used[ax][ay] <= k){
        cout << "YES";
    } else{
        cout << "NO";
    }
}


int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t=1;
    //cin >> t;

    for(int i = 0; i < t; i++){
        solve();
        cout << "\n";
    }
}