#include<iostream>
#include<vector>
#include<numeric>
#include<map>
#include<algorithm>
#include<cassert>
#include<set>
#include<cmath>
#include<deque>
#define dbg(x) cout << #x << "=" << x << "\n";
using namespace std;
#define int long long 
const int inf = 1e18;

struct graph {
    vector<int> pa;
    vector<int> pb;
    vector<vector<int> > ga;
    vector<vector<int> > gb;
    vector<int> useda;
    vector<pair<int, int> > ans;
    set<int> l;

    graph(int n) {
        pa.resize(n);
        pb.resize(n);
        ga.resize(n, vector<int> ());
        gb.resize(n, vector<int> ());
        useda.resize(n, 0);
    }
};

void dfs(int a, int b, graph &g) {
    g.useda[a] = 1;
    g.l.erase(a);

    while(g.ga[a].size() < g.gb[b].size()) {
        if(g.l.size() == 0){
            cout << "HUITA";
        }

        int la = (*g.l.begin());
        int pa = g.pa[la];
        g.l.erase(la);

        g.ga[a].push_back(la);

        g.ga[pa].erase(find(g.ga[pa].begin(), g.ga[pa].end(), la));

        if(g.ga[pa].size() == 0 && g.useda[pa] == 0) {
            g.l.insert(g.pa[la]);
        }

        g.ans.push_back(make_pair(la, a));
    }

    for(int i=0; i < g.gb[b].size(); i++){
        g.useda[g.ga[a][i]] = 1;
        g.l.erase(g.ga[a][i]);
    }

    for(int i=0; i < g.gb[b].size(); i++){
        dfs(g.ga[a][i], g.gb[b][i], g);
    }
}

void solve() {
    int n; cin >> n;

    graph g = graph(n);

    for(int i=1; i < n; i++) {
        cin >> g.pa[i];
        g.ga[g.pa[i]].push_back(i);
    }

    for(int i=1; i < n; i++){
        cin >> g.pb[i];
        g.gb[g.pb[i]].push_back(i);
    }

    for(int i=0; i < n; i++){
        if(g.ga[i].size() == 0) {
            g.l.insert(i);
        }
    }

    dfs(0, 0, g);

    cout << g.ans.size() << "\n";

    for(auto el: g.ans) {
        cout << el.first << " " << el.second << "\n";
    }
 }


int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t=1;
    //cin >> t;

    for(int i = 0; i < t; i++){
        solve();
        cout << "\n";
    }
}