#include <bits/stdc++.h>
#include <ctime>
#pragma GCC optimize("O3,fast-math")
#pragma GCC target("avx,avx2,sse4,sse4.1,sse4.2,bmi2,tune=native")
#ifdef KOK
#include "debug_output.h"
#define dbg(x)                                                                 \
    cerr << "\n" << #x << ":\n ";                                              \
    debug::print(x);                                                           \
    cerr << "\n"
#else
#define dbg(x) ;
#endif


#define all(x) begin(x), end(x)
#define rall(x) x.rbegin(), x.rend()
#define rep(i, k, n) for (int i = k; i < n; i++)
#define rrep(i, k, n) for (int i = n - 1; i >= k; i--)
#define frl(i, x) for (auto &i : x)
#define forall(i, x) frl(i, x)
#define pb push_back
#define eb emplace_back
#define F first
#define S second

using ll = long long;
using ld = long double;
using dd = double;

using namespace std;

const ld eps = 1e-8;

const ld pi = acosl(-1);

struct pt {
        ld x, y;
};

struct vec {
        ld x, y;

        vec(pt a, pt b) : x(b.x - a.x), y(b.y - a.y) {}
        vec(ld x, ld y) : x(x), y(y) {}

        ld len() { return sqrtl(x * x + y * y); }

        ld sq_len() { return x * x + y * y; }

        friend const ld operator*(vec a, vec b) {
            return a.x * b.x + a.y * b.y;
        }
        friend vec operator-(vec a, vec b) { return vec(a.x - b.x, a.y - b.y); }
        friend const ld operator^(vec a, vec b) {
            return a.x * b.y - b.x * a.y;
        }

        friend const vec operator*(const vec a, int k) {
            return vec(a.x * k, a.y * k);
        }

        friend const vec operator*(int k, const vec a) {
            return vec(a.x * k, a.y * k);
        }

        friend vec operator+(vec a, vec b) { return vec(a.x + b.x, a.y + b.y); }
};

ld dist(pt a, pt b) {
    return sqrtl((a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y));
}

bool in_angle(vec oa, vec ob, vec op) {
    if (((op ^ ob) > 0 && (oa ^ ob) > 0 || (op ^ ob) < 0 && (oa ^ ob) < 0) &&
        ((op ^ oa) > 0 && (ob ^ oa) > 0 || (op ^ oa) < 0 && (ob ^ oa) < 0))
        return 1;
    if (fabsl((op ^ oa)) < eps && op * oa >= -eps ||
        fabsl((op ^ ob)) < eps && op * ob >= -eps)
        return 1;
    return 0;
}

void out(vec x) { cout << '\n' << x.x << ' ' << x.y << '\n'; }

bool in(pt &p, vector<pt> &v, vector<pt> &old, ld d) {
    if (!in_angle(vec(v[0], v[1]), vec(v[0], v.back()), vec(v[0], p))) {
        if (dist(old[0], p) <= d)
            return 1;
        return 0;
    }
    int l = 0, r = v.size() - 1, mid;
    while (r - l > 1) {
        mid = r + l >> 1;
        if (in_angle(vec(v[0], v[mid]), vec(v[0], v.back()), vec(v[0], p)))
            l = mid;
        else
            r = mid;
    }
    if (in_angle(vec(v[l], v[0]), vec(v[l], v[l + 1]), vec(v[l], p)) &&
        in_angle(vec(v[l + 1], v[l]), vec(v[l + 1], v[0]), vec(v[l + 1], p))) {
        return 1;
    } else {
        if (l % 2 == 1) {
            if (dist(old[(l + 1) / 2], p) <= d) {
                return 1;
            }
            return 0;
        }
        return 0;
    }
}

vector<pt> generate(vector<pt> &old, ld d) {
    vector<pt> nw;
    rep(i, 0, old.size()) {
        pt a = old[i];
        pt b = old[(i + 1) % old.size()];
        vec k = vec(a, b);
        vec nx = vec(k.y, -k.x);
        ld ln = nx.len();
        nx.x *= d / ln;
        nx.y *= d / ln;
        nw.push_back({a.x + nx.x, a.y + nx.y});
        nw.push_back({b.x + nx.x, b.y + nx.y});
    }
    return nw;
}

vector<bool> check(vector<pt>& old, vector<pt>& qq, vector<int>& ind, ld d){
    vector<bool> ans(ind.size(), 0);
    vector<pt> nw = generate(old, d);
    rep(i, 0, ind.size()){
        ans[i] = in(qq[ind[i]], nw, old, d);
    }
    return ans;
}