#include <bits/stdc++.h>

#define int long long
#define F first
#define S second
#define pii pair<int, int>
#define pb push_back
#define ld long double
#ifdef OlegSanders
#else
#define cerr if(0)cerr
#endif
#define graph vector<vector<int>>

using namespace std;

const int INF = 1e18 + 1234567;
const int MOD = 1e9 + 7;

mt19937_64 gen(chrono::high_resolution_clock().now().time_since_epoch().count());

ld rast(int x1, int y1, int x2, int y2) {
    return sqrt((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2));
}

int32_t main() {
#ifdef OlegSanders
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n,m,k;
    cin >> n >> m >> k;

    vector<string> a(n);
    for (int i = 0;i < n;i++) cin >> a[i];

    int x1,y1,x2,y2;
    cin >> x1 >> y1 >> x2 >> y2;
    x1--;
    y1--;
    x2--;
    y2--;

    int cmp = 0;
    vector<vector<int>> d(n,vector<int>(m));

    for (int i = 0;i < n;i++) {
        for (int j = 0;j < m;j++) {
            if (a[i][j] != '#' && !d[i][j]) {
                cmp++;
                d[i][j] = cmp;
                queue<pair<int,int>> q;
                q.emplace(i,j);
                while (!q.empty()) {
                    pair<int,int> p = q.front();
                    q.pop();
                    int x = p.first;
                    int y = p.second;
                    if (x && a[x - 1][y] != '#' && !d[x - 1][y]) {
                        d[x - 1][y] = cmp;
                        q.emplace(x - 1,y);
                    }
                    if (x + 1 < n && a[x + 1][y] != '#' && !d[x + 1][y]) {
                        d[x + 1][y] = cmp;
                        q.emplace(x + 1,y);
                    }
                    if (y && a[x][y - 1] != '#' && !d[x][y - 1]) {
                        d[x][y - 1] = cmp;
                        q.emplace(x,y - 1);
                    }
                    if (y + 1 < m && a[x][y + 1] != '#' && !d[x][y + 1]){
                        d[x][y + 1] = cmp;
                        q.emplace(x,y + 1);
                    }
                }
            }
        }
    }

    vector<set<int>> edge(cmp + 1);
    for (int i = 0;i < n;i++) {
        for (int j = 0;j < m;j++) {
            if (d[i][j]) {
                if (i >= 2 && d[i - 2][j]) {
                    edge[d[i][j]].insert(d[i - 2][j]);
                    edge[d[i - 2][j]].insert(d[i][j]);
                }
                if (i + 2 < n && d[i + 2][j]) {
                    edge[d[i][j]].insert(d[i + 2][j]);
                    edge[d[i + 2][j]].insert(d[i][j]);
                }
                if (j >= 2 && d[i][j - 2]) {
                    edge[d[i][j]].insert(d[i][j - 2]);
                    edge[d[i][j - 2]].insert(d[i][j]);
                }
                if (j + 2 < m && d[i][j + 2]) {
                    edge[d[i][j]].insert(d[i][j + 2]);
                    edge[d[i][j + 2]].insert(d[i][j]);
                }
            }
        }
    }

    graph g(cmp + 1);
    for (int i = 0;i <= cmp;i++)
        for (int v : edge[i]) g[i].push_back(v);

    vector<int> dist(cmp + 1,INF);
    dist[d[x1][y1]] = 0;
    queue<int> q;
    q.push(d[x1][y1]);
    while (!q.empty()) {
        int u = q.front();q.pop();
        for (int v : g[u]) {
            if (dist[v] == INF) {
                dist[v] = dist[u] + 1;
                q.push(v);
            }
        }
    }

    if (dist[d[x2][y2]] <= k) cout << "YES";
    else cout << "NO";
}
