#include <iostream>
#include <string>
#include <vector>
 
using namespace std;

int n, m, k;
string ans = "NO";
pair<int, int> start, dest;
vector<vector<int>> g;
vector<vector<bool>> used;


void dfs(pair<int, int> curr, int jumps) {
    if (curr == dest) {
        ans = "YES";
        return;
    }
    int x = curr.first;
    int y = curr.second;
    if (x > 0) {
        if (g[x-1][y] == 0 && !used[x-1][y]) {
            used[x-1][y] = true;
            dfs({x-1, y}, jumps);
        }
    }
    if (x+1 < n) {
        if (g[x+1][y] == 0 && !used[x+1][y]) {
            used[x+1][y] = true;
            dfs({x+1, y}, jumps);
        }
    }
    if (y > 0) {
        if (g[x][y-1] == 0 && !used[x][y-1]) {
            used[x][y-1] = true;
            dfs({x, y-1}, jumps);
        }
    }
    if (y+1 < m) {
        if (g[x][y+1] == 0 && !used[x][y+1]) {
            used[x][y+1] = true;
            dfs({x, y+1}, jumps);
        }
    }
    if (jumps > 0) {
        if (x > 1) {
            if (g[x-2][y] == 0 && !used[x-2][y]) {
                used[x-2][y] = true;
                dfs({x-2, y}, jumps-1);
            }
        }
        if (x+2 < n) {
            if (g[x+2][y] == 0 && !used[x+2][y]) {
                used[x+2][y] = true;
                dfs({x+2, y}, jumps-1);
            }
        }
        if (y > 1) {
            if (g[x][y-2] == 0 && !used[x][y-2]) {
                used[x][y-2] = true;
                dfs({x, y-2}, jumps-1);
            }
        }
        if (y+2 < m) {
            if (g[x][y+2] == 0 && !used[x][y+2]) {
                used[x][y+2] = true;
                dfs({x, y+2}, jumps-1);
            }
        }
    }
}
 
int main() {
    cin >> n >> m >> k;
    g.resize(n);
    used.resize(n, vector<bool>(m, false));
    string s;
    for (int i = 0; i < n; ++i) {
        cin >> s;
        for (char ch: s) {
            if (ch == '.') {
                g[i].push_back(0);
            } else {
                g[i].push_back(1);
            }
        }
    }
    int x, y;
    cin >> x >> y;
    start = {x-1, y-1};
    cin >> x >> y;
    dest = {x-1, y-1};
    dfs(start, k);
    cout << ans;
}