#include <iostream>
#include <vector>
using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int n, m, k;
    cin >> n >> m >> k;
    vector<string> field(n);
    for (int i = 0; i < n; i++) {
        cin >> field[i];
    }
    int total = n * m;
    vector<bool> next_iteration(total, false);
    vector<bool> was(total, false);
    vector<pair<int, int>> start_end(2);
    for (int i = 0; i < 2; i++) {
        int x, y;
        cin >> x >> y;
        start_end[i] = make_pair(x - 1, y - 1);
    }
    auto get_pos = [&](pair<int, int> current) {
        return current.first + current.second * m;
    };
    auto dfs = [&](pair<int, int> current, bool has_jump) {
        if (was[get_pos(current)]) {
            return;
        }
        was[get_pos(current)] = true;
        for (int dx = -1; dx <= 1; dx++) {
            for (int dy = -1; dy <= 1; dy++) {
                if (abs(dx) + abs(dy) != 1) {
                    continue;
                }
                if (!(0 <= current.first + dx && current.first + dx < m && 0 <= current.second + dy && current.second + dy < n)) {
                    continue;
                }
                if (field[current.second + dy][current.first + dx] != '.') {
                    dfs(make_pair(current.first + dx, current.second + dy), has_jump);
                }
            }
        }
        if (has_jump) {
            for (int dx = -1; dx <= 1; dx++) {
                for (int dy = -1; dy <= 1; dy++) {
                    if (abs(dx) + abs(dy) != 1) {
                        continue;
                    }
                    dx *= 2;
                    dy *= 2;
                    if (!(0 <= current.first + dx && current.first + dx < m && 0 <= current.second + dy && current.second + dy < n)) {
                        continue;
                    }
                    if (field[current.second + dy][current.first + dx] != '.') {
                        next_iteration[get_pos(make_pair(current.first + dx, current.second + dy))] = true;
                    }
                }
            }
        }
    };
    next_iteration[get_pos(start_end[0])] = true;
    while (true) {
        vector<bool> real_next = next_iteration;
        next_iteration.assign(total, false);
        bool happened = false;
        for (int i = 0; i < total; i++) {
            bool need = real_next[i];
            if (need) {
                happened = true;
                break;
            }
        }
        if (!happened) {
            break;
        }
        for (int i = 0; i < total; i++) {
            if (real_next[i]) {
                pair<int, int> current = make_pair(i % m, i / m);
                dfs(current, true);
            }
        }
    }
    if (was[get_pos(start_end[1])]) {
        cout << "YES" << endl;
    } else {
        cout << "NO" << endl;
    }
    return 0;
}