#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <unordered_map>
#include <set>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;
using my_tree = tree<long long, null_type, less<long long>, rb_tree_tag, tree_order_statistics_node_update>;

long long find_min_unused(my_tree& s) {
    long long l = -1;
    long long r = 1e15;
    while (r - l > 1) {
        long long m = (r + l) / 2;
        auto t = s.find_by_order(m);
        if (t == s.end() || *t > m) {
            r = m;
        } else {
            l = m;
        }
    }
    return r;
}

int main()
{
    long long q;
    cin >> q;
    unordered_map<string, my_tree> m;
    for (size_t i = 0; i < q; i++) {
        string s;
        cin >> s;
        auto k = find_min_unused(m[s]);
        if (k != 0) {
            s += to_string(k);
        }
        cout << s << '\n';
        size_t j = s.size() - 1;
        m[s].insert(0);
        while (j >= 0 && s[j] >= '1' && s[j] <= '9') {
            string t = s.substr(0, j);
            long long k = stol(s.substr(j, s.size()));
            m[t].insert(k);
            j--;
        }
    }
}
