#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;
using namespace std;

const ll INF = 1e9;

const vector <pair <int, int>> moves {
    {-1, 0}, {1, 0}, {0, -1}, {0, 1}
};

void dfs(vector <string> &field, vector<vector<int>> &color, int i, int j, int c) {
    color[i][j] = c;

    int n = field.size();
    int m = field[0].size();
    for (auto &[move_i, move_j]: moves) {
        int next_i = i + move_i;
        int next_j = j + move_j;

        if (next_i < 0 || next_j < 0) continue;
        if (next_i >= n || next_j >= m) continue;
        if (field[next_i][next_j] == '#') continue;
        if (color[next_i][next_j] != -1) continue;

        dfs(field, color, next_i, next_j, c);
    }
}

void solve() {
    int n, m, k;
    cin >> n >> m >> k;

    vector<string> field(n);
    for (auto&s: field)
        cin >> s;

    int c =0;
    vector <vector <int>> colors(n, vector <int> (m, -1));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (colors[i][j] != -1) continue;
            dfs(field, colors,i ,j, c++);
        }
    }

    vector <unordered_set <int>> graph(c);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            for (auto &[move_i, move_j]: moves) {
                int next_i = i + 2*move_i;
                int next_j = j + 2*move_j;

                if (next_i < 0 || next_j < 0) continue;
                if (next_i >= n || next_j >= m) continue;
                if (field[i][j] == '#') continue;
                if (colors[i][j] == colors[next_i][next_j]) continue;

                graph[colors[i][j]].insert(colors[next_i][next_j]);
            }
        }
    }

    int dx, dy;
    cin >> dx >> dy;
    dx--, dy--;

    int ax, ay;
    cin >> ax >> ay;
    ax--, ay--;

    deque <int> dq;
    dq.push_back(colors[dx][dy]);

    vector <int> dp(c, INF);
    dp[colors[dx][dy]] = 0;

    while (!dq.empty()) {
        auto u = dq.front();
        dq.pop_front();

        for (int v: graph[u]) {
            if (dp[v] > dp[u] + 1) {
                dp[v] = dp[u] + 1;
                dq.push_back(v);
            }
        }
    }

    int u = colors[ax][ay];
    if (dp[u] > k) {
        cout << "NO\n";
    } else {
        cout << "YES\n";
    }
}

signed main() {
    cin.tie(NULL);
    ios_base::sync_with_stdio(false);

    solve();
}