#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;
using namespace std;

const ll INF = 1e9;

const vector <pair <int, int>> moves {
    {-1, 0}, {1, 0}, {0, -1}, {0, 1}
};

void solve() {
    int n, m, k;
    cin >> n >> m >> k;

    vector<string> field(n);
    for (auto&s: field)
        cin >> s;

    int dx, dy;
    cin >> dx >> dy;
    dx--, dy--;

    int ax, ay;
    cin >> ax >> ay;
    ax--, ay--;

    deque <pair <int, int>> dq;
    dq.emplace_back(dx, dy);

    vector <vector <int>> dp(n, vector <int> (m, INF));
    dp[dx][dy] = 0;

    while (!dq.empty()) {
        auto [i, j] = dq.front();
        dq.pop_front();

        for (auto &[move_i, move_j]: moves) {
            int next_i = i + move_i;
            int next_j = j + move_j;

            if (next_i < 0 || next_j < 0) continue;
            if (next_i >= n || next_j >= m) continue;
            if (field[next_i][next_j] == '#') continue;

            if (dp[next_i][next_j] > dp[i][j]) {
                dp[next_i][next_j] = dp[i][j];
                dq.emplace_front(next_i, next_j);
            }
        }

        for (auto &[move_i, move_j]: moves) {
            int next_i = i + 2*move_i;
            int next_j = j + 2*move_j;

            if (next_i < 0 || next_j < 0) continue;
            if (next_i >= n || next_j >= m) continue;
            if (field[next_i][next_j] == '#') continue;

            if (dp[next_i][next_j] > dp[i][j] + 1) {
                dp[next_i][next_j] = dp[i][j] + 1;
                dq.emplace_back(next_i, next_j);
            }
        }
    }

    if (dp[ax][ay] > k) {
        cout << "NO\n";
    } else {
        cout << "YES\n";
    }
}

signed main() {
    cin.tie(NULL);
    ios_base::sync_with_stdio(false);

    solve();
}