#include <bits/stdc++.h>
using namespace std;

// #define int long long
#define double long double
#define ld double

#define all(x) x.begin(), x.end()

const int INF = 2e9 + 5;
const int SZ = 1 << 10;
const double eps = 1e-10;

char a[SZ][SZ];
struct Point {
    int x;
    int y;
};

istream& operator >> (istream& in, Point& p){
    in >> p.x >> p.y;
    return in;
}

ostream& operator << (ostream& out, const Point& p){
    out << p.x << ' ' << p.y;
    return out;
}

Point operator + (const Point& p, const Point& q){
    return {p.x + q.x, p.y + q.y};
}

int h(const Point& p){
    return p.x * SZ + p.y;
}

Point g(int e){
    return {e / SZ, e % SZ};
}

void solve(){

    for (int i = 0; i < SZ; i++){
        for (int j = 0; j < SZ; j++){
            a[i][j] = '#';
        }
    }

    int n, m, k;
    cin >> n >> m >> k;
    for (int i = 2; i <= n + 1; i++){
        for (int j = 2; j <= m + 1; j++){
            cin >> a[i][j];
        }
    }

    Point st, fi;
    cin >> st >> fi;

    st = st + Point{1, 1};
    fi = fi + Point{1, 1};

    vector<int> d(SZ*SZ, INF);
    d[h(st)] = 0;
    deque<int> q;
    q.push_back(h(st));
    while (q.size()){
        Point p = g(q.front());
        q.pop_front();
        int hp = h(p);

        for (int k = 1; k <= 2; k++){
            for (int sx = -1; sx <= 1; sx++){
                for (int sy = -1; sy <= 1; sy++){
                    if (abs(sx) + abs(sy) != 1){
                        continue;
                    }

                    auto z = p + Point{sx * k, sy * k};

                    if (a[z.x][z.y] == '#'){
                        continue;
                    }
                    int hq = h(z);
                    if (d[hq] > d[hp] + k - 1){
                        d[hq] = d[hp] + k - 1;
                        if (k == 1){
                            q.push_front(hq);
                        }else{
                            q.push_back(hq);
                        }
                    }
                }
            }
        }
    }

    if (d[h(fi)] > k){
        cout << "NO";
    }else{
        cout << "YES";
    }

}

signed main(){

    // freopen("input.txt", "r", stdin);

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cout << fixed << setprecision(10);

    int t = 1;
    // cin >> t;

    while (t--){
        solve();
        cout << '\n';
    }

}