#include <bits/stdc++.h>

#define ff first
#define ss second
#define pb push_back

#ifndef LOCAL
#define cerr                                                                                                           \
	if (0)                                                                                                             \
	cerr
#endif

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef pair<ld, ld> pld;
typedef vector<int> vi;
typedef vector<vi> vvi;

template <typename T, typename V> ostream &operator<<(ostream &out, pair<T, V> &p) {
	out << "(" << p.ff << ", " << p.ss << ")";

	return out;
}

template <typename T> ostream &operator<<(ostream &out, vector<T> &v) {
	out << "[";
	for (T &e : v)
		out << e << ", ";
	out << "]";

	return out;
}

void solve();

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int t = 1;
	// cin >> t;

	while (t--) {
		solve();
		cout << "\n";
	}

	return 0;
}

struct node
{
	map<char, node*> sons;
	bool isWord;

	node()
	: isWord(false)
	{}
};

node* root = new node();

bool contains(string& s)
{
	node* cur = root;
	for(char c : s)
	{
		if(cur->sons.find(c) == cur->sons.end())
			return false;

		cur = cur->sons[c];
	}

	return cur->isWord;
}

void add(string& s)
{
	node* cur = root;
	for(char c : s)
	{
		if(cur->sons.find(c) == cur->sons.end())
			cur->sons[c] = new node();

		cur = cur->sons[c];
	}

	cur->isWord = true;
}

void solve() {
	int q;
	cin >> q;

	while(q--)
	{
		string s;
		cin >> s;

		if(!contains(s))
		{
			add(s);
			cout << s << "\n";
			continue;
		}

		for(int x = 1;; x++)
		{
			string ss = s + to_string(x);
			if(!contains(ss))
			{
				add(ss);
				cout << ss << "\n";
				break;
			}
		}
	}
}

