#include <bits/stdc++.h>

#define ff first
#define ss second
#define pb push_back

#ifndef LOCAL
#define cerr                                                                                                           \
	if (0)                                                                                                             \
	cerr
#endif

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef pair<ld, ld> pld;
typedef vector<int> vi;
typedef vector<vi> vvi;

template <typename T, typename V> ostream &operator<<(ostream &out, pair<T, V> &p) {
	out << "(" << p.ff << ", " << p.ss << ")";

	return out;
}

template <typename T> ostream &operator<<(ostream &out, vector<T> &v) {
	out << "[";
	for (T &e : v)
		out << e << ", ";
	out << "]";

	return out;
}

void solve();

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int t = 1;
	// cin >> t;

	while (t--) {
		solve();
		cout << "\n";
	}

	return 0;
}

const int inf = 1e9;

vector<string> table;
vector<vector<int>> d;

vector<pair<int, int>> moves = {{0, 1}, {0, -1}, {1, 0}, {-1, 0}};
vector<pair<int, int>> jumps = {{0, 2}, {0, -2}, {2, 0}, {-2, 0}};

void bfs(int sx, int sy, const int n, const int m)
{
	d[sx][sy] = 0;
	deque<pair<int, int>> q;
	q.push_front({sx, sy});

	while(!q.empty())
	{
		auto [vx, vy] = q.front();
		q.pop_front();

		for(int i = 0; i < 4; i++)
		{
			int wx = vx + moves[i].ff, wy = vy + moves[i].ss;

			if(wx >= 0 && wx < n && wy >= 0 && wy < m)
			{
				if(table[wx][wy] != '#' && d[wx][wy] > d[vx][vy])
				{
					d[wx][wy] = d[vx][vy];
					q.push_front({wx, wy});
				}
				else if(table[wx][wy] == '#')
				{
					wx = vx + jumps[i].ff, wy = vy + jumps[i].ss;

					if(wx >= 0 && wx < n && wy >= 0 && wy < m)
					{
						if(table[wx][wy] != '#' && d[wx][wy] > d[vx][vy] + 1)
						{
							d[wx][wy] = d[vx][vy] + 1;
							q.push_back({wx, wy});
						}
					}
				}
			}
		}
	}
}

void solve() {
	int n, m, k;
	cin >> n >> m >> k;

	table.resize(n);
	d.resize(n, vector<int>(m, inf));

	for(int i = 0; i < n; i++) cin >> table[i];

	int sx, sy, dx, dy;
	cin >> sx >> sy >> dx >> dy;

	sx--, sy--, dx--, dy--;

	bfs(sx, sy, n, m);

	cerr << d << endl;

	cout << (d[dx][dy] > k ? "NO" : "YES");
}

