#include <bits/stdc++.h>
using namespace std;
 
template<typename T>
ostream& operator<<(ostream &os, const vector<T> &vec)
{
   for(size_t i = 0; i < vec.size(); i++)
      os << vec[i] << " \n"[i + 1 == vec.size()];
   return os;
}
 
template<typename T>
istream& operator>>(istream &is, vector<T> &vec)
{
    for (T &it : vec)
        is >> it;
    return is;
}
 
typedef long long ll;
typedef long double ld;
#define endl "\n"

const int INF = 1e9 + 1000;

const int M = 50000;
const int N = 21;
const ld eps = 1e-9;
const ld PI = atan2l(0, -1);
 
struct point
{
	ld x, y;
	point() = default;
	point(ld x, ld y): x(x), y(y){}
 
	friend istream& operator>>(istream& in, point &a)
	{
		in >> a.x >> a.y;
		return in;
	}
 
	friend ostream& operator<<(ostream& os, point &a)
	{
		os << a.x << " " << a.y << endl;
		return os;
	}
 
	ld len()
	{
		return sqrt(x*x + y*y);
	}
 
	ld operator*(point &a)
	{
		ld c;
		c = x * a.x + y * a.y;
		return c;
	}

	point operator+(point &a)
	{
		point c;
		c.x = x + a.x;
		c.y = y + a.y;

		return c;
	}
};
 
bool equal(ld a, ld b)
{
	return (abs(a - b) < eps);
}
 
 
 
 
ll my_pow(ll a, ll p){
    if (p == 0)
        return 1;
    if(p % 2 == 0)
        return my_pow(a * a, p / 2);
    return my_pow(a, p - 1) * a;
}
 
void solve()
{
    int n, m, k;
    cin >> n >> m >> k;
    vector<string> fl(n);
    vector<vector<int>> was(n, vector<int>(m, 0));
    for (int i = 0; i < n; i++)
        cin >> fl[i];
    int x1, y1;
    cin >> x1 >> y1;
    x1 --;
    y1 --;
    int x2, y2;
    cin >> x2 >> y2;
    x2 --;
    y2 --;
    priority_queue<pair<int, pair<int, int>>> q;
    q.push({0, {x1, y1}});
    ll s = -1;
    while(!q.empty()){
        auto cur = q.top();
        q.pop();
        auto v = cur.second;
        was[v.first][v.second] = 1;
        //cout << v.first << " " << v.second << "\n";
        //cout << v.first << " " << v.second << "\n";
        if (v.first == x2 && v.second == y2){
        	s = -cur.first;
            break;
        }
        if (v.first + 1 < n && !was[v.first + 1][v.second]){
        	if ((fl[v.first][v.second] != '#') || fl[v.first + 1][v.second] != '#' && v.first - 1 >= 0 && fl[v.first - 1][v.second] != '#')
            	q.push({(fl[v.first + 1][v.second] == '#' ? cur.first - 1 : cur.first), {v.first + 1, v.second}});
        }
        if (v.first - 1 >= 0 && !was[v.first - 1][v.second]){
        	if ((fl[v.first][v.second] != '#') || fl[v.first - 1][v.second] != '#' && v.first + 1 < n && fl[v.first + 1][v.second] != '#')
            	q.push({(fl[v.first - 1][v.second] == '#' ? cur.first - 1 : cur.first), {v.first - 1, v.second}});
        }
        if (v.second + 1 < m && !was[v.first][v.second + 1]){
        	if ((fl[v.first][v.second] != '#') || fl[v.first][v.second + 1] != '#' && (v.second - 1 >= 0 && fl[v.first][v.second - 1] != '#'))
            	q.push({(fl[v.first][v.second + 1] == '#' ? cur.first - 1 : cur.first), {v.first, v.second + 1}});
        }
        if (v.second - 1 >= 0 && !was[v.first][v.second - 1]){
        	if ((fl[v.first][v.second] != '#') || fl[v.first][v.second - 1] != '#' && (v.second + 1 < m && fl[v.first][v.second + 1] != '#'))
            	q.push({(fl[v.first][v.second - 1] == '#' ? cur.first - 1 : cur.first), {v.first, v.second - 1}});
        }
    }
    if(s <= k && s != -1)
        cout << "YES\n";
    else
        cout << "NO\n";
}
 
signed main()
{
   ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
 
   #ifndef LOCAL
   // freopen("disttosegment.in", "r", stdin);
   // freopen("disttosegment.out", "w", stdout);
   // #else
   // freopen("mincut.in", "r", stdin);
   // freopen("mincut.out", "w", stdout);
   #endif
 
   int t = 1;
   // cin >> t;
   while(t--)
   {
      // cout << t << endl;
      solve();
   }
   return 0;
}