#include <bits/stdc++.h>

using namespace std;

const int K = 62;
const long long MOD = 1791791791;

set<long long> hashSet;
vector<long long> powK;

int getAlphNum(char x) {
    if (isdigit(x)) {
        return 52 + x - '0';
    } else if (isupper(x)) {
        return 26 + x - 'A';
    }
    return x - 'a';
}

struct node {
    node* links[K]{};
    bool term = false;
    char sign;
    int repeat = 0;
    long long hash;

};

node* root = new node();

long long addedHash(int len, long long hash, string &suff) {

    for (int i = len; i < len + suff.size(); i++) {
        int ind = getAlphNum(suff[i - len]);
        hash = (hash + (ind * powK[i] % MOD)) % MOD;
    }

    return hash;
}

string add(string &str, node* start) {

    node* current = start;

    for (int i = 0; i < str.size(); i++) {
        int ind = getAlphNum(str[i]);
        if (!current->links[ind]) {
            current->links[ind] = new node();
            current->links[ind]->sign = str[i];
            current->links[ind]->hash = (current->hash + (ind * powK[i] % MOD)) % MOD;
        }
        current = current->links[ind];
    }

    if (current->repeat) {
        current->repeat++;

        int left = 0;
        int right = 1e5 + 10;

        while (right - left > 1) {
            int m = (left + right) / 2;
            string num = to_string(m);
            long long currentHash = addedHash(str.size(), current->hash, num);

            if (hashSet.find(currentHash) == hashSet.end()) {
                right = m;
            } else {
                left = m;
            }
        }

        string num = to_string(right);
        long long currentHash = addedHash(str.size(), current->hash, num);
        hashSet.insert(currentHash);

        return str + add(num, current);
    } else {
        current->repeat++;
        hashSet.insert(current->hash);
        return str;
    }

}

int main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr);
    root->hash = 0;

    for (int i = 0; i < 1e4; i++) {
        if (i == 0) {
            powK.push_back(1);
            continue;
        }
        powK.push_back(powK.back() * K % MOD);
    }

    int q;
    cin >> q;

    while (q--) {
        string str;
        cin >> str;

        cout << add(str, root) << endl;
    }
}