#include <bits/stdc++.h>

using namespace std;

const int K = 73;
const long long MOD = 1791791791;

set<long long> hashSet;
vector<long long> powK;

int getAlphNum(char x) {
    if (isdigit(x)) {
        return 52 + x - '0';
    } else if (isupper(x)) {
        return 26 + x - 'A';
    }
    return x - 'a';
}

long long addedHash(int len, long long hash, string &suff) {

    for (int i = len; i < len + suff.size(); i++) {
        int ind = getAlphNum(suff[i - len]);
        hash = (hash + (ind * powK[i] % MOD)) % MOD;
    }

    return hash;
}

long long polynomHash(string &str) {
    long long result = 0;
    for (int i = 0; i < str.size(); i++) {
        result = (result + (getAlphNum(str[i]) * powK[i] % MOD)) % MOD;
    }

    return result;
}

string get(string &str) {
    long long hash = polynomHash(str);

    if (hashSet.find(hash) != hashSet.end()) {
        int left = 0, right = 1e5+10;
        while (right - left > 1) {
            int m = (left + right) / 2;
            string num = to_string(m);

            long long addedHash = polynomHash(num);
            long long totalHash = (hash + (addedHash * powK[str.size() - 1] % MOD)) % MOD;

            if (hashSet.find(totalHash) != hashSet.end()) {
                left = m;
            } else {
                right = m;
            }
        }

        string num = to_string(right);
        long long addedHash = polynomHash(num);
        long long totalHash = (hash + (addedHash * powK[str.size() - 1] % MOD)) % MOD;

        hashSet.insert(totalHash);
        return str + num;

    } else {
        hashSet.insert(hash);
        return str;
    }

}

int main() {

    for (int i = 0; i < 1e4; i++) {
        if (i == 0) {
            powK.push_back(1);
            continue;
        }
        powK.push_back(powK.back() * K % MOD);
    }

    int q;
    cin >> q;

    while (q--) {
        string str;
        cin >> str;

        cout << get(str) << endl;
    }
}
