#include <iostream>
#include <vector>
#include <string>
#include <utility>
#include <unordered_map>
#include <unordered_set>
#include <deque>
using namespace std;

int n, m;
int a[1000][1000];
string map[1000];
int color;
unordered_map<int, unordered_set<int>> g;

const vector<pair<int, int>> moves = {{1, 0}, {0, 1}, {-1, 0}, {0, -1}};
void dfs(int i, int j) {
    if (i < 0 || j < 0 || i >= n || j >= m || a[i][j] != 0 || map[i][j] == '#') {
        return;
    }
    a[i][j] = color;
    for (auto move: moves) {
        int x = i + move.first;
        int y = j + move.second;
        dfs(x, y);
    }
}
int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int k;
    cin >> n >> m >> k;
    for (int i = 0; i < n; ++i) {
        cin >> map[i];
    }
    color = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (a[i][j] == 0 && map[i][j] != '#') {
                color++;
                dfs(i, j);
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (map[i][j] == '#') {
                continue;
            }
            for (auto move: moves) {
                int x = i + 2 * move.first;
                int y = j + 2 * move.second;
                if (x < 0 || y < 0 || x >= n || y >= m || map[x][y] == '#') {
                    continue;
                }
                if (a[i][j] != a[x][y]) {
                    g[a[i][j]].insert(a[x][y]);
                    g[a[x][y]].insert(a[i][j]);
                }
            }
        }
    }
    int x_s, y_s;
    cin >> x_s >> y_s;
    int x_e, y_e;
    cin >> x_e >> y_e;
    int cs = a[x_s - 1][y_s - 1];
    int ce = a[x_e - 1][y_e - 1];
    deque<int> bfs;
    vector<int> dist(color + 1, 1'000'000'000);
    dist[cs] = 0;
    bfs.push_back(cs);
    while (!bfs.empty()) {
        int cur = bfs[0];
        bfs.pop_front();
        for (auto i: g[cur]) {
            if (dist[i] == 1'000'000'000) {
                dist[i] = dist[cur] + 1;
                bfs.push_back(i);
            }
        }
    }
    /*for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << a[i][j] << " ";
        }
        cout << "\n";
    }
    for (auto i: g) {
        std::cout << i.first << "\n";
        for (auto j: i.second) {
            std::cout << j << " ";
        }
        std::cout << "\n";
    }*/
    if (dist[ce] > k) {
        cout << "NO";
    } else {
        cout << "YES";
    }
}