#include <bits/stdc++.h>
using namespace std;

#define int long long

vector<int> deltax = {1, -1, 0, 0};
vector<int> deltay = {0, 0, 1, -1};
vector<vector<bool>> cells;
vector<vector<int>> dp;

void dfs(int x, int y, int k) {
    if (x < 0 || x >= cells.size() || y < 0 || y >= cells[0].size() || !cells[x][y] ||
        dp[x][y] <= k) {
        return;
    }
    dp[x][y] = k;
    for (int i = 0; i < 4; i++) {
        dfs(x + deltax[i], y + deltay[i], k);
    }
    for (int i = 0; i < 4; i++) {
        dfs(x + 2 * deltax[i], y + 2 * deltay[i], k + 1);
    }
}

signed main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif  // LOCAL
    int n, m, k = 0;
    cin >> n >> m >> k;
    cells.resize(n, vector<bool>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            char ch;
            cin >> ch;
            if (ch == '.')
                cells[i][j] = 1;
        }
    }
    dp.resize(n, vector<int>(m, INT64_MAX));
    int dx, dy;
    cin >> dx >> dy;
    --dx;
    --dy;
    int ax, ay;
    cin >> ax >> ay;
    --ax;
    --ay;
    dfs(dx, dy, 0);
    if (dp[ax][ay] <= k)
        cout << "YES\n";
    else
        cout << "NO\n";
}

