#include <bits/stdc++.h>
using namespace std;

#define int long long

int n, m;
vector<int> dx = {1, -1, 0, 0};
vector<int> dy = {0, 0, 1, -1};
vector<vector<bool>> cells;

auto bfs(int sx, int sy) {
    deque<pair<int, int>> q;
    vector<vector<int>> d(n, vector<int>(m, LLONG_MAX));

    q.emplace_back(sx, sy);
    d[sx][sy] = 0;
    while (not q.empty()) {
        auto v = q.front();
        q.pop_front();
        for (int i = 0; i < 4; ++i) {
            auto nx = v.first + dx[i];
            auto ny = v.second + dy[i];
            if (nx < 0 || nx >= n || ny < 0 || ny >= m || !cells[nx][ny] || d[nx][ny] != LLONG_MAX) {
                continue;
            }
            q.emplace_front(nx, ny);
            d[nx][ny] = d[v.first][v.second] + 0;
        }
        for (int i = 0; i < 4; ++i) {
            auto nx = v.first + 2 * dx[i];
            auto ny = v.second + 2 * dy[i];
            if (nx < 0 || nx >= n || ny < 0 || ny >= m || !cells[nx][ny] || d[nx][ny] != LLONG_MAX) {
                continue;
            }
            q.emplace_back(nx, ny);
            d[nx][ny] = d[v.first][v.second] + 1;
        }
    }
    return d;
}

signed main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif  // LOCAL
    int k;
    cin >> n >> m >> k;
    cells.resize(n, vector<bool>(m, false));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            char ch;
            cin >> ch;
            if (ch == '.')
                cells[i][j] = true;
        }
    }
    int sx, sy;
    cin >> sx >> sy;
    --sx, --sy;
    int fx, fy;
    cin >> fx >> fy;
    --fx, --fy;
    auto d = bfs(sy, sx);
    cout << (d[fx][fy] <= k ? "YES" : "NO") << "\n";
}
