#include <bits/stdc++.h>
using namespace std;

#define int long long

int n, m, k;
vector<int> dx = {1, -1, 0, 0};
vector<int> dy = {0, 0, 1, -1};
vector<string> cells;

auto bfs(int sx, int sy) {
    deque<pair<int, int>> q;
    vector<vector<int>> d(n, vector<int>(m, INT_MAX));

    q.emplace_back(sx, sy);
    d[sx][sy] = 0;
    while (not q.empty()) {
        auto [x, y] = q.front();
        q.pop_front();
        for (int i = 0; i < 4; ++i) {
            auto nx = x + dx[i];
            auto ny = y + dy[i];
            if (nx < 0 || nx >= n ||
                ny < 0 || ny >= m ||
                cells[nx][ny] != '.' ||
                d[nx][ny] <= d[x][y] + 0) {
                continue;
            }
            q.emplace_front(nx, ny);
            d[nx][ny] = d[x][y] + 0;
        }
        for (int i = 0; i < 4; ++i) {
            auto nx = x + 2 * dx[i];
            auto ny = y + 2 * dy[i];
            if (nx < 0 || nx >= n ||
                ny < 0 || ny >= m ||
                cells[nx][ny] != '.' ||
                d[nx][ny] <= d[x][y] + 1) {
                continue;
            }
            q.emplace_back(nx, ny);
            d[nx][ny] = d[x][y] + 1;
        }
    }
    return d;
}

signed main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif  // LOCAL
    cin >> n >> m >> k;
    cells.resize(n);
    for (auto& i : cells) {
        cin >> i;
    }
    int sx, sy;
    sx = 1, sy = 1;
    cin >> sx >> sy;
    --sx, --sy;
    int fx, fy;
    fx = n, fy = n;
    cin >> fx >> fy;
    --fx, --fy;
    auto d = bfs(sx, sy);
    cout << (d[fx][fy] <= k ? "YES" : "NO") << "\n";
}
