#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<ll, ll> Vector;

ll magn2(const Vector& v) {
    return v.first * v.first + v.second * v.second;
}

Vector dir(const Vector& from, const Vector& to) {
    return {to.first - from.first, to.second - from.second};
}

bool is_same_dir(const Vector& a, const Vector& b) {
    if (magn2(a) > magn2(b)) {
        return is_same_dir(b, a);
    }
    if (a.first == 0 && a.second == 0) {
        return true;
    } else if (a.first == 0) {
        return b.first == 0;
    } else if (a.second == 0) {
        return b.second == 0;
    } else {
        double kx = (double) b.first * 1.0 / (double) a.first;
        double ky = (double) b.second * 1.0 / (double) a.second;
        return fabs(kx - ky) < 1e-6;
    }
}

int main() {
    int n;
    cin >> n;
    vector<Vector> pts(n);
    for (int i = 0; i < n; i++) {
        ll x, y;
        cin >> x >> y;
        pts[i] = {x, y};
    }

    Vector lastD = dir(pts[n - 1], pts[0]);
    ll maxDist = magn2(lastD);
    ll lastDist = magn2(lastD);
    long double result = sqrt(lastDist);
    for (int i = 0; i < n - 1; i++) {
        Vector from = pts[i];
        Vector to = pts[i + 1];
        Vector d = dir(from, to);
        ll dist = magn2(d);

        if (is_same_dir(lastD, d)) {
            lastDist += dist;
        } else {
            lastDist = dist;
        }

        maxDist = max(maxDist, lastDist);
        lastD = d;
        result += sqrt(dist);
    }

    result -= sqrt(maxDist);
    cout << fixed << setprecision(6) << result;
    return 0;
}