#include <bits/stdc++.h>

using namespace std;


void dfs(int x, int y, int n, int m, int id,
         vector<vector<int>>& mark,
         const vector<vector<char>>& mp) noexcept {
    if (x < 0 || x >= n ||
        y < 0 || y >= m ||
        mark[x][y] != -1 ||
        mp[x][y] == '#') {
        return;
    }
    mark[x][y] = id;
    const vector<pair<int, int>> delta = {{0, -1}, {0, 1}, {1, 0}, {-1, 0}};
    for (auto d: delta) {
        dfs(x + d.first, y + d.second, n, m, id, mark, mp);
    }
}

int main() noexcept {
    const vector<pair<int, int>> deltaS = {{0, 1}, {1, 0}};

    int n, m, k;
    cin >> n >> m >> k;

    vector<vector<char>> mp(n, vector<char>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> mp[i][j];
        }
    }

    int dx, dy;
    cin >> dx >> dy;
    dx--;
    dy--;

    int ax, ay;
    cin >> ax >> ay;
    ax--;
    ay--;

    vector<vector<int>> mark(n, vector<int> (m, -1));
    int cnt = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (mp[i][j] != '#' && mark[i][j] == -1) {
                dfs(i, j, n, m, cnt++, mark, mp);
            }
        }
    }



    vector<set<int>> links(cnt);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (mp[i][j] == '#') {
                for (auto d: deltaS) {
                    int fx = i + d.first;
                    int fy = j + d.second;
                    int tx = i - d.first;
                    int ty = j - d.second;

                    if (fx < 0 || fx >= n || fy < 0 || fy >= m ||
                        tx < 0 || tx >= n || ty < 0 || ty >= m) {
                        continue;
                    }


                    int fid = mark[fx][fy];
                    int tid = mark[tx][ty];
                    if (fid != -1 && tid != -1 && fid != tid) {
                        links[fid].insert(tid);
                        links[tid].insert(fid);
                    }
                }
            }
        }
    }

    int end = mark[ax][ay];
    queue<pair<int, int>> ids;
    vector<int> dist(cnt, -1);
    ids.emplace(mark[dx][dy], 0);
    while (!ids.empty()) {
        pair<int, int> w = ids.front();
        ids.pop();
        int cur = w.first;
        int d = w.second;
        if (dist[cur] != -1) {
            continue;
        }
        dist[cur] = d;
        for (int to: links[cur]) {
            if (dist[to] == -1) {
                ids.emplace(to, d + 1);
            }
        }
    }

    cout << (dist[end] != -1 && dist[end] <= k ? "YES" : "NO");
    return 0;
}
