#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

void dfs(int x, int y, int n, int m, int id,
         vector<vector<int>>& mark,
         const vector<vector<char>>& mp,
         const vector<pair<int, int>>& delta) {
    if (x < 0 || x >= n || y < 0 || y >= m) {
        return;
    }
    if (mark[x][y] != -1 || mp[x][y] == '#') {
        return;
    }
    mark[x][y] = id;
    for (auto d: delta) {
        dfs(x + d.first, y + d.second, n, m, id, mark, mp, delta);
    }
}

vector<vector<char>> test(int n, int m) {
    vector<vector<char>> mp(n, vector<char>(m, '.'));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            mp[i][j] = rand() % 2 == 0 ? '#' : '.';
        }
    }
    return mp;
}

int main() {
    int n, m, k;
    cin >> n >> m >> k;

    vector<vector<char>> mp(n, vector<char>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> mp[i][j];
        }
    }

    int dx, dy;
    cin >> dx >> dy;
    dx--; dy--;

    if (dx < 0 || dx >= n || dy < 0 || dy >= m) {
        cout << "NO\n";
        return 0;
    }

    int ax, ay;
    cin >> ax >> ay;
    ax--; ay--;

    if (ax < 0 || ax >= n || ay < 0 || ay >= m) {
        cout << "NO\n";
        return 0;
    }

    vector<vector<int>> mark(n, vector<int>(m, -1));
    vector<pair<int, int>> delta = {{1,  0},
                                    {-1, 0},
                                    {0,  1},
                                    {0,  -1}};
    int markCount = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (mark[i][j] == -1 && mp[i][j] != '#') {
                dfs(i, j, n, m, markCount++, mark, mp, delta);
            }
        }
    }

    vector<set<int>> links(markCount);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (mp[i][j] == '#') {
                for (auto d: delta) {
                    int fromX = i - d.first;
                    int fromY = j - d.second;
                    int toX = i + d.first;
                    int toY = j + d.second;

                    if (fromX < 0 || fromX >= n || fromY < 0 || fromY >= m ||
                        toX < 0 || toX >= n || toY < 0 || toY >= m) {
                        continue;
                    }

                    int fromId = mark[fromX][fromY];
                    int toId = mark[toX][toY];
                    if (fromId != -1 && toId != -1 && fromId != toId) {
                        links[fromId].insert(toId);
                        links[toId].insert(fromId);
                    }
                }
            }
        }
    }

    int end = mark[ax][ay];
    queue<pair<int, int>> que;
    vector<int> dist(markCount, -1);

    que.emplace(mark[dx][dy], 0);
    while (!que.empty()) {
        auto cur = que.front();
        que.pop();
        int node = cur.first;
        int d = cur.second;
        if (dist[node] != -1) {
            continue;
        }
        dist[node] = d;
        for (int link: links[node]) {
            if (dist[link] == -1) {
                que.emplace(link, d + 1);
            }
        }
    }

    cout << (end != -1 && dist[end] != -1 && dist[end] <= k ? "YES" : "NO") << "\n";
    return 0;
}