def is_point_inside_polygon(vertices, x, y):
    n = len(vertices)
    inside = False
    p1x, p1y = vertices[0]
    for i in range(n + 1):
        p2x, p2y = vertices[i % n]
        if y > min(p1y, p2y):
            if y <= max(p1y, p2y):
                if x <= max(p1x, p2x):
                    if p1y != p2y:
                        xinters = (y - p1y) * (p2x - p1x) / (p2y - p1y) + p1x
                    if p1x == p2x or x <= xinters:
                        inside = not inside
        p1x, p1y = p2x, p2y
    return inside

def last_day_for_settlement(vertices, settlements):
    last_day = None
    for i, settlement in enumerate(settlements):
        tx, ty = settlement
        day = 0
        while True:
            if is_point_inside_polygon(vertices, tx, ty):
                last_day = day
                break
            day += 1
            tx *= 2
            ty *= 2
        print(last_day)


# Считываем входные данные
n = int(input())
vertices = [list(map(int, input().split())) for _ in range(n)]
q = int(input())
settlements = [list(map(int, input().split())) for _ in range(q)]

# Вызываем функцию для определения последнего дня для каждого поселения
last_day_for_settlement(vertices, settlements)